
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program fitfluxes
!__________________________________________________________________________________________________________________________________
!
! This code is part of GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay
!__________________________________________________________________________________________________________________________________
!
       implicit      none

       logical       lfname1, lfname2, lunix, lgood, lconv, ldebug, lfnameo, limages, lpostscript, ltiming, lgoodfound, lconverged
     &             , lconvergedo, ldone, lnochange, lconvgood, lnotconvo, lsing
                                            
       character*1   csnband(100)
       character*2   cwav, cno
       character*3   cjx, ckx, clx, cmx, cl, cpx, cpjx, cpkx, cplx, cpmx, cnperc
       character*4   clam1, clam2, cx, cy
       character*5   cfpptime
       character*6   cfitsversion, lverbose
       character*7   clibname, punits(4)
       character*8   ctime, cmodel, cnumber, yesno(2)
       character*9   cfts, ccpu, cwal, cccpu, ccwal
       character*10  cdate, cnsrc, cnsend
       character*21  compda
       character*80  object, creator, ctype1, ctype2, bunit, history
       character*128 header, footer(2)
       character*500 arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, argA, argB, argC, argD, outname, prefix, excat, callwaves
     &             , callsnerr, callparams, postscript, paramsfile, filename, coldensity, temperatur, chisquarnu, paraspace
     &             , commandline
       character*2000 headline(1000), cline

       integer       i, j, k, l, m, nsrc, ilp, ion, ndate, iotty, iolog, firstb, lastc, lhl, lb, nbands, psunit, icp, ia1, ia2, ia3
     &             , ia4, ia5, ia6, ia7, ia8, ia9, iaA, iaB, iaC, iaD, nhead, nextr, ncolumns, ncolxcoo, ncolycoo, nhcols, iexc
     &             , nn, n1, n2, n3, irc, icm, nptstofit, ncolgood, ncolsigg, nmodparams, npar(4), nplt, ils, ns, nfreedom, ne, nm
     &             , njx, nkx, nlx, nmx, nl, ics, ip, nl1, nl2, nbande, nfitparams, lam1, lam2, number, npjx, npkx, nplx, npmx, ny1
     &             , numfits, nfts, ncolnumb, nx, ny, nb, blank, ilc, ilt, ilq, ncx, ncy, na, icl, npercent, icw, nx1, nband(100)
     &             , ivarornot(4), npart, nparts, nsbeg, nsend, nx0o, ny0o, ile, wchours, wcmins, ipr, wcsecs, cpuhours, cpumins
     &             , cpusecs, ndc, ndw, nbn, nbx, itref, npx, maxitref, iter, itrefmin, itrefmax, itermin, itermax, nparo, nparmx(4)
     &             , iterdone
     
       real          fitsvers

       real*8        dx, dy, crpix1, crpix2, crval1, crval2, ra, dec, funmin, funmax, beamx, crota1, crota2, cd11, cd12, chisqfree 
     &             , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, pi, pio2, pi2, derivedmass, pspace1o, beam1
     &             , speedolight, distancepc, dust2gas, opacity0, chisqx, opaslope, wavepeak, frequency0, wavelength0, goodmin
     &             , sq_arcsecs_per_sterad, sigmin, amu, muH2, almostzero, Msun, pc, chisqmin, opacityrelerr, dustgasrelerr, dlogpo
     &             , distancrelerr, fluxpeak, modparam1(4), modparam2(4), dlogp(4), waveband(100), adderro(100), snrmin(100), wctot
     &             , modparams1(4), modparams2(4), quantities(100), parmin(4), parmax(4), modp1, modp2, delta, cpu, wal, cpu_sum
     &             , wal_sum, cputot, timer, offset, modelflux, cdelt1, cdelt2, chisqfreeo, parmn(4), parmx(4), numpart, numtotal
     &             , isumpct, itermean, itrefmean, nitmean, nrefmean, parmnlog, parmxlog, chisqfmax, pspace2o, dlogpmax(4)
     &             , solidapixel

       logical, allocatable :: ltakeit(:)
                                         
       integer, allocatable :: ncolsig(:), ncolfxp(:), ncolfxt(:), ncolsnr(:), ncolfpe(:), ncolfte(:), ipfitornot(:), nxmin(:,:)
     &                       , uplimit(:)
       real*8, allocatable :: sigmono(:), snrpeak(:), snrtotal(:), frequency(:), fxpbest(:), fxperro(:), fxtbest(:), fxterro(:)
     &                      , sfrequency(:), sfxtbest(:), sfxterro(:), opacity(:), sedslope(:), wavelength(:), fitparameters(:)
     &                      , dyda(:), covar(:,:), alpha(:,:), chisq(:,:,:,:), paramspace(:,:), fun(:,:), image(:,:,:), beam(:)
     &                      , paramspacemin(:), paramspacemax(:), x0o(:), y0o(:), sigglobal(:), goodness(:), space(:,:)
     &                      , coldens(:,:), tempers(:,:), chisqnu(:,:), fxterror(:), fxperror(:)
     
       parameter   ( sq_arcsecs_per_sterad = 3282.80635d0 * 3600.0d0**2, pi = 3.14159265358979d0, pio2 = pi / 2.0d0, muH2 = 2.8d0
     &             , pi2 = pi * 2.0d0, speedolight = 2.99792458d10, psunit = 60, almostzero = 1.0d-20, amu = 1.6605402D-24
     &             , Msun = 1.9891d33, pc = 3.085678d18, ldebug = .false., ltiming = .true., maxitref = 5, chisqfmax = 0.001d0 )

       common / copacity / frequency0, wavelength0, opacity0, dust2gas, lverbose

       external      graybody, thinbody, firstb, lastc, when, lastbs, fitfun, timer
!__________________________________________________________________________________________________________________________________
!                    
       iotty = 6
       yesno(1) = 'constant'
       yesno(2) = 'variable'

! Determine operating system

       call osystem ( lunix )

       call ftvers ( fitsvers )

       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       compda = __DATE__//' '//cfpptime

! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )

! Get command line parameters (file names).

       call getarg (  1, arg1 )
       call getarg (  2, arg2 )
       call getarg (  3, arg3 )
       call getarg (  4, arg4 )
       call getarg (  5, arg5 )
       call getarg (  6, arg6 )
       call getarg (  7, arg7 )
       call getarg (  8, arg8 )
       call getarg (  9, arg9 )
       call getarg ( 10, argA )
       call getarg ( 11, argB )
       call getarg ( 12, argC )
       call getarg ( 13, argD )

       ia1 = lastc ( arg1 )
       ia2 = lastc ( arg2 )
       ia3 = lastc ( arg3 )
       ia4 = lastc ( arg4 )
       ia5 = lastc ( arg5 )
       ia6 = lastc ( arg6 )
       ia7 = lastc ( arg7 )
       ia8 = lastc ( arg8 )
       ia9 = lastc ( arg9 )
       iaA = lastc ( argA )
       iaB = lastc ( argB )
       iaC = lastc ( argC )
       iaD = lastc ( argD )
       
       lverbose = '-verb2'
       if (iaD .gt. 0 .and. (argD(1:iaD-1) .eq. '-verb' .or. argD(1:iaD-1) .eq. '+verb')) lverbose = argD(1:iaD)
       if (iaC .gt. 0 .and. (argC(1:iaC-1) .eq. '-verb' .or. argC(1:iaC-1) .eq. '+verb')) lverbose = argC(1:iaC)
       if (iaB .gt. 0 .and. (argB(1:iaB-1) .eq. '-verb' .or. argB(1:iaB-1) .eq. '+verb')) lverbose = argB(1:iaB)
       if (iaA .gt. 0 .and. (argA(1:iaA-1) .eq. '-verb' .or. argA(1:iaA-1) .eq. '+verb')) lverbose = argA(1:iaA)
       
       if (lverbose(1:1) .eq. '+') then
         lpostscript = .true.
         lverbose(1:1) = '-'
       else
         lpostscript = .false.
       endif
       
       if (iotty .gt. 0) then
         write (iotty,'(/a$)') ' FITFLUXES = Fit Source Fluxes or Image Intensities = '//compda
       endif
       if (arg1(1:ia1) .eq. ':') stop
       if (iotty .gt. 0) then
         write (iotty,'()')
         write (iotty,'( a)') ' Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
         write (iotty,'( a)') ' Using MRQMIN from Numerical Recipes for F77 by William H Press et al.'
!!         write (iotty,'( a)') ' Using PSPLOT library by Kevin E Kohler adapted by Alexander Men`shchikov.'
!!         write (iotty,'( a)') ' Using AZEuS plotting routines by David Clarke & Alexander Men`shchikov.'
         if (iaA .eq. 0) then
           write (iotty,'(a)')
           write (iotty,'(a)') ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ USAGE ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
           write (iotty,'(a)')
           write (iotty,'(a)') ' fitfluxes {<number>|<xcoo>} {<sigmin>|<npart>|<ycoo>} {<goodmin>|<nparts>}'
           write (iotty,'(a)') '           [+|-]<n1>:<wave1>,[+|-]<n2>:<wave2>,...,[+|-]<nN>:<waveN>'
           write (iotty,'(a)') '           <snr1>:<adderr1>,<snr2>:<adderr2>,...,<snrN>:<adderrN>'
           write (iotty,'(a)') '           {thinbody|graybody}'
           write (iotty,'(a)') '           <pval1>:{1|0},<pval2>:{1|0},<pval3>:{1|0},<pval4>:{1|0}'
           write (iotty,'(a)') '           <distpc> <kappa0> <catalog> [-o <outname>] [{-|+}verb{0|1|2}]'
           write (iotty,'(a)')
           write (iotty,'(a)') ' This utility fits fluxes of sources from a catalog or of pixels from two or'
           write (iotty,'(a)') ' more images. The source catalogs must have column headers consistent with'
           write (iotty,'(a)') ' those found in the catalogs produced by GETSOURCES.'
!!           write (iotty,'(a)') ' The images must first be'
!!           write (iotty,'(a)') ' convolved to various band resolutions, preferably by using a Bash script'
!!           write (iotty,'(a)') ' HIRESCOLDENS to prepare and create higher-resolution column density images.'
           write (iotty,'(a)')
           write (iotty,'(a)') ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ PARAMETERS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
           write (iotty,'(a)')
           write (iotty,'(a)') ' {<number>|<xcoo>} .. number of a source/pixel to fit ("0" all sources/pixels)'
           write (iotty,'(a)') ' {<sigmin>|<npart>|<ycoo>} min source significance | part of all pixels to fit'
           write (iotty,'(a)') ' {<goodmin>|<nparts>} min global goodness | total number of equal parts'
           write (iotty,'(a)') ' [+|-]<n1>:<wave1> .. number & value of waveband1 (um); [+|-] to fit or skip'
           write (iotty,'(a)') ' [+|-]<n2>:<wave2> .. number & value of waveband2 (um); [+|-] to fit or skip'
           write (iotty,'(a)') ' [+|-]<nN>:<waveN> .. number & value of wavebandN (um); [+|-] to fit or skip'
           write (iotty,'(a)') ' <snr1>:<adderr1> ... min S/N ratio; additional flux uncertainty (relative)'
           write (iotty,'(a)') ' <snr2>:<adderr2> ... min S/N ratio; additional flux uncertainty (relative)'
           write (iotty,'(a)') ' <snrN>:<adderrN> ... min S/N ratio; additional flux uncertainty (relative)'
           write (iotty,'(a)') ' {thinbody|graybody}  name of the fitting model known to the code'
           write (iotty,'(a)') ' <pval1>:{<dlp1>|1|0} parameter1 value; dlogp1max or "1|0" (variable/constant)'
           write (iotty,'(a)') ' <pval2>:{<dlp2>|1|0} parameter2 value; dlogp2max or "1|0" (variable/constant)'
           write (iotty,'(a)') ' <pval3>:{<dlp3>|1|0} parameter3 value; dlogp3max or "1|0" (variable/constant)'
           write (iotty,'(a)') ' <pval4>:{<dlp4>|1|0} parameter4 value; dlogp4max or "1|0" (variable/constant)'
           write (iotty,'(a)') ' <distpc> ........... distance to sources (pc); for images, use <distpc> = 1'
           write (iotty,'(a)') ' <kappa0> ........... reference opacity value (per gram of *dust*) at 1000 GHz'
           write (iotty,'(a)') ' <catalog> .......... catalog of sources or images with proper column headers'
           write (iotty,'(a)') ' [-o <outname>] ..... optional base name of output files produced by the code'
           write (iotty,'(a)') ' [{-|+}verb{0|1|2}] . verbosity level; "+" to produce postscript (pdf) plots'
           write (iotty,'(a)')
           write (iotty,'(a)') ' Columns with headers NO, XCO_P, YCO_P, SIG_GLOB, GOOD, FXP_BEST##, FXP_ERRO##'
           write (iotty,'(a)') ' FXT_BEST##, FXT_ERRO## must be present in the catalog (## means the number of'
           write (iotty,'(a)') ' the waveband, with a leading zero). Columns SIG_MONO## (if present) will be'
           write (iotty,'(a)') ' used for selecting sources to be fitted.'
           write (iotty,'(a)')
           write (iotty,'(a)') ' The code can use upper limits (instead of fluxes) to constrain acceptable'
           write (iotty,'(a)') ' fits; the latter are required to always pass below upper limits. Users can'
           write (iotty,'(a)') ' add a "+" sign in front of flux values in the source catalog to indicate that'
           write (iotty,'(a)') ' they are upper limits (i.e., 35.647 is flux, but +35.647 is an upper limit).'
           write (iotty,'(a)')
           write (iotty,'(a)') ' Parameters of the thinbody model (for fitting sources): dust temperature (K),'
           write (iotty,'(a)') ' source mass (Msun), and opacity slope beta (> 0).'
           write (iotty,'(a)')
           write (iotty,'(a)') ' Parameters of the thinbody model (for fitting images): dust temperature (K),'
           write (iotty,'(a)') ' column density (cm^-2), and opacity slope beta (> 0).'
           write (iotty,'(a)')
           write (iotty,'(a)') ' Parameters of the graybody model (for fitting both sources and images): dust'
           write (iotty,'(a)') ' temperature (K), solid angle diameter (arcsec), column density (cm^-2), and'
           write (iotty,'(a)') ' opacity slope beta (> 0).'
           write (iotty,'(a)')
           write (iotty,'(a)') ' If a parameter value (pval1-pval4) is 0, then its optimal initial value for'
           write (iotty,'(a)') ' fitting is found by automatically exploring the multi-dimensional parameter'
           write (iotty,'(a)') ' space. The opacity slope is generally to be kept fixed and its actual value'
           write (iotty,'(a)') ' must be supplied in either pval3 or pval4. It is suggested that one always'
           write (iotty,'(a)') ' uses the default values by setting the parameters 0:1,0:1,2:0 (thinbody) or'
           write (iotty,'(a)') ' 0:1,0:1,0:1,2:0 (graybody).'
           write (iotty,'(a)')
           write (iotty,'(a)') ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ EXAMPLES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
           write (iotty,'(a)')
           write (iotty,'(a)') ' DERIVE PHYSICAL PARAMETERS FOR SOURCES FROM AN EXTRACTION CATALOG:'
           write (iotty,'(a)')
           write (iotty,'(a)') ' fitfluxes 0 1 1 -1:070,-2:160,3:250,4:350,5:500 1:0.2,1:0.15,1:0.1,1:0.1,1:0.1 thinbody'
     &                       //' 0:1,0:1,2:0 140 10 sky5.sw.final.relitent.ok.cat +verb2'
           write (iotty,'(a)') ' fitfluxes 0 1 1 -1:070,-2:160,3:250,4:350,5:500 1:0.2,1:0.15,1:0.1,1:0.1,1:0.1 graybody'
     &                       //' 0:1,0:1,0:1,2:0 140 10 sky5.sw.final.relitent.ok.cat +verb2'
!!           write (iotty,'(a)')
!!           write (iotty,'(a)') ' DERIVE COLUMN DENSITY IMAGE FROM PIXEL-BY-PIXEL FITTING OF IMAGES:'
!!           write (iotty,'(a)')
!!           write (iotty,'(a)') ' fitfluxes 0 0 0 -1:070,-2:160,3:250,4:350,5:500 1:0.2,1:0.2,1:0.2,1:0.2,1:0.2 thinbody'
!!     &                       //' 0:1,0:1,2:0 140 10 coldens.cfg -verb0'
!!           write (iotty,'(a)')
!!           write (iotty,'(a)') ' DERIVE COLUMN DENSITY VALUE BY FITTING A SINGLE PIXEL (51,73) OF IMAGES:'
!!           write (iotty,'(a)')
!!           write (iotty,'(a)') ' fitfluxes 51 73 0 -1:070,-2:160,3:250,4:350,5:500 1:0.2,1:0.2,1:0.2,1:0.2,1:0.2 thinbody'
!!     &                       //' 0:1,0:1,2:0 140 10 coldens.cfg +verb2'
!!           write (iotty,'(a)')
!!           write (iotty,'(a)') ' DERIVE COLUMN DENSITY IMAGE FROM PIXEL-BY-PIXEL FITTING OF LARGE IMAGES,'
!!           write (iotty,'(a)') ' ACCELERATING THE ENTIRE PROCESS BY SPLITTING IT IN 3 INDEPENDENT PARTS'
!!           write (iotty,'(a)') ' (PARALLEL JOBS):'
!!           write (iotty,'(a)')
!!           write (iotty,'(a)') ' fitfluxes 0 1 3 -1:070,-2:160,3:250,4:350,5:500 1:0.2,1:0.2,1:0.2,1:0.2,1:0.2 thinbody'
!!     &                       //' 0:1,0:1,2:0 140 10 coldens.cfg -verb0'
!!           write (iotty,'(a)') ' fitfluxes 0 2 3 -1:070,-2:160,3:250,4:350,5:500 1:0.2,1:0.2,1:0.2,1:0.2,1:0.2 thinbody'
!!     &                       //' 0:1,0:1,2:0 140 10 coldens.cfg -verb0'
!!           write (iotty,'(a)') ' fitfluxes 0 3 3 -1:070,-2:160,3:250,4:350,5:500 1:0.2,1:0.2,1:0.2,1:0.2,1:0.2 thinbody'
!!     &                       //' 0:1,0:1,2:0 140 10 coldens.cfg -verb0'
!!           write (iotty,'(a)')
!!           write (iotty,'(a)') ' PARTIAL IMAGES RESULTING FROM THE ABOVE SPLITTING CAN EASILY BE COMBINED'
!!           write (iotty,'(a)') ' INTO COMPLETE IMAGES USING THE OPERATE UTILITY OR HIRESCOLDENS SCRIPT.'
           write (iotty,'(a)')
           write (iotty,'(a)') ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
           stop 99
         endif
       endif  

       dust2gas = 0.01d0
       opacity0 = 10.0d0  !<-- Default value for opacity per gram of dust (cm^2/g).
       opaslope = 2.0d0   !<-- Default value for long-wavelengh opacity slope. 

       read (arg1(1:ia1),*,err=10) number
       read (arg2(1:ia2),*,err=12) sigmin
       read (arg3(1:ia3),*,err=14) goodmin
       read (arg8(1:ia8),*,err=16) distancepc
       read (arg9(1:ia9),*,err=18) opacity0
       
       callwaves = arg4(1:ia4)
       icw = ia4
       callsnerr = arg5(1:ia5)
       ics = ia5
       cmodel = arg6(1:ia6)
       icm = ia6
       callparams = arg7(1:ia7)
       icp = ia7
       excat = argA(1:iaA)
       iexc = iaA

! Check if the input file exists and open it.

       inquire ( file=excat(1:iexc), exist=lfname1 )
       
       if (excat(iexc-3:iexc) .eq. '.cfg') then
         limages = .true.
         if (lverbose .eq. '-verb0') then
           iolog = 3
         else
           iolog = 0
         endif
         npart = nint ( sigmin)
         nparts = nint ( goodmin )
         na = 1
         if (number .eq. 0 .and. npart .gt. nparts .and. iotty .gt. 0) then
           write (iotty,'(/a)') ' FITFLUXES: ERROR: number = 0 & npart > nparts...'
           stop 99
         endif
         if (number .ne. 0 .and. npart .eq. 0 .and. nparts .eq. 0) then
           iolog = 3
           write (cnumber,'(i8.8)') number
         else
           if (number .ne. 0 .and. npart .ne. 0 .and. nparts .eq. 0) then
             iolog = 3
             write (cnumber(1:4),'(i4.4)') number
             write (cnumber(5:8),'(i4.4)') npart
           endif
         endif
       else
         limages = .false.
         iolog = 3
         npart = 0
         nparts = 0
         na = 3
         write (cnumber,'(i8.8)') number
       endif

       if (limages .and. distancepc .gt. 1.001d0) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: For fitting images, the distance value must be 1.0'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: For fitting images, the distance value must be 1.0'
         if (iolog .gt. 0) close ( iolog )
         stop 99
       endif

       goto 100
  10   continue
         if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: Trouble getting NUMBER...'
         stop 99
  12   continue
         if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: Trouble getting SIGMIN...'
         stop 99
  14   continue
         if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: Trouble getting GOODMIN...'
         stop 99
  16   continue
         if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: Trouble getting DISTPC...'
         stop 99
  18   continue
         if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: Trouble getting KAPPA0...'
         stop 99
 100   continue
       
       if (argB(1:2) .eq. '-o') then
         outname = argC(1:iaC)//'.00'
       else
         outname = excat(1:iexc)//'.00'
       endif
       ion = lastc ( outname )
       
       prefix = cmodel(1:4)//'.'//outname(1:ion)
       ipr = lastc ( prefix )

       do i=0,99
         write (cno,'(i2.2)') i
         prefix = prefix(1:ipr-3)//'.'//cno
         inquire ( file=prefix(1:ipr)//'.log', exist=lfnameo )
         if (.not.lfnameo) then
           if (limages .and. npart .eq. 0) exit
           inquire ( file=prefix(1:ipr)//'.'//cnumber(na:)//'.log', exist=lfnameo )
           if (.not.lfnameo) exit
           do j=i+1,99
             write (cno,'(i2.2)') j
             prefix = prefix(1:ipr-3)//'.'//cno
             inquire ( file=prefix(1:ipr)//'.'//cnumber(na:)//'.log', exist=lfnameo )
             if (.not.lfnameo) goto 1 
           enddo
         endif
       enddo
  1    continue

       ipr = lastc ( prefix )
       if (number .gt. 0) then
         prefix = prefix(1:ipr)//'.'//cnumber(na:)
       endif
       ipr = lastc ( prefix )
       postscript = prefix(1:ipr)//'.ps'
       paramsfile = prefix(1:ipr)//'.spa'
       coldensity = prefix(1:ipr)//'.coldens.fits'
       temperatur = prefix(1:ipr)//'.tempers.fits'
       chisquarnu = prefix(1:ipr)//'.chisqnu.fits'
       paraspace  = prefix(1:ipr)//'.space.fits'
       ilp = lastc ( postscript )
       ilc = lastc ( coldensity )
       ilq = lastc ( chisquarnu )
       ilt = lastc ( temperatur )
       ils = lastc ( paramsfile )
       ile = lastc ( paraspace  )
       
       if (iolog .gt. 0) then
         open ( iolog, file=postscript(1:ilp-3)//'.log', status='unknown' )
       endif

       commandline = 'fitfluxes '//arg1(1:ia1)//' '//arg2(1:ia2)//' '//arg3(1:ia3)//' '//arg4(1:ia4)//' '//arg5(1:ia5)//' '
     &             //arg6(1:ia6)//' '//arg7(1:ia7)//' '//arg8(1:ia8)//' '//arg9(1:ia9)//' '//argA(1:iaA)//' '//argB(1:iaB)//' '
     &             //argC(1:iaC)//' '//argD(1:iaD)
       icl = lastc ( commandline )

       if (iolog .gt. 0) then
         write (iolog,'(a)') ' FITFLUXES = Fit Source Fluxes or Image Intensities = '//compda
         write (iolog,'(a)') ' Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
         write (iolog,'(a)') ' Using MRQMIN from Numerical Recipes for F77 by William H Press et al.'
!!         write (iolog,'(a)') ' Using PSPLOT library by Kevin E Kohler adapted by Alexander Men`shchikov.'
!!         write (iolog,'(a)') ' Using AZEuS plotting routines by David Clarke & Alexander Men`shchikov.'
         write (iolog,'( )')
         write (iolog,'(a)') ' '//commandline(1:icl)
       endif

       if (cmodel .ne. 'graybody' .and. cmodel .ne. 'thinbody') then
         if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: Unknown name of a fitting model: '//cmodel
         if (iolog .gt. 0) write (iolog,'(/a)') ' FITFLUXES: ERROR: Unknown name of a fitting model: '//cmodel
         if (iolog .gt. 0) close ( iolog )
         stop 99
       endif
       if (.not.lfname1) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: File '''//excat(1:iexc)//''' not found.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' FITFLUXES: ERROR: File '''//excat(1:iexc)//''' not found.'
         if (iolog .gt. 0) close ( iolog )
         stop 1
       endif
       
       open ( 15, file=excat(1:iexc), status='old' )

       call skipcomm ( 15, excat(1:iexc), nhead )
       call linescolumns ( 15, excat(1:iexc), nhead, nextr, ncolumns )

       rewind ( 15 )
       do k=1,nhead
         read (15,'(a)') headline(k)
         lhl = lastc ( headline(k) )
         if (lhl .gt. 5) nhcols = k
       enddo
       lhl = lastc ( headline(nhcols) )
       solidapixel = 0.0d0

       if (limages) then
         read (15,*,err=333) wave, beam1, offset, filename
         goto 334
 333     continue
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble reading '''//excat(1:iexc)//'''...'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble reading '''//excat(1:iexc)//'''...'
         if (iolog .gt. 0) close ( iolog )
         stop 333
 334     continue
         backspace ( 15 )

         lhl = lastc ( filename )

! Check if the input file exists and open it.

         inquire ( file=filename(1:lhl), exist=lfname2 )
         
         if (.not.lfname2) then
           if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: File '''//filename(1:lhl)//''' not found.'
           if (iolog .gt. 0) write (iolog,'(/a)') ' FITFLUXES: ERROR: File '''//filename(1:lhl)//''' not found.'
           if (iolog .gt. 0) close ( iolog )
           stop 2
         endif

! Determine numbers of pixels in the first FITS image.
  
         call getpixels ( filename(1:lhl), nx1, ny1, dx, dy )

         solidapixel = dx * dy / sq_arcsecs_per_sterad
         nx0o = 1
         ny0o = 1
         if (number .ne. 0 .and. npart .eq. 0 .and. nparts .eq. 0) then
           ny0o = dble ( (number - 1) / nx1 ) + 1
           nx0o = dble ( number ) - dble ( nx1 ) * (ny0o - 1)
         endif
         if (number .ne. 0 .and. npart .ne. 0 .and. nparts .eq. 0) then
           nx0o = number
           ny0o = npart
           number = (ny0o - 1) * nx1 + nx0o
           npart = 0
           arg2 = '0'
           ia2 = 1
         endif
         write (cx,'(i4)') nx0o
         write (cy,'(i4)') ny0o
         ncx = int ( log10 ( dble ( nx0o ) ) ) + 1
         ncy = int ( log10 ( dble ( ny0o ) ) ) + 1
       endif
       write (cnsrc,'(i10)') number
       if (number .ne. 0) then
         nn = int ( log10 ( dble ( number ) ) ) + 1
       else
         nn = 1
       endif

       if (ltiming) then
         cpu = 0.0d0
         wal = 0.0d0
         cpu_sum = 0.0d0
         wal_sum = 0.0d0
         if (iotty .gt. 0) write (iotty,'(/a)') ' STARTED: '//cdate//' '//ctime
         if (iolog .gt. 0) write (iolog,'(/a)') ' STARTED: '//cdate//' '//ctime
       endif
       if (iotty .gt. 0) write (iotty,'(a)') ' ______________________________________________________________________________'
       if (iolog .gt. 0) write (iolog,'(a)') ' ______________________________________________________________________________'

! Report accepted values of the command-line parameters.

       if (number .ne. 0) then
         if (.not.limages) then
           if (iotty .gt. 0) write (iotty,'(/a)') ' Fitting flux distribution for single source # '//cnsrc(10-nn+1:10)//'...'
           if (iolog .gt. 0) write (iolog,'(/a)') ' Fitting flux distribution for single source # '//cnsrc(10-nn+1:10)//'...'
         else
           if (iotty .gt. 0) write (iotty,'(/a)') ' Fitting flux distribution for single pixel # '//cnsrc(10-nn+1:10)//' ('
     &                                          //cx(4-ncx+1:4)//','//cy(4-ncy+1:4)//')...'
           if (iolog .gt. 0) write (iolog,'(/a)') ' Fitting flux distribution for single pixel # '//cnsrc(10-nn+1:10)//' ('
     &                                          //cx(4-ncx+1:4)//','//cy(4-ncy+1:4)//')...'
         endif
       else
         if (.not.limages) then
           if (iotty .gt. 0) write (iotty,'(/a)') ' Fitting flux distributions for all selected sources...'
           if (iolog .gt. 0) write (iolog,'(/a)') ' Fitting flux distributions for all selected sources...'
         else
           if (npart .eq. 0) then
             if (iotty .gt. 0) write (iotty,'(/a)') ' Fitting intensities for all pixels of images...'
             if (iolog .gt. 0) write (iolog,'(/a)') ' Fitting intensities for all pixels of images...'
           else
             if (iotty .gt. 0) write (iotty,'(/a)') ' Fitting intensities for selected pixels of images...'
             if (iolog .gt. 0) write (iolog,'(/a)') ' Fitting intensities for selected pixels of images...'
           endif
         endif
       endif
       if (.not.limages) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' Selection of sources: ... global significance > '//arg2(1:ia2)
         if (iolog .gt. 0) write (iolog,'(/a)') ' Selection of sources: ... global significance > '//arg2(1:ia2)
         if (iotty .gt. 0) write (iotty,'(a )') ' Selection of sources: ....... global goodness > '//arg3(1:ia3)
         if (iolog .gt. 0) write (iolog,'(a )') ' Selection of sources: ....... global goodness > '//arg3(1:ia3)
       else
         if (iotty .gt. 0) write (iotty,'(/a)') ' Selection of pixels: .... selected part number: '//arg2(1:ia2)
         if (iolog .gt. 0) write (iolog,'(/a)') ' Selection of pixels: .... selected part number: '//arg2(1:ia2)
         if (iotty .gt. 0) write (iotty,'(a )') ' Selection of pixels: ... total number of parts: '//arg3(1:ia3)
         if (iolog .gt. 0) write (iolog,'(a )') ' Selection of pixels: ... total number of parts: '//arg3(1:ia3)
       endif

! Specify all wavelengths for fitting.

       n1 = 1
       n2 = 1
       n3 = 0
       nbands = 0
       do i=1,100
         n2 = index ( callwaves(n1:icw), ':' )
         n3 = index ( callwaves(n1:icw), ',' )
         if (n2 .gt. 0 .and. n3 .gt. 0) then
           n2 = n1 - 1 + n2
           n3 = n1 - 1 + n3
           read (callwaves(n1:n2-1  ),*,err=30,end=30) nband(i)
           read (callwaves(n2+1:n3-1),*,err=30,end=30) waveband(i)
           csnband(i) = ''
           if (callwaves(n1:n1) .eq. '+') csnband(i) = '+'
           if (callwaves(n1:n1) .eq. '-') csnband(i) = '-'
           nband(i) = abs ( nband(i) )
           n1 = n3 + 1
         else
           n2 = n1 - 1 + n2
           read (callwaves(n1:n2-1 ),*,err=30,end=30) nband(i)
           read (callwaves(n2+1:icw),*,err=30,end=30) waveband(i)
           csnband(i) = ''
           if (callwaves(n1:n1) .eq. '+') csnband(i) = '+'
           if (callwaves(n1:n1) .eq. '-') csnband(i) = '-'
           nband(i) = abs ( nband(i) )
           nbands = i
         endif
         if (nbands .eq. i) exit
       enddo

       goto 33
 30    continue
         if (iotty .gt. 0) write (iotty,'(a)')  ' FITFLUXES: ERROR: Trouble getting wavelengths.'
         if (iolog .gt. 0) write (iolog,'(a)')  ' FITFLUXES: ERROR: Trouble getting wavelengths.'
         if (iolog .gt. 0) close ( iolog )
         stop 99
 33    continue  
       if (nbands .le. 1) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Too few wavebands for fitting.'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Too few wavebands for fitting.'
         if (iolog .gt. 0) close ( iolog )
         stop 99
       endif
       
! Specify selection S/N and additional errors, such as calibration uncertainties, for each band.

       n1 = 1
       n2 = 1
       n3 = 0
       nbande = 0
       if (iotty .gt. 0) write (iotty,'()')
       if (iolog .gt. 0) write (iolog,'()')
       do i=1,100
         n2 = index ( callsnerr(n1:ics), ':' )
         n3 = index ( callsnerr(n1:ics), ',' )
         if (n2 .gt. 0 .and. n3 .gt. 0) then
           n2 = n1 - 1 + n2
           n3 = n1 - 1 + n3
           read (callsnerr(n1:  n2-1),*,err=30,end=30) snrmin(i)
           read (callsnerr(n2+1:n3-1),*,err=30,end=30) adderro(i)
           n1 = n3 + 1
         else
           n2 = n1 - 1 + n2
           read (callsnerr(n1: n2-1),*,err=30,end=30) snrmin(i)
           read (callsnerr(n2+1:ics),*,err=30,end=30) adderro(i)
           nbande = i
         endif
         if (iotty .gt. 0) write (iotty,'(a,i2.2,i4,a,f5.2,a,f4.1)')  ' Waveband'//csnband(i), nband(i), nint( waveband(i) )
     &                                 , ' um, additional relative error:', adderro(i), ', peak S/N >', snrmin(i)
         if (iolog .gt. 0) write (iolog,'(a,i2.2,i4,a,f5.2,a,f4.1)')  ' Waveband'//csnband(i), nband(i), nint( waveband(i) )
     &                                   , ' um, additional relative error:', adderro(i), ', peak S/N >', snrmin(i)
         if (nbande .eq. i) exit                                                                 
       enddo
       
       goto 44
 40    continue
       if (i .lt. nbands) then
         if (iotty .gt. 0) write (iotty,'(a)')  ' FITFLUXES: ERROR: Trouble getting additional errors.'
         if (iolog .gt. 0) write (iolog,'(a)')  ' FITFLUXES: ERROR: Trouble getting additional errors.'
         if (iolog .gt. 0) close ( iolog )
         stop 99
       endif
 44    continue
       if (nbande .ne. nbands) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Invalid number of additional errors.'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Invalid number of additional errors.'
         if (iolog .gt. 0) close ( iolog )
         stop 99
       else
         if (iotty .gt. 0) write (iotty,'()')
         if (iolog .gt. 0) write (iolog,'()')
       endif
       
       opacityrelerr = 0.2d0
       dustgasrelerr = 0.2d0
       distancrelerr = 0.2d0

       if (iotty .gt. 0) then
         write (iotty,'(a,f5.2)') ' Adopted relative error in dust-to-gas ratio: ...', dustgasrelerr
         write (iotty,'(a,f5.2)') ' Adopted relative error in reference opacity: ...', opacityrelerr
         write (iotty,'(a,f5.2)') ' Adopted relative error in distance: ............', distancrelerr
       endif
       if (iolog .gt. 0) then
         write (iolog,'(a,f5.2)') ' Adopted relative error in dust-to-gas ratio: ...', dustgasrelerr
         write (iolog,'(a,f5.2)') ' Adopted relative error in reference opacity: ...', opacityrelerr
         write (iolog,'(a,f5.2)') ' Adopted relative error in distance: ............', distancrelerr
       endif

       allocate ( ncolsig(nbands), ncolfxp(nbands), ncolfxt(nbands), ncolsnr(nbands), ncolfpe(nbands), ncolfte(nbands)
     &          , snrpeak(nbands), snrtotal(nbands), frequency(nbands), fxpbest(nbands), fxperro(nbands), fxtbest(nbands)
     &          , fxterro(nbands), opacity(nbands), sedslope(nbands), wavelength(nbands), sfrequency(nbands), sfxtbest(nbands)
     &          , sfxterro(nbands), sigmono(nbands), beam(nbands), fxperror(nbands), fxterror(nbands), uplimit(nbands), stat=irc )

       if (irc .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (5).'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (5).'
         if (iolog .gt. 0) close ( iolog )
         stop 5
       endif
       
       do i=1,nbands
         wavelength(i) = waveband(i)
       enddo
       do i=1,4
         ivarornot(i) = 0
         modparams1(i) = 0.0d0
         modparams2(i) = 0.0d0
         dlogp(i) = 0.0d0
         dlogpmax(i) = 0.0d0
       enddo
       do i=1,100
         quantities(i) = 0.0d0
       enddo

! Number of parameters NMODPARAMS in the fitting model can take values of only 2 or 4.
! Specify if the corresponding fitting parameter should be varied during the fitting (=1) or held fixed (=0).

       n1 = 1
       n2 = 1
       n3 = 0
       nm = 0
       nmodparams = 0
       do i=1,4
         n2 = index ( callparams(n1:icp), ':' )
         n3 = index ( callparams(n1:icp), ',' )
         nm = index ( callparams(n1:icp), '~' )
         if (n2 .gt. 0 .and. n3 .gt. 0) then
           n2 = n1 - 1 + n2
           n3 = n1 - 1 + n3
           if (nm .gt. 0) then
             nm = n1 - 1 + nm
           else
             nm = n2
           endif
           read (callparams(n1:nm-1  ),*) modparams1(i)
           read (callparams(n2+1:n3-1),*) dlogpmax(i)
           if (dlogpmax(i) .gt. almostzero) then
             ivarornot(i) = 1
           else
             ivarornot(i) = 0
           endif
           n1 = n3 + 1
         else
           n2 = n1 - 1 + n2
           if (nm .gt. 0) then
             nm = n1 - 1 + nm
           else
             nm = n2
           endif
           read (callparams(n1:nm-1 ),*) modparams1(i)
           read (callparams(n2+1:icp),*) dlogpmax(i)
           if (dlogpmax(i) .gt. almostzero) then
             ivarornot(i) = 1
           else
             ivarornot(i) = 0
           endif
           nmodparams = i
         endif
         if (nm .lt. n2) then
           read (callparams(nm+1:n2-1),*) modparams2(i)
         else
           modparams2(i) = modparams1(i)
         endif
         if (nmodparams .eq. i) exit
       enddo
       
       if (cmodel .eq. 'thinbody') then
         nmodparams = max ( nmodparams, 4 )
       endif       
       if (limages .and. cmodel .eq. 'graybody') then
         ivarornot(2) = 0
       endif       
       
       if (nmodparams .le. 1 .or. nmodparams .gt. 4) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Invalid number of parameters (must be 2 or 4).'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Invalid number of parameters (must be 2 or 4).'
         if (iolog .gt. 0) close ( iolog )
         stop 99
       endif
       
! Prepare the header of the output parameter space file for all selected sources.

       if (ldebug) then
         open ( 55, file=paramsfile(1:ils), status='unknown' )

         write (55,'(a)') '# FITFLUXES = Fit Source Fluxes or Image Intensities = '//compda
         write (55,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
         write (55,'(a)') '# Using MRQMIN from Numerical Recipes for F77 by William H Press et al.'
!!         write (55,'(a)') '# Using PSPLOT library by Kevin E Kohler adapted by Alexander Men`shchikov.'
!!         write (55,'(a)') '# Using AZEuS plotting routines by David Clarke & Alexander Men`shchikov.'
         write (55,'(a)') '#'
         write (55,'(a)') '# '//commandline(1:icl)
       endif

! Prepare the header of the output data file with results of final fitting for all selected sources.

       if (.not.limages) then
         open ( 66, file=postscript(1:ilp-3)//'.dat', status='unknown' )
 
         write (66,'(a)') '# FITFLUXES = Fit Source Fluxes or Image Intensities = '//compda
         write (66,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
         write (66,'(a)') '# Using MRQMIN from Numerical Recipes for F77 by William H Press et al.'
!!         write (66,'(a)') '# Using PSPLOT library by Kevin E Kohler adapted by Alexander Men`shchikov.'
!!         write (66,'(a)') '# Using AZEuS plotting routines by David Clarke & Alexander Men`shchikov.'
         write (66,'(a)') '#'
         write (66,'(a)') '# OBSERVED FLUXES AND FITTED FUNCTIONS FOR SELECTED SOURCES OR IMAGE PIXELS'
         write (66,'(a)') '#'
         write (66,'(a)') '# '//commandline(1:icl)
         write (66,'(a)') '#'
         write (66,'(a)') '# Input catalog: '//excat(1:iexc)
         write (66,'(a)') '#  Output files: '//prefix(1:ipr)//'.*'
 
         write (66,'(a)') '#'
         if (.not.limages) then
         write (66,'(a)') '# Selected sources: ... global significance > '//arg2(1:ia2)
         write (66,'(a)') '# Selected sources: ....... global goodness > '//arg3(1:ia3)
         else
         write (66,'(a)') '# Selected pixels: ......... part of all pixels to fit: '//arg2(1:ia2)
         write (66,'(a)') '# Selected pixels: ... number of equal parts of pixels: '//arg3(1:ia3)
         endif
         write (66,'(a)') '#'
         write (66,'(a,50(1pe9.2))') '#  Wavebands for SED fitting:', (waveband(i),i=1,nbands)
         write (66,'(a,50(1pe9.2))') '# Additional relative errors:', (adderro(i),i=1,nbands)
         write (66,'(a)') '#'
         write (66,'(a,1pe9.2)') '# Assumed relative error in dust-to-gas ratio:', dustgasrelerr
         write (66,'(a,1pe9.2)') '# Assumed relative error in reference opacity:', opacityrelerr
         write (66,'(a,1pe9.2)') '# Assumed relative error in distance estimate:', distancrelerr
         write (66,'(a)') '#'
         if (cmodel .eq. 'graybody') then
         write (66,'(a)') '# Fitting model: '//cmodel//' ~> Fnu = Bnu(T) (1-exp(-tau)) Omega'
         write (66,'(a)') '#'
         write (66,'(a)') '# 1st parameter ...... temperature: '//yesno(ivarornot(1)+1)
         write (66,'(a)') '# 2nd parameter ...... solid angle: '//yesno(ivarornot(2)+1)
         write (66,'(a)') '# 3rd parameter ... column density: '//yesno(ivarornot(3)+1)
         write (66,'(a)') '# 4th parameter .... opacity slope: '//yesno(ivarornot(4)+1)
         endif
         if (cmodel .eq. 'thinbody') then
         write (66,'(a)') '# Fitting model: '//cmodel//' ~> Fnu = Bnu(T) kappa M D^-2'
         write (66,'(a)') '#'
         write (66,'(a)') '# 1st parameter ..... temperature: '//yesno(ivarornot(1)+1)
         if (.not.limages) then
         write (66,'(a)') '# 2nd parameter ...... total mass: '//yesno(ivarornot(2)+1)
         else
         write (66,'(a)') '# 2nd parameter .. column density: '//yesno(ivarornot(2)+1)
         endif
         write (66,'(a)') '# 3rd parameter ... opacity slope: '//yesno(ivarornot(3)+1)
         write (66,'(a)') '# 4th parameter ........ distance: '//yesno(ivarornot(4)+1)
         endif
         write (66,'(a)') '#'
         write (66,'(a)') '# Tabulated quantities:'
         write (66,'(a)') '#'
         write (66,'(a)') '#   NO ................ Point number'
         write (66,'(a)') '#   WAVEO ............. Observed wavelength (um)'
         write (66,'(a)') '#   OBSFLUX ........... Observed fluxes or intensities (Jy, Jy/sr)'
         write (66,'(a)') '#   WAVEOF ............ Observed wavelength to fit (um)'
         write (66,'(a)') '#   OBSFLUXF .......... Observed fluxes or intensities to fit (Jy, Jy/sr)'
         if (cmodel .eq. 'graybody') then
         write (66,'(a)') '#   WAVEG ............. Wavelength for graybody (um)'
         write (66,'(a)') '#   GRAYBODY .......... Fitted graybody fluxes or intensities (Jy, Jy/sr)'
         endif
         if (cmodel .eq. 'thinbody') then
         write (66,'(a)') '#   WAVEM ............. Wavelength for thinbody (um)'
         write (66,'(a)') '#   THINBODY .......... Fitted thinbody fluxes or intensities (Jy, Jy/sr)'
         endif
         write (66,'(a)') '#   WAVEB ............. Wavelength for blackbody (um)'
         write (66,'(a)') '#   BLACKBODY ......... Blackbody at derived temperature (scaled)'
         write (66,'(a)') '#   WAVER ............. Wavelength for Rayleigh-Jeans (um)'
         write (66,'(a)') '#   RAY-JEANS ......... Rayleigh-Jeans approximation (scaled)'
       endif

! Prepare the header of the output catalog with derived parameters for all selected sources.

       if (.not.limages) then
         open ( 77, file=postscript(1:ilp-3)//'.cat', status='unknown' )

           write (77,'(a)') '# FITFLUXES = Fit Source Fluxes or Image Intensities = '//compda
         write (77,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
         write (77,'(a)') '# Using MRQMIN from Numerical Recipes for F77 by William H Press et al.'
!!         write (77,'(a)') '# Using PSPLOT library by Kevin E Kohler adapted by Alexander Men`shchikov.'
!!         write (77,'(a)') '# Using AZEuS plotting routines by David Clarke & Alexander Men`shchikov.'
         write (77,'(a)') '#'
         write (77,'(a)') '# CATALOG OF DERIVED QUANTITIES FOR SELECTED SOURCES OR IMAGE PIXELS'
         write (77,'(a)') '#'
         write (77,'(a)') '# '//commandline(1:icl)
         write (77,'(a)') '#'
         write (77,'(a)') '# Input catalog: '//excat(1:iexc)
         write (77,'(a)') '#  Output files: '//prefix(1:ipr)//'.*'
         write (77,'(a)') '#'
         if (.not.limages) then
         write (77,'(a)') '# Selected sources: ... global significance > '//arg2(1:ia2)
         write (77,'(a)') '# Selected sources: ....... global goodness > '//arg3(1:ia3)
         else
         write (77,'(a)') '# Selected pixels: ......... part of all pixels to fit: '//arg2(1:ia2)
         write (77,'(a)') '# Selected pixels: ... number of equal parts of pixels: '//arg3(1:ia3)
         endif
         write (77,'(a)') '#'
         write (77,'(a,50(1pe9.2))') '#  Wavebands for SED fitting:', (waveband(i),i=1,nbands)
         write (77,'(a,50(1pe9.2))') '# Additional relative errors:', (adderro(i),i=1,nbands)
         write (77,'(a)') '#'
         write (77,'(a,1pe9.2)') '# Assumed relative error in dust-to-gas ratio:', dustgasrelerr
         write (77,'(a,1pe9.2)') '# Assumed relative error in reference opacity:', opacityrelerr
         write (77,'(a,1pe9.2)') '# Assumed relative error in distance estimate:', distancrelerr
         write (77,'(a)') '#'
         if (cmodel .eq. 'graybody') then
         write (77,'(a)') '# Fitting model: '//cmodel//' ~> Fnu = Bnu(T) (1-exp(-tau)) Omega'
         write (77,'(a)') '#'
         write (77,'(a)') '# 1st parameter ...... temperature: '//yesno(ivarornot(1)+1)
         write (77,'(a)') '# 2nd parameter ...... solid angle: '//yesno(ivarornot(2)+1)
         write (77,'(a)') '# 3rd parameter ... column density: '//yesno(ivarornot(3)+1)
         write (77,'(a)') '# 4th parameter .... opacity slope: '//yesno(ivarornot(4)+1)
         endif
         if (cmodel .eq. 'thinbody') then
         write (77,'(a)') '# Fitting model: '//cmodel//' ~> Fnu = Bnu(T) kappa M D^-2'
         write (77,'(a)') '#'
         write (77,'(a)') '# 1st parameter ..... temperature: '//yesno(ivarornot(1)+1)
         if (.not.limages) then
         write (77,'(a)') '# 2nd parameter ...... total mass: '//yesno(ivarornot(2)+1)
         else
         write (77,'(a)') '# 2nd parameter .. column density: '//yesno(ivarornot(2)+1)
         endif
         write (77,'(a)') '# 3rd parameter ... opacity slope: '//yesno(ivarornot(3)+1)
         write (77,'(a)') '# 4th parameter ........ distance: '//yesno(ivarornot(4)+1)
         endif
         write (77,'(a)') '#'
         write (77,'(a)') '# Tabulated quantities:'
         write (77,'(a)') '#'
         write (77,'(a)') '#  1 NO .......... Input catalog source or image pixel number ...........'
         write (77,'(a)') '#  2 XCO_P ....... X-coordinate of current source or pixel .............. pixels'
         write (77,'(a)') '#  3 YCO_P ....... Y-coordinate of current source or pixel .............. pixels'
         write (77,'(a)') '#  4 SIG_GLOB .... Global significance or part of all pixels to fit .....'
         write (77,'(a)') '#  5 GOOD ........ Global goodness or number of equal parts of pixels ...'
         write (77,'(a)') '#  6 DUST_TEMP ... Derived dust temperature of source or pixel .......... K'
         write (77,'(a)') '#  7 TEMP_ERRO ... Uncertainty of derived temperature ................... K'
         if (cmodel .eq. 'graybody') then
         write (77,'(a)') '#  8 TOTL_MASS ... Derived total mass (gas+dust) of source .............. Msun'
         write (77,'(a)') '#  9 MASS_ERRO ... Uncertainty of derived total mass .................... Msun'
         endif
         if (cmodel .eq. 'thinbody') then
         if (.not.limages) then
         write (77,'(a)') '#  8 TOTL_MASS ... Derived total mass (gas+dust) of source .............. Msun'
         write (77,'(a)') '#  9 MASS_ERRO ... Uncertainty of derived total mass .................... Msun'
         else
         write (77,'(a)') '#  8 COLUMN_DE ... Derived column density of source or pixel ............ cm^-2'
         write (77,'(a)') '#  9 COLD_ERRO ... Uncertainty of derived column density ................ cm^-2'
         endif
         endif
         write (77,'(a)') '# 10 BOLO_LUMI ... Derived bolometric luminosity ........................ Lsun'
         write (77,'(a)') '# 11 LUMI_ERRO ... Uncertainty of derived luminosity .................... Lsun'
         write (77,'(a)') '# 12 SLD_ANGLE ... Derived solid angle (diameter) ....................... arcsec'
         write (77,'(a)') '# 13 ANGL_ERRO ... Uncertainty of derived solid angle ................... arcsec'
         write (77,'(a)') '# 14 COLUMN_DE ... Derived column density of source or pixel ............ cm^-2'
         write (77,'(a)') '# 15 COLD_ERRO ... Uncertainty of derived column density ................ cm^-2'
         write (77,'(a)') '# 16 OPA_BETA .... Derived (or assumed) opacity slope ...................'
         write (77,'(a)') '# 17 BETA_ERRO ... Uncertainty of derived slope .........................'
         write (77,'(a)') '# 18 DISTANCE .... Derived (or assumed) distance ........................ pc'
         write (77,'(a)') '# 19 DIST_ERRO ... Uncertainty of derived distance ...................... pc'
         write (77,'(a)') '# 20 WAVE_TAU1 ... Wavelength where optical depth tau=1 ................. um'
         write (77,'(a)') '# 21 CHISQUARE ... Actual chi^2 value of the fit ........................'
         write (77,'(a)') '# 22 DEG_FREED ... Degrees of freedom of the fit ........................'
         write (77,'(a)') '#'
         write (77,'(a)') '#    1      2       3        4        5          6         7          8         9         10        11'
     &                  //'         12        13         14        15         16        17         18        19         20'
     &                  //'        21        22'
         if (cmodel .eq. 'graybody') then
         write (77,'(a)') '#   NO    XCO_P   YCO_P  SIG_GLOB   GOOD    DUST_TEMP TEMP_ERRO  TOTL_MASS MASS_ERRO  BOLO_LUMI'
     &                  //' LUMI_ERRO  SLD_ANGLE ANGL_ERRO   COLUMN_D COLD_ERRO   OPA_BETA BETA_ERRO   DISTANCE DIST_ERRO'
     &                  //'  WAVE_TAU1 CHISQUARE DEG_FREED'
         endif
         if (cmodel .eq. 'thinbody') then
         if (.not.limages) then
         write (77,'(a)') '#   NO    XCO_P   YCO_P  SIG_GLOB   GOOD    DUST_TEMP TEMP_ERRO  TOTL_MASS MASS_ERRO  BOLO_LUMI'
     &                  //' LUMI_ERRO  SLD_ANGLE ANGL_ERRO   COLUMN_D COLD_ERRO   OPA_BETA BETA_ERRO   DISTANCE DIST_ERRO'
     &                  //'  WAVE_TAU1 CHISQUARE DEG_FREED'
         else
         write (77,'(a)') '#   NO    XCO_P   YCO_P  SIG_GLOB   GOOD    DUST_TEMP TEMP_ERRO  COLUMN_DE COLD_ERRO  BOLO_LUMI'
     &                  //' LUMI_ERRO  SLD_ANGLE ANGL_ERRO  COLUMN_DE COLD_ERRO   OPA_BETA BETA_ERRO   DISTANCE DIST_ERRO'
     &                  //'  WAVE_TAU1 CHISQUARE DEG_FREED'
         endif
         endif
         write (77,'(a)') '#'
       endif

       allocate ( fitparameters(nmodparams), ipfitornot(nmodparams), dyda(nmodparams), covar(nmodparams,nmodparams)
     &          , alpha(nmodparams,nmodparams), paramspacemin(nmodparams), paramspacemax(nmodparams), stat=irc )

       if (irc .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (6).'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (6).'
         if (iolog .gt. 0) close ( iolog )
         stop 6
       endif

       frequency0 = 1.0d12
       wavelength0 = 1.0d4 * speedolight / frequency0
       
! Actual number of fitting parameters.

       nfitparams = 0
       do i=1,nmodparams
         ipfitornot(i) = ivarornot(i)
         nfitparams = nfitparams + ipfitornot(i)
       enddo

! Create grid over the entire multidimensional parameter space.

       punits(1) = ' K'
       if (cmodel .eq. 'graybody') then
         punits(2) = ' arcsec'
         punits(3) = ' cm^-2'
         punits(4) = ''
       endif
       if (cmodel .eq. 'thinbody') then
         punits(2) = ' Msun'
         punits(3) = ''
         punits(4) = ' cm'
       endif
       
! Default and maximum steps over parameter space.
       
       if (abs ( dlogpmax(1) - 1.0d0 ) .lt. 0.00001d0) then
         if (     limages) dlogpmax(1) = 0.5d0
         if (.not.limages) dlogpmax(1) = 0.1d0
       else
         dlogpmax(1) = min ( dlogpmax(1), 1.0d0 )
       endif
       if (abs ( dlogpmax(2) - 1.0d0 ) .lt. 0.00001d0) then
         if (     limages) dlogpmax(2) = 0.5d0
         if (.not.limages) dlogpmax(2) = 0.1d0
       else
         dlogpmax(2) = min ( dlogpmax(2), 1.0d0 )
       endif
       if (abs ( dlogpmax(3) - 1.0d0 ) .lt. 0.00001d0) then
         if (     limages) dlogpmax(3) = 0.5d0
         if (.not.limages) dlogpmax(3) = 0.1d0
       else
         dlogpmax(3) = min ( dlogpmax(3), 1.0d0 )
       endif
       if (abs ( dlogpmax(4) - 1.0d0 ) .lt. 0.00001d0) then
         if (     limages) dlogpmax(4) = 0.5d0
         if (.not.limages) dlogpmax(4) = 0.1d0
       else
         dlogpmax(4) = min ( dlogpmax(4), 1.0d0 )
       endif

       npar(1) = 1
       nparmx(1) = 1
       if (modparams1(1) .lt. almostzero .and. modparams2(1) .lt. almostzero) then
         modparam1(1) = 4.0d0
         modparam2(1) = 1000.0d0
       else
         modparam1(1) = modparams1(1)
         modparam2(1) = modparams2(1)
       endif
       if (ipfitornot(1) .eq. 1) then
         nparmx(1) = 2**(maxitref)
       endif
       
       npar(2) = 1
       nparmx(2) = 1
       if (modparams1(2) .lt. almostzero .and. modparams2(2) .lt. almostzero) then
         if (cmodel .eq. 'graybody') then
           punits(2) = ' ster'
           if (limages) then
             modparam1(2) = 2.0d0 * sqrt ( solidapixel * sq_arcsecs_per_sterad / pi )  !<- equivalent pixel diameter in arcseconds
             modparam2(2) = modparam1(2)
             dlogpmax(2) = 0.0d0
           else
             modparam1(2) = 1.0d-2  !<- diameter in arcseconds
             modparam2(2) = 1.0d+6  !<- diameter in arcseconds
           endif
           modparam1(2) = pi * (modparam1(2) / 2.0d0)**2 / sq_arcsecs_per_sterad  !<- solid angle in steradians
           modparam2(2) = pi * (modparam2(2) / 2.0d0)**2 / sq_arcsecs_per_sterad  !<- solid angle in steradians
         endif
         if (cmodel .eq. 'thinbody') then
           if (distancepc .gt. 1.0001d0) then
             punits(2) = ' g'
             modparam1(2) = 3.0d-8 * Msun
             modparam2(2) = 3.0d+2 * Msun
           else
             punits(2) = ' cm^-2'
             modparam1(2) = 1.0d17
             modparam2(2) = 1.0d27
           endif
         endif
       else
         if (cmodel .eq. 'graybody') then
           punits(2) = ' ster'
           modparam1(2) = pi * (modparams1(2) / 2.0d0)**2 / sq_arcsecs_per_sterad
           modparam2(2) = pi * (modparams2(2) / 2.0d0)**2 / sq_arcsecs_per_sterad
         endif
         if (cmodel .eq. 'thinbody') then
           if (distancepc .gt. 1.0001d0) then
             punits(2) = ' g'
             modparam1(2) = modparams1(2)
             modparam2(2) = modparams2(2)
           else
             punits(2) = ' cm^-2'
             modparam1(2) = modparams1(2)
             modparam2(2) = modparams2(2)
           endif
         endif
       endif
       if (ipfitornot(2) .eq. 1) then
         nparmx(2) = 2**(maxitref)
       endif

       npar(3) = 1
       nparmx(3) = 1
       if (modparams1(3) .lt. almostzero .and. modparams2(3) .lt. almostzero) then
         if (cmodel .eq. 'graybody') then
           punits(3) = ' cm^-2'
           modparam1(3) = 1.0d17
           modparam2(3) = 1.0d27
         endif
         if (cmodel .eq. 'thinbody') then
           modparam1(3) = 1.0d0
           modparam2(3) = 4.0d0
         endif
       else
         modparam1(3) = modparams1(3)
         modparam2(3) = modparams2(3)
       endif
       if (ipfitornot(3) .eq. 1) then
         nparmx(3) = 2**(maxitref)
       endif

       npar(4) = 1
       nparmx(4) = 1
       if (modparams1(4) .lt. almostzero .and. modparams2(4) .lt. almostzero) then
         if (cmodel .eq. 'graybody') then
           modparam1(4) = 1.0d0
           modparam2(4) = 4.0d0
         endif
         if (cmodel .eq. 'thinbody') then
           modparam1(4) = distancepc * pc
           modparam2(4) = modparam1(4)
         endif
       else
         if (cmodel .eq. 'graybody') then
           modparam1(4) = modparams1(4)
           modparam2(4) = modparams2(4)
         endif
         if (cmodel .eq. 'thinbody') then
           modparam1(4) = modparams1(4) * pc
           modparam2(4) = modparams2(4) * pc
           if (abs ( (modparams1(4) - distancepc) * 2.0d0 / (modparams1(4) + distancepc) ) .gt. 0.1d0) then
             if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Incompatible command-line distance values.'
             if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Incompatible command-line distance values.'
             if (iolog .gt. 0) close ( iolog )
             stop 99
           endif
         endif
       endif
       if (ipfitornot(4) .eq. 1) then
         nparmx(4) = 2**(maxitref)
       endif

       do i=1,nmodparams
         if (modparam1(i) .lt. almostzero .and. ipfitornot(i) .eq. 0) then
           if (iotty .gt. 0) write (iotty,'(/a,1pe9.2,2(a,i1))')  ' FITFLUXES: ERROR: Incompatible initial values'
     &                                                         , modparam1(i), ' and ', ivarornot(i),' for parameter ', i
           if (iolog .gt. 0) write (iolog,'(/a,1pe9.2,2(a,i1))')  ' FITFLUXES: ERROR: Incompatible initial values'
     &                                                         , modparam1(i), ' and ', ivarornot(i),' for parameter ', i
           if (iolog .gt. 0) close ( iolog )
           stop 99
         endif
       enddo
       if (iotty .gt. 0) write (iotty,'()')
       if (iolog .gt. 0) write (iolog,'()')
       do i=1,nmodparams
         if (iotty .gt. 0) then
           write (iotty,'(a,i1,a,4(1pe9.2,a))') ' Parameter ', i, ' ('//yesno(ivarornot(i)+1)//'):', modparams1(i), ' ~>'
     &                                         , modparam1(i), ' to', modparam2(i), punits(i), dlogpmax(i)
         endif
         if (iolog .gt. 0) then
           write (iolog,'(a,i1,a,4(1pe9.2,a))') ' Parameter ', i, ' ('//yesno(ivarornot(i)+1)//'):', modparams1(i), ' ~>'
     &                                         , modparam1(i), ' to', modparam2(i), punits(i), dlogpmax(i)
         endif
       enddo

       if (iotty .gt. 0) write (iotty,'(/a,i2)')  ' Maximum number of adaptive refinement levels: ......', maxitref
       if (iolog .gt. 0) write (iolog,'(/a,i2)')  ' Maximum number of adaptive refinement levels: ......', maxitref

       write (cpjx,'(i3)') nparmx(1)
       npjx = int ( log10 ( dble ( nparmx(1) ) ) ) + 1
       if (iotty .gt. 0) write (iotty,'(a)')  ' Maximum number of zones in adaptive refinement: .... '//cpjx(3-npjx+1:3)
       if (iolog .gt. 0) write (iolog,'(a)')  ' Maximum number of zones in adaptive refinement: .... '//cpjx(3-npjx+1:3)

       if (iotty .gt. 0) write (iotty,'(a,f6.3)')  ' Maximum desired value of chi^2/nu in refinement: ...', chisqfmax
       if (iolog .gt. 0) write (iolog,'(a,f6.3)')  ' Maximum desired value of chi^2/nu in refinement: ...', chisqfmax

       if (iotty .gt. 0) write (iotty,'(/a)') ' Names of output files: '//prefix(1:ipr)//'.*'
       if (iolog .gt. 0) write (iolog,'(/a)') ' Names of output files: '//prefix(1:ipr)//'.*'

       if (.not.limages) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' Reading catalog of sources: '''//excat(1:iexc)//'''...'
         if (iolog .gt. 0) write (iolog,'(/a)') ' Reading catalog of sources: '''//excat(1:iexc)//'''...'
       else
         if (iotty .gt. 0) write (iotty,'(/a)') ' Reading catalog of images: '''//excat(1:iexc)//'''...'
         if (iolog .gt. 0) write (iolog,'(/a)') ' Reading catalog of images: '''//excat(1:iexc)//'''...'
       endif
       if (cmodel .eq. 'graybody') then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' Fitting model ~> '//cmodel//': Fnu = Bnu(T) (1-exp(-tau)) Omega'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' Fitting model ~> '//cmodel//': Fnu = Bnu(T) (1-exp(-tau)) Omega'
       endif
       if (cmodel .eq. 'thinbody') then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' Fitting model ~> '//cmodel//': Fnu = Bnu(T) kappa M D^-2'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' Fitting model ~> '//cmodel//': Fnu = Bnu(T) kappa M D^-2'
       endif
       
! Start processing.

       if (ltiming) then
         cpu = timer ( 'cpu', 0.0d0 )
         wal = timer ( 'wal', 0.0d0 )
       endif

       ncolnumb = 0
       ncolxcoo = 0
       ncolycoo = 0
       ncolsigg = 0
       ncolgood = 0
       do i=1,nbands
         ncolsig(i) = 0
         ncolfxp(i) = 0
         ncolfxt(i) = 0
         ncolsnr(i) = 0
         ncolfpe(i) = 0
         ncolfte(i) = 0
         fxperro(i) = 0.0d0
         fxterro(i) = 0.0d0
       enddo

       if (.not.limages) then
         ncolnumb = index ( headline(nhcols)(1:lhl), '   NO ' )
         ncolxcoo = index ( headline(nhcols)(1:lhl), ' XCO_P' )
         ncolycoo = index ( headline(nhcols)(1:lhl), ' YCO_P' )
         ncolsigg = index ( headline(nhcols)(1:lhl), ' SIG_GLOB' )
         ncolgood = index ( headline(nhcols)(1:lhl), ' GOOD' )
         if (ncolxcoo .gt. 0 .and. ncolxcoo .lt. 5) ncolxcoo = 0        
         if (ncolycoo .gt. 0 .and. ncolycoo .lt. 5) ncolycoo = 0        
               
         do i=1,nbands
           write (cwav,'(i2.2)') nband(i)

           if (ncolsig(i) .eq. 0) ncolsig(i) = index ( headline(nhcols)(1:lhl), ' SIG_MONO'//cwav )
           if (ncolfxp(i) .eq. 0) ncolfxp(i) = index ( headline(nhcols)(1:lhl), ' FXP_BEST'//cwav )
           if (ncolfpe(i) .eq. 0) ncolfpe(i) = index ( headline(nhcols)(1:lhl), ' FXP_ERRO'//cwav )
           if (ncolfxt(i) .eq. 0) ncolfxt(i) = index ( headline(nhcols)(1:lhl), ' FXT_BEST'//cwav )
           if (ncolfte(i) .eq. 0) ncolfte(i) = index ( headline(nhcols)(1:lhl), ' FXT_ERRO'//cwav )

           if (ncolnumb .eq. 0 .or. ncolxcoo .eq. 0 .or. ncolycoo .eq. 0 .or. ncolsigg .eq. 0 .or. 
     &         ncolfxp(i) .eq. 0 .or. ncolfpe(i) .eq. 0 .or. ncolfxt(i) .eq. 0 .or. ncolfte(i) .eq. 0) then
             if (iotty .gt. 0) then
               write (iotty,'(/a)')  ' FITFLUXES: ERROR: Some columns not found for wavelength # '//cwav//'...'
               write (iotty,'(8i5)') i, ncolnumb, ncolxcoo, ncolycoo, ncolsigg, ncolfxp(i), ncolfpe(i), ncolfxt(i), ncolfte(i)
               write (iotty,'(a)') headline(nhcols)(1:lhl)
             endif
             if (iolog .gt. 0) then
               write (iolog,'(/a)')  ' FITFLUXES: ERROR: Some columns not found for wavelength # '//cwav//'...'
               write (iolog,'(8i5)') i, ncolnumb, ncolxcoo, ncolycoo, ncolsigg, ncolfxp(i), ncolfpe(i), ncolfxt(i), ncolfte(i)
               write (iolog,'(a)') headline(nhcols)(1:lhl)
             endif
             if (iolog .gt. 0) close ( iolog )
             stop 99
           endif
           if (number .eq. 0) then
             nsbeg = 1
             nsend = nextr
           else
             nsbeg = number
             nsend = number
           endif
         enddo
       else
         read (15,*,err=111) wave, beam(1), offset, filename
         goto 112
 111     continue
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble reading '''//excat(1:iexc)//'''...'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble reading '''//excat(1:iexc)//'''...'
         if (iolog .gt. 0) close ( iolog )
         stop 111
 112     continue

         lhl = lastc ( filename )

! Check if the input file exists and open it.

         inquire ( file=filename(1:lhl), exist=lfname2 )
         
         if (.not.lfname2) then
           if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: File '''//filename(1:lhl)//''' not found.'
           if (iolog .gt. 0) write (iolog,'(/a)') ' FITFLUXES: ERROR: File '''//filename(1:lhl)//''' not found.'
           if (iolog .gt. 0) close ( iolog )
           stop 2
         endif

! Determine numbers of pixels in the FITS image.
  
         call getpixels ( filename(1:lhl), nx, ny, dx, dy )
  
! Allocate the image arrays.
  
         allocate ( fun(nx,ny), image(nx,ny,nbands), coldens(nx,ny), tempers(nx,ny), chisqnu(nx,ny), stat=irc )
  
         if (irc .ne. 0) then
           if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (8).'
           if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (8).'
           if (iolog .gt. 0) close ( iolog )
           stop 8
         endif
         backspace ( 15 )
         nbx = 1

         do nb=1,nbands
           do nbn=nbx,nband(nbands)
             read (15,*,end=114,err=113) wave, beam(nb), offset, filename
             goto 115
 113         continue
             if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble reading '''//excat(1:iexc)//'''...'
             if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble reading '''//excat(1:iexc)//'''...'
             if (iolog .gt. 0) close ( iolog )
             stop 113
 114         continue
             if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Too few wavebands in '''//excat(1:iexc)//'''...'
             if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Too few wavebands in '''//excat(1:iexc)//'''...'
             if (iolog .gt. 0) close ( iolog )
             stop 114
 115         continue
             if (nbn .eq. nband(nb)) exit
           enddo
           nbx = nbn + 1
         
           lhl = lastc ( filename )

! Check if the input file exists and open it.

           inquire ( file=filename(1:lhl), exist=lfname2 )

           if (.not.lfname2) then
             if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: File '''//filename(1:lhl)//''' not found.'
             if (iolog .gt. 0) write (iolog,'(/a)') ' FITFLUXES: ERROR: File '''//filename(1:lhl)//''' not found.'
             if (iolog .gt. 0) close ( iolog )
             stop 3
           endif

! Determine numbers of pixels in the FITS image.
  
           call getpixels ( filename(1:lhl), nx, ny, dx, dy )

           write (cx,'(i4)') nx
           write (cy,'(i4)') ny
           ncx = int ( log10 ( dble ( nx ) ) ) + 1
           ncy = int ( log10 ( dble ( ny ) ) ) + 1
           if (lverbose .eq. '-verb2') then
             if (iotty .gt. 0) write (iotty,'(/a)') ' Reading '''//filename(1:lhl)//'''... '//cx(4-ncx+1:4)//' x '//cy(4-ncy+1:4)
             if (iolog .gt. 0) write (iolog,'(/a)') ' Reading '''//filename(1:lhl)//'''... '//cx(4-ncx+1:4)//' x '//cy(4-ncy+1:4)
           endif
           if (nx .ne. nx1 .or. ny .ne. ny1) then
             if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Image size differs between wavebands.'
             if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Image size differs between wavebands.'
             if (iolog .gt. 0) close ( iolog )
             stop 99
           endif
  
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, fun, dx, dy, object, ra, dec
     &                , filename(1:lhl), header, footer, iotty, 0, creator, beamx, funmin, funmax, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
  
           if (lverbose .eq. '-verb2') then
             if (iotty .gt. 0) write (iotty,'(a,1x,2(1pe14.7))') ' Minmax values in the image:', funmin, funmax
             if (iolog .gt. 0) write (iolog,'(a,1x,2(1pe14.7))') ' Minmax values in the image:', funmin, funmax
           endif
  
           do j=1,ny
             do i=1,nx
               image(i,j,nb) = fun(i,j)
             enddo
           enddo
         enddo
         nextr = nx * ny
         if (number .eq. 0 .and. npart .gt. 0 .and. nparts .gt. 0) then
           nsbeg = (npart - 1) * nextr / nparts + 1
           nsend = npart * nextr / nparts
         else
           if (number .eq. 0) then
             nsbeg = 1
             nsend = nextr
           else
             nsbeg = number
             nsend = number
           endif
         endif
       endif

       allocate ( chisq(nparmx(1),nparmx(2),nparmx(3),nparmx(4)), paramspace(4,max(nparmx(1),nparmx(2),nparmx(3),nparmx(4)))
     &          , stat=irc )

       if (irc .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (7).'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (7).'
         if (iolog .gt. 0) close ( iolog )
         stop 7
       endif
       
       allocate ( ltakeit(nextr), x0o(nextr), y0o(nextr), sigglobal(nextr), goodness(nextr), nxmin(nextr,4), stat=irc )

       if (irc .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (9).'
         if (iolog .gt. 0) write (iolog,'(/a)')  ' FITFLUXES: ERROR: Trouble allocating memory (9).'
         if (iolog .gt. 0) close ( iolog )
         stop 9
       endif

       do ip=1,4
         paramspacemin(ip) = 1.0d99
         paramspacemax(ip) = 0.0d0
       enddo
       nplt = 0
       nsrc = 0
       itermean = 0.0d0
       itermin = 99
       itermax = 0
       itrefmean = 0.0d0
       itrefmin = 9
       itrefmax = 0
       nitmean = 0.0d0
       nrefmean = 0.0d0
       isumpct = 0.0d0
       numtotal = dble ( nextr )
       numpart = 0.0d0
       
       if (lverbose .eq. '-verb0' .and. limages) then
         if (iotty .gt. 0) then
           write (iotty,'(11x,a)') '__________________________________________________ 100%'
           write (iotty,'(a)', advance='no') ' Progress: '
           if (iotty .gt. 0) endfile   ( iotty, err=999 )
 999       continue 
           if (iotty .gt. 0) backspace ( iotty )
         endif       
         if (iolog .gt. 0) then
           write (iolog,'(11x,a)') '__________________________________________________ 100%'
           write (iolog,'(a)', advance='no') ' Progress: '
         endif
       endif

! Prepare arrays and explore fitting model parameter space.

       do ns=1,nextr
       
         if (.not.limages) then
           read (15,'(a)') cline
           read (cline(ncolnumb:),*) nsrc
         else
           cline = ' '
           nsrc = ns
         endif
         write (cnsrc,'(i10)') nsrc
         nn = int ( log10 ( dble ( nsrc ) ) ) + 1

         if (.not.limages) then
           read (cline(ncolxcoo:),*) x0o(ns)
           read (cline(ncolycoo:),*) y0o(ns)
           read (cline(ncolsigg:),*) sigglobal(ns)
           if (ncolgood .gt. 0) read (cline(ncolgood:),*) goodness(ns)
         else
           y0o(ns) = dble ( (ns - 1) / nx ) + 1.0d0
           x0o(ns) = dble ( ns ) - dble ( nx ) * (y0o(ns) - 1.0d0)
           sigglobal(ns) = 1.0d30
           goodness(ns) = 1.0d30
           if (lverbose .eq. '-verb0') then
             numpart = dble ( nsrc )
             call showprogress ( iotty, iolog, lunix, numpart, numtotal, isumpct )
           endif
         endif
         nx0o = nint ( x0o(ns) )
         ny0o = nint ( y0o(ns) )

         ltakeit(ns) = .false.
         
         if (nsrc .ge. nsbeg .and. nsrc .le. nsend .and. cline(1:1) .ne. '!' .and. cline(1:1) .ne. '#') then
           if (sigglobal(ns) .lt. sigmin .or. goodness(ns) .lt. goodmin) then
             if (.not.limages .and. lverbose .ne. '-verb0') then
               if (iotty .gt. 0) write (iotty,'(/a)') ' Skipping source # '//cnsrc(10-nn+1:10)//': too low SIGGLOB or GOODNESS...'
               if (iolog .gt. 0) write (iolog,'(/a)') ' Skipping source # '//cnsrc(10-nn+1:10)//': too low SIGGLOB or GOODNESS...'
             endif
             goto 777
           endif

           do i=1,nbands
             sigmono(i) = sigglobal(ns)
             uplimit(i) = 0
             if (.not.limages) then
               if (ncolsig(i) .gt. 0) then
                 read (cline(ncolsig(i):),*) sigmono(i)
               endif
               read (cline(ncolfxp(i):),*) fxpbest(i)
               read (cline(ncolfpe(i):),*) fxperro(i)
               read (cline(ncolfxt(i):),*) fxtbest(i)
               read (cline(ncolfte(i):),*) fxterro(i)
               if (index ( cline(ncolfxt(i):ncolfxt(i)+5), ' +' ) .gt. 0) uplimit(i) = 1
             else
               fxtbest(i) = max ( image(nx0o,ny0o,i), 0.0d0 ) * 1.0d6  !<-- Convert intensity from MJy/sr to Jy/sr
               if (cmodel .eq. 'graybody' .or. distancepc .gt. 1.0001d0) then
                 fxtbest(i) = fxtbest(i) * solidapixel                 !<-- Convert from intensity in Jy/sr to flux in Jy
               endif
               fxterro(i) = 0.0d0
             endif
             if (csnband(i) .eq. '-' .and. uplimit(i) .eq. 1) uplimit(i) = -1
             frequency(i) = speedolight * 1.0d4 / wavelength(i)
             fxperror(i) = sqrt ( fxperro(i)**2 + (fxpbest(i) * adderro(i))**2 )
             fxterror(i) = sqrt ( fxterro(i)**2 + (fxtbest(i) * adderro(i))**2 )
             snrpeak(i) = fxpbest(i) / (fxperro(i) + almostzero)
             snrtotal(i) = fxtbest(i) / (fxterro(i) + almostzero)
           enddo
           
! Here we can choose to use fewer data points for fitting. Make sure that the number is at least NMODPARAMS.

           nptstofit = 0
           wavepeak = 0.0d0
           fluxpeak = 0.0d0
           do i=1,nbands
             if ((.not.limages .and. uplimit(i) .eq. 0 .and. csnband(i) .ne. '-' .and.
     &            (csnband(i) .eq. '+' .or. (sigmono(i) .ge. sigmin .and. 
     &            snrpeak(i) .ge. snrmin(i) .and. snrtotal(i) .gt. snrmin(i))) .and. 
     &            fxpbest(i) .gt. almostzero .and. fxperro(i) .gt. almostzero .and.
     &            fxtbest(i) .gt. almostzero .and. fxterro(i) .gt. almostzero) .or.
     &           (limages .and. csnband(i) .ne. '-' .and. 
     &            (csnband(i) .eq. '+' .or. snrtotal(i) .gt. 0.01d0) .and.               
     &            fxtbest(i) .gt. almostzero)) then
               nptstofit = nptstofit + 1
               sfrequency(nptstofit) = frequency(i)
               sfxtbest(nptstofit) = fxtbest(i)
               sfxterro(nptstofit) = fxterror(i)
             endif
             if (fxtbest(i) .gt. fluxpeak) then
               fluxpeak = fxtbest(i)
               wavepeak = wavelength(i)
             endif
           enddo
           if (wavepeak .lt. almostzero) then
             if (.not.limages .and. lverbose .ne. '-verb0') then
               if (iotty .gt. 0) write (iotty,'(/a)') ' Skipping source # '//cnsrc(10-nn+1:10)//': peak of SED not found...'
               if (iolog .gt. 0) write (iolog,'(/a)') ' Skipping source # '//cnsrc(10-nn+1:10)//': peak of SED not found...'
             endif
             goto 777
           endif
           if (nptstofit .lt. nfitparams) then
             if (.not.limages .and. lverbose .ne. '-verb0') then
               if (iotty .gt. 0) then
                 write (iotty,'(/a,i1,a)') ' Skipping source # '//cnsrc(10-nn+1:10)//': too few (', nptstofit, ') fluxes to fit...'
               endif
               if (iolog .gt. 0) then
                 write (iolog,'(/a,i1,a)') ' Skipping source # '//cnsrc(10-nn+1:10)//': too few (', nptstofit, ') fluxes to fit...'
               endif
             endif
             goto 777
           endif
           if (lverbose .ne. '-verb0') then
             if (iotty .gt. 0) write (iotty,'(a)') ' ______________________________________________________________________________'
             if (iolog .gt. 0) write (iolog,'(a)') ' ______________________________________________________________________________'
           endif
           lam1 = nint ( 1.0d4 * speedolight / sfrequency(1) )
           lam2 = nint ( 1.0d4 * speedolight / sfrequency(nptstofit) )
           write (clam1,'(i4)') lam1
           write (clam2,'(i4)') lam2
           nl1 = int ( log10 ( dble ( lam1 ) ) ) + 1
           nl2 = int ( log10 ( dble ( lam2 ) ) ) + 1
           write (cx,'(i4)') nx0o
           write (cy,'(i4)') ny0o
           ncx = int ( log10 ( dble ( max ( nx0o, 1 ) ) ) ) + 1
           ncy = int ( log10 ( dble ( max ( ny0o, 1 ) ) ) ) + 1
           write (cnsend,'(i10)') nsend
           ne = int ( log10 ( dble ( nsend ) ) ) + 1
           npercent = nint ( dble ( nsrc ) / dble ( nsend ) * 100.0d0 )
           write (cnperc,'(i3)') npercent

           if (lverbose .ne. '-verb0' .or. .not.limages) then
             if (iotty .gt. 0) then
               if (.not.limages) then
                 write (iotty,'(/a)') ' Fitting '//clam1(4-nl1+1:4)//'~'//clam2(4-nl2+1:4)//' um fluxes: source # '
     &                              //cnsrc(10-nn+1:10)//' of '//cnsend(10-ne+1:10)//'... '//cnperc//'%'
               else
                 write (iotty,'(/a)') ' Fitting '//clam1(4-nl1+1:4)//'~'//clam2(4-nl2+1:4)//' um fluxes: pixel ('
     &                              //cx(4-ncx+1:4)//','//cy(4-ncy+1:4)//') # '//cnsrc(10-nn+1:10)
     &                              //' of '//cnsend(10-ne+1:10)//'... '//cnperc//'%'
               endif
             endif
             if (iolog .gt. 0) then
               if (.not.limages) then
                 write (iolog,'(/a)') ' Fitting '//clam1(4-nl1+1:4)//'~'//clam2(4-nl2+1:4)//' um fluxes: source # '
     &                              //cnsrc(10-nn+1:10)//' of '//cnsend(10-ne+1:10)//'... '//cnperc//'%'
               else
                 write (iolog,'(/a)') ' Fitting '//clam1(4-nl1+1:4)//'~'//clam2(4-nl2+1:4)//' um fluxes: pixel ('
     &                              //cx(4-ncx+1:4)//','//cy(4-ncy+1:4)//') # '//cnsrc(10-nn+1:10)
     &                              //' of '//cnsend(10-ne+1:10)//'... '//cnperc//'%'
               endif
             endif
           endif

           do ip=1,4
             parmin(ip) = modparam1(ip)
             parmax(ip) = modparam2(ip)
           enddo
           ltakeit(ns) = .true.
           chisqfreeo = 1.0d0
           lconvergedo = .false.
           ldone = .false.

           itref = 0
 1111      continue
           lnochange = .true.
           
           do ip=1,4
             nparo = npar(ip)
             dlogpo = dlogp(ip)
             if (ipfitornot(ip) .eq. 1) then
               npar(ip) = 2**(itref)
             endif
             if (npar(ip) .gt. nparmx(ip)) then
               if (iotty .gt. 0) then
                 write (iotty,'(/a,3i4)') ' FITFLUXES: ERROR: Too many zones in parameter space:', itref, npar(ip), nparmx(ip)
               endif
               if (iolog .gt. 0) then
                 write (iolog,'(/a,3i4)') ' FITFLUXES: ERROR: Too many zones in parameter space:', itref, npar(ip), nparmx(ip)
               endif
               if (iolog .gt. 0) close ( iolog )
               stop 99
             endif
             modp1 = log ( parmin(ip) )
             modp2 = log ( parmax(ip) )
             pspace1o = paramspace(ip,1)
             pspace2o = paramspace(ip,nparo)
             dlogp(ip) = (modp2 - modp1) / dble ( npar(ip) )
             if (dlogp(ip) .gt. almostzero) then
               dlogp(ip) = max ( dlogp(ip), dlogpmax(ip) )
               npar(ip) = nint ( (modp2 - modp1) / dlogp(ip) )
               dlogp(ip) = (modp2 - modp1) / dble ( npar(ip) )
             endif
             modp1 = modp1 + dlogp(ip) / 2.0d0
             do j=1,npar(ip)
               paramspace(ip,j) = exp ( modp1 + dble ( j - 1 ) * dlogp(ip) )
             enddo
             if (dlogp(ip) .gt. almostzero .and. (npar(ip) .ne. nparo .or. 
     &           abs ( dlogp(ip) - dlogpo ) .gt. almostzero .or. abs ( paramspace(ip,1) - pspace1o ) .gt. almostzero .or.
     &           abs ( paramspace(ip,npar(ip)) - pspace2o ) .gt. almostzero)) then
               lnochange = .false.
             endif
           enddo

! Exit refinement loop if the above discretization of parameter space did not change since the last iteration.

           if (itref .gt. 0 .and. lnochange) then
             itref = itref - 1
             goto 3333
           endif

           write (cpjx,'(i3)') npar(1)
           npjx = int ( log10 ( dble ( npar(1) ) ) ) + 1
           write (cpkx,'(i3)') npar(2)
           npkx = int ( log10 ( dble ( npar(2) ) ) ) + 1
           write (cplx,'(i3)') npar(3)
           nplx = int ( log10 ( dble ( npar(3) ) ) ) + 1
           write (cpmx,'(i3)') npar(4)
           npmx = int ( log10 ( dble ( npar(4) ) ) ) + 1
           numfits = npar(1) * npar(2) * npar(3) * npar(4)
           write (cfts,'(i9)') numfits
           nfts = int ( log10 ( dble ( numfits ) ) ) + 1
           if (lverbose .eq. '-verb2') then
             if (iotty .gt. 0) then
               write (iotty,'(/a)') ' Exploring '//cmodel//' parameter space ('//cpjx(3-npjx+1:3)//','//cpkx(3-npkx+1:3)//','
     &                            //cplx(3-nplx+1:3)//','//cpmx(3-npmx+1:3)//') in '//cfts(9-nfts+1:9)//' fits...'
             endif
             if (iolog .gt. 0) then
               write (iolog,'(/a)') ' Exploring '//cmodel//' parameter space ('//cpjx(3-npjx+1:3)//','//cpkx(3-npkx+1:3)//','
     &                            //cplx(3-nplx+1:3)//','//cpmx(3-npmx+1:3)//') in '//cfts(9-nfts+1:9)//' fits...'
             endif
           endif
           if (lverbose .eq. '-verb2') then
             if (iotty .gt. 0) write (iotty,'()')
             if (iolog .gt. 0) write (iolog,'()')
           endif
           
           do i=1,nmodparams
             write (cpx,'(i3)') npar(i)
             npx = int ( log10 ( dble ( npar(i) ) ) ) + 1
             if (lverbose .eq. '-verb2') then
               if (iotty .gt. 0) then
                 write (iotty,'(a,i1,a,4(1pe9.2,a))') ' Parameter ', i, ' ('//yesno(ivarornot(i)+1)//'):', modparams1(i), ' ~>'
     &                                              , paramspace(i,1), ' to', paramspace(i,npar(i)), punits(i), dlogp(i)
               endif
               if (iolog .gt. 0) then
                 write (iolog,'(a,i1,a,4(1pe9.2,a))') ' Parameter ', i, ' ('//yesno(ivarornot(i)+1)//'):', modparams1(i), ' ~>'
     &                                              , paramspace(i,1), ' to', paramspace(i,npar(i)), punits(i), dlogp(i)
               endif
             endif
             if (modparam1(i) .lt. almostzero .and. ipfitornot(i) .eq. 0) then
               if (iotty .gt. 0) write (iotty,'(/a,1pe9.2,2(a,i1))')  ' FITFLUXES: ERROR: Incompatible initial values'
     &                                                             , modparam1(i), ' and ', ivarornot(i),' for parameter ', i
               if (iolog .gt. 0) write (iolog,'(/a,1pe9.2,2(a,i1))')  ' FITFLUXES: ERROR: Incompatible initial values'
     &                                                             , modparam1(i), ' and ', ivarornot(i),' for parameter ', i
               if (iolog .gt. 0) close ( iolog )
               stop 99
             endif
           enddo

           nxmin(ns,1) = 1
           nxmin(ns,2) = 1
           nxmin(ns,3) = 1
           nxmin(ns,4) = 1
           iterdone = 0
           chisqmin = 1.0d55
           chisqfree = 1.0d55
           lgoodfound = .false.
           lconverged = .false.

           do j=1,npar(1)
             do k=1,npar(2)
               do l=1,npar(3)
                 do m=1,npar(4)
                   fitparameters(1) = paramspace(1,j)
                   fitparameters(2) = paramspace(2,k)
                   fitparameters(3) = paramspace(3,l)
                   fitparameters(4) = paramspace(4,m)
                   
                   if (cmodel .eq. 'graybody') then
                     do i=1,nbands
                       opacity(i) = opacity0 * (frequency(i) / frequency0)**fitparameters(4)
                     enddo
                     call fitsed ( iotty, iolog, nsrc, nx0o, ny0o, nbands, nmodparams, nfitparams, nptstofit, wavelength, frequency
     &                           , fxtbest, fxterror, sfrequency, sfxtbest, sfxterro, sedslope, distancepc, derivedmass, ctime
     &                           , cdate, postscript(1:ilp), fitparameters, ipfitornot, dyda, covar, alpha, chisq(j,k,l,m), iter
     &                           , lgood, lconv, lsing, limages, cmodel, graybody, 'parspace', quantities, opacityrelerr
     &                           , dustgasrelerr, distancrelerr, uplimit, lpostscript, solidapixel )
                   endif
                   if (cmodel .eq. 'thinbody') then
                     do i=1,nbands
                       opacity(i) = opacity0 * (frequency(i) / frequency0)**fitparameters(3)
                     enddo
                     call fitsed ( iotty, iolog, nsrc, nx0o, ny0o, nbands, nmodparams, nfitparams, nptstofit, wavelength, frequency
     &                           , fxtbest, fxterror, sfrequency, sfxtbest, sfxterro, sedslope, distancepc, derivedmass, ctime
     &                           , cdate, postscript(1:ilp), fitparameters, ipfitornot, dyda, covar, alpha, chisq(j,k,l,m), iter
     &                           , lgood, lconv, lsing, limages, cmodel, thinbody, 'parspace', quantities, opacityrelerr
     &                           , dustgasrelerr, distancrelerr, uplimit, lpostscript, solidapixel )
                   endif

! Discard the source fit if it goes above an upper limit value.

                   if (.not.limages) then
                     do i=1,nbands
                       if (uplimit(i) .eq. 1) then
                         if (cmodel .eq. 'graybody') then
                           call graybody ( frequency(i), fitparameters, modelflux, dyda, nmodparams )
                         endif
                         if (cmodel .eq. 'thinbody') then
                           call thinbody ( frequency(i), fitparameters, modelflux, dyda, nmodparams )
                         endif
                         if (modelflux .gt. fxtbest(i)) lgood = .false.
                       endif
                     enddo
                   endif

! Identify the minimum values of the parameter space.

                   if (chisq(j,k,l,m) .lt. chisqmin .and. .not.lsing) then
                     if (lgood) lgoodfound = .true.
                     if (lconv) lconverged = .true.
                     chisqmin = chisq(j,k,l,m)
                     iterdone = iter
                     nxmin(ns,1) = j
                     nxmin(ns,2) = k
                     nxmin(ns,3) = l
                     nxmin(ns,4) = m
                     nfreedom = nptstofit - nfitparams
                     chisqfree = chisqmin / (dble ( nfreedom ) + 1.0d0 )
                   endif
                   if (lconv) then
                     itermin = min ( itermin, iter )
                     itermax = max ( itermax, iter )
                     itermean = itermean + dble ( iter )
                     nitmean = nitmean + 1.0d0
                   endif
                 enddo
               enddo
             enddo
           enddo
           npjx = 1
           write (cpjx,'(i3)') iterdone
           if (iterdone .gt. 0) npjx = int ( log10 ( dble ( iterdone ) ) ) + 1
           if (lverbose .eq. '-verb2' .and. iotty .gt. 0) then
             write (iotty,'(/a,1pe21.14,a,3l)') 
     &                    ' Minimum chi^2 value', chisqmin, ' found in '//cpjx(3-npjx+1:3)//' iterations', lgood, lconv, lsing
           endif
           if (lverbose .ne. '-verb0' .and. iolog .gt. 0) then
             write (iolog,'(/a,1pe21.14,a,3l)')
     &                    ' Minimum chi^2 value', chisqmin, ' found in '//cpjx(3-npjx+1:3)//' iterations', lgood, lconv, lsing
           endif

           do ip=1,4
             parmn(ip) = 1.0d99
             parmx(ip) = 0.0d0
           enddo
           do j=1,npar(1)
             do k=1,npar(2)
               do l=1,npar(3)
                 do m=1,npar(4)
                   if (chisq(j,k,l,m) .le. 2.0d0 * chisqmin) then
                     parmn(1) = min ( parmn(1), paramspace(1,j) )
                     parmx(1) = max ( parmx(1), paramspace(1,j) )
                     parmn(2) = min ( parmn(2), paramspace(2,k) )
                     parmx(2) = max ( parmx(2), paramspace(2,k) )
                     parmn(3) = min ( parmn(3), paramspace(3,l) )
                     parmx(3) = max ( parmx(3), paramspace(3,l) )
                     parmn(4) = min ( parmn(4), paramspace(4,m) )
                     parmx(4) = max ( parmx(4), paramspace(4,m) )
                   endif
                 enddo
               enddo
             enddo
           enddo
           do ip=1,4
             parmxlog = log ( parmx(ip) )
             parmnlog = log ( parmn(ip) )
             delta = max ( (parmxlog - parmnlog) / 10.0d0, 2.0d0 * dlogp(ip) )
             if (parmn(ip) .lt. 1.0d99) parmin(ip) = max ( exp ( parmnlog - delta ), modparam1(ip) )
             if (parmx(ip) .gt. 0.0d0 ) parmax(ip) = min ( exp ( parmxlog + delta ), modparam2(ip) )
           enddo

           if (lverbose .eq. '-verb2' .and. iotty .gt. 0) then
             write (iotty,'()')
             do ip=1,4
               write (iotty,'(a,i1,a,2(1pe9.2,a))') ' Minimum chi^2 domain in parameter ', ip, ':'
     &                                            , parmin(ip), ' to', parmax(ip), punits(ip)
             enddo
           endif
           if (lverbose .ne. '-verb0' .and. iolog .gt. 0) then
             write (iolog,'()')
             do ip=1,4
               write (iolog,'(a,i1,a,2(1pe9.2,a))') ' Minimum chi^2 domain in parameter ', ip, ':'
     &                                            , parmin(ip), ' to', parmax(ip), punits(ip)
             enddo
           endif

! Check if we need to continue parameter space refinement iterations.

           lconvgood = lconverged .and. lgoodfound
           lnotconvo = .not.lconverged .and. .not.lconvergedo
           ldone = .false.
           if (itref .gt. 0) then
             if ((lconvgood  .and. chisqfree .lt. chisqfmax) .or.
     &           (lconverged .and. abs ( chisqfree - chisqfreeo ) .lt. 1.0d-3 * chisqfreeo) .or.
     &           (lnotconvo  .and. abs ( chisqfree - chisqfreeo ) .gt. 1.0d-3 * chisqfreeo .and. 
     &            chisqfree .gt. chisqfreeo / 2.0d0 .and. itref .ge. 2)) then
               ldone = .true.
             endif
           endif
           if (itref .lt. maxitref .and. .not.ldone) then 
             chisqfreeo = chisqfree
             lconvergedo = lconverged
             itref = itref + 1
             goto 1111
           endif
 3333      continue
           itrefmin = min ( itrefmin, itref )
           itrefmax = max ( itrefmax, itref )
           itrefmean = itrefmean + dble ( itref )
           nrefmean = nrefmean + 1.0d0

! Find minimum and maximum values of the optimal initial parameters for all best fits.

           if (ldone .and. chisqfree .le. chisqfmax) then
             do ip=1,4
               paramspacemin(ip) = min ( paramspacemin(ip), parmin(ip) )
               paramspacemax(ip) = max ( paramspacemax(ip), parmax(ip) )
             enddo
           endif

! Save chi^2 values in the model parameter space.

           if (ldebug) then
             if (cmodel .eq. 'graybody') then
               write (55,'(/a)') '# CHI^2 VALUES IN A GRAYBODY PARAMETER SPACE ('//cpjx(3-npjx+1:3)//','//cpkx(3-npkx+1:3)//','
     &                         //cplx(3-nplx+1:3)//','//cpmx(3-npmx+1:3)//') FOR SOURCE # '//cnsrc(10-nn+1:10)
             endif
             if (cmodel .eq. 'thinbody') then
               write (55,'(/a)') '# CHI^2 VALUES IN THE THINBODY PARAMETER SPACE ('//cpjx(2-npjx+1:2)//','//cpkx(2-npkx+1:2)//','
     &                         //cplx(2-nplx+1:2)//','//cpmx(2-npmx+1:2)//') FOR SOURCE # '//cnsrc(10-nn+1:10)
             endif
             write (cjx,'(i3)') nxmin(ns,1)
             njx = int ( log10 ( dble ( nxmin(ns,1) ) ) ) + 1
             write (ckx,'(i3)') nxmin(ns,2)
             nkx = int ( log10 ( dble ( nxmin(ns,2) ) ) ) + 1
             write (clx,'(i3)') nxmin(ns,3)
             nlx = int ( log10 ( dble ( nxmin(ns,3) ) ) ) + 1
             write (cmx,'(i3)') nxmin(ns,4)
             nmx = int ( log10 ( dble ( nxmin(ns,4) ) ) ) + 1
             write (55,'(/a,1pe10.3)') '# BEST FIT FOUND AT POINT ('//cjx(3-njx+1:3)//','//ckx(3-nkx+1:3)//','//clx(3-nlx+1:3)
     &                               //','//cmx(3-nmx+1:3)//'): CHI^2 =', chisq(nxmin(ns,1),nxmin(ns,2),nxmin(ns,3),nxmin(ns,4))
            
             write (55,'(/a,1pe10.3)') '# Slice through the 4th dimension for source # '//cnsrc(10-nn+1:10)//' at point # '
     &                               //cmx(3-nmx+1:3)//', value:', paramspace(4,nxmin(ns,4))
             do l=1,npar(3)
               write (cl,'(i3)') l
               nl = int ( log10 ( dble ( l ) ) ) + 1
               write (55,'(/a,1pe10.3)') '# Slice through the 3rd dimension for source # '//cnsrc(10-nn+1:10)//' at point # '
     &                                 //cl(3-nl+1:3)//', value:', paramspace(3,l)
               write (55,'(/15x,1000(2x,i3,4x))') (k, k=1,npar(2))
               write (55,'( 14x,1000(1pe9.2))') (paramspace(2,k), k=1,npar(2))
               write (55,'()')
               do j=1,npar(1)
                 write (55,'(i3,1x,1pe9.2,1x,1000(e9.2))') j, paramspace(1,j), (chisq(j,k,nxmin(ns,3),nxmin(ns,4)), k=1,npar(2))
               enddo
             enddo
           endif

! Open PostScript file for plotting (if required).

           nplt = nplt + 1
!!           if (lpostscript) then
!!             if (nplt .eq. 1) then
!!               call newdev ( postscript(1:ilp) )
!!               call psinit ( psunit, .true., ctime, cdate )
!!             else
!!               call chopit ( 0., 0. )
!!             endif
!!           endif
           do ip=1,4
             fitparameters(ip) = paramspace(ip,nxmin(ns,ip))
           enddo

           if (cmodel .eq. 'graybody') then
             do i=1,nbands
               opacity(i) = opacity0 * (frequency(i) / frequency0)**fitparameters(4)
             enddo
             call fitsed ( iotty, iolog, nsrc, nx0o, ny0o, nbands, nmodparams, nfitparams, nptstofit, wavelength, frequency
     &                   , fxtbest, fxterror, sfrequency, sfxtbest, sfxterro, sedslope, distancepc, derivedmass, ctime, cdate
     &                   , postscript(1:ilp), fitparameters, ipfitornot, dyda, covar, alpha, chisqx, iter, lgood, lconv, lsing
     &                   , limages, cmodel, graybody, 'finalfit', quantities, opacityrelerr, dustgasrelerr, distancrelerr, uplimit
     &                   , lpostscript, solidapixel )
           endif
           if (cmodel .eq. 'thinbody') then
             do i=1,nbands
               opacity(i) = opacity0 * (frequency(i) / frequency0)**fitparameters(3)
             enddo
             call fitsed ( iotty, iolog, nsrc, nx0o, ny0o, nbands, nmodparams, nfitparams, nptstofit, wavelength, frequency
     &                   , fxtbest, fxterror, sfrequency, sfxtbest, sfxterro, sedslope, distancepc, derivedmass, ctime, cdate
     &                   , postscript(1:ilp), fitparameters, ipfitornot, dyda, covar, alpha, chisqx, iter, lgood, lconv, lsing
     &                   , limages, cmodel, thinbody, 'finalfit', quantities, opacityrelerr, dustgasrelerr, distancrelerr, uplimit
     &                   , lpostscript, solidapixel )
           endif
           if (.not.limages) then
             write (77,'(i7,2f8.1,1x,2(1pe9.2),8(1x,2(1pe10.3)),10(1pe10.3))')
     &                  ns, x0o(ns), y0o(ns), sigglobal(ns), goodness(ns), (quantities(ip), ip=1,17)
           endif
     
           if (limages) then
             chisqnu(nx0o,ny0o) = quantities(16) / (quantities(17) + 1.0d0)
             if (chisqnu(nx0o,ny0o) .le. 10.0d0) then
               tempers(nx0o,ny0o) = quantities(1)  !<-- temperatures
               coldens(nx0o,ny0o) = quantities(9)  !<-- column densities
             else
               tempers(nx0o,ny0o) = 0.0d0  !<-- temperatures
               coldens(nx0o,ny0o) = 0.0d0  !<-- column densities
             endif
           endif
           goto 888
         endif
 777     continue
         if (limages) then
           tempers(nx0o,ny0o) = 0.0d0  !<-- temperatures
           coldens(nx0o,ny0o) = 0.0d0  !<-- column densities
           chisqnu(nx0o,ny0o) = 0.0d0  !<-- chi^2 values
         endif
 888     continue
       enddo

       close ( 15 )
       if (ldebug) close ( 55 )
       if (.not.limages) then
         close ( 66 )
         close ( 77 )
       endif
       
       if (nitmean .gt. 0) itermean = itermean / nitmean
       if (nrefmean .gt. 0) itrefmean = itrefmean / nrefmean

       if (ldebug .and. lpostscript .and. npar(1) .ge. 2 .and. npar(2) .ge. 2) then
         allocate ( space(npar(1),npar(2)), stat=irc )
        
         if (irc .ne. 0) then
           if (iotty .gt. 0) write (iotty,'(/a)') ' FITFLUXES: ERROR: Trouble allocating memory (10).'
           if (iolog .gt. 0) write (iolog,'(/a)') ' FITFLUXES: ERROR: Trouble allocating memory (10).'
           if (iolog .gt. 0) close ( iolog )
           stop 10
         endif

         bunit = ' '
         creator = 'FITFLUXES'
         ctype1 = 'Temper'
         if (cmodel .eq. 'graybody' .or. limages) then
           ctype2 = 'ColDens'
           header = 'Chi^2 parameter space (T,N)'
         else
           ctype2 = 'Mass'
           header = 'Chi^2 parameter space (T,M)'
         endif
         footer(1) = 'Fitting model: '//cmodel
         footer(2) = ' '
         object = 'None'
         history = ' '
         blank = 0
         datamax = 0.0d0
         datamin = 0.0d0
         cdelt1 = -dlogp(1) * 3600.0d0
         cdelt2 = dlogp(2) * 3600.0d0
         crpix1 = dble ( npar(1) ) / 2.0d0
         crpix2 = dble ( npar(2) ) / 2.0d0
         crota1 = 0.0d0
         crota2 = 0.0d0
         cd11 = -dlogp(1) * 3600.0d0
         cd12 = 0.0d0
         cd21 = 0.0d0
         cd22 = dlogp(2) * 3600.0d0
         crval1 = (log ( paramspace(1,1) ) + log ( paramspace(1,npar(1)) )) / 2.0d0 - dlogp(1) / 2
         crval2 = (log ( paramspace(2,1) ) + log ( paramspace(2,npar(2)) )) / 2.0d0 - dlogp(2) / 2
         epoch = 0.0d0
         equinox = 0.0d0
         bzero = 0.0d0
         bscale = 1.0d0
         wave = 0.0d0
         beamx = 0.0d0
         
         do j=1,npar(1)
           do k=1,npar(2)
             space(j,k) = min ( chisq(j,k,nxmin(nsbeg,3),nxmin(nsbeg,4)), 30.0d0 )
           enddo
         enddo
        
         if (iotty .gt. 0) write (iotty,'(/a)') ' Writing output: '''//paraspace(1:ile)//'''...'
         if (iolog .gt. 0) write (iolog,'(/a)') ' Writing output: '''//paraspace(1:ile)//'''...'
        
         call wfits ( cfitsversion, npar(1), npar(2), bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, space, cdelt1
     &              , cdelt2, object, crval1, crval2, paraspace(1:ile), header, footer, iotty, cdate, ctime, creator, beamx
     &              , blank, crota1, crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax
     &              , history, lverbose )
        
         deallocate ( space )
       endif

       if (iotty .gt. 0) write (iotty,'(a)') ' ______________________________________________________________________________'
       if (iolog .gt. 0) write (iolog,'(a)') ' ______________________________________________________________________________'
       npjx = 1
       npkx = 1
       nplx = 1
       write (cpjx,'(i3)') itermin
       if (itermin .gt. 0) npjx = int ( log10 ( dble ( itermin ) ) ) + 1
       write (cpkx,'(i3)') nint ( itermean )
       if (nint ( itermean ) .gt. 0) npkx = int ( log10 ( dble ( nint ( itermean ) ) ) ) + 1
       write (cplx,'(i3)') itermax
       if (itermax .gt. 0) nplx = int ( log10 ( dble ( itermax ) ) ) + 1
       if (iotty .gt. 0) then
         write (iotty,'(/a)')    ' Min avg max numbers of iterations in fitting: '
     &                      //cpjx(3-npjx+1:3)//' '//cpkx(3-npkx+1:3)//' '//cplx(3-nplx+1:3)
         write (iotty,'(a,3i2)') ' Min avg max numbers of refinement iterations:', itrefmin, nint ( itrefmean ), itrefmax
       endif
       if (iolog .gt. 0) then
         write (iolog,'(/a)')    ' Min avg max numbers of iterations in fitting: '
     &                      //cpjx(3-npjx+1:3)//' '//cpkx(3-npkx+1:3)//' '//cplx(3-nplx+1:3)
         write (iolog,'(a,3i2)') ' Min avg max numbers of refinement iterations:', itrefmin, nint ( itrefmean ), itrefmax
       endif
       
       deallocate ( chisq, paramspace )

       deallocate ( ncolsig, ncolfxp, ncolfxt, ncolsnr, ncolfpe, ncolfte, snrpeak, snrtotal, frequency, fxpbest, fxperro, fxtbest
     &            , fxterro, opacity, sedslope, wavelength, sfrequency, sfxtbest, sfxterro, sigmono, beam, fxperror, fxterror )
       
       deallocate ( ltakeit, x0o, y0o, sigglobal, goodness, nxmin )

       deallocate ( fitparameters, ipfitornot, dyda, covar, alpha )
       
       if (limages) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' Writing output: '''//temperatur(1:ilt)//'''...'
         if (iolog .gt. 0) write (iolog,'(/a)') ' Writing output: '''//temperatur(1:ilt)//'''...'
        
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, tempers, dx, dy, object, crval1
     &              , crval2, temperatur(1:ilt), header, footer, iotty, cdate, ctime, creator, beamx, blank, crota1, crota2
     &              , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
        
         if (iotty .gt. 0) write (iotty,'(a)') ' Writing output: '''//coldensity(1:ilc)//'''...'
         if (iolog .gt. 0) write (iolog,'(a)') ' Writing output: '''//coldensity(1:ilc)//'''...'
        
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, coldens, dx, dy, object, crval1
     &              , crval2, coldensity(1:ilc), header, footer, iotty, cdate, ctime, creator, beamx, blank, crota1, crota2
     &              , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
        
         if (iotty .gt. 0) write (iotty,'(a)') ' Writing output: '''//chisquarnu(1:ilq)//'''...'
         if (iolog .gt. 0) write (iolog,'(a)') ' Writing output: '''//chisquarnu(1:ilq)//'''...'

         do j=1,ny
           do i=1,nx
             chisqnu(i,j) = min ( chisqnu(i,j), 30.0d0 )
           enddo
         enddo
        
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, chisqnu, dx, dy, object, crval1
     &              , crval2, chisquarnu(1:ilq), header, footer, iotty, cdate, ctime, creator, beamx, blank, crota1, crota2
     &              , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )

         deallocate ( fun, image, coldens, tempers, chisqnu )
       endif

! Convert plots from PostScript into PDF using Ghostscript's 'ps2pdf' script.

!!       if (lpostscript .and. nplt .gt. 0) then
!!         call plotnd ( psunit )
!!
!!         if (iotty .gt. 0) write (iotty,'(a)') ' ______________________________________________________________________________'
!!         if (iolog .gt. 0) write (iolog,'(a)') ' ______________________________________________________________________________'
!!
!!         if (iotty .gt. 0) write (iotty,'(/a)') ' Converting '''//postscript(1:ilp)//''' in PDF...'
!!         if (iolog .gt. 0) write (iolog,'(/a)') ' Converting '''//postscript(1:ilp)//''' in PDF...'
!!
!!         call ps2pdf ( postscript(1:ilp) )
!!       endif

       if (iotty .gt. 0) write (iotty,'(a)') ' ______________________________________________________________________________'
       if (iolog .gt. 0) write (iolog,'(a)') ' ______________________________________________________________________________'

       if (ltiming) then
         cpu_sum = cpu_sum + timer ( 'cpu', cpu )
         wal_sum = wal_sum + timer ( 'wal', wal )
       endif

! Total cpu usage, expressed in hours, minutes, and seconds.

       cputot = cpu_sum
       cpuhours = int ( cputot / 3600.0d0 )
       cpumins  = int ( cputot / 60.0d0 ) -  60 * cpuhours
       cpusecs  = int ( cputot + 0.5d0 ) - 3600 * cpuhours - 60 * cpumins

! Final wall clock time, expressed in hours, minutes, and seconds.

       wctot = wal_sum
       wchours = int ( wctot / 3600.0d0 )
       wcmins  = int ( wctot / 60.0d0 ) -  60 * wchours
       wcsecs  = int ( wctot + 0.5d0 ) - 3600 * wchours - 60 * wcmins

       call when ( lunix, ctime, cdate, ndate, 4 )

       write (ccpu,'(1pe9.2)') cpu_sum
       write (cwal,'(1pe9.2)') wal_sum
       write (cccpu,'(i3.2,a,i2.2,a,i2.2)') cpuhours,':',cpumins,':',cpusecs
       write (ccwal,'(i3.2,a,i2.2,a,i2.2)') wchours,':',wcmins,':',wcsecs
       ndc = 1
       ndw = 1
       if (cccpu(1:1) .eq. ' ') ndc = 2
       if (ccwal(1:1) .eq. ' ') ndw = 2

       if (iotty .gt. 0) write (iotty,'(/a)') ' DONE. '//cdate//' '//ctime//' CPU:'//ccpu//' s '//cccpu(ndc:)
     &                                      //' WALL:'//cwal//' s '//ccwal(ndw:)
       if (iolog .gt. 0) write (iolog,'(/a)') ' DONE. '//cdate//' '//ctime//' CPU:'//ccpu//' s '//cccpu(ndw:)
     &                                      //' WALL:'//cwal//' s '//ccwal(ndw:)
       if (iolog .gt. 0) close ( iolog )

!!       stop !<-- commented out because it would lead to run-time messages about denormalized values, when using gfortran.
       end

!|||||||||||||||||||||||||||||||||||||||||||||||||||||| MCM3D |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine fitsed 
       
     &            ( iotty, iolog, nsrc, nx0o, ny0o, nbands, nmodparams, nfitparams, nptstofit, wavelength, frequency, fluxvalue
     &            , fluxerror, sfrequency, sfluxvalue, sfluxerror, sedslope, distancepc, derivedmass, ctime, cdate, postscript
     &            , fitparameters, ipfitornot, dyda, covar, alpha, chisq, iter, lgood, lconv, lsing, limages, cmodel, modelfun
     &            , cwhat, quantities, opacityrelerr, dustgasrelerr, distancrelerr, uplimit, lpostscript, solidapixel )
!__________________________________________________________________________________________________________________________________
!
!__________________________________________________________________________________________________________________________________
!
       implicit      none

       logical       lgood, lconv, lsing, limages, lpostscript

       integer       nps, nsmx, nfu, nrj, iotty, iolog

       parameter   ( nps = 200, nsmx = 50, nfu = nsmx, nrj = nsmx )

       character*4   clam1, clam2, cx, cy
       character*5   xhlp, yhlp
       character*6   ctdf, lverbose
       character*7   cnu 
       character*8   cchi
       character*9   cso, clo
       character*10  cnsrc
       character*80  symbol(nfu), color(nfu)
       character*128 xlab(2), ylab(2), phdr, varnam(nfu), pftr(4)
       character*(*) ctime, cdate, cmodel, cwhat, postscript

       integer       nsrc, nmodparams, nbands, nfitparams, nfun, i, j, lam1, lam2, nu, nn, lastc, nl1, nl2, nm, nt, nptstofit, npf
     &             , nx0o, ny0o, ncx, ncy, iter

       integer       ndsh(nfu), ibe(nfu), ien(nfu), lwid(nfu), uplimit(nbands), ipfitornot(nmodparams)

       real          funmx, funmn, xnmn, xnmx, xnlmn, xnlmx, plt1x0, plt1y0, xoffset, yoffset

       real          fun(nps,nfu), xn(nps,nfu), ssze(nfu), uppr(nfu), rght(nfu), xerrp(nps,nfu), xerrm(nps,nfu), yerrp(nps,nfu)
     &             , yerrm(nps,nfu), grayslope(nsmx)                                             
                                                                                                     
       real*8        distance2, pc, fq, derivedmass, derivedmassx, speedolight, fitflux, opacity0, angulardiam, hh, k_B, Msun
     &             , grayintens1, grayintens2, chisq, wave4mass, distancepc, dust2gas, freq4mass, scalingfactor, fitflux4mass
     &             , rayleighjeans, frequency0, wavelength0, bbody, almostzero, fluxpeak, fluxmin, domegarelerr, dcdenrelerr
     &             , sq_arcsecs_per_sterad, fun2max, fun3max, freqmeanhi, freqmeanlo, Lsun, pi, pi4, sedluminosity, fitluminosity
     &             , sedbolflux, fitbolflux, amu, muH2, tauwave4mass, wavedepthone, dlog10freq, fitlumerror, bbodyZmass
     &             , dmasserror, sedbolfrelerr, sedbolfluxerr, fitbolfrelerr, fitfluxrelerr, opacityrelerr, dustgasrelerr
     &             , distancrelerr, dmassrelerr, opacdepthone, fitflux4massup, dncoldrelerr, derivedcden, dcdenerror, solidapixel

       real*8        frequency(nbands), wavelength(nbands), fluxvalue(nbands), fluxerror(nbands), sedslope(nbands), fitparamsup(4)
     &             , sfrequency(nptstofit), sfluxvalue(nptstofit), sfluxerror(nptstofit), waves(nps), sedfit(nps)
     &             , fitparameters(nmodparams), dyda(nmodparams), covar(nmodparams,nmodparams), alpha(nmodparams,nmodparams)
     &             , quantities(*)

       parameter   ( pc = 3.085678d18, speedolight = 2.99792458d10, k_B = 1.380658d-16, hh = 6.626d-27, Msun = 1.9891d33
     &             , Lsun = 3.826D+33, sq_arcsecs_per_sterad = 3282.80635d0 * 3600.0d0**2, pi = 3.14159265358979d0
     &             , pi4 = pi * 4.0d0, almostzero = 1.0d-20, amu = 1.6605402D-24, muH2 = 2.8d0 )  ! muH = 2.33d0 is wrong

       common / copacity / frequency0, wavelength0, opacity0, dust2gas, lverbose
  
       external      modelfun, fitfun, planck, lastc
!__________________________________________________________________________________________________________________________________
!
       write (cnsrc,'(i10)') nsrc
       nn = int ( log10 ( dble ( nsrc ) ) ) + 1

! Number of the degrees of freedom NU: for reliable fits, CHI^2 is similar to NU.

       nu = nptstofit - nfitparams
       write (cnu,'(i7)') nu
       if (nu .gt. 0) then
         nm = int ( log10 ( dble ( nu ) ) ) + 1
       else
         nm = 1
       endif

       distance2 = (distancepc * pc)**2

       call fitfun ( iotty, iolog, nmodparams, nptstofit, sfrequency, sfluxvalue, sfluxerror, fitparameters, ipfitornot, covar
     &             , alpha, chisq, iter, lgood, lconv, lsing, cmodel, modelfun, cwhat )
     
! Compute SED slopes between the PACS and SPIRE wavelengths and slopes of the fitted SED.

       call modelfun ( sfrequency(1), fitparameters, grayintens1, dyda, nmodparams )

       do i=1,nptstofit-1

         call modelfun ( sfrequency(i+1), fitparameters, grayintens2, dyda, nmodparams )

         dlog10freq = -(log10 ( sfrequency(i+1) ) - log10 ( sfrequency(i) ))
         sedslope(i) = (log10 ( sfluxvalue(i+1) ) - log10 ( sfluxvalue(i) )) / dlog10freq
         grayslope(i) = (log10 ( grayintens2 ) - log10 ( grayintens1 )) / dlog10freq
         grayintens1 = grayintens2
       enddo

! Integrate rough bolometric flux under the input fluxes.

       sedbolflux = 0.0d0
       freqmeanhi = sfrequency(1) + (sfrequency(1) - 0.5d0 * (sfrequency(1) + sfrequency(2)))
       do i=1,nptstofit-1
         freqmeanlo = 0.5d0 * (sfrequency(i) + sfrequency(i+1))
         sedbolflux = sedbolflux + 1.0d-23 * sfluxvalue(i) * (freqmeanhi - freqmeanlo)
         freqmeanhi = freqmeanlo
       enddo
       
       sedluminosity = sedbolflux * pi4 * distance2 / Lsun

! Integrate bolometric flux under the fitted graybody fluxes.

       xnmn = min ( wavelength(1), 30.0d0 )
       xnmx = max ( wavelength(nptstofit), 1000.0d0 )
       xnlmn = log10 ( xnmn )
       xnlmx = log10 ( xnmx )

       do i=1,nps
         waves(i) = 10.0d0**( xnlmn + (i - 1) * (xnlmx - xnlmn) / (nps - 1) )

         call modelfun ( 1.0d4 * speedolight / waves(i), fitparameters, sedfit(i), dyda, nmodparams )

       enddo

       fitbolflux = 0.0d0
       freqmeanhi = 1.0d4 * speedolight * (1.0d0 / waves(1) + (1.0d0 / waves(1) - 2.0d0 / (waves(1) + waves(2))))
       do i=1,nps-1
         freqmeanlo = 1.0d4 * speedolight * 2.0d0 / (waves(i) + waves(i+1))
         fitbolflux = fitbolflux + 1.0d-23 * sedfit(i) * (freqmeanhi - freqmeanlo)
         freqmeanhi = freqmeanlo
       enddo

! Error propagation for sums and differences for random and independent quantities: 
! total uncertainty of sums and differences is the quadratic sum of the individual uncertainties.
! Error propagation for products and quotients for random and independent quantities: 
! total uncertainty of products and quotients is the quadratic sum of the individual *relative* uncertainties.

       sedbolfluxerr = 0.0d0
       do i=1,nptstofit-1
         sedbolfluxerr = sedbolfluxerr + (1.0d-23 * sfluxerror(i))**2
       enddo
       sedbolfrelerr = sqrt ( sedbolfluxerr ) / sedbolflux

       fitparamsup(1) = fitparameters(1) + sqrt ( abs ( covar(1,1) ) )
       fitparamsup(2) = fitparameters(2) + sqrt ( abs ( covar(2,2) ) )
       fitparamsup(3) = fitparameters(3) + sqrt ( abs ( covar(3,3) ) )
       fitparamsup(4) = fitparameters(4) + sqrt ( abs ( covar(4,4) ) )

       call planck ( fitparameters(1), 1.0d4 / wavelength(nptstofit), bbodyZmass )
       
       wave4mass = 100000.0d0 !<-- 100 millimeters
       freq4mass = 1.0d4 * speedolight / wave4mass

       call modelfun ( freq4mass, fitparameters, fitflux4mass, dyda, nmodparams )
       call modelfun ( freq4mass, fitparamsup, fitflux4massup, dyda, nmodparams )

       fitfluxrelerr = 0.0d0
       if (fitflux4mass .gt. almostzero) then
         fitfluxrelerr = (fitflux4massup - fitflux4mass) / fitflux4mass
       endif
       fitbolfrelerr = sedbolfrelerr

       fitluminosity = fitbolflux * pi4 * distance2 / Lsun
       fitlumerror = fitluminosity * sqrt ( fitbolfrelerr**2 + 2.0d0 * distancrelerr**2 )

! Derive quantities at fitted temperature.

       if (cmodel .eq. 'graybody') then

! Standard formula for mass derivation: M=Fnu*D^2/(kappanu*Bnu(T)). It can be converted to the alternative formula (see below) 
! by simply using the definition: Fnu=Bnu(T)*Omega, assuming a blackbody source with uniform brightness at temperature T.
! Simpler formula for mass derivation: M=Omega*D^2*Sigma (mass = area * column_number_density * muH2 * mH).

         domegarelerr = sqrt ( abs ( covar(2,2) )) / fitparameters(2)
         dncoldrelerr = sqrt ( abs ( covar(3,3) )) / fitparameters(3)
         derivedmass = fitparameters(2) * distance2 * fitparameters(3) * (amu * muH2) / Msun
         dmasserror = derivedmass * sqrt ( domegarelerr**2 + dncoldrelerr**2 + 2.0d0 * distancrelerr**2 + opacityrelerr**2 
     &                                   + dustgasrelerr**2 )
     
! Another mass formula (Pezzutto et al. 2012). From tau=(frq/frq1)^beta or tau=(lam1/lam)^beta; kappa=kappa0*(lam0/lam)^beta;
! Omega=pi*R^2/D^2; tau=kappa0*(lam0/lam)^beta*M/(pi*R^2), one can get: M=Omega*D^2*/kappa1, where kappa1=kappa0*(lam0/lam1)^beta
! is the opacity of gas+dust at wavelength where the optical depth is unity.

         tauwave4mass = fitparameters(3) * (amu * muH2) * dust2gas * opacity0 * (wavelength0 / wave4mass)**fitparameters(4)
         wavedepthone = (wave4mass**fitparameters(4) * tauwave4mass)**(1.0d0 / fitparameters(4))
         opacdepthone = opacity0 * (wavelength0 / wavedepthone)**fitparameters(4)
         derivedmassx = fitparameters(2) * distance2 / dust2gas / opacdepthone / Msun
         angulardiam = 2.0d0 * sqrt ( fitparameters(2) * sq_arcsecs_per_sterad / pi )
       endif
       if (cmodel .eq. 'thinbody') then
         if (distancepc .gt. 1.0001d0) then
           derivedmass = fitparameters(2) / Msun
           dmassrelerr = sqrt ( abs ( covar(2,2) )) / fitparameters(2)
           dmasserror = derivedmass * sqrt ( dmassrelerr**2 + 2.0d0 * distancrelerr**2 + opacityrelerr**2 + dustgasrelerr**2 )
           if (limages) then
             derivedcden = fitparameters(2) / (amu * muH2) / solidapixel / distance2
             dcdenerror = derivedcden * sqrt ( dmassrelerr**2 + 2.0d0 * distancrelerr**2 + opacityrelerr**2 + dustgasrelerr**2 )
           else
             derivedcden = 0.0d0
             dcdenerror = 0.0d0
           endif
         else
           derivedcden = fitparameters(2)
           dcdenrelerr = sqrt ( abs ( covar(2,2) )) / fitparameters(2)
           dcdenerror = derivedcden * sqrt ( dcdenrelerr**2 + opacityrelerr**2 + dustgasrelerr**2 )
           derivedmass = 0.0d0
           dmasserror = 0.0d0
         endif
         tauwave4mass = derivedcden * (amu * muH2) * dust2gas * opacity0 * (wavelength0 / wave4mass)**fitparameters(3)
         wavedepthone = (wave4mass**fitparameters(3) * tauwave4mass)**(1.0d0 / fitparameters(3))
         angulardiam = 2.0d0 * sqrt ( solidapixel * sq_arcsecs_per_sterad / pi )
       endif

! Collect derived parameters.

       quantities(1) = fitparameters(1)
       quantities(2) = sqrt ( abs ( covar(1,1) ) )
       quantities(3) = derivedmass
       quantities(4) = dmasserror
       quantities(5) = fitluminosity
       quantities(6) = fitlumerror
         
       if (cmodel .eq. 'graybody') then
         quantities( 7) = angulardiam
         quantities( 8) = 2.0d0 * sqrt ( sqrt ( abs ( covar(2,2) ) ) * sq_arcsecs_per_sterad / pi )
         quantities( 9) = fitparameters(3)
         quantities(10) = sqrt ( abs ( covar(3,3) ) )
         quantities(11) = fitparameters(4)
         quantities(12) = sqrt ( abs ( covar(4,4) ) )
         quantities(13) = distancepc
         quantities(14) = 0.0d0
       endif
       if (cmodel .eq. 'thinbody') then
         quantities( 7) = angulardiam
         quantities( 8) = 0.0d0
         quantities( 9) = derivedcden
         quantities(10) = dcdenerror
         quantities(11) = fitparameters(3)
         quantities(12) = sqrt ( abs ( covar(3,3) ) )
         quantities(13) = fitparameters(4) / pc
         quantities(14) = sqrt ( abs ( covar(4,4) ) ) / pc
       endif

       quantities(15) = wavedepthone
       quantities(16) = chisq
       quantities(17) = dble ( nu )
       
! Show graybody slopes between the PACS and SPIRE wavelengths.

       if (cwhat .eq. 'finalfit' .and. iotty .gt. 0 .and. lverbose .ne. '-verb0') then
         if (lverbose .eq. '-verb2') then
           write (iotty,'(/a,f7.3,10f8.3)') '   FITSED: Original SED slopes:', (sedslope (i), i=1,nptstofit-1)
           write (iotty,'( a,f7.3,10f8.3)') '   FITSED: Graybody fit slopes:', (grayslope(i), i=1,nptstofit-1)
           write (iotty,'()')
           if (nmodparams .eq. 4 .and. wavedepthone .gt. almostzero) then  !!! .and. distancepc .lt. 1.0001d0   
             write (iotty,'(a,2(1pe9.2,a))') '   FITSED: Optical depth is 1.00 at', wavedepthone, ' um'
     &                                      , 1.0d4 * speedolight / wavedepthone / 1.0d9, ' GHz'
           endif
           write (iotty,'(a,f5.2,a,2(1pe9.2,a))') '   FITSED:  Dust opacity is', opacity0,' at', wavelength0, ' um'
     &                                          , frequency0 / 1.0d9, ' GHz'
         endif
         write (iotty,'(/a,1pe10.3,a,2(e9.2,a))'  ) '   FITSED:    Temperature:', quantities(1), ' K     ±'
     &                                            , quantities(2), ' K     ±', quantities(2) / (quantities(1) + almostzero)
         if (cmodel .eq. 'graybody') then
           write (iotty,'(a,1pe10.3,a,2(e9.2,a))' ) '   FITSED:    Solid angle:', fitparameters(2), ' ster  ±'
     &                                            , sqrt ( abs ( covar(2,2) ) ), ' ster  ±'
     &                                            , sqrt ( abs ( covar(2,2) ) ) / (fitparameters(2) + almostzero)
           if (nmodparams .eq. 4) then
             write (iotty,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED: Column density:', quantities(9), ' cm^-2 ±'
     &                                            , quantities(10), ' cm^-2 ±', quantities(10) / (quantities(9) + almostzero)
             write (iotty,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED:  Opacity slope:', quantities(11), '       ±'
     &                                            , quantities(12), '       ±', quantities(12) / (quantities(11) + almostzero)
           endif
         endif
         if (cmodel .eq. 'thinbody') then
           write (iotty,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED:     Total mass:', quantities(3), ' Msun  ±'
     &                                          , quantities(4), ' Msun  ±', quantities(4) / (quantities(3) + almostzero)
           write (iotty,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED: Column density:', quantities(9), ' cm^-2 ±'
     &                                          , quantities(10), ' cm^-2 ±', quantities(10) / (quantities(9) + almostzero)
           if (nmodparams .eq. 4) then
             write (iotty,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED:  Opacity slope:', quantities(11), '       ±'
     &                                            , quantities(12), '       ±', quantities(12) / (quantities(11) + almostzero)
             write (iotty,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED:       Distance:', quantities(13), ' pc    ±'
     &                                            , quantities(14), ' pc    ±', quantities(14) / (quantities(13) + almostzero)
           endif
         endif
         if (cmodel .eq. 'graybody') then
           write (iotty,'(/a,1pe10.3,a)'  ) '   FITSED:   Assumed distance:', distancepc, ' pc'
           write (iotty,'(a,3(1pe10.3,a))') '   FITSED: Derived total mass:', quantities(3), ' Msun ±', quantities(4), ' Msun ±'
     &                                    , quantities(4) / (quantities(3) + almostzero)
           write (iotty,'(a,3(1pe10.3,a))') '   FITSED: Derived total mass:', derivedmassx,  ' Msun (alternative formula)'
           write (iotty,'(a,3(1pe10.3,a))') '   FITSED: Derived luminosity:', quantities(5), ' Lsun ±', quantities(6), ' Lsun ±'
     &                                    , quantities(6) / (quantities(5) + almostzero)
           write (iotty,'(a,2(1pe10.3,a))') '   FITSED: Approx. luminosity:', sedluminosity, ' Lsun (from observed fluxes)'
           write (iotty,'(a,2(1pe10.3,a))') '   FITSED:   Angular diameter:', quantities(7), ' arcsec'
         endif
         if (cmodel .eq. 'thinbody' .and. lverbose .ne. '-verb0') then    !!! .and. distancepc .gt. 1.0001d0
           write (iotty,'(/a,3(1pe10.3,a))' ) '   FITSED: Derived luminosity:', quantities(5), ' Lsun ±', quantities(6), ' Lsun ±'
     &                                      , quantities(6) / (quantities(5) + almostzero)
           write (iotty,'(a,2(1pe10.3,a))'  ) '   FITSED: Approx. luminosity:', sedluminosity, ' Lsun (from observed fluxes)'
           write (iotty,'(a,2(1pe10.3,a))'  ) '   FITSED:   Angular diameter:', quantities(7), ' arcsec'
         endif
       endif
       
       if (cwhat .eq. 'finalfit' .and. iolog .gt. 0 .and. lverbose .ne. '-verb0') then
         if (lverbose .eq. '-verb2') then
           write (iolog,'(/a,f7.3,10f8.3)') '   FITSED: Original SED slopes:', (sedslope (i), i=1,nptstofit-1)
           write (iolog,'( a,f7.3,10f8.3)') '   FITSED: Graybody fit slopes:', (grayslope(i), i=1,nptstofit-1)
           write (iolog,'()')
           if (nmodparams .eq. 4 .and. wavedepthone .gt. almostzero) then        !!! .and. distancepc .lt. 1.0001d0
             write (iolog,'(a,2(1pe9.2,a))') '   FITSED: Optical depth is 1.00 at', wavedepthone, ' um'
     &                                      , 1.0d4 * speedolight / wavedepthone / 1.0d9, ' GHz'
           endif
           write (iolog,'(a,f5.2,a,2(1pe9.2,a))') '   FITSED:  Dust opacity is', opacity0,' at', wavelength0, ' um'
     &                                          , frequency0 / 1.0d9, ' GHz'
         endif
         write (iolog,'(/a,1pe10.3,a,2(e9.2,a))'  ) '   FITSED:    Temperature:', quantities(1), ' K     ±'
     &                                            , quantities(2), ' K     ±', quantities(2) / (quantities(1) + almostzero)
         if (cmodel .eq. 'graybody') then
           write (iolog,'(a,1pe10.3,a,2(e9.2,a))' ) '   FITSED:    Solid angle:', fitparameters(2), ' ster  ±'
     &                                            , sqrt ( abs ( covar(2,2) ) ), ' ster  ±'
     &                                            , sqrt ( abs ( covar(2,2) ) ) / (fitparameters(2) + almostzero)
           if (nmodparams .eq. 4) then
             write (iolog,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED: Column density:', quantities(9), ' cm^-2 ±'
     &                                            , quantities(10), ' cm^-2 ±', quantities(10) / (quantities(9) + almostzero)
             write (iolog,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED:  Opacity slope:', quantities(11), '       ±'
     &                                            , quantities(12), '       ±', quantities(12) / (quantities(11) + almostzero)
           endif
         endif
         if (cmodel .eq. 'thinbody') then
           write (iolog,'(a,1pe10.3,2(a,e9.2))'   ) '   FITSED:     Total mass:', quantities(3), ' Msun  ±'
     &                                            , quantities(4), ' Msun  ±', quantities(4) / (quantities(3) + almostzero)
           write (iolog,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED: Column density:', quantities(9), ' cm^-2 ±'
     &                                          , quantities(10), ' cm^-2 ±', quantities(10) / (quantities(9) + almostzero)
           if (nmodparams .eq. 4) then
             write (iolog,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED:  Opacity slope:', quantities(11), '       ±'
     &                                            , quantities(12), '       ±', quantities(12) / (quantities(11) + almostzero)
             write (iolog,'(a,1pe10.3,2(a,e9.2))' ) '   FITSED:       Distance:', quantities(13), ' pc    ±'
     &                                            , quantities(14), ' pc    ±', quantities(14) / (quantities(13) + almostzero)
           endif
         endif
         if (cmodel .eq. 'graybody') then
           write (iolog,'(/a,1pe10.3,a)'  ) '   FITSED:   Assumed distance:', distancepc, ' pc'
           write (iolog,'(a,3(1pe10.3,a))') '   FITSED: Derived total mass:', quantities(3), ' Msun ±', quantities(4), ' Msun ±'
     &                                    , quantities(4) / (quantities(3) + almostzero)
           write (iolog,'(a,3(1pe10.3,a))') '   FITSED: Derived total mass:', derivedmassx,  ' Msun (alternative formula)'
           write (iolog,'(a,3(1pe10.3,a))') '   FITSED: Derived luminosity:', quantities(5), ' Lsun ±', quantities(6), ' Lsun ±'
     &                                    , quantities(6) / (quantities(5) + almostzero)
           write (iolog,'(a,2(1pe10.3,a))') '   FITSED: Approx. luminosity:', sedluminosity, ' Lsun (from observed fluxes)'
           write (iolog,'(a,2(1pe10.3,a))') '   FITSED:   Angular diameter:', quantities(7), ' arcsec'
         endif
         if (cmodel .eq. 'thinbody' .and. lverbose .ne. '-verb0') then        !!! .and. distancepc .gt. 1.0001d0
           write (iolog,'(/a,3(1pe10.3,a))' ) '   FITSED: Derived luminosity:', quantities(5), ' Lsun ±', quantities(6), ' Lsun ±'
     &                                      , quantities(6) / (quantities(5) + almostzero)
           write (iolog,'(a,2(1pe10.3,a))'  ) '   FITSED: Approx. luminosity:', sedluminosity, ' Lsun (from observed fluxes)'
           write (iolog,'(a,2(1pe10.3,a))'  ) '   FITSED:   Angular diameter:', quantities(7), ' arcsec'
         endif
       endif
       
! Plot fitted SEDs.

       if (cwhat .eq. 'finalfit' .and. lpostscript) then
       
!!         if (lverbose .eq. '-verb2') then
!!           if (iotty .gt. 0) write (iotty,'(/a)') '   FITSED: Plotting: '''//postscript//'''...'
!!           if (iolog .gt. 0) write (iolog,'(/a)') '   FITSED: Plotting: '''//postscript//'''...'
!!         endif
        
         write (ctdf,'(f6.1)') fitparameters(1)
         nt = int ( log10 ( fitparameters(1) ) ) + 1
        
         lam1 = nint ( 1.0d4 * speedolight / sfrequency(1) )
         lam2 = nint ( 1.0d4 * speedolight / sfrequency(nptstofit) )
         write (clam1,'(i4)') lam1
         write (clam2,'(i4)') lam2
         nl1 = int ( log10 ( dble ( lam1 ) ) ) + 1
         nl2 = int ( log10 ( dble ( lam2 ) ) ) + 1
        
         nfun = 5
         do j=1,nfu
           ibe(j) = 1
           do i=1,nps
             xerrp(i,j) = 0.0
             xerrm(i,j) = 0.0
             yerrp(i,j) = 0.0
             yerrm(i,j) = 0.0
           enddo
         enddo

         phdr = ''
         pftr(1) = ''
         pftr(2) = ''
         pftr(3) = ''
         pftr(4) = ''
         write (pftr(1),'(a)') postscript
         write (pftr(2),'(a10,''  '',a8)') cdate, ctime
        
         xlab(1) = 'Wavelength |F5|l|BF0| |N|(|F5|m|F0|m)'
!!!         if (.not.limages) then
         ylab(1) = '  Total flux |F10|F|BF5|n |NF0|(Jy)'
!!!         else
!!!           ylab(1) = '  Pixel intensity |F10|I|BF5|n |NF0|(Jy/sr)'
!!!         endif
         xlab(2) = 'Frequency |F5|n|F0| (GHz)'
         ylab(2) = ' '
         varnam(1) = ' '
         varnam(2) = '|F10|F|BF5|n|BF0|,obs'
         varnam(3) = '|F10|F|BF5|n|BF0|,GB ('//ctdf(6-nt-1:6)//'|B|K)'
         varnam(4) = '|F10|F|BF5|n|BF0|,BB ('//ctdf(6-nt-1:6)//'|B|K)'
         varnam(5) = '|F10|F|BF5|n|BF0|,BBRJ'
         xhlp = 'all'
         yhlp = 'all'

! Wavelengths.

         do i=1,nbands
           xn(i,1) = 1.0e4 * speedolight / frequency(i)
           fun(i,1) = max ( fluxvalue(i), 0.00001d0 )
           if (uplimit(i) .eq. 0) then
             yerrp(i,1) = fluxerror(i)
           else
             yerrp(i,1) = 0.0d0
           endif
           yerrm(i,1) = min ( fluxerror(i), 0.999999 * fun(i,1) )
         enddo
         ien(1) = nbands

         do i=1,nptstofit
           xn(i,2) = 1.0e4 * speedolight / sfrequency(i)
           fun(i,2) = max ( sfluxvalue(i), 0.00001d0 )
           yerrp(i,2) = sfluxerror(i)
           yerrm(i,2) = min ( sfluxerror(i), 0.999999 * fun(i,2) )
         enddo
         ien(2) = nptstofit

! If there are upper limits, make them the same color as the fitted points.

         npf = nptstofit
         do i=1,nbands
           if (uplimit(i) .eq. 1) then
             npf = npf + 1
             xn(npf,2) = xn(i,1)
             fun(npf,2) = max ( fluxvalue(i), 0.00001d0 )
             yerrp(npf,2) = 0.0d0
             yerrm(npf,2) = min ( fluxerror(i), 0.999999 * fun(i,1) )
           endif
         enddo
         ien(2) = npf

! Graybody fitted to the input fluxes.

         do i=1,nps
           xn(i,3) = 10.0**( xnlmn + (i - 1) * (xnlmx - xnlmn) / (nps - 1) )
           call modelfun ( 1.0d4 * speedolight / dble ( xn(i,3) ), fitparameters, fitflux, dyda, nmodparams )
           fun(i,3) = fitflux
         enddo
         ien(3) = nps

! Blackbody normalized to the maximum of the graybody fit.

         fun2max = -1.0e+30
         fun3max = -1.0e+30
         do i=1,nps
           xn(i,4) = 10.0**( xnlmn + (i - 1) * (xnlmx - xnlmn) / (nps - 1) )
           call planck ( fitparameters(1), 1.0d4 / dble ( xn(i,4) ), bbody )
           fun(i,4) = bbody
           fun2max = max ( fun(i,3), fun2max )
           fun3max = max ( fun(i,4), fun3max )
         enddo
         scalingfactor = fun2max / fun3max
         do i=1,nps
           call planck ( fitparameters(1), 1.0d4 / dble ( xn(i,4) ), bbody )
           fun(i,4) = bbody * scalingfactor
         enddo
         ien(4) = nps
        
! Rayleigh-Jeans curve, normalized to blackbody at 100 millimeters.

         fq = 1.0d4 * speedolight / 1.0d5
         call planck ( fitparameters(1), 1.0d4 / 1.0d5, bbody )
         rayleighjeans = 2.0 * fq**2 * k_B * fitparameters(1) / speedolight**2
         scalingfactor = scalingfactor * (bbody / rayleighjeans)
        
         do i=1,nrj
           xn(i,5) = 500.0 + (i - 1) * (xnmx - 500.0) / (nrj - 1)
           fq = 1.0d4 * speedolight / xn(i,5)
           rayleighjeans = 2.0 * fq**2 * k_B * fitparameters(1) / speedolight**2
           fun(i,5) = rayleighjeans * scalingfactor
         enddo
         ien(5) = nrj

! Limit displayed values of fluxes.

         fluxpeak = 0.0d0
         fluxmin = 1.0d30
         do i=1,nbands
           if (fluxvalue(i) .gt. fluxpeak) then
             fluxpeak = fluxvalue(i)
           endif
           if (fluxvalue(i) .le. fluxmin .and. fluxvalue(i) .gt. 0.0001) then
             fluxmin = fluxvalue(i)
           endif
         enddo
         funmx = -1.0e+30
         funmn =  1.0e+30
         do j=1,nfun
           do i=1,ien(j)
             funmx = max ( fun(i,j), funmx )
             if (fun(i,j) .gt. 0.0001) funmn = min ( fun(i,j), funmn )
           enddo
         enddo
         funmn = max ( 0.5 * fluxmin, funmn )  !!!, 0.0001
         funmx = min ( 1.5 * fluxpeak, 1.1 * funmx )

! Limit function values to avoid problems when creating PostScript plots.

         do j=1,nfun
           do i=1,nps
             if (i .le. ien(j)) then
               fun(i,j) = max ( fun(i,j), funmn / 100.0 )
               fun(i,j) = min ( fun(i,j), funmx * 10.0 )
             else
               xn(i,j) = xn(ien(j),j) * 100.0
               fun(i,j) = fun(ien(j),j) / 100.0
             endif
           enddo
         enddo

         if (.not.limages) then
           write (66,'(a)') '#___________________________________________________________________________________________'
           write (66,'(a)') '#'
           write (66,'(a)') '# DATA FOR SOURCE # '//cnsrc(10-nn+1:10)
           write (66,'(a)') '#'
           write (66,'(a)') '#  1      2          3          4          5          6          7          8          9          10'
     &                    //'         11'
           if (cmodel .eq. 'graybody') then
             write (66,'(a)') '# NO    WAVEO     OBSFLUX     WAVEOF    OBSFLUXF    WAVEG     GRAYBODY    WAVEB    BLACKBODY'
     &                      //'    WAVER    RAY-JEANS'
           endif
           if (cmodel .eq. 'thinbody') then
             write (66,'(a)') '# NO    WAVEO     OBSFLUX     WAVEOF    OBSFLUXF    WAVEM     THINBODY    WAVEB    BLACKBODY'
     &                      //'    WAVER    RAY-JEANS'
           endif
           write (66,'(a)') '#'
          
           do i=1,nps
             write (66,'(i4,100(1pe11.3))') i, (xn(i,j), fun(i,j), j=1,nfun)
           enddo
         endif
           
         color (1) = 'green'
         symbol(1) = 'circle'
         ssze  (1) = 1.20
         ndsh  (1) = 0
         lwid  (1) = 0
         uppr  (1) = 3.0e5
         rght  (1) = 0.0
         color (2) = 'blue'
         symbol(2) = 'circle'
         ssze  (2) = 1.20
         ndsh  (2) = 0
         lwid  (2) = 0
         uppr  (2) = -1.0
         rght  (2) = 0.0
         color (3) = 'red'
         symbol(3) = 'circle'
         ssze  (3) = 0.0
         ndsh  (3) = 0
         lwid  (3) = 7
         uppr  (3) = -1.0
         rght  (3) = 1.0
         color (4) = 'black'
         symbol(4) = 'circle'
         ssze  (4) = 0.0
         ndsh  (4) = 4
         lwid  (4) = 3
         uppr  (4) = -1.0
         rght  (4) = 1.0
         color (5) = 'black'
         symbol(5) = 'circle'
         ssze  (5) = 0.0
         ndsh  (5) = 8
         lwid  (5) = 3
         uppr  (5) = -1.0
         rght  (5) = 1.0

! Position plot on page.

         plt1x0 =  3.3
         plt1y0 = 15.0
         
! Produce the plot.         

!!         call gsav ()
!!        
!!         call psmv1d ( xn, fun, ibe, ien, nps, nfun, varnam, xlab, ylab, phdr, pftr, plt1x0, plt1y0, 'loglog', 'nono', xnmn
!!     &               , xnmx, uppr, funmn, funmx, rght, xhlp, yhlp, color, ndsh, lwid, ssze, symbol, xerrp, xerrm, yerrp, yerrm )
!!        
!!         call grest ()
        
         xoffset = 12.3
         yoffset = 6.7
         if (nmodparams .lt. 4) yoffset = yoffset - 2.4
        
         if (.not.limages) then
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset + 5.7, 0.27, 'Source # '//cnsrc(10-nn+1:10), 0., 0 )
         else
           write (cx,'(i4)') nx0o
           write (cy,'(i4)') ny0o
           ncx = int ( log10 ( dble ( nx0o ) ) ) + 1
           ncy = int ( log10 ( dble ( ny0o ) ) ) + 1
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset + 5.8, 0.27, 'Pixel # '//cnsrc(10-nn+1:10), 0., 0 )
!!           call pschars ( plt1x0 + xoffset + 1.3, plt1y0 + yoffset + 5.4, 0.2, '('//cx(4-ncx+1:4)//','//cy(4-ncy+1:4)//')', 0., 0 )
         endif
        
!!         call pschars ( plt1x0 + xoffset, plt1y0 + yoffset + 0.6, 0.27, '|F5|l|BF0| |N|'//clam1(4-nl1+1:4)//'-'//clam2(4-nl2+1:4)//
!!     &                '|B| |NF5|m|F0|m', 0., 0 )
        
         yoffset = yoffset - 0.15
         write (cso,'(1pe9.2)') quantities(1)
         cso(6:6) = 'e'
!!         call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F10|T|B|  |NF0|='//cso//'|B| |N|K', 0., 0 )
        
         yoffset = yoffset - 0.6
         if (cmodel .eq. 'graybody') then
           write (cso,'(1pe9.2)') quantities(3)
           cso(6:6) = 'e'
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F10|M|B| |NF0|='//cso//'|B| |NF10|M|BF18|*', 0., 0 )
           yoffset = yoffset - 0.6
           write (cso,'(1pe9.2)') quantities(9)
           cso(6:6) = 'e'
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F10|N|B| |NF0|='//cso//'|B| |N|cm|S|-2|N|', 0., 0 )
         endif
         if (cmodel .eq. 'thinbody') then
           write (cso,'(1pe9.2)') quantities(3)
           cso(6:6) = 'e'
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F10|M|B| |NF0|='//cso//'|B| |NF10|M|BF18|*', 0., 0 )
           yoffset = yoffset - 0.6
           write (cso,'(1pe9.2)') quantities(9)
           cso(6:6) = 'e'
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F10|N|B| |NF0|='//cso//'|B| |N|cm|S|-2|N|', 0., 0 )
         endif
        
         if (nmodparams .eq. 4) then
           yoffset = yoffset - 0.6
           if (cmodel .eq. 'thinbody') then
             write (cso,'(1pe9.2)') quantities(11)
             cso(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|b|B|  |NF0|='//cso, 0., 0 )
             yoffset = yoffset - 0.6
             write (cso,'(1pe9.2)') quantities(13)
             cso(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F10|D|B|  |NF0|='//cso//'|B| |N|pc', 0., 0 )
           endif
           if (cmodel .eq. 'graybody') then
             write (cso,'(1pe9.2)') quantities(11)
             cso(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|b|B|  |NF0|='//cso, 0., 0 )
             yoffset = yoffset - 0.6
             write (cso,'(1pe9.2)') fitparameters(2)
             cso(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|W|B| |NF0|='//cso//'|B| |N|ster', 0., 0 )
           endif
         endif

         yoffset = yoffset - 0.6 - 0.15
         write (cchi,'(1pe8.1)') chisq
        
         if (chisq / dble ( nu + 1 ) .le. 1.0d0) then
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|c|SF0|2 |NF0|='//cchi//' ('//cnu(7-nm+1:7)//') ok', 0.,0 )
         else
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|c|SF0|2 |NF0|='//cchi//' ('//cnu(7-nm+1:7)//') bad', 0.,0 )
         endif
        
         yoffset = yoffset - 0.6 - 0.15
         write (cso,'(1pe9.2)') quantities(5)
         cso(6:6) = 'e'
!!         call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F10|L|B|  |NF0|='//cso//'|B| |NF10|L|BF18|*', 0., 0 )
        
         yoffset = yoffset - 0.6 - 0.15
         write (clo,'(1pe9.2)') quantities(2) / (quantities(1) + 1.0e-30)
         clo(6:6) = 'e'
!!         call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF10|T|F0| |NF0|='//clo, 0., 0 )
        
         yoffset = yoffset - 0.6
         if (cmodel .eq. 'graybody') then
           write (clo,'(1pe9.2)') quantities(8) / (quantities(7) + 1.0e-30)
           clo(6:6) = 'e'
!!           call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF5|W|F0| |NF0|='//clo, 0., 0 )
         endif
         if (cmodel .eq. 'thinbody') then
           if (distancepc .gt. 1.001d0) then
             write (clo,'(1pe9.2)') quantities(4) / (quantities(3) + 1.0e-30)
             clo(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF10|M|F0| |NF0|='//clo, 0., 0 )
           else
             write (clo,'(1pe9.2)') quantities(4) / (quantities(3) + 1.0e-30)
             clo(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF10|N|F0| |NF0|='//clo, 0., 0 )
           endif
         endif
        
         if (nmodparams .eq. 4) then
           yoffset = yoffset - 0.6
           if (cmodel .eq. 'graybody') then
             write (clo,'(1pe9.2)') quantities(10) / (quantities(9) + 1.0e-30)
             clo(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF10|N|F0| |NF0|='//clo, 0., 0 )
           endif
           if (cmodel .eq. 'thinbody') then
             write (clo,'(1pe9.2)') quantities(12) / (quantities(11) + 1.0e-30)
             clo(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF5|b|F0| |NF0|='//clo, 0., 0 )
           endif
        
           yoffset = yoffset - 0.6
           if (cmodel .eq. 'graybody') then
             write (clo,'(1pe9.2)') quantities(12) / (quantities(11) + 1.0e-30)
             clo(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF5|b|F0| |NF0|='//clo, 0., 0 )
           endif
           if (cmodel .eq. 'thinbody') then
             write (clo,'(1pe9.2)') quantities(14) / (quantities(13) + 1.0e-30)
             clo(6:6) = 'e'
!!             call pschars ( plt1x0 + xoffset, plt1y0 + yoffset, 0.27, '|F5|e|BF10|D|F0| |NF0|='//clo, 0., 0 )
           endif
         endif
       endif

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine showprogress ( iotty, iolog, lunix, icount, ntotal, isumpct )
!__________________________________________________________________________________________________________________________________
!
! Display progress bar in percentage of current work; each point means that 2 % of work has been done (50 points in total)
!__________________________________________________________________________________________________________________________________
!
       logical       lshow, lunix
       character*1   shsq
       integer       i, ishow, iotty, iolog
       real*8        icount, ntotal, isumpct, ipcent
       parameter   ( shsq = '=' )
!__________________________________________________________________________________________________________________________________
!
       ipcent = icount * 100.0d0 / ntotal
       ishow = int ( ipcent / 2.0d0 - isumpct )
       lshow = mod ( int ( ipcent ), 2 ) .eq. 0
     
       if (lshow) then
         do i=1,ishow
           if (iotty .gt. 0) write (iotty,'(a)', advance='no') shsq
           if (iolog .gt. 0) write (iolog,'(a)', advance='no') shsq
           if (lunix) then
             if (iotty .gt. 0) endfile   ( iotty, err=888 )
 888         continue 
             if (iotty .gt. 0) backspace ( iotty )
           endif
           isumpct = isumpct + 1.0d0
         enddo
       endif
     
       if (abs ( icount - ntotal ) .lt. ntotal * 1.0d-14) then
          call sleep ( 1 )
          if (iotty .gt. 0) write (iotty,'(a)', advance='no') ' done'
          if (iolog .gt. 0) write (iolog,'(a)', advance='no') ' done'
          if (lunix) then
            if (iotty .gt. 0) endfile   ( iotty, err=999 )
 999        continue 
            if (iotty .gt. 0) backspace ( iotty )
          endif
          call sleep ( 1 )
          if (iotty .gt. 0) write (iotty,'()')
          if (iolog .gt. 0) write (iolog,'()')
       endif
     
       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header, footer, iotty
     &            , iolog, creator, beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history, lverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend, anynull, myfile
       character*(*) ctype1, ctype2, creator, fname, header, footer(2), bunit, object, history, lverbose
       character*25  cdatetime
       character*80  footer1, footer2, comment
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, lastc, iotty, iolog, maxdim
     &             , ilc1, ilc2, rw, nfound, blank, stat01, stat02, stat03, stat04, stat05, stat06, stat07, stat08, stat09
     &             , stat10, stat11, stat12, stat13, stat14, stat15, stat16, stat17, stat18, stat19, stat20, stat21, stat22
     &             , stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30, stat31, stat32, stat0, nan
       parameter   ( maxdim = 2 )
       integer       naxes(maxdim)
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22
       real*8        fun(nx,ny)
       real*8        as2deg, datamx, datamn
       parameter   ( as2deg = 1.0d0 / 3600.0d0 )
       external      lastc, ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat01 = 0
       stat02 = 0
       stat03 = 0
       stat04 = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:22) .eq. 'Alexander Men`shchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'FITFLUXES'
       endif

       header = 'FITS Plot Header'

       if (myfile) then
         call ftgkys ( unit, 'HEADER' , header , comment, stat01 )
         call ftgkys ( unit, 'FOOTER1', footer1, comment, stat02 )
         call ftgkys ( unit, 'FOOTER2', footer2, comment, stat03 )
         ilc1 = lastc ( footer1 )
         ilc2 = lastc ( footer2 )
         if (ilc1 .ne. 0 .and. ilc2 .ne. 0) then
           footer(1) = footer1(1:ilc1)//footer2(1:ilc2)
         else
           footer(1) = 'Footer'
         endif
       else
         call ftgkys ( unit, 'OBJECT' , header, comment, stat04 )
         if (stat04 .ne. 0 .or. header(1:10) .eq. '          ') header = fname
         footer(1) = header
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. Maybe
! there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat08 = 0
       stat0 = stat01 + stat02 + stat03 + stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15
     &       + stat16 + stat17 + stat18 + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28
     &       + stat29 + stat30 + stat31

       if (lverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat01 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword HEADER absent or error'
         if (stat02 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER1 absent or error'
         if (stat03 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER2 absent or error'
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat29 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EPOCH absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = 'No object specified'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       nan = 0
       do j=1,ny
         do i=1,nx
           if (isnan ( fun(i,j) )) then  
             nan = nan + 1
             if (lverbose .ne. '-verb0') then
               if (nan .lt. 100) then
                 write (iotty,'(a,i4,a,i4,a)') '   RFITS: Element (', i,',', j, ') contains not a number (NaN)...'
               elseif (nan .eq. 100) then
                 write (iotty,'(a)') '   RFITS: Many NaNs, no more info on the elements.'
               endif
             endif
           else
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header
     &            , footer, iotty, cdate, ctime, creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero
     &            , bscale, wave, datamn, datamx, history, lverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, header, ctime, cdate, bunit, cfitsversion, history, lverbose, footer(2)
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), iat, iflen, nan
     &             , lastc, blank, iotty
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, rot1, rot2, epoch, equinox, datamn
     &             , cosrota, sinrota, rotangle, datamx, dxdeg, dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      lastc
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny

! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       nan = 0
       do j=1,ny
         do i=1,nx
           if (isnan ( fun(i,j) )) then  
             nan = nan + 1
             if (lverbose .ne. '-verb0') then
               if (nan .lt. 100) then
                 write (iotty,'(a,i4,a,i4,a)') '   WFITS: Element (', i,',', j, ') contains not a number (NaN)...'
               elseif (nan .eq. 100) then
                 write (iotty,'(a)') '   WFITS: Many NaNs, no more info on the elements.'
               endif
             endif
           else
             datamn = min ( datamn, fun(i,j) )
             datamx = max ( datamx, fun(i,j) )
           endif
         enddo
       enddo

       bitpix = -32     !<-- single precision floating-point values

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator, 'Alexander Men`shchikov, SAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'HEADER' , header, 'title', status )

       iat = 0
       iat = index ( footer(1), ' |F' )
       if (iat .eq. 0) iat = index ( footer(1), ' mm ' )
       iflen = lastc ( footer(1) )

       if (iat .gt. 0) then
         call ftpkys ( unit, 'FOOTER1', footer(1)(1:iat-1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', footer(1)(iat:iflen), 'part 2', status )
       else
         call ftpkys ( unit, 'FOOTER1', footer(1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', ' ', 'part 2', status )
       endif
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = dx * as2deg
       dydeg = dy * as2deg

! Correct if the input images had cd11 or cd22 set to zero.

       if (abs ( cd11 ) .lt. almostzero .or. abs ( cd11 ) .gt. dxdeg) then
         cd11 = -dxdeg
         cd12 = 0.0d0
       endif
       if (abs ( cd22 ) .lt. almostzero .or. abs ( cd22 ) .gt. dxdeg) then
         cd21 = 0.0d0
         cd22 = dydeg
       endif
       
       cosrota = - cd11 / dxdeg
       sinrota = - cd12 / dxdeg
       rotangle = acos ( cosrota ) * 180.0d0 / pi
       
       if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = 180.0d0 - rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = 180.0d0 + rotangle
       elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = - rotangle
       endif
       rot2 = rot1

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
       if  (blank .gt. 0)
     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , -dxdeg, 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftpkyd ( unit, 'EPOCH'  , epoch  , 13, ' ', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, ' ', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'image was convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||