
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program fmeasure
!__________________________________________________________________________________________________________________________________
!
! Measure and catalog properties of filaments.
!
! This code is part of GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay  
!__________________________________________________________________________________________________________________________________
!                 
       implicit      none

       logical       lfnama, lfnamb, lunix, lendpoint, ldone, ldebug, lused
                                          
       character*2   cnpw
       character*4   cnextr, clk1, clk2, clk3, clk
       character*5   cfpptime, cnmax
       character*6   cfitsversion, lverbose         
       character*7   clibname
       character*8   ctime
       character*10  cdate
       character*21  compda
       character*80  object, bunit, bunit1, bunit2, ctype1, ctype2, ctype11, ctype12, ctype21, ctype22, object1, object2, creator
     &             , history, history1, history2
       character*128 header, footer(2), header2, footer2(2), cathead0
       character*500 filenama, filenamb, outname, pixdistname, pixmeanname, normalsname, curvname, individprofs, pathprofs
     &             , arg1, arg2, arg3, arg4, arg5, arg6, arg7

       integer       i, j, fnlen1, fnlen2, nx, ny, nx1, ny1, nx2, ny2, firstb, lastc, lasts, ia1, ia2, ia3, ia4, ia5, ia6, ia7
     &             , isp1, isp2, blank, blank1, blank2, irc, lb, nextr, k, ii, jj, m, iotty, numfil, im1, ip1, jm1, jp1, l, ll
     &             , npixconn4, npixconn8, npixconn, npixconnmin, npxmax, ipd, ipn, im, jm, npw, npa, npts, ia, ib, ja, jb, n, indp
     &             , iopa, lm1, lp1, idot1, idot2, idot3, ion, is1, n0, npix4, npix8, ipw, nbra, nptfact, npxstep, ndate, npta
     &             , nptb, nptsa, nptsb, lk1, ilc0, ntry, ico1, jco1

       real          fitsvers
       real*8        dx, dy, dx1, dy1, dx2, dy2, ra, dec, beam, imagelow, imagehalf, dxp, dyp, wida, widb, funmin1, funmax1, delta
     &             , beam1, beam2, epoch, epoch2, equinox, equinox1, equinox2, epoch1, ra1, ra2, dec1, dec2, bzero, bscale, deltamin
     &             , bzero1, bzero2, bscale1, bscale2, funmin2, funmax2, crpix11, crpix12, crval11, crval12, datamin1, datamax1, dr
     &             , crpix1, crpix2, crval1, crval2, crota11, crota12, crota1, crota2, datamin2, datamax2, datamin, datamax, dist
     &             , crpix21, crpix22, crval21, crval22, crota21, crota22, cd11, cd12, cd21, cd22, wave, wave1, wave2, almostzero
     &             , cd111, cd112, cd121, cd122, cd211, cd212, cd221, cd222, segmlen, cosx, sinx, distmax, profhalfa, profhalfb, pi
     &             , dxdt, dydt, d2xdt2, d2ydt2, dxm, dym, dxt, dyt, dxmdt, dxpdt, dymdt, dypdt, distm, distp, distt, dxdydt
     &             , curvsmo, lenbra(1000)

       character*200, allocatable :: cathead(:)
       integer, allocatable :: pixfil(:), iwidth(:,:), iwidtha(:,:), iwidthb(:,:), np(:), nava(:), navb(:), nav(:), ilc(:), navc(:)
     &                       , nptw(:) 
       real*8, allocatable :: imagefil(:,:), imageseg(:,:), filmean(:,:), xcoo(:), ycoo(:), pixd(:), xpix(:), ypix(:), xpixfil(:,:)
     &                      , ypixfil(:,:), pixdist(:,:), normals(:,:), rad(:), profilea(:,:), profileb(:,:), xpixmean(:,:)
     &                      , ypixmean(:,:), length(:), cosa(:,:), sina(:,:), cosb(:,:), sinb(:,:), profmeana(:,:), profmeanb(:,:)
     &                      , profstda(:,:), profstdb(:,:), profmean(:,:), profstd(:,:), widthmean(:), widthstd(:), widtha(:)
     &                      , widthb(:), sangle(:,:), nanglea(:,:), nangleb(:,:), curvature(:,:), curvmean(:), curvstd(:)
     &                      , curvtota(:), curvmedi(:), funmed(:), curva(:,:), curvsmoo(:,:)

       parameter   ( iotty = 6, almostzero = 1.0d-20, nptfact = 10, pi = 3.14159265358979d0 )

       external      firstb, lastc, rfits, wfits, when
!__________________________________________________________________________________________________________________________________
!
! Determine operating system

       call osystem ( lunix )

       call ftvers ( fitsvers )

       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       compda = __DATE__//' '//cfpptime

! Get command line parameters (file names).

       call getarg ( 1, arg1 )
       call getarg ( 2, arg2 )
       call getarg ( 3, arg3 )
       call getarg ( 4, arg4 )
       call getarg ( 5, arg5 )
       call getarg ( 6, arg6 )
       call getarg ( 7, arg7 )

       ia1 = lastc ( arg1 )
       ia2 = lastc ( arg2 )
       ia3 = lastc ( arg3 )
       ia4 = lastc ( arg4 )
       ia5 = lastc ( arg5 )
       ia6 = lastc ( arg6 )
       ia7 = lastc ( arg7 )

       lverbose = '-verb2'
       if (ia7 .gt. 0 .and. arg7(1:ia7-1) .eq. '-verb') lverbose = arg7(1:ia7)
       if (ia6 .gt. 0 .and. arg6(1:ia6-1) .eq. '-verb') lverbose = arg6(1:ia6)
       if (ia5 .gt. 0 .and. arg5(1:ia5-1) .eq. '-verb') lverbose = arg5(1:ia5)

       if (lverbose .eq. '-verb2') write (iotty,'(/a$)') ' FMEASURE = Measure & Catalog Filaments = '//compda
       if (arg1(1:ia1) .eq. ':') stop
       if (lverbose .eq. '-verb2') write (iotty,'()')
       if (lverbose .eq. '-verb2') write (iotty,'( a)') ' Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
       if (lverbose .eq. '-verb2') write (iotty,'( a)') ' Using '//clibname(lb:7)//' library version'//cfitsversion
     &                                                //' by William D Pence.'
       if (ia4 .eq. 0 .or. arg4(1:2) .eq. '-o' .or. arg4(1:2) .eq. '-v') then
         write (iotty,'(/a)') ' USAGE: fmeasure <imagefil> <imageseg> [+]<npxstep> <outpath> [-o <outname>] [-verb{0|1|2}]'
         write (iotty,'(  )')   
         write (iotty,'(a )') ' This is a GETFILAMENTS utility that produces measurements of intensity'
         write (iotty,'(a )') ' profiles of filaments. <IMAGEFIL> and <IMAGESEG> are the input images'
         write (iotty,'(a )') ' of filaments and skeletons produced by GETSOURCES. <NPXSTEP> is the'
         write (iotty,'(a )') ' step over skeleton pixels defining an interval at which the profiles'
         write (iotty,'(a )') ' are separated along the skeleton. The optional "+" sign signals that'
         write (iotty,'(a )') ' the user wants to produce more catalogs and images than by default.'
         write (iotty,'(a )') ' <OUTPATH> is the existing path where the output images and catalogs'
         write (iotty,'(a )') ' are placed. The optional <OUTNAME> allows one to change the default'
         write (iotty,'(a )') ' output names and -VERB# defines verbosity level.'
         stop 99
       endif

       filenama = arg1(1:ia1)
       fnlen1 = lastc ( filenama )
       
       filenamb = arg2(1:ia2)
       fnlen2 = lastc ( filenamb )
       
       ldebug = .false.
       if (arg3(1:1) .eq. '+') ldebug = .true.

       read (arg3(1:ia3),'(i5)',err=9) npxstep

       pathprofs = arg4(1:ia4)
       iopa = lastc ( pathprofs )

! Check if the input file exists and open it.

       inquire ( file=filenama(1:fnlen1), exist=lfnama )
       if (.not.lfnama) then

! Maybe the file name extension was omitted?

         filenama = filenama(1:fnlen1)//'.fits'
         fnlen1 = lastc ( filenama )
         inquire ( file=filenama(1:fnlen1), exist=lfnama )
       endif

! Check if the input file exists and open it.

       inquire ( file=filenamb(1:fnlen2), exist=lfnamb )
       if (.not.lfnamb) then

! Maybe the file name extension was omitted?

         filenamb = filenamb(1:fnlen2)//'.fits'
         fnlen2 = lastc ( filenamb )
         inquire ( file=filenamb(1:fnlen2), exist=lfnamb )
       endif
                             
       isp1 = lasts ( filenama ) + 1
       isp2 = lasts ( filenamb ) + 1
       
       idot1 = index ( filenamb(isp2:fnlen2-5), '.' )
       idot2 = index ( filenamb(isp2+idot1:fnlen2-5), '.' ) + idot1
       idot3 = index ( filenamb(isp2+idot2:fnlen2-5), '.' ) + idot2

       if (arg5(1:2) .eq. '-o') then
         outname = arg6
         ion = lastc ( outname )
         is1 = lasts ( outname ) + 1
         if (outname(max(ion-4,1):ion) .eq. '.fits') then
           outname = outname(is1:ion-5)
         else
           outname = outname(is1:ion)
         endif
       else
         outname = filenama(isp1:fnlen1-5)//filenamb(idot3:fnlen2-5)
       endif
       ion = lastc ( outname )

       if (lverbose .eq. '-verb1') write (iotty,'(/a)') ' FMEASURE: '//filenama(isp1:fnlen1-5)//' '//filenamb(isp2:fnlen2-5)
     &                                                          //' '//arg3(1:ia3)//' '//pathprofs(1:iopa)
       if (.not.lfnama) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: File '''//filenama(1:fnlen1-5)//'.fits'' not found.'
         stop 1
       endif
       if (.not.lfnamb) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: File '''//filenamb(1:fnlen2-5)//'.fits'' not found.'
         stop 2
       endif
       goto 10
   9   continue
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble reading NPXSTEP from command line.'
         stop 3
  10   continue       

! Determine numbers of pixels in the FITS image.

       call getnumpix ( filenama(1:fnlen1), nx1, ny1 )

! Allocate the image arrays.
       
       allocate ( imagefil(nx1,ny1), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (10).'
         stop 10
       endif
       
       if (lverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading filaments '''//filenama(1:fnlen1)//'''...'

       call rfits ( nx1, ny1, bunit1, ctype11, ctype12, crpix11, crpix12, crval11, crval12, imagefil, dx1, dy1, object1, ra1
     &            , dec1, filenama(1:fnlen1), header, footer, iotty, 0, creator, beam1, funmin1, funmax1, blank1, crota11, crota12
     &            , cd111, cd112, cd121, cd122, epoch1, equinox1, bzero1, bscale1, wave1, datamin1, datamax1, history1, lverbose )

       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin1, funmax1

! Determine numbers of pixels in the FITS image.

       call getnumpix ( filenamb(1:fnlen2), nx2, ny2 )

       allocate ( imageseg(nx2,ny2), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (20).'
         stop 20
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading skeletons '''//filenamb(1:fnlen2)//'''...'

       call rfits ( nx2, ny2, bunit2, ctype21, ctype22, crpix21, crpix22, crval21, crval22, imageseg, dx2, dy2, object2, ra2
     &            , dec2, filenamb(1:fnlen2), header2, footer2, iotty, 0, creator, beam2, funmin2, funmax2, blank2, crota21, crota22
     &            , cd211, cd212, cd221, cd222, epoch2, equinox2, bzero2, bscale2, wave2, datamin2, datamax2, history2, lverbose )

       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin2, funmax2

       if (beam1 .eq. beam2) then
         beam = beam1
       else
         beam = 0.0d0
       endif

       if (nx1 .ne. nx2 .or. ny1 .ne. ny2) then
         write (iotty, '(/a)') '   FMEASURE: ERROR: The images have different numbers of pixels:'
         write (iotty, '(a )') '                   '//filenama(1:fnlen1)
         write (iotty, '(a )') '                   '//filenamb(1:fnlen2)
         stop 3
       else
         nx = nx1
         ny = ny1
         bunit = bunit1
         ctype1 = ctype11
         ctype2 = ctype12
         dx = dx1
         dy = dy1
         crpix1 = crpix11
         crpix2 = crpix12
         crval1 = crval11
         crval2 = crval12
         blank = blank1
         crota1 = crota11
         crota2 = crota12
         cd11 = cd111
         cd12 = cd112
         cd21 = cd121
         cd22 = cd122
         epoch = epoch1
         equinox = equinox1
         object = object1
         ra = ra1
         dec = dec1
         bzero = bzero1
         bscale = bscale1
         wave = wave1
         history = history1
       endif
       
       nextr = nint ( funmax2 )
       
       if (nextr .eq. 0 .or. funmax1 .lt. almostzero) goto 999

! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )

       individprofs = pathprofs(1:iopa)
       indp = lastc ( individprofs )
     
       open (44, file=individprofs(1:indp)//'/README', status='unknown', err=24 )
       goto 25
 24    continue
       write (iotty,'(/a)') '   FMEASURE: ERROR: Directory '''//individprofs(1:indp)//''' does not exist?..'
       stop 99
 25    continue
       write (44,'(a)') '#______________________________________________________________________________________________'
       write (44,'(a)') '#'
       write (44,'(a)') '# GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men''shchikov, SAp IRFU CEA Saclay'
       write (44,'(a)') '#______________________________________________________________________________________________'
       write (44,'(a)') '#'
       write (44,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FMEASURE compiled on '//compda
       write (44,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (44,'(a)') '# Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence '
     &                //'(william.d.pence@nasa.gov)'
       write (44,'(a)') '# and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
       write (44,'(a)') '#'
       write (44,'(a)') '# This directory contains catalogs of intensity profiles for filaments.'
       close (44)
     
       allocate ( pixdist(nx,ny), np(nextr), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (30).'
         stop 30
       endif

! Find number of pixels belonging to each filament.

       npxmax = 0
       do k=1,nextr
         np(k) = 0
         do j=1,ny
           do i=1,nx
             if (k .eq. nint ( imageseg(i,j) )) then
               np(k) = np(k) + 1
             endif
           enddo
         enddo
         if (np(k) .gt. npxmax) npxmax = np(k)
       enddo
       write (cnmax,'(i5)') npxmax
         
       allocate ( xcoo(nextr), ycoo(nextr), pixfil(nextr), xpix(npxmax), ypix(npxmax), pixd(npxmax)
     &          , xpixfil(nextr,npxmax), ypixfil(nextr,npxmax), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (40).'
         stop 40
       endif

! Find filament coordinates.

       do k=1,nextr
         ntry = 0
 80      continue
         xcoo(k) = 0.0d0
         ycoo(k) = 0.0d0
         pixfil(k) = 0.0d0
         npixconnmin = 8
         ico1 = 0
         jco1 = 0

         do j=1,ny
           jm1 = max ( j - 1, 1 )
           jp1 = min ( j + 1, ny )
           do i=1,nx
             numfil = nint ( imageseg(i,j) )
             if (k .eq. numfil) then
               if (ico1 .eq. 0) ico1 = i
               if (jco1 .eq. 0) jco1 = j
               im1 = max ( i - 1, 1 )
               ip1 = min ( i + 1, nx )
               pixfil(k) = pixfil(k) + 1
               npixconn4 = 0
               npixconn8 = 0
               npix4 = 0
               npix8 = 0
               if (imageseg(im1,j) .gt. almostzero) then
                 npixconn4 = npixconn4 + 1
                 npix4 = 1
               endif
               if (imageseg(ip1,j) .gt. almostzero) then
                 npixconn4 = npixconn4 + 1
                 npix4 = 2
               endif
               if (imageseg(i,jm1) .gt. almostzero) then
                 npixconn4 = npixconn4 + 1
                 npix4 = 3
               endif
               if (imageseg(i,jp1) .gt. almostzero) then
                 npixconn4 = npixconn4 + 1
                 npix4 = 4
               endif
               if (imageseg(im1,jm1) .gt. almostzero) then
                 npixconn8 = npixconn8 + 1
                 npix8 = 1
               endif
               if (imageseg(ip1,jp1) .gt. almostzero) then
                 npixconn8 = npixconn8 + 1
                 npix8 = 2
               endif
               if (imageseg(im1,jp1) .gt. almostzero) then
                 npixconn8 = npixconn8 + 1
                 npix8 = 3
               endif
               if (imageseg(ip1,jm1) .gt. almostzero) then
                 npixconn8 = npixconn8 + 1
                 npix8 = 4
               endif
               npixconn = npixconn4 + npixconn8
               lendpoint = .false.
               if ((npixconn4 .le. 1 .and. npixconn8 .le. 1) .and. npixconn .le. npixconnmin) then
                 if (npixconn4 .eq. 1 .and. npixconn8 .eq. 1) then
                   if (npix4 .eq. 1 .and. (npix8 .eq. 1 .or. npix8 .eq. 3)) lendpoint = .true.
                   if (npix4 .eq. 2 .and. (npix8 .eq. 2 .or. npix8 .eq. 4)) lendpoint = .true.
                   if (npix4 .eq. 3 .and. (npix8 .eq. 1 .or. npix8 .eq. 4)) lendpoint = .true.
                   if (npix4 .eq. 4 .and. (npix8 .eq. 3 .or. npix8 .eq. 2)) lendpoint = .true.
                 else
                   lendpoint = .true.
                 endif
               endif
               if (lendpoint) then
                 xcoo(k) = dble ( i )
                 ycoo(k) = dble ( j )
               endif
               npixconnmin = min ( npixconnmin, npixconn )
             endif
           enddo
         enddo
         
! Fix a problem and try again, if the first pixel of the current filament has not been found (using the above logic).      
         
         if (nint ( xcoo(k) ) .eq. 0 .or. nint ( ycoo(k) ) .eq. 0) then
           if (imageseg(ico1,jco1) .gt. almostzero) then
             imageseg(ico1,jco1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1-1,jco1) .gt. almostzero) then
             imageseg(ico1-1,jco1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1+1,jco1) .gt. almostzero) then
             imageseg(ico1+1,jco1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1,jco1-1) .gt. almostzero) then
             imageseg(ico1,jco1-1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1,jco1+1) .gt. almostzero) then
             imageseg(ico1,jco1+1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1-1,jco1-1) .gt. almostzero) then
             imageseg(ico1-1,jco1-1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1+1,jco1+1) .gt. almostzero) then
             imageseg(ico1+1,jco1+1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1-1,jco1+1) .gt. almostzero) then
             imageseg(ico1-1,jco1+1) = 0.0d0
             np(k) = np(k) - 1
           endif
           if (imageseg(ico1+1,jco1-1) .gt. almostzero) then
             imageseg(ico1+1,jco1-1) = 0.0d0
             np(k) = np(k) - 1
           endif
           ntry = ntry + 1
           if (ntry .le. 2) then  !<-- Do no more than 3 attempts to find the first pixel.
             goto 80
           else
             write (iotty,'(/a,i5)') '   FMEASURE: ERROR: Trouble finding the first pixel of a skeleton:', k
             write (iotty,'(a    )') '  '//filenamb(1:fnlen2)
             stop 99
           endif
         endif

! The first pixel has been defined, now search for the last pixel of the current filament.
         
         i = nint ( xcoo(k) )
         j = nint ( ycoo(k) )
         l = 0
         delta = 0.0d0
 111     continue           
         l = l + 1
         if (l .eq. 1) then
           n0 = 0  !<-- At the first pixel, a one-pixel window (has zero pixel radius)
         else
           n0 = 1  !<-- At all other pixels, a 9-pixel window (has one pixel radius)
         endif
         deltamin = 1.0d+30
         im = 0
         jm = 0
         do jj=max(j-n0,1),min(j+n0,ny)
           do ii=max(i-n0,1),min(i+n0,nx)
             if (k .eq. nint ( imageseg(ii,jj) )) then

! The pixel (ii,jj) in this small window belongs to the filament k. 
! Check if it has already been considered (used) in this search for the last pixel.
               
               lused = .false.
               if (l .gt. 1) then
                 do m=1,l-1
                   if (ii .eq. nint ( xpix(m) ) .and. jj .eq. nint ( ypix(m) )) then
                     lused = .true.
                     exit
                   endif
                 enddo
               endif
               
! If the pixel (ii,jj) in this small window has not been considered (used), find its distance from the previously accepted pixel.
! Find the minimum distance between all pixels of the window and the previously accepted pixel.
               
               if (.not.lused) then
                 if (l .gt. 1) then
                   delta = sqrt ( (dble ( ii ) - xpix(lm1))**2 + (dble ( jj ) - ypix(lm1))**2 )
                 endif
                 if (delta .lt. deltamin) then
                   deltamin = delta
                   im = ii
                   jm = jj
                 endif
               endif
             endif
           enddo
         enddo

         if (im .gt. 0 .and. jm .gt. 0) then

! The minimum distance within the small 9-pixel window has been found. 
! Consider the pixel (im,jm) as the next current pixel of the skeleton.
! Store the distance of the current pixel from the first pixel of the skeleton.
! Create an image of the distances of each pixel from the first one.

           xpix(l) = dble ( im )
           ypix(l) = dble ( jm )
           if (l .eq. 1) then
             pixd(l) = 1.0d0
           else
             pixd(l) = pixd(lm1) + deltamin
           endif
           pixdist(im,jm) = pixd(l)
           i = im
           j = jm
           n = l
           lm1 = l
           if (l .lt. np(k)) goto 111  !<-- turn to the next pixel of the skeleton.
         else
         
! The minimum distance has not been determined as all pixels in the 9-pixel window have been used.
! There are further pixels belonging to the skeleton, because of its branching.
! Skip back over the previously accepted pixels until the branch is found and continue.
         
           l = l - 1
           n = n - 1
           if (n .le. 1) then
             write (iotty,'(/a,2i5)') '   FMEASURE: ERROR: Trouble finding the last pixel of a skeleton:', k, l
             write (iotty,'(a    )') '  '//filenamb(1:fnlen2)
             stop 99
           endif
           i = nint ( xpix(n) )
           j = nint ( ypix(n) )
           lm1 = n
           goto 111
         endif

! The pixel (im,jm) is accepted as the next current pixel of the skeleton k.
         
         do l=1,np(k)
           xpixfil(k,l) = xpix(l)
           ypixfil(k,l) = ypix(l)
         enddo
       enddo         

       allocate ( iwidth(nextr,npxmax), iwidtha(nextr,npxmax), iwidthb(nextr,npxmax), widtha(npxmax), widthb(npxmax), length(nextr)
     &          , xpixmean(nextr,npxmax), ypixmean(nextr,npxmax), cosa(nextr,npxmax), sina(nextr,npxmax), cosb(nextr,npxmax)
     &          , sinb(nextr,npxmax), sangle(nextr,npxmax), nanglea(nextr,npxmax), nangleb(nextr,npxmax), curvature(nextr,npxmax)
     &          , curvmean(nextr), curvstd(nextr), navc(nextr), nptw(nextr), curvtota(nextr), curvmedi(nextr), funmed(npxmax)
     &          , curvsmoo(nextr,npxmax), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (50).'
         stop 50
       endif
  
       do k=1,nextr
         do m=1,npxmax
           iwidth(k,m) = 0
           iwidtha(k,m) = 0
           iwidthb(k,m) = 0
           xpixmean(k,m) = 0.0d0
           ypixmean(k,m) = 0.0d0
         enddo
       enddo

! Average pixel coordinates in a window of 2*NPW+1 pixels to make skeletons smoother on a (sub-)pixel scale.

       npw = 4
       ipw = 1
       write (cnpw,'(i2)') 2 * npw + 1
       if (cnpw(1:1) .eq. ' ') ipw = ipw + 1
       distmax = 1.5d0 * dble ( npw )
       do k=1,nextr
         do l=1,np(k)
           npa = 0
           do ll=max(l-npw,1),min(l+npw,np(k))
             dist = sqrt ( (xpixfil(k,ll) - xpixfil(k,l))**2 + (ypixfil(k,ll) - ypixfil(k,l))**2 )
             if (dist .le. distmax) then
               npa = npa + 1
               xpixmean(k,l) = xpixmean(k,l) + xpixfil(k,ll)
               ypixmean(k,l) = ypixmean(k,l) + ypixfil(k,ll)
             endif
           enddo
           xpixmean(k,l) = xpixmean(k,l) / npa
           ypixmean(k,l) = ypixmean(k,l) / npa
         enddo
       enddo
       
! Find lengths of filaments taking into account possible branching.

       do k=1,nextr
         length(k) = 0.0d0
         nbra = 1
         lenbra(nbra) = 0.0d0
         do l=2,np(k)
           dist = sqrt ( (xpixmean(k,l) - xpixmean(k,l-1))**2 + (ypixmean(k,l) - ypixmean(k,l-1))**2 )
           if (dist .le. 1.5d0) then
             lenbra(nbra) = lenbra(nbra) + dist
           else
             nbra = nbra + 1
             lenbra(nbra) = 0.0d0
           endif
         enddo
         do m=1,nbra
           length(k) = length(k) + lenbra(m)
         enddo
         length(k) = length(k) * dx
       enddo

       if (ldebug) then

         pixdistname = individprofs(1:indp)//'/'//outname(1:ion)//'.pixels.dist.fits'
         ipd = lastc ( pixdistname )
         header = pixdistname(1:ipd)
  
         datamin =  1.0d+30
         datamax = -1.0d+30
         do j=1,ny
           do i=1,nx
             if (pixdist(i,j) .gt. datamax) datamax = pixdist(i,j)
             if (pixdist(i,j) .lt. datamin) datamin = pixdist(i,j)
           enddo
         enddo

         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing orig pix distances '''//pixdistname(1:ipd)//'''...'
        
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, pixdist, dx, dy, object, crval1
     &              , crval2, pixdistname(1:ipd), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &              , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
        
         allocate ( filmean(nx,ny), stat=irc )

         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (60).'
           stop 60
         endif
         do j=1,ny
           do i=1,nx
             filmean(i,j) = min ( imageseg(i,j), 0.50d0 )
           enddo
         enddo
         do k=1,nextr
           do l=1,np(k)
             ia = nint ( xpixmean(k,l) )
             ja = nint ( ypixmean(k,l) )
             filmean(ia,ja) = 1.0d0
           enddo
         enddo
         pixmeanname = individprofs(1:indp)//'/'//outname(1:ion)//'.points.hires.fits'
         ipd = lastc ( pixmeanname )
         header = pixmeanname(1:ipd)
  
         datamin =  1.0d+30
         datamax = -1.0d+30
         do j=1,ny
           do i=1,nx
             if (filmean(i,j) .gt. datamax) datamax = filmean(i,j)
             if (filmean(i,j) .lt. datamin) datamin = filmean(i,j)
           enddo
         enddo
  
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing high-res skeletons '''//pixmeanname(1:ipd)//'''...'
  
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, filmean, dx, dy, object, crval1
     &              , crval2, pixmeanname(1:ipd), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &              , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
       
         deallocate ( filmean )

         if (lverbose .eq. '-verb2') 
     &      write (iotty,'(a)') '   Writing skeleton coords '''//individprofs(1:indp)//'/'//outname(1:ion)//'.coord.pixels.cat'
     &                        //'''...'
         
         open ( 55, file=individprofs(1:indp)//'/'//outname(1:ion)//'.coord.pixels.cat', status='unknown' )
         write (55,'(a)') '#______________________________________________________________________________________________'
         write (55,'(a)') '#'
         write (55,'(a)') '# GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men''shchikov, SAp IRFU CEA Saclay'
         write (55,'(a)') '#______________________________________________________________________________________________'
         write (55,'(a)') '#'
         write (55,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
         write (55,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
         write (55,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
         write (55,'(a)') '#'
         write (55,'(a)') '# CATALOG OF ORIGINAL SKELETONS (DOCUMENTING ALL PIXELS)'
         write (55,'(a)') '#'
         write (55,'(a)') '# Filaments: '//filenama(1:fnlen1)
         write (55,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
         write (55,'(a)') '#'
         write (55,'(a)') '# TABULATED QUANTITIES:'
         write (55,'(a)') '#'
         write (55,'(a)') '#   NS ..... Number of a skeleton (filament) ...'
         write (55,'(a)') '#   PIXS ... Number of pixels in a skeleton ....'
         write (55,'(a)') '#   N# ..... Skeleton pixel # number ...........'
         write (55,'(a)') '#   X# ..... Skeleton pixel # X-coordinate ..... pixels from lower-left corner'
         write (55,'(a)') '#   Y# ..... Skeleton pixel # Y-coordinate ..... pixels from lower-left corner'
         write (55,'(a)') '#'
         write (55,'(a)') '#  NS PIXS    N1   X1   Y1    N2   X2   Y2    N3   X3   Y3     etc.~>'
         write (55,'(a)') '#'
         do k=1,nextr
           write (55,'(i5,i5,'//cnmax//'(i6,i5,i5))') k, pixfil(k), (l, nint ( xpixfil(k,l) ), nint ( ypixfil(k,l) ), l=1,np(k))
         enddo
        
         close (55)
       endif

! Compute curvature of skeletons (filaments) taking into account possible branching.

       do k=1,nextr
         do m=1,npxmax
           curvature(k,m) = 9.9999d+30
         enddo
       enddo
       
       do k=1,nextr
         do l=2,np(k)-1
           lm1 = max ( l - 1, 1 )
           lp1 = min ( l + 1, np(k) )
           dxt = xpixmean(k,lp1) - xpixmean(k,lm1)
           dyt = ypixmean(k,lp1) - ypixmean(k,lm1)
           dxm = xpixmean(k,l) - xpixmean(k,lm1)
           dym = ypixmean(k,l) - ypixmean(k,lm1)
           dxp = xpixmean(k,lp1) - xpixmean(k,l)
           dyp = ypixmean(k,lp1) - ypixmean(k,l)
           distt = sqrt ( dxt**2 + dyt**2 )
           distm = sqrt ( dxm**2 + dym**2 )
           distp = sqrt ( dxp**2 + dyp**2 )
           if (distt .le. 3.0d0 .and. distm .le. 1.5d0 .and. distp .le. 1.5d0) then
             dxdt = 0.0d0
             dydt = 0.0d0
             if (abs ( distt ) .gt. almostzero) dxdt = dxt / distt
             if (abs ( distt ) .gt. almostzero) dydt = dyt / distt
             dxmdt = 0.0d0
             dxpdt = 0.0d0
             if (abs ( distm ) .gt. almostzero) dxmdt = dxm / distm
             if (abs ( distp ) .gt. almostzero) dxpdt = dxp / distp
             dymdt = 0.0d0
             dypdt = 0.0d0
             if (abs ( distm ) .gt. almostzero) dymdt = dym / distm
             if (abs ( distp ) .gt. almostzero) dypdt = dyp / distp
             d2xdt2 = 0.0d0
             d2ydt2 = 0.0d0
             if (abs ( distt ) .gt. almostzero) d2xdt2 = (dxpdt - dxmdt) / distt
             if (abs ( distt ) .gt. almostzero) d2ydt2 = (dypdt - dymdt) / distt
             dxdydt = dxdt**2 + dydt**2
             if (dxdydt .gt. almostzero) then
               curvature(k,l) = (dxdt * d2ydt2 - dydt * d2xdt2) / sqrt ( dxdydt )**3
             endif
           endif
         enddo
       enddo

! Smooth curvatures in a sliding window of 2*NPW+1 pixels along skeleton.

       do k=1,nextr
         do l=1,np(k)
           curvsmo = 0.0d0
           npa = 0
           do ll=max(l-npw,1),min(l+npw,np(k))
             dist = sqrt ( (xpixfil(k,ll) - xpixfil(k,l))**2 + (ypixfil(k,ll) - ypixfil(k,l))**2 )
             if (dist .le. distmax .and. curvature(k,ll) .lt. 9.99d+30) then
               npa = npa + 1
               curvsmo = curvsmo + curvature(k,ll)
             endif
           enddo
           if (npa .gt. 0) then
             curvsmoo(k,l) = curvsmo / dble ( npa )
           else
             curvsmoo(k,l) = 9.9999d+30
           endif
         enddo
       enddo

       do k=1,nextr
         curvmean(k) = 0.0d0
         curvmedi(k) = 0.0d0
         curvtota(k) = 0.0d0
         navc(k) = 0
         do l=2,np(k)-1
           if (curvsmoo(k,l) .lt. 9.99d+30) then
             if (l .gt. npw .and. l .le. np(k) - npw) then
               navc(k) = navc(k) + 1
               curvmean(k) = curvmean(k) + curvsmoo(k,l)
               curvtota(k) = curvtota(k) + curvsmoo(k,l) * (distm + distp) / 2.0d0
               funmed(navc(k)) = curvsmoo(k,l)
             endif
           endif
         enddo
         if (navc(k) .gt. 0) then
           curvmean(k) = curvmean(k) / dble ( navc(k) )
         endif
         if (navc(k) .gt. 1) then
           call sortarr ( navc(k), funmed, funmed )
           curvmedi(k) = funmed((navc(k)+1)/2)
         endif
       enddo

       do k=1,nextr
         curvstd(k) = 0.0d0
         navc(k) = 0
         do l=2,np(k)-1
           if (curvsmoo(k,l) .lt. 9.99d+30) then
             if (l .gt. npw .and. l .le. np(k) - npw) then
               navc(k) = navc(k) + 1
               curvstd(k) = curvstd(k) + (curvsmoo(k,l) - curvmean(k))**2
             endif
           endif
         enddo
         if (navc(k) .gt. 1) curvstd(k) = sqrt ( curvstd(k) / (dble ( navc(k) ) - 1.0d0) )

         curvmean(k) = abs ( curvmean(k) )
         curvmedi(k) = abs ( curvmedi(k) )
         curvtota(k) = abs ( curvtota(k) )
       enddo

! Find sine and cosine defining direction of a skeleton segment, as well as
! the sine and cosine of the left (a) and right (b) normals to the segment (+- pi/2).

       do k=1,nextr
         do l=1,np(k)
           i = nint ( xpixmean(k,l) )
           j = nint ( ypixmean(k,l) )
           lm1 = max ( l - 1, 1 )
           lp1 = min ( l + 1, np(k) )
           dxp = xpixmean(k,lp1) - xpixmean(k,lm1)
           dyp = ypixmean(k,lp1) - ypixmean(k,lm1)
           segmlen = sqrt ( dxp**2 + dyp**2 )
           if (segmlen .gt. almostzero) then
             cosx = dxp / segmlen
             sinx = dyp / segmlen
           else
             cosx = 1.0d0
             sinx = 0.0d0
           endif
           cosa(k,l) = - sinx
           sina(k,l) = + cosx
           cosb(k,l) = + sinx
           sinb(k,l) = - cosx
             
! Position angle of the skeleton segment.

           sangle(k,l) = acos ( cosx ) * 180.0d0 / pi
           if (sinx .ge. 0.0d0) then
             sangle(k,l) = sangle(k,l) - 90.0d0
           elseif (cosx .lt. 0.0d0) then
             sangle(k,l) = 270.0d0 - sangle(k,l)
           elseif (cosx .ge. 0.0d0) then
             sangle(k,l) = -90.0d0 - sangle(k,l)
           endif

! Position angle of the left normal to the skeleton segment.
             
           nanglea(k,l) = acos ( cosa(k,l) ) * 180.0d0 / pi
           if (sina(k,l) .ge. 0.0d0) then
             nanglea(k,l) = nanglea(k,l) - 90.0d0
           elseif (cosa(k,l) .lt. 0.0d0) then
             nanglea(k,l) = 270.0d0 - nanglea(k,l)
           elseif (cosa(k,l) .ge. 0.0d0) then
             nanglea(k,l) = -90.0d0 - nanglea(k,l)
           endif

! Position angle of the right normal to the skeleton segment.
             
           nangleb(k,l) = acos ( cosb(k,l) ) * 180.0d0 / pi
           if (sinb(k,l) .ge. 0.0d0) then
             nangleb(k,l) = nangleb(k,l) - 90.0d0
           elseif (cosb(k,l) .lt. 0.0d0) then
             nangleb(k,l) = 270.0d0 - nangleb(k,l)
           elseif (cosb(k,l) .ge. 0.0d0) then
             nangleb(k,l) = -90.0d0 - nangleb(k,l)
           endif
         enddo
       enddo

       if (lverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing skeletons '''//individprofs(1:indp)//'/'//outname(1:ion)//'.coord.hires.cat''...'

       open ( 66, file=individprofs(1:indp)//'/'//outname(1:ion)//'.coord.hires.cat', status='unknown' )
       write (66,'(a)') '#______________________________________________________________________________________________'
       write (66,'(a)') '#'
       write (66,'(a)') '# GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men''shchikov, SAp IRFU CEA Saclay'
       write (66,'(a)') '#______________________________________________________________________________________________'
       write (66,'(a)') '#'
       write (66,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (66,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
       write (66,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (66,'(a)') '#'
       write (66,'(a)') '# CATALOG OF HIGH-RESOLUTION SKELETONS (AVERAGED OVER '//cnpw(ipw:2)//' NEAREST PIXELS)'
       write (66,'(a)') '#'
       write (66,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (66,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (66,'(a)') '#'
       write (66,'(a,i2)') '# Window size over skeleton points for smoothing:', 2*npw+1
       write (66,'(a)') '#'
       write (66,'(a)') '# TABULATED QUANTITIES:'
       write (66,'(a)') '#'
       write (66,'(a)') '#   NS ...... Number of a skeleton (filament) .....'
       write (66,'(a)') '#   PIXS .... Number of skeleton pixels ...........'
       write (66,'(a)') '#   N# ...... Skeleton pixel # number .............'
       write (66,'(a)') '#   X# ...... Skeleton pixel # X-coordinate ....... pixels from lower-left corner'
       write (66,'(a)') '#   Y# ...... Skeleton pixel # Y-coordinate ....... pixels from lower-left corner'
       write (66,'(a)') '#   CURV# ... Skeleton curvature (smoothed) ....... 1/arcsec,'
     &                //' CURV=(DXDT*D2YDT2-DYDT*D2XDT2)/sqrt(DXDT^2+DYDT^2)^3'
       write (66,'(a)') '#   SPA# .... Skeleton direction position angle ... degrees east of north'
       write (66,'(a)') '#   NAPA# ... Left normal position angle .......... degrees east of north'
       write (66,'(a)') '#   NBPA# ... Right normal position angle ......... degrees east of north'
       write (66,'(a)') '#'
       write (66,'(a)') '#  NS PIXS    N1      X1          Y1         CURV1     SPA1    NAPA1   NBPA1'
     &                //'    N2      X2          Y2         CURV2     SPA2    NAPA2   NBPA2    N3'
     &                //'      X3          Y3         CURV3     SPA3    NAPA3   NBPA3     etc.~>'
       write (66,'(a)') '#'
       write (cnmax,'(i5)') npxmax
       do k=1,nextr
         write (66,'(i5,i5,'//cnmax//'(i6,3(1pe12.4),3(0pf8.2)))') k, pixfil(k), (l, xpixmean(k,l), ypixmean(k,l), curvsmoo(k,l)
     &                                                           , sangle(k,l), nanglea(k,l), nangleb(k,l), l=1,np(k))
       enddo
       close (66)
       
       deallocate ( pixdist, pixd, xpix, ypix )

! Filament half-maximum widths.

       npta = nint ( sqrt ( dble  ( nx )**2 + dble ( ny )**2 ) )
       nptb = nint ( sqrt ( dble  ( nx )**2 + dble ( ny )**2 ) )

       do k=1,nextr
         do l=1,np(k)
           i = nint ( xpixmean(k,l) )
           j = nint ( ypixmean(k,l) )
           imagehalf = imagefil(i,j) / 2.0d0
           imagelow = imagefil(i,j) / 100.0d0
           widtha(l) = 0.0d0
           widthb(l) = 0.0d0

           if (imagefil(i,j) .gt. almostzero) then
             ldone = .false.
             do m=1,npta
               dr = dble ( m - 1 )
               ia = nint ( xpixmean(k,l) + cosa(k,l) * dr )
               ja = nint ( ypixmean(k,l) + sina(k,l) * dr )
               if (imagefil(ia,ja) .gt. imagelow .and. ia .ge. 1 .and. ia .le. nx .and. ja .ge. 1 .and. ja .le. ny) then
                 if (imagefil(ia,ja) .gt. imagehalf .and. .not.ldone) then
                   widtha(l) = sqrt ( dble ( ia - i )**2 + dble ( ja - j )**2 )
                 else
                   ldone = .true.
                 endif
               else
                 exit
               endif
             enddo
             ldone = .false.
             do m=1,nptb
               dr = dble ( m - 1 )
               ib = nint ( xpixmean(k,l) + cosb(k,l) * dr )
               jb = nint ( ypixmean(k,l) + sinb(k,l) * dr )
               if (imagefil(ib,jb) .gt. imagelow .and. ib .ge. 1 .and. ib .le. nx .and. jb .ge. 1 .and. jb .le. ny) then
                 if (imagefil(ib,jb) .gt. imagehalf .and. .not.ldone) then
                   widthb(l) = sqrt ( dble ( ib - i )**2 + dble ( jb - j )**2 )
                 else
                   ldone = .true.
                 endif
               else
                 exit
               endif
             enddo
           endif
           iwidtha(k,l) = min ( nint ( min ( widtha(l), widthb(l) ) ), pixfil(k) )
           iwidthb(k,l) = min ( nint ( min ( widtha(l), widthb(l) ) ), pixfil(k) )
         enddo
       enddo
       
! Image of normals to skeletons to visualize them.

       allocate ( normals(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (70).'
         stop 70
       endif
       
       do j=1,ny
         do i=1,nx
           normals(i,j) = min ( imageseg(i,j), 1.0d0 )
         enddo
       enddo

! Compute and catalog filament profiles.

       allocate ( widthmean(nextr), widthstd(nextr), stat=irc )
     
       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (80).'
         stop 80
       endif

       do k=1,nextr
         write (cnextr,'(i4.4)') k
         lk1 = max ( (np(k) - int ( dble ( np(k) ) / dble ( npxstep ) ) * npxstep) / 2, 1 )
         widthmean(k) = 0.0d0
         widthstd(k) = 0.0d0
         nptw(k) = 0
         nptsa = 0
         do l=1,np(k)
           nptsa = max ( nptsa, nptfact * iwidtha(k,l) )
         enddo
         nptsb = 0
         do l=1,np(k)
           nptsb = max ( nptsb, nptfact * iwidthb(k,l) )
         enddo
         npts = max ( nptsa, nptsb )
         
         if (npts .eq. 0) goto 888

         allocate ( profilea(npxmax,npts), profileb(npxmax,npts), profmeana(nextr,npts), profmeanb(nextr,npts), profmean(nextr,npts)
     &            , profstda(nextr,npts), profstdb(nextr,npts), profstd(nextr,npts), rad(npts), nava(npts), navb(npts), nav(npts)
     &            , stat=irc )

         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (90).'
           stop 90
         endif

         do m=1,npts
           rad(m) = dble ( m - 1 ) * dx
           do n=1,npxmax
             profilea(n,m) = 0.0d0
             profileb(n,m) = 0.0d0
           enddo
         enddo

! Profiles at each skeleton point are only made and saved in the debug mode.

         if (ldebug) then
         
           do l=1,np(k)
             i = nint ( xpixmean(k,l) )
             j = nint ( ypixmean(k,l) )
             if (imagefil(i,j) .gt. almostzero) then
               npta = nptfact * iwidtha(k,l)
               nptb = nptfact * iwidthb(k,l)
               do m=1,npta
                 dr = dble ( m - 1 )
                 ia = nint ( xpixmean(k,l) + cosa(k,l) * dr )
                 ja = nint ( ypixmean(k,l) + sina(k,l) * dr )
                 if (ia .ge. 1 .and. ia .le. nx .and. ja .ge. 1 .and. ja .le. ny) then
                   profilea(l,m) = imagefil(ia,ja)
                   profilea(l,m) = profilea(l,m) / imagefil(i,j)
                 endif
               enddo
               do m=1,nptb
                 dr = dble ( m - 1 )
                 ib = nint ( xpixmean(k,l) + cosb(k,l) * dr )
                 jb = nint ( ypixmean(k,l) + sinb(k,l) * dr )
                 if (ib .ge. 1 .and. ib .le. nx .and. jb .ge. 1 .and. jb .le. ny) then
                   profileb(l,m) = imagefil(ib,jb)
                   profileb(l,m) = profileb(l,m) / imagefil(i,j)
                 endif
               enddo
             endif
           enddo

           if (lverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing profiles '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'.profiles.fi.????.allpts.cat'//'''...'
           if (npts .gt. 0) then
             write (clk1,'(i4.4)') 1
             write (clk2,'(i4.4)') 2
             write (clk3,'(i4.4)') 3
             open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'.profiles.fi.'//cnextr//'.allpts.cat', status='unknown' )
             write (77,'(a)') '#______________________________________________________________________________________________'
             write (77,'(a)') '#'
             write (77,'(a)') '# GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men''shchikov, SAp IRFU CEA Saclay'
             write (77,'(a)') '#______________________________________________________________________________________________'
             write (77,'(a)') '#'
             write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
             write (77,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
             write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
             write (77,'(a)') '#'
             write (77,'(a)') '# CATALOG OF INTENSITY PROFILES ACROSS FILAMENT (AT EACH SKELETON POINT)'
             write (77,'(a)') '#'
             write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
             write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
             write (77,'(a)') '#'
             write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
             write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
             write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
             write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
             write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', pixfil(k)
             write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', 1
             write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', 1
             write (77,'(a)') '#'
             write (77,'(a)') '# TABULATED QUANTITIES:'
             write (77,'(a)') '#'
             write (77,'(a)') '#   NR ........ Number of radial point ....................'
             write (77,'(a)') '#   RADIUS .... Radial distance from the skeleton ......... arcsec'
             write (77,'(a)') '#   PROFA_# ... Left-side intensity profile at pixel # .... normalized'
             write (77,'(a)') '#   PROFB_# ... Right-side intensity profile at pixel # ... normalized'
             write (77,'(a)') '#'
             allocate ( cathead(np(k)), ilc(np(k)), stat=irc )
             if (irc .ne. 0) then
               write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (41).'
               stop 41
             endif
             cathead0 = '#  NR    RADIUS  |'
             ilc0 = lastc ( cathead0 ) - 1
             do l=1,np(k)
               write (clk,'(i4.4)') l
               cathead(l) = '   PROFA_'//clk//'  PROFB_'//clk
               ilc(l) = lastc ( cathead(l) )
             enddo
             write (77,'(a,'//cnmax//'(a))') cathead0(1:ilc0), (cathead(l)(1:ilc(l)), l=1,np(k))
             write (77,'(a)') '#'
             do m=1,npts
               write (77,'(i5,1pe12.4,'//cnmax//'(1x,2(1pe12.4)))') m, rad(m), (profilea(l,m), profileb(l,m), l=1,np(k))
             enddo
             close (77)
             deallocate ( cathead, ilc )
           endif
         endif

! Make sure that selected profiles are placed symmetrically about filament ends.

         do l=lk1,np(k),npxstep
           i = nint ( xpixmean(k,l) )
           j = nint ( ypixmean(k,l) )
           if (imagefil(i,j) .gt. almostzero) then
             npta = nptfact * iwidtha(k,l)
             nptb = nptfact * iwidthb(k,l)
             do m=1,npta
               dr = dble ( m - 1 )
               ia = nint ( xpixmean(k,l) + cosa(k,l) * dr )
               ja = nint ( ypixmean(k,l) + sina(k,l) * dr )
               if (ia .ge. 1 .and. ia .le. nx .and. ja .ge. 1 .and. ja .le. ny) then
                 profilea(l,m) = imagefil(ia,ja)
                 profilea(l,m) = profilea(l,m) / imagefil(i,j)
               endif
             enddo
             do m=1,nptb
               dr = dble ( m - 1 )
               ib = nint ( xpixmean(k,l) + cosb(k,l) * dr )
               jb = nint ( ypixmean(k,l) + sinb(k,l) * dr )
               if (ib .ge. 1 .and. ib .le. nx .and. jb .ge. 1 .and. jb .le. ny) then
                 profileb(l,m) = imagefil(ib,jb)
                 profileb(l,m) = profileb(l,m) / imagefil(i,j)
               endif
             enddo
           endif
         enddo

         if (npts .gt. 0) then
           if (lverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing profiles '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'.profiles.fi.????.select.cat'//'''...'
           write (clk1,'(i4.4)') lk1
           write (clk2,'(i4.4)') lk1+npxstep
           write (clk3,'(i4.4)') lk1+npxstep+npxstep
           open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'.profiles.fi.'//cnextr//'.select.cat', status='unknown' )
           write (77,'(a)') '#______________________________________________________________________________________________'
           write (77,'(a)') '#'
           write (77,'(a)') '# GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men''shchikov, SAp IRFU CEA Saclay'
           write (77,'(a)') '#______________________________________________________________________________________________'
           write (77,'(a)') '#'
           write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
           write (77,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
           write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
           write (77,'(a)') '#'
           write (77,'(a)') '# CATALOG OF INTENSITY PROFILES ACROSS FILAMENT (AT SELECTED SKELETON POINTS)'
           write (77,'(a)') '#'
           write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
           write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
           write (77,'(a)') '#'
           write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
           write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
           write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
           write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
           write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', pixfil(k)
           write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', lk1
           write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', npxstep
           write (77,'(a)') '#'
           write (77,'(a)') '# TABULATED QUANTITIES:'
           write (77,'(a)') '#'
           write (77,'(a)') '#   NR ........ Number of radial point ....................'
           write (77,'(a)') '#   RADIUS .... Radial distance from the skeleton ......... arcsec'
           write (77,'(a)') '#   PROFA_# ... Left-side intensity profile at pixel # .... normalized'
           write (77,'(a)') '#   PROFB_# ... Right-side intensity profile at pixel # ... normalized'
           write (77,'(a)') '#'
           allocate ( cathead(np(k)), ilc(np(k)), stat=irc )
           if (irc .ne. 0) then
             write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (42).'
             stop 42
           endif
           cathead0 = '#  NR    RADIUS  |'
           ilc0 = lastc ( cathead0 ) - 1
           do l=lk1,np(k),npxstep
             write (clk,'(i4.4)') l
             cathead(l) = '   PROFA_'//clk//'  PROFB_'//clk
             ilc(l) = lastc ( cathead(l) )
           enddo
           write (77,'(a,'//cnmax//'(a))') cathead0(1:ilc0), (cathead(l)(1:ilc(l)), l=lk1,np(k),npxstep)
           write (77,'(a)') '#'
           do m=1,npts
             write (77,'(i5,1pe12.4,'//cnmax//'(1x,2(1pe12.4)))') m, rad(m), (profilea(l,m), profileb(l,m), l=lk1,np(k),npxstep)
           enddo
           close (77)
           deallocate ( cathead, ilc )
         endif

         do n=1,nextr
           do m=1,npts
             profmeana(n,m) = 0.0d0
             profmeanb(n,m) = 0.0d0
             profmean(n,m) = 0.0d0
             profstda(n,m) = 0.0d0
             profstdb(n,m) = 0.0d0
             profstd(n,m) = 0.0d0
           enddo
         enddo

! Selected one-sided mean values and standard deviations of the profiles.

         do m=1,npts
           nava(m) = 0
           navb(m) = 0
           do l=lk1,np(k),npxstep
             if (profilea(l,m) .gt. almostzero) then
               nava(m) = nava(m) + 1
               profmeana(k,m) = profmeana(k,m) + profilea(l,m)
             endif
             if (profileb(l,m) .gt. almostzero) then
               navb(m) = navb(m) + 1
               profmeanb(k,m) = profmeanb(k,m) + profileb(l,m)
             endif
           enddo
           if (nava(m) .gt. 0) profmeana(k,m) = profmeana(k,m) / dble ( nava(m) )
           if (navb(m) .gt. 0) profmeanb(k,m) = profmeanb(k,m) / dble ( navb(m) )
           nava(m) = 0
           navb(m) = 0
           do l=lk1,np(k),npxstep
             if (profilea(l,m) .gt. almostzero) then
               nava(m) = nava(m) + 1
               profstda(k,m) = profstda(k,m) + (profilea(l,m) - profmeana(k,m))**2
             endif
             if (profileb(l,m) .gt. almostzero) then
               navb(m) = navb(m) + 1
               profstdb(k,m) = profstdb(k,m) + (profileb(l,m) - profmeanb(k,m))**2
             endif
           enddo
           if (nava(m) .gt. 1) profstda(k,m) = sqrt ( profstda(k,m) / (dble ( nava(m) ) - 1.0d0) )
           if (navb(m) .gt. 1) profstdb(k,m) = sqrt ( profstdb(k,m) / (dble ( navb(m) ) - 1.0d0) )
         enddo

! Selected full (two-sided) mean values and standard deviations of the profiles.

         do m=1,npts
           profmean(k,m) = (profmeana(k,m) + profmeanb(k,m)) / 2.0d0
           nav(m) = 0
           do l=lk1,np(k),npxstep
             if (profilea(l,m) .gt. almostzero) then
               nav(m) = nav(m) + 1
               profstd(k,m) = profstd(k,m) + (profilea(l,m) - profmean(k,m))**2
             endif
             if (profileb(l,m) .gt. almostzero) then
               nav(m) = nav(m) + 1
               profstd(k,m) = profstd(k,m) + (profileb(l,m) - profmean(k,m))**2
             endif
           enddo
           if (nav(m) .gt. 1) profstd(k,m) = sqrt ( profstd(k,m) / (dble ( nav(m) ) - 1.0d0) )
         enddo

         if (npts .gt. 0) then
           if (lverbose .eq. '-verb2' .and. k .eq. 1) 
     &        write (iotty,'(a)') '   Writing profiles '''//individprofs(1:indp)//'/'
     &                          //outname(1:ion)//'.profiles.fi.????.mean.cat'//'''...'

           open ( 77, file=individprofs(1:indp)//'/'//outname(1:ion)//'.profiles.fi.'//cnextr//'.mean.cat', status='unknown' )
           write (77,'(a)') '#______________________________________________________________________________________________'
           write (77,'(a)') '#'
           write (77,'(a)') '# GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men''shchikov, SAp IRFU CEA Saclay'
           write (77,'(a)') '#______________________________________________________________________________________________'
           write (77,'(a)') '#'
           write (77,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
           write (77,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
           write (77,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
           write (77,'(a)') '#'
           write (77,'(a)') '# CATALOG OF INTENSITY PROFILES ACROSS FILAMENT (AVERAGED ALONG ITS SKELETON)'
           write (77,'(a)') '#'
           write (77,'(a)') '# Filaments: '//filenama(1:fnlen1)
           write (77,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
           write (77,'(a)') '#'
           write (77,'(a,i5)'    ) '# Filament (skeleton) number .............', k
           write (77,'(a,f8.2,a)') '# Hi-res X coordinate of the 1st point ...', xpixmean(k,1)
           write (77,'(a,f8.2,a)') '# Hi-res Y coordinate of the 1st point ...', ypixmean(k,1)
           write (77,'(a,f8.2,a)') '# Skeleton direction at the 1st point ....', sangle(k,1)
           write (77,'(a,i5  ,a)') '# Number of points in skeleton ...........', pixfil(k)
           write (77,'(a,i5  ,a)') '# Initial skeleton point to profile ......', lk1
           write (77,'(a,i5  ,a)') '# Step over skeleton points to profile ...', npxstep
           write (77,'(a)') '#'
           write (77,'(a)') '# TABULATED QUANTITIES:'
           write (77,'(a)') '#'
           write (77,'(a)') '#   NR ......... Number of radial point ..............................'
           write (77,'(a)') '#   RADIUS ..... Radial distance from the skeleton ................... arcsec'
           write (77,'(a)') '#   PROFILE .... Mean filament intensity profile on both sides ....... normalized'
           write (77,'(a)') '#   PROFSTD .... Standard deviations about PROFILE along filament .... normalized'
           write (77,'(a)') '#   NPT ........ Number of points used for PROFILE and PROFSTD .......'
           write (77,'(a)') '#   PROFILEA ... Left-side mean intensity profile .................... normalized'
           write (77,'(a)') '#   PROFSTDA ... Standard deviations about PROFILEA along filament ... normalized'
           write (77,'(a)') '#   NPTA ....... Number of points used for PROFILEA and PROFSTDA .....'
           write (77,'(a)') '#   PROFILEB ... Right-side mean intensity profile ................... normalized'
           write (77,'(a)') '#   PROFSTDB ... Standard deviations about PROFILEB along filament ... normalized'
           write (77,'(a)') '#   NPTB ....... Number of points used for PROFILEB and PROFSTDB .....'
           write (77,'(a)') '#'
           write (77,'(a)') '#  NR    RADIUS     PROFILE     PROFSTD    NPT   PROFILEA    PROFSTDA  NPTA   PROFILEB    PROFSTDB'
     &                    //'  NPTB'
           write (77,'(a)') '#'
           do m=1,npts
             write (77,'(i5,1pe12.4,3(2(1pe12.4),i5))') m, rad(m), profmean(k,m), profstd(k,m), nav(m), profmeana(k,m)
     &                                                , profstda(k,m), nava(m), profmeanb(k,m), profstdb(k,m), navb(m)
           enddo
           close (77)
         endif

! Mean width of a filament.

         wida = 0.0d0
         widb = 0.0d0
         profhalfa = profmeana(k,1) / 2.0d0
         profhalfb = profmeanb(k,1) / 2.0d0
         do m=2,npts
           if (profmeana(k,m-1) .gt. profhalfa .and. profmeana(k,m) .le. profhalfa) then
             wida = rad(m) + (profhalfa - profmeana(k,m)) * (rad(m) - rad(m-1))
             exit
           endif
         enddo
         do m=2,npts
           if (profmeanb(k,m-1) .gt. profhalfb .and. profmeanb(k,m) .le. profhalfb) then
             widb = rad(m) + (profhalfb - profmeanb(k,m)) * (rad(m) - rad(m-1))
             exit
           endif
         enddo
         widthmean(k) = wida + widb

! Standard deviations of widths along filament.

         nptw(k) = 0
         do l=lk1,np(k),npxstep
           profhalfa = profilea(l,1) / 2.0d0
           profhalfb = profileb(l,1) / 2.0d0
           do m=2,npts
             if (profilea(l,m-1) .gt. profhalfa .and. profilea(l,m) .le. profhalfa) then
               nptw(k) = nptw(k) + 1
               widthstd(k) = widthstd(k) + (rad(m) - widthmean(k))**2
               exit
             endif
           enddo
           do m=2,npts
             if (profileb(l,m-1) .gt. profhalfb .and. profileb(l,m) .le. profhalfb) then
               nptw(k) = nptw(k) + 1
               widthstd(k) = widthstd(k) + (rad(m) - widthmean(k))**2
               exit
             endif
           enddo
         enddo
         if (nptw(k) .gt. 1) widthstd(k) = sqrt ( widthstd(k) / (dble ( nptw(k) ) - 1.0d0) )

! Make sure that profiles are placed symmetrically about filament end points.

         do l=lk1,np(k),npxstep
           npta = iwidtha(k,l)
           nptb = iwidthb(k,l)
           if (npta .gt. 2) then
             do m=1,npta
               dr = dble ( m - 1 )
               ia = nint ( xpixmean(k,l) + cosa(k,l) * dr )
               ja = nint ( ypixmean(k,l) + sina(k,l) * dr )
               normals(ia,ja) = max ( min ( imageseg(ia,ja), 1.0d0 ), 0.11d0 )
             enddo
           endif
           if (nptb .gt. 2) then
             do m=1,nptb
               dr = dble ( m - 1 )
               ib = nint ( xpixmean(k,l) + cosb(k,l) * dr )
               jb = nint ( ypixmean(k,l) + sinb(k,l) * dr )
               normals(ib,jb) = max ( min ( imageseg(ib,jb), 1.0d0 ), 0.11d0 )
             enddo
           endif
         enddo

         deallocate ( profilea, profileb, profmeana, profmeanb, profstda, profstdb, profmean, profstd, rad, nava, navb, nav )

 888     continue     
       enddo

       if (lverbose .eq. '-verb2') 
     &    write (iotty,'(a)') '   Writing profiles '''//individprofs(1:indp)//'/'//outname(1:ion)//'.properties.cat'//'''...'
     
       open ( 66, file=individprofs(1:indp)//'/'//outname(1:ion)//'.properties.cat', status='unknown' )
       write (66,'(a)') '#______________________________________________________________________________________________'
       write (66,'(a)') '#'
       write (66,'(a)') '# GETFILAMENTS = Multi-Scale Filament Extraction = Alexander Men''shchikov, SAp IRFU CEA Saclay'
       write (66,'(a)') '#______________________________________________________________________________________________'
       write (66,'(a)') '#'
       write (66,'(a)') '# FMEASURE = Measure & Catalog Filaments = '//compda
       write (66,'(a)') '# Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
       write (66,'(a)') '# Using '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence.'
       write (66,'(a)') '#'
       write (66,'(a)') '# CATALOG OF THE GLOBAL PROPERTIES OF FILAMENTS'
       write (66,'(a)') '#'
       write (66,'(a)') '# Filaments: '//filenama(1:fnlen1)
       write (66,'(a)') '# Skeletons: '//filenamb(1:fnlen2)
       write (66,'(a)') '#'
       write (66,'(a,i3,a,i2)') '# Step over skeleton points for computing widths:', npxstep, ', curvatures:', 1
       write (66,'(a,i2     )') '# Window size over skeleton points for smoothing:', 2*npw+1
       write (66,'(a)') '#'
       write (66,'(a)') '# TABULATED QUANTITIES:'
       write (66,'(a)') '#'
       write (66,'(a)') '#   NF .......... Number of a filament (skeleton) ........'
       write (66,'(a)') '#   LENGTH ...... Total filament length .................. arcsec'
       write (66,'(a)') '#   WIDTH ....... Filament mean width (half-maximum) ..... arcsec'
       write (66,'(a)') '#   WIDSTD ...... Standard deviation about WIDTH ......... arcsec'
       write (66,'(a)') '#   NPTW ........ Number of points used for WIDSTD .......'
       write (66,'(a)') '#   CURVTOTAL ... Filament |total smoothed curvature| .... CURVTOTAL=abs(sum(CURV*DS)),'
     &                //' CURV=(DXDT*D2YDT2-DYDT*D2XDT2)/sqrt(DXDT^2+DYDT^2)^3'
       write (66,'(a)') '#   CURVMEDI .... Filament |median smoothed curvature| ... 1/arcsec'
       write (66,'(a)') '#   CURVMEAN .... Filament |mean smoothed curvature| ..... 1/arcsec'
       write (66,'(a)') '#   CURVSTD ..... Standard deviation about CURVMEAN ...... 1/arcsec'
       write (66,'(a)') '#   NPTC ........ Number of points used for CURVSTD ......'
       write (66,'(a)') '#'
       write (66,'(a)') '#  NF    LENGTH      WIDTH      WIDSTD  NPTW   CURVTOTAL   CURVMEDI   CURVMEAN   CURVSTD  NPTC'
       write (66,'(a)') '#'
       do k=1,nextr
         write (66,'(i5,1pe11.3,1x,2(1pe11.3),i5,1x,4(1pe11.3),i5)') k, length(k), widthmean(k), widthstd(k), nptw(k)
     &                                                             , curvtota(k), curvmedi(k), curvmean(k), curvstd(k), navc(k)
       enddo
       close (66)
       
       deallocate ( widthmean, widthstd )
       
       normalsname = individprofs(1:indp)//'/'//outname(1:ion)//'.normals.fits'
       ipn = lastc ( normalsname )
       header = normalsname(1:ipn)

       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (normals(i,j) .gt. datamax) datamax = normals(i,j)
           if (normals(i,j) .lt. datamin) datamin = normals(i,j)
         enddo
       enddo

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing normals '''//normalsname(1:ipn)//'''...'
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, normals, dx, dy, object, crval1
     &            , crval2, normalsname(1:ipn), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
  
       deallocate ( normals )

       allocate ( curva(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FMEASURE: ERROR: Trouble allocating memory (61).'
         stop 60
       endif
       do j=1,ny
         do i=1,nx
           curva(i,j) = -0.1d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           if (curvsmoo(k,l) .lt. 9.99d+30) then
             curva(ia,ja) = abs ( curvsmoo(k,l) )
           else
             curva(ia,ja) = -1.0d0
           endif
         enddo
       enddo
       curvname = individprofs(1:indp)//'/'//outname(1:ion)//'.curvsmo.fits'
       ipd = lastc ( curvname )
       header = curvname(1:ipd)

       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (curva(i,j) .gt. datamax) datamax = curva(i,j)
           if (curva(i,j) .lt. datamin) datamin = curva(i,j)
         enddo
       enddo

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing smoothed curvatures '''//curvname(1:ipd)//'''...'

       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, curva, dx, dy, object, crval1
     &            , crval2, curvname(1:ipd), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
     
       do j=1,ny
         do i=1,nx
           curva(i,j) = -0.1d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           curva(ia,ja) = curvtota(k)
         enddo
       enddo
       curvname = individprofs(1:indp)//'/'//outname(1:ion)//'.curvtot.fits'
       ipd = lastc ( curvname )
       header = curvname(1:ipd)

       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (curva(i,j) .gt. datamax) datamax = curva(i,j)
           if (curva(i,j) .lt. datamin) datamin = curva(i,j)
         enddo
       enddo

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing total curvatures '''//curvname(1:ipd)//'''...'

       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, curva, dx, dy, object, crval1
     &            , crval2, curvname(1:ipd), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
     
       do j=1,ny
         do i=1,nx
           curva(i,j) = -0.1d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           curva(ia,ja) = abs ( curvmean(k) )
         enddo
       enddo
       curvname = individprofs(1:indp)//'/'//outname(1:ion)//'.curvmea.fits'
       ipd = lastc ( curvname )
       header = curvname(1:ipd)
  
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (curva(i,j) .gt. datamax) datamax = curva(i,j)
           if (curva(i,j) .lt. datamin) datamin = curva(i,j)
         enddo
       enddo
  
       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing mean curvatures '''//curvname(1:ipd)//'''...'
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, curva, dx, dy, object, crval1
     &            , crval2, curvname(1:ipd), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
 
       do j=1,ny
         do i=1,nx
           curva(i,j) = -0.1d0
         enddo
       enddo
       do k=1,nextr
         do l=1,np(k)
           ia = nint ( xpixmean(k,l) )
           ja = nint ( ypixmean(k,l) )
           curva(ia,ja) = abs ( curvmedi(k) )
         enddo
       enddo
       curvname = individprofs(1:indp)//'/'//outname(1:ion)//'.curvmed.fits'
       ipd = lastc ( curvname )
       header = curvname(1:ipd)
  
       datamin =  1.0d+30
       datamax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (curva(i,j) .gt. datamax) datamax = curva(i,j)
           if (curva(i,j) .lt. datamin) datamin = curva(i,j)
         enddo
       enddo
  
       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing median curvatures '''//curvname(1:ipd)//'''...'
  
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, curva, dx, dy, object, crval1
     &            , crval2, curvname(1:ipd), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
   
       deallocate ( curva )

       deallocate ( imagefil, imageseg )

       deallocate ( np, xcoo, ycoo, pixfil, xpixfil, ypixfil, iwidth, iwidtha, iwidthb, widtha, widthb, xpixmean, ypixmean, length
     &            , cosa, sina, cosb, sinb, sangle, nanglea, nangleb, curvature, curvmean, curvstd, navc, nptw, curvtota, curvmedi
     &            , funmed, curvsmoo )

 999   continue
       if (nextr .gt. 0) then
         if (lverbose .eq. '-verb2') write (iotty,'(/a)') ' Done.'
       else
         if (lverbose .eq. '-verb2') write (iotty,'(/a)') ' Nothing to do: no filaments found...'
       endif

!!       stop !<-- commented out because it would lead to run-time messages about denormalized values, when using gfortran.
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header, footer, iotty
     &            , iolog, creator, beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history, lverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend, anynull, myfile
       character*(*) ctype1, ctype2, creator, fname, header, footer(2), bunit, object, history, lverbose
       character*25  cdatetime
       character*80  footer1, footer2, comment
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, lastc, iotty, iolog, maxdim
     &             , ilc1, ilc2, rw, nfound, blank, stat01, stat02, stat03, stat04, stat05, stat06, stat07, stat08, stat09
     &             , stat10, stat11, stat12, stat13, stat14, stat15, stat16, stat17, stat18, stat19, stat20, stat21, stat22
     &             , stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30, stat31, stat32, stat0, nan
       parameter   ( maxdim = 2 )
       integer       naxes(maxdim)
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22
       real*8        fun(nx,ny)
       real*8        as2deg, datamx, datamn
       parameter   ( as2deg = 1.0d0 / 3600.0d0 )
       external      lastc, ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat01 = 0
       stat02 = 0
       stat03 = 0
       stat04 = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:22) .eq. 'Alexander Men`shchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'FMEASURE'
       endif

       header = 'FITS Plot Header'

       if (myfile) then
         call ftgkys ( unit, 'HEADER' , header , comment, stat01 )
         call ftgkys ( unit, 'FOOTER1', footer1, comment, stat02 )
         call ftgkys ( unit, 'FOOTER2', footer2, comment, stat03 )
         ilc1 = lastc ( footer1 )
         ilc2 = lastc ( footer2 )
         if (ilc1 .ne. 0 .and. ilc2 .ne. 0) then
           footer(1) = footer1(1:ilc1)//footer2(1:ilc2)
         else
           footer(1) = 'Footer'
         endif
       else
         call ftgkys ( unit, 'OBJECT' , header, comment, stat04 )
         if (stat04 .ne. 0 .or. header(1:10) .eq. '          ') header = fname
         footer(1) = header
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. 
! Maybe there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat08 = 0
       stat0 = stat01 + stat02 + stat03 + stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15
     &       + stat16 + stat17 + stat18 + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28
     &       + stat29 + stat30 + stat31

       if (lverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat01 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword HEADER absent or error'
         if (stat02 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER1 absent or error'
         if (stat03 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER2 absent or error'
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat29 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EPOCH absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = 'No object specified'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       nan = 0
       do j=1,ny
         do i=1,nx
           if (isnan ( fun(i,j) )) then  
             nan = nan + 1
             if (lverbose .ne. '-verb0') then
               if (nan .lt. 100) then
                 write (iotty,'(a,i4,a,i4,a)') '   RFITS: Element (', i,',', j, ') contains not a number (NaN)...'
               elseif (nan .eq. 100) then
                 write (iotty,'(a)') '   RFITS: Many NaNs, no more info on the elements.'
               endif
             endif
           else
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header
     &            , footer, cdate, ctime, creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, header, footer(2), ctime, cdate, bunit, cfitsversion, history
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), iat, iflen
     &             , lastc, blank
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, dfun, rot1, rot2, epoch, equinox, datamn
     &             , cosrota, sinrota, rotangle, datamx, dxdeg, dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      lastc
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny

! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       do j=1,ny
         do i=1,nx
           dfun = fun(i,j)
           if (dfun .lt. datamn ) datamn = dfun
           if (dfun .gt. datamx ) datamx = dfun
         enddo
       enddo

       bitpix = -32     !<-- single precision floating-point values

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator,'Alexander Men`shchikov, SAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'HEADER' , header, 'title', status )

       iat = 0
       iat = index ( footer(1), ' |F' )
       if (iat .eq. 0) iat = index ( footer(1), ' mm ' )
       iflen = lastc ( footer(1) )

       if (iat .gt. 0) then
         call ftpkys ( unit, 'FOOTER1', footer(1)(1:iat-1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', footer(1)(iat:iflen), 'part 2', status )
       else
         call ftpkys ( unit, 'FOOTER1', footer(1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', ' ', 'part 2', status )
       endif
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = dx * as2deg
       dydeg = dy * as2deg

! Correct if the input images had cd11 or cd22 set to zero.

       if (abs ( cd11 ) .lt. almostzero .or. abs ( cd11 ) .gt. dxdeg) then
         cd11 = -dxdeg
         cd12 = 0.0d0
       endif
       if (abs ( cd22 ) .lt. almostzero .or. abs ( cd22 ) .gt. dxdeg) then
         cd21 = 0.0d0
         cd22 = dydeg
       endif
       
       cosrota = - cd11 / dxdeg
       sinrota = - cd12 / dxdeg
       rotangle = acos ( cosrota ) * 180.0d0 / pi
       
       if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = 180.0d0 - rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = 180.0d0 + rotangle
       elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = - rotangle
       endif
       rot2 = rot1

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
       if  (blank .gt. 0)
     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , -dxdeg, 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftpkyd ( unit, 'EPOCH'  , epoch  , 13, ' ', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, ' ', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'image was convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||