
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program sfinder
!__________________________________________________________________________________________________________________________________
!
! Find sources in a set of single-scale detection images.
!
! This code is part of GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay
!
! Return codes:
!
!   10-29 ... problems with the input parameters
!   30-49 ... non-existing files or directories
!   50-69 ... problems with reading/writing files or values
!   70-89 ... problems with memory allocation
!   90-99 ... other code-specific problems
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       lunix, lfname1, lfname2, lfname3, lfname4, lfname5, lfname6, laccelerate, ledgeszero, lcornerpos, l1st, lfoots
     &             , ldebug, lfname, lnothingsleft, lfnvers, ltiming, ltime, lfoundold, linside, ldone  !!!, lnotsource
                          
       character*2   cnscale, cnscaleo, cnscaleoo
       character*3   cl, cfnl
       character*4   cfpm
       character*5   cnx, cny, cnxx, cnyy, cns, cne, cneo, cnn, cnno, cng, cngo, cfpptime, chan, cnx1, cnx1o, cny1, cny1o
       character*6   cfitsversion, csscale, csscaleo, csscaleoo, cnobj, cpix, cpixx, lverbose, cfmt
       character*7   clibname, crotangle
       character*8   ctime        
       character*10  cdate, funits
       character*12  charnum
       character*21  compda
       character*80  object, creator, ctype1, ctype2, bunit, cwave, history
       character*128 header, footer(2)
       character*132 getstitle
       character*300 cfgline(200)
       character*500 imagename, oldsegm, newsegm, catname, oldcat, segmentl, imagel, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8
     &             , arg9, argA, argB, argC, argD, argE, oldimage, ooldimage, footprint, individs, cfgfile, segmentln, imageln
     &             , swcatname, filewithswnames, sswname, versfile, domaskname, simagename, soldimage, sooldimage, unrotname
       character*999 cline, cscales, cproblem

       integer       isp1, ifn, ins, isk, iik, ndate, iotty, nx, ny, lastc, lasts, irc, lb, ia1, ia2, ia3, ia4, ia5, ia6, ia7, lpix
     &             , blank, nextr, nextrmax, i, j, lev, m, nlevs, iocat, n, is, js, ios, nhead, ncolumns, ioc, iu, lnx, lny, lneo
     &             , nscale, nscaleo, idot1, idot2, im1, jm1, ip1, jp1, nextro, ioi, ind, lcns, icno, ino1, ifp, isl, lcfg, idm, kk
     &             , ncfglines, k, fu, nextroldscale, iskn, iikn, ia8, nscalemax, nextrnew, ns1min, ia9, iaA, iaB, iswc, idot3, jsa 
     &             , nscaleoo, noisesources, iss, nfiles, nheadf, ifwn, lver, lnno, lngo, n1xmin, n2xmax, n1ymin, n2ymax, iaC, ioo
     &             , l, ktouch, nlevsmin, isfn, isoi, isoo, maxtouch, nxco, nyco, ndelta, icp, n1y, n2y, nxminn, nxmaxn, nyminn 
     &             , nymaxn, imiddle, jmiddle, nlevsact, wchours, wcmins, wcsecs, cpuhours, cpumins, cpusecs, iaD, imx, jmx, isa
     &             , nxn, nyn, iun, lnx1o, lny1o, nx1, ny1, icr, icre, iaE

       parameter   ( iotty = 6, nextrmax = 15000, maxtouch = 1000 )

       real          fitsvers
       
       real*8        cpu_filling_old, cpu_filling_new, cput_filling_old, cput_filling_new, cpu_checkisolation, cpu_measuring
     &             , cput_checkisolation, cput_measuring, cpu_identifynoise, cput_identifynoise, cpu_measurespecial
     &             , cput_measurespecial, cpu_sum, cpu_checkmerging, cput_checkmerging, cpu_reading_images, cpu_writing_images
     &             , cput_reading_images, cput_writing_images, timer, cputot, wctot

       real*8        walt_filling_old, walt_filling_new, walt_checkisolation, walt_measuring, walt_identifynoise
     &             , walt_measurespecial, wal_sum, walt_checkmerging, walt_reading_images, walt_writing_images
     &             , wal_filling_old, wal_filling_new, wal_checkisolation, wal_measuring, wal_identifynoise, wal_measurespecial
     &             , wal_checkmerging, wal_reading_images, wal_writing_images

       real*8        dx, dy, crpix1, crpix2, crval1, crval2, ra, dec, beam, funmin, funmax, pi, crota1, crota2, epoch, equinox
     &             , bzero, bscale, datamin, datamax, sscale, newpixval, boupixval, almostzero, delta, outerradius, sscaleo, sfactor
     &             , imgmin, imgmax, imglev, obsbeammin, ratio, contranoise, wave, wavef, sourcearea, sqpixel, outerradius2
     &             , dlogmaxmin, sigma, maximgmax, tfluxradius, sscaleoo, mxconmk, myconmk, factincrease, pixels, dscale, rotangle
     &             , oldpixels, pixmin, pixadd, factortotal, aperture, cd11, cd12, cd21, cd22, smax, dxdeg, dydeg, crpix1n, crpix2n
     &             , cd11n, cd12n, cd21n, cd22n, mxcomin, mycomin, mxcomax, mycomax, sscaleooh, sscaleoh, cosrota, sinrota
                                                                                                                      
       logical    , allocatable :: lisolated(:), lgotanother(:), lcoordsdone(:)
       character*1, allocatable :: flag(:), flago(:)
       integer    , allocatable :: ns1(:), ns2(:), nsx(:), nxmin(:), nxmax(:), nymin(:), nymax(:), nonzero(:), nimglev(:), flg(:)
     &                           , ntouching(:,:), ntouchino(:,:), ktouching(:), n1x(:), n2x(:), nxmino(:), nxmaxo(:), nymino(:)
     &                           , nymaxo(:), flm(:)
       real*8     , allocatable :: image(:,:), iworker(:,:), osegm(:,:), nsegm(:,:), fluxpeak(:), momxx(:), momyy(:), fluxtot(:)
     &                           , afwhm(:), bfwhm(:), atheta(:), equivrad(:), foomajor(:), foothepa(:), sigmono(:), mxco(:)
     &                           , myco(:), fluxpo(:), fluxto(:), dfpdso(:), elongationo(:), contramin(:), dfpds(:), elongation(:)
     &                           , fxpbest(:), fxtbest(:), mxcor(:), mycor(:), scalensx(:), contrast(:), fluxgauss(:), foominor(:)
     &                           , fxperror(:), fxterror(:), sigglob(:), factnoise(:), detectomask(:,:), foots(:,:), segmen(:,:)
     &                           , intenstouch(:,:), simage(:,:), simageo(:,:), simageoo(:,:), momxy(:), deltx(:), delty(:), good(:)
     &                           , foota(:,:), unrotated(:,:), footfact(:)

       parameter   ( laccelerate = .true., ldebug = .false., ltiming = .true. )

       parameter   ( boupixval = 0.0d0, nlevsmin = 30, pi = 3.14159265358979d0, almostzero = 1.0d-30 )

       external      lastc, rfits, wfits, when, getnumpix, fillarea, fillleft, fillright, scanhi, scanlo, pop, push, timer
!__________________________________________________________________________________________________________________________________
!
! Determine operating acttem

       call osystem ( lunix )

       call ftvers ( fitsvers )

       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       compda = __DATE__//' '//cfpptime
       
! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )
       
! Get command line parameters (file names).

       call getarg (  1, arg1 )
       call getarg (  2, arg2 )
       call getarg (  3, arg3 )
       call getarg (  4, arg4 )
       call getarg (  5, arg5 )
       call getarg (  6, arg6 )
       call getarg (  7, arg7 )
       call getarg (  8, arg8 )
       call getarg (  9, arg9 )
       call getarg ( 10, argA )
       call getarg ( 11, argB )
       call getarg ( 12, argC )
       call getarg ( 13, argD )
       call getarg ( 14, argE )

       ia1 = lastc ( arg1 )
       ia2 = lastc ( arg2 )
       ia3 = lastc ( arg3 )
       ia4 = lastc ( arg4 )
       ia5 = lastc ( arg5 )
       ia6 = lastc ( arg6 )
       ia7 = lastc ( arg7 )
       ia8 = lastc ( arg8 )
       ia9 = lastc ( arg9 )
       iaA = lastc ( argA )
       iaB = lastc ( argB )
       iaC = lastc ( argC )
       iaD = lastc ( argD )
       iaE = lastc ( argE )
       
       lverbose = '-verb2'
       if (iaE .gt. 0 .and. argE(1:iaE-1) .eq. '-verb') lverbose = argE(1:iaE)
       if (iaD .gt. 0 .and. argD(1:iaD-1) .eq. '-verb') lverbose = argD(1:iaD)
       if (iaC .gt. 0 .and. argC(1:iaC-1) .eq. '-verb') lverbose = argC(1:iaC)
       if (iaB .gt. 0 .and. argB(1:iaB-1) .eq. '-verb') lverbose = argB(1:iaB)
       if (iaA .gt. 0 .and. argA(1:iaA-1) .eq. '-verb') lverbose = argA(1:iaA)
       if (ia9 .gt. 0 .and. arg9(1:ia9-1) .eq. '-verb') lverbose = arg9(1:ia9)
       
       if (lverbose .eq. '-verb2') write (iotty,'(/a$)') ' SFINDER = Detect Sources in Single Scales = '//compda
       if (arg1(1:ia1) .eq. ':') stop
       if (lverbose .eq. '-verb2') write (iotty,'()')
       if (lverbose .eq. '-verb2') write (iotty,'( a)') ' Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
       if (lverbose .eq. '-verb2') write (iotty,'( a)') ' Using '//clibname(lb:7)//' library version'//cfitsversion
     &                                                //' by William D Pence.'
       if (ia8 .eq. 0) then
         write (iotty,'(/a)') ' USAGE: sfinder <waveband> <obsbeammin> <contranoise> <factortotal> <nscalemax> <aperture>'
     &                      //' <detectomask> <image> [<oldimage> <ooldimage> <oldsegm>] [-o <newsegm>] [-verb{0|1|2}]'
         stop 11
       endif  

       cwave = arg1(1:ia1)
       read (cwave(1:ia1),*,err=2) wave     !<-- wavelength (microns)
       goto 3
  2    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading wavelength: '//cwave(1:ia1)
       stop 51
  3    continue
       if (cwave(1:ia1) .eq. '0') then
         cwave = 'sw'
         ia1 = lastc ( cwave )
       endif

       read (arg2(1:ia2),*,err=4) obsbeammin    !<-- beam size (arcsec)
       goto 5
  4    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading beam size: '//arg2(1:ia2)
       stop 52
  5    continue

       read (arg3(1:ia3),*,err=6) contranoise   !<-- intensity ratio for removing noise peaks
       goto 7
  6    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading contranoise: '//arg3(1:ia3)
       stop 53
  7    continue

       read (arg4(1:ia4),*,err=83) factortotal   !<-- factor defining footprint size from FWHM
       goto 84
 83    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading factortotal: '//arg4(1:ia4)
       stop 54
 84    continue

       read (arg5(1:ia5),*,err=8) nscalemax     !<-- maximum scale at which find new sources
       goto 9
  8    write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading nscalemax: '//arg5(1:ia5)
       stop 55
  9    continue

       read (arg6(1:ia6),*,err=81) aperture     !<-- radius of a fixed aperture
       goto 82
  81   write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading aperture: '//arg6(1:ia6)
       stop 56
  82   continue

       domaskname = arg7(1:ia7)
       imagename = arg8(1:ia8)
       if (ia9 .gt. 0) then
         if (arg9(1:2) .ne. '-o' .and. arg9(1:ia9-1) .ne. '-verb') then
           oldimage = arg9(1:ia9)
           ooldimage = argA(1:iaA)
           oldsegm = argB(1:iaB)
         else
           oldimage = 'none'
           ooldimage = 'none'
           oldsegm = 'none'
         endif
       else
         oldimage = 'none'
         ooldimage = 'none'
         oldsegm = 'none'
       endif
       
       ios = lastc ( oldsegm )
       ioi = lastc ( oldimage )
       ioo = lastc ( ooldimage )
       ifn = lastc ( imagename )
       idm = lastc ( domaskname )
       
       if (ltiming) then
         inquire ( file='+timing.sfinder', exist=ltime )
         open ( 60, file='+timing.sfinder', status='unknown' )
         if (ltime) then
           do 
             read (60,'()',end=61)
           enddo
  61       backspace ( 60 )
         endif
         write (60,'(/a)') ' SFINDER started: '//cdate//' '//ctime//' Image: '//imagename(1:ifn)

         cput_reading_images = 0.0d0
         walt_reading_images = 0.0d0
         cput_filling_old = 0.0d0
         walt_filling_old = 0.0d0
         cput_filling_new = 0.0d0
         walt_filling_new = 0.0d0
         cput_checkisolation = 0.0d0
         walt_checkisolation = 0.0d0
         cput_checkmerging = 0.0d0
         walt_checkmerging = 0.0d0
         cput_measuring = 0.0d0
         walt_measuring = 0.0d0
         cput_identifynoise = 0.0d0
         walt_identifynoise = 0.0d0
         cput_measurespecial = 0.0d0
         walt_measurespecial = 0.0d0
         cput_writing_images = 0.0d0
         walt_writing_images = 0.0d0
         cpu_sum = 0.0d0
         wal_sum = 0.0d0
       endif
       
! Check if the input files exist.

       inquire ( file=domaskname(1:idm), exist=lfname1 )
       if (.not.lfname1) then

! Maybe the file name extension was omitted?

         domaskname = domaskname(1:idm)//'.fits'
         idm = lastc ( domaskname )

         inquire ( file=domaskname(1:idm), exist=lfname1 )
       endif

       inquire ( file=imagename(1:ifn), exist=lfname2 )
       if (.not.lfname2) then

! Maybe the file name extension was omitted?

         imagename = imagename(1:ifn)//'.fits'
         ifn = lastc ( imagename )

         inquire ( file=imagename(1:ifn), exist=lfname2 )
       endif
       isp1 = lasts ( imagename ) + 1
       newsegm = imagename(isp1:ifn-5)//'.m.fits'

       simagename = imagename(1:ifn-10)//'.as.m.fits'
       isfn = lastc ( simagename )
       
       idot1 = index ( imagename, '.' )
       idot2 = index ( imagename(idot1+1:ifn), '.' ) + idot1
       idot3 = index ( imagename(idot2+1:ifn), '.' ) + idot2

       if (lfname2) then
         cnscale = imagename(idot3+1:idot3+2)
         read (cnscale,'(i2)',err=38) nscale
         csscale = imagename(idot3+5:idot3+10)
         read (csscale,'(f6.3)',err=38) sscale
         goto 39
 38      write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading scales from '//imagename(idot3+1:idot3+10)
         stop 55
 39      continue

! Define name of a file listing all file names for single-scale combined detection images.

         filewithswnames = imagename(1:idot3-1)//'.combining'
         ifwn = lastc ( filewithswnames )
         inquire ( file=filewithswnames(1:ifwn), exist=lfname5 )
         if (.not.lfname5) then
           write (iotty,'(/a)') '   SFINDER: ERROR: File '//filewithswnames(1:ifwn)//' not found.'
           stop 30
         endif
       endif
       nscaleo = 0
       nscaleoo = 0
       sscaleo = sscale
       
! Check if the input file exists and open it.

       if (oldimage .ne. 'none') then

         inquire ( file=oldimage(1:ioi), exist=lfname3 )
         if (.not.lfname3) then

! Maybe the file name extension was omitted?

           oldimage = oldimage(1:ioi)//'.fits'
           ioi = lastc ( oldimage )
           inquire ( file=oldimage(1:ioi), exist=lfname3 )
         endif

         idot1 = index ( oldimage, '.' )
         idot2 = index ( oldimage(idot1+1:ioi), '.' ) + idot1
         idot3 = index ( oldimage(idot2+1:ioi), '.' ) + idot2

         swcatname = 'sm.sw.'//oldimage(1:idot1)//'sw.nn.smf.cat'
         iswc = lastc ( swcatname )

         if (lfname3) then
           cnscaleo = oldimage(idot3+1:idot3+2)
           read (cnscaleo,'(i2)',err=48) nscaleo
           csscaleo = oldimage(idot3+5:idot3+10)
           read (csscaleo,'(f6.3)',err=48) sscaleo
           goto 49
 48        write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading old scales from '//oldimage(idot3+1:idot3+10)
           stop 56
 49        continue
           nscaleoo = nscaleo - 1
         endif

         inquire ( file=oldsegm(1:ios), exist=lfname4 )
         if (.not.lfname4) then

! Maybe the file name extension was omitted?

           oldsegm = oldsegm(1:ios)//'.fits'
           ios = lastc ( oldsegm )
           inquire ( file=oldsegm(1:ios), exist=lfname4 )
         endif

         if (argB(1:2) .eq. '-o') then
           newsegm = argC
         else if (argC(1:2) .eq. '-o') then
           newsegm = argD
         endif
       else
         lfname3 = .true.
         lfname4 = .true.
         if (argA(1:2) .eq. '-o') newsegm = argB
       endif

       soldimage = oldimage(1:ioi-10)//'.as.m.fits'
       isoi = lastc ( soldimage )
       
       if (ooldimage .ne. 'none') then

         inquire ( file=ooldimage(1:ioo), exist=lfname6 )
         if (.not.lfname6) then

! Maybe the file name extension was omitted?

           ooldimage = ooldimage(1:ioo)//'.fits'
           ioo = lastc ( ooldimage )
           inquire ( file=ooldimage(1:ioo), exist=lfname6 )
         endif

         idot1 = index ( ooldimage, '.' )
         idot2 = index ( ooldimage(idot1+1:ioo), '.' ) + idot1
         idot3 = index ( ooldimage(idot2+1:ioo), '.' ) + idot2

         if (lfname6) then
           cnscaleoo = ooldimage(idot3+1:idot3+2)
           read (cnscaleoo,'(i2)',err=58) nscaleoo
           csscaleoo = ooldimage(idot3+5:idot3+10)
           read (csscaleoo,'(f6.3)',err=58) sscaleoo
           goto 59
 58        write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading oold scales from '//ooldimage(idot3+1:idot3+10)
           stop 57
 59        continue
         else
           nscaleoo = 0
         endif
       else
         lfname6 = .true.
         nscaleoo = 0
       endif

       sooldimage = ooldimage(1:ioi-10)//'.as.m.fits'
       isoo = lastc ( sooldimage )
       
       ins = lastc ( newsegm )
       if (newsegm(ins-4:ins) .ne. '.fits') then
         newsegm = newsegm(1:ins)//'.fits'
         ins = lastc ( newsegm )
       endif

       footprint = newsegm(1:ins-5)//'.fp.fits'
       ifp = lastc ( footprint )

       if (lverbose .eq. '-verb1') 
     &   write (iotty,'(/a)') ' SFINDER: '//cwave(1:ia1)//' '//arg2(1:ia2)//' '//arg3(1:ia3)//' '//arg4(1:ia4)//' '//arg5(1:ia5)
     &                               //' '//arg6(1:ia6)//' '//arg7(1:ia7)//' '//arg8(1:ia8)//' '//arg9(1:ia9)//' '//argA(1:iaA)
       
       if (.not.lfname1) then
         write (iotty,'(/a)') '   SFINDER: ERROR: File '''//domaskname(1:idm)//''' not found.'
         stop 31
       endif
       if (.not.lfname2) then
         write (iotty,'(/a)') '   SFINDER: ERROR: File '''//imagename(1:ifn)//''' not found.'
         stop 32
       endif
       if (.not.lfname3) then
         if (nscaleo .eq. 0) then
           if (nscale .gt. 1 .and. lverbose .eq. '-verb2') 
     &       write (iotty,'(/a)') '   SFINDER: WARNING: Old image file not specified or not existing.'
         else  
           write (iotty,'(/a)') '   SFINDER: ERROR: File '''//oldimage(1:ioi)//''' not found.'
           stop 33
         endif
         oldimage = 'none'
       endif
       if (.not.lfname6) then
         if (nscaleoo .eq. 0) then
           if (nscale .gt. 2 .and. lverbose .eq. '-verb2') 
     &       write (iotty,'(/a)') '   SFINDER: WARNING: Oold image file not specified or not existing.'
         else  
           write (iotty,'(/a)') '   SFINDER: ERROR: File '''//ooldimage(1:ioo)//''' not found.'
           stop 34
         endif
         ooldimage = 'none'
       endif
       if (.not.lfname4) then
         if (nscaleo .eq. 0) then
           if (nscale .gt. 1 .and. lverbose .eq. '-verb2') 
     &       write (iotty,'(/a)') '   SFINDER: WARNING: Old segmentation file not specified or not existing.'
         else  
           write (iotty,'(/a)') '   SFINDER: ERROR: File '''//oldsegm(1:ios)//''' not found.'
           stop 35
         endif
         oldsegm = 'none'
       endif

! Check whether subdirectory of current directory exists.
       
       individs = 'sources'
       ind = lastc ( individs )

       if (lverbose .eq. '-verb2') write (iotty,'()')

! Read in the configuration file of GETSOURCES just for documenting catalogs.

       inquire ( file='+getsources.cfg', exist=lfname )
       if (.not.lfname) then
         inquire ( file='+GETSOURCES.CFG', exist=lfname )
         if (.not.lfname) then
           inquire ( file='+getsources.'//cwave(1:ia1)//'.cfg', exist=lfname )
           if (.not.lfname) then
             inquire ( file='+GETSOURCES.'//cwave(1:ia1)//'.CFG', exist=lfname )
             if (.not.lfname) then
               write (iotty,'(/a)') '   SFINDER: WARNING: Config file for GETSOURCES not found.'
               cfgfile = ''
             else
               cfgfile='+GETSOURCES.'//cwave(1:ia1)//'.CFG'
             endif
           else
             cfgfile='+getsources.'//cwave(1:ia1)//'.cfg'
           endif
         else
           cfgfile = '+GETSOURCES.CFG'
         endif                  
       else
         cfgfile = '+getsources.cfg'
       endif
       lcfg = lastc ( cfgfile )
       ncfglines = 0
              
       if (lfname) then
         open ( 25, file=cfgfile(1:lcfg), status='old' )
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   SFINDER: Reading configuration file '''//cfgfile(1:lcfg)//'''...'
         do i=1,200
           read (25,'(a)',end=98,err=90) cfgline(i)
         enddo
  90     continue
         close (25)
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading file '''//cfgfile(1:lcfg)//'''.'
         stop 58
  98     continue
         close (25)
         ncfglines = i - 1
       endif

       versfile='+log.VERSION'
       lver = lastc ( versfile )
       getstitle='# GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction'
       inquire ( file=versfile(1:lver), exist=lfnvers )
       if (lfnvers) then
         open ( 25, file=versfile(1:lver), status='old' )
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   SFINDER: Reading version file '''//versfile(1:lver)//'''...'
         do i=1,3
           read (25,'(a)',end=97,err=91) getstitle
         enddo
         getstitle = getstitle(1:1)//getstitle(4:)
         goto 97
  91     continue
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading file '''//versfile(1:lver)//'''.'
         close (25)
         stop 59
  97     continue
         close (25)
       else        
         write (iotty,'(/a)') '   SFINDER: WARNING: Version file for GETSOURCES not found.'
       endif

! Determine numbers of pixels in the FITS image.

       call getnumpix ( imagename(1:ifn), nx, ny )

! Allocate the image arrays.
       
       allocate ( image(nx,ny), iworker(nx,ny), osegm(nx,ny), nsegm(nx,ny), segmen(nx,ny), foots(nx,ny), n1x(ny), n2x(ny)
     &          , simage(nx,ny), simageo(nx,ny), simageoo(nx,ny), foota(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (71).'
         stop 71
       endif

       allocate ( detectomask(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (72).'
         stop 72
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(a,f4.1)') '   Required minimum contrast to identify noise peaks: ', contranoise
       
       if (ltiming) then
         cpu_reading_images = timer ( 'cpu', 0.0d0 )
         wal_reading_images = timer ( 'wal', 0.0d0 )
       endif

       if (ooldimage .ne. 'none') then
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading image '''//sooldimage(1:isoo)//'''...'

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, simageoo, dx, dy, object, ra, dec
     &              , sooldimage(1:isoo), header, footer, iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11
     &              , cd12, cd21, cd22, epoch, equinox, bzero, bscale, wavef, datamin, datamax, history, lverbose )

         if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       endif

       if (oldimage .ne. 'none') then

         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading image '''//soldimage(1:isoi)//'''...'

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, simageo, dx, dy, object, ra, dec
     &              , soldimage(1:isoi), header, footer, iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11
     &              , cd12, cd21, cd22, epoch, equinox, bzero, bscale, wavef, datamin, datamax, history, lverbose )

         if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading image '''//imagename(1:ifn)//'''...'

       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, image, dx, dy, object, ra, dec
     &            , imagename(1:ifn), header, footer, iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wavef, datamin, datamax, history, lverbose )

       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
                                   
       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading image '''//simagename(1:isfn)//'''...'

       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, simage, dx, dy, object, ra, dec
     &            , simagename(1:isfn), header, footer, iotty, 0, creator, beam, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wavef, datamin, datamax, history, lverbose )

       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
                                   
       iu = lastc ( bunit )

       if (bunit(1:iu) .ne. 'MJy/sr'   .and.
     &     bunit(1:iu) .ne. 'no-units') then
         write (iotty,'(/a)') '   SFINDER: ERROR: Unknown intensity units in the image.'
         write (iotty,'(a )') '   BUNIT must be ''MJy/sr'' or ''no-units''.'
         stop 90
       endif

       funits = 'Jy'
       fu = lastc ( funits )
       sqpixel = dx * dy
       dxdeg = dx / 3600.0d0
       dydeg = dy / 3600.0d0

       if (oldsegm .ne. 'none') then
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading image '''//oldsegm(1:ios)//'''...'

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, osegm, dx, dy, object, ra, dec
     &              , oldsegm(1:ios), header, footer, iotty, 0, creator, beam, datamin, datamax, blank, crota1, crota2, cd11, cd12
     &              , cd21, cd22, epoch, equinox, bzero, bscale, wavef, datamin, datamax, history, lverbose )

         if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', datamin, datamax
       else
         do j=1,ny
           do i=1,nx
             osegm(i,j) = 0.0d0
           enddo
         enddo
       endif
       
       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading image '''//domaskname(1:idm)//'''...'
       
       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, detectomask, dx, dy, object, ra, dec
     &            , domaskname(1:idm), header, footer, iotty, 0, creator, beam, datamin, datamax, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wavef, datamin, datamax, history, lverbose )
       
       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', datamin, datamax

       if (ltiming) then
         cput_reading_images = cput_reading_images + timer ( 'cpu', cpu_reading_images )
         walt_reading_images = walt_reading_images + timer ( 'wal', wal_reading_images )
       endif

       n1xmin = nx
       n2xmax = 1
       do j=1,ny
         n1x(j) = 0
         do i=1,nx
           if (detectomask(i,j) .gt. 0.5d0) then
             n1x(j) = max ( i - 2, 1 )
             if (n1x(j) .lt. n1xmin) n1xmin = n1x(j)
             exit
           endif
         enddo
         n2x(j) = 0
         do i=nx,1,-1
           if (detectomask(i,j) .gt. 0.5d0) then
             n2x(j) = min ( i + 2, nx )
             if (n2x(j) .gt. n2xmax) n2xmax = n2x(j)
             exit
           endif
         enddo
       enddo
       n1ymin = ny
       n2ymax = 1
       do i=1,nx
         do j=1,ny
           if (detectomask(i,j) .gt. 0.5d0) then
             n1y = max ( j - 2, 1 )
             if (n1y .lt. n1ymin) n1ymin = n1y
             exit
           endif
         enddo
         do j=ny,1,-1
           if (detectomask(i,j) .gt. 0.5d0) then
             n2y = min ( j + 2, ny )
             if (n2y .gt. n2ymax) n2ymax = n2y
             exit
           endif
         enddo
       enddo
       if (n1ymin .eq. ny) n1ymin = 1
       if (n2ymax .eq. 1 ) n2ymax = 1
       do j=1,ny
         if (n1x(j) .eq. 0) n1x(j) = 1
         if (n2x(j) .eq. 0) n2x(j) = 1
       enddo
       
       deallocate ( detectomask )

       allocate ( mxco(nextrmax), myco(nextrmax), fluxpeak(nextrmax), fluxtot(nextrmax), afwhm(nextrmax), bfwhm(nextrmax)
     &          , atheta(nextrmax), equivrad(nextrmax), foomajor(nextrmax), foominor(nextrmax), sigmono(nextrmax), ns1(nextrmax)
     &          , ns2(nextrmax), flag(nextrmax), flago(nextrmax), nxmin(nextrmax), nxmax(nextrmax), nymin(nextrmax), nymax(nextrmax)
     &          , nonzero(nextrmax), fluxpo(nextrmax), fluxto(nextrmax), dfpds(nextrmax), dfpdso(nextrmax), elongationo(nextrmax)
     &          , elongation(nextrmax), contramin(nextrmax), nsx(nextrmax), fxpbest(nextrmax), fxtbest(nextrmax), fxperror(nextrmax)
     &          , fxterror(nextrmax), mxcor(nextrmax), mycor(nextrmax), scalensx(nextrmax), contrast(nextrmax), fluxgauss(nextrmax)
     &          , foothepa(nextrmax), sigglob(nextrmax), flg(nextrmax), factnoise(nextrmax), ktouching(maxtouch), deltx(nextrmax)
     &          , delty(nextrmax), nxmino(nextrmax), nxmaxo(nextrmax), nymino(nextrmax), nymaxo(nextrmax), flm(nextrmax)
     &          , good(nextrmax), footfact(nextrmax), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (73).'
         stop 73
       endif
       
       allocate ( lisolated(nextrmax), lgotanother(nextrmax), ntouching(nextrmax,nextrmax), ntouchino(nextrmax,nextrmax)
     &          , intenstouch(nextrmax,nextrmax), nimglev(nextrmax), momxx(nextrmax), momyy(nextrmax), momxy(nextrmax)
     &          , lcoordsdone(nextrmax), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (74).'
         stop 74
       endif
       
! Initialize.
                                   
       do n=1,nextrmax
         ns1  (n) = nscale
         ns2  (n) = nscale
         nsx  (n) = 0
         flag (n) = ' '
         flago(n) = ' '
         mxco (n) = -1.0d0     
         myco (n) = -1.0d0     
         mxcor(n) = -1.0d0     
         mycor(n) = -1.0d0     
         sigglob  (n) = 0.0d0
         flg      (n) = 0
         good     (n) = 0.0d0
         sigmono  (n) = 0.0d0
         flm      (n) = 0
         fxpbest  (n) = 0.0d0
         fxperror (n) = 0.0d0
         fxtbest  (n) = 0.0d0
         fxterror (n) = 0.0d0
         fluxgauss(n) = 0.0d0
         scalensx (n) = 0.0d0
         afwhm    (n) = 0.0d0
         bfwhm    (n) = 0.0d0
         atheta   (n) = 0.0d0
         equivrad (n) = 0.0d0
         footfact (n) = 0.0d0
         foomajor (n) = 0.0d0
         foominor (n) = 0.0d0
         foothepa (n) = 0.0d0
         fluxpeak (n) = 0.0d0
         fluxtot  (n) = 0.0d0
         contrast (n) = 0.0d0
         fluxpo   (n) = 0.0d0
         fluxto   (n) = 0.0d0
         dfpdso   (n) = 0.0d0
         dfpds    (n) = 0.0d0
         elongationo(n) = 0.0d0
         nxmin(n) = n1xmin
         nxmax(n) = n2xmax
         nymin(n) = n1ymin
         nymax(n) = n2ymax
         nxmino(n) = nxmin(n)
         nxmaxo(n) = nxmax(n)
         nymino(n) = nymin(n)
         nymaxo(n) = nymax(n)
       enddo
       do k=1,maxtouch
         ktouching(k) = 0
       enddo
       datamin = 0.0d0
       datamax = 0.0d0
       nextr = 0
       lfoots = .false.

       if (nscale .le. 9) write (cns,'('' ['',i1'']'')') nscale
       if (nscale .gt. 9) write (cns,'('' ['',i2'']'')') nscale
       lcns = lastc ( cns )

       cscales = '# SCALES:'
       noisesources = 0
         
! If old segmentation image exists, read it and corresponding catalog.

       if (oldsegm .ne. 'none') then
         oldcat = oldsegm(1:ios-5)//'.cat'
         ioc = lastc ( oldcat )

         open ( 15, file=oldcat(1:ioc), status='old' )

         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading catalog '''//oldcat(1:ioc)//'''...'
       
         call skipcomm     ( 15, oldcat(1:ioc), nhead )
         call linescolumns ( 15, oldcat(1:ioc), nhead, nextr, ncolumns )
         
! Read previous catalog.

         do m=1,nextr
           read (15,'(i6,3i3,2x,a,4(f11.4),1pe11.3,i3,0pf6.2,1pe11.3,i5,20(1pe11.3),2(e10.2),4i7,1x,i3,1000i6)',err=19) 
     &          n, ns1(n), ns2(n), nsx(n), flag(n), mxco(n), myco(n), mxcor(n), mycor(n), sigglob(n), flg(n), good(n), sigmono(n)
     &        , flm(n), fxpbest(n), fxperror(n), fxtbest(n), fxterror(n), sigmono(n), scalensx(n), afwhm(n), bfwhm(n), atheta(n)
     &        , equivrad(n), footfact(n), foomajor(n), foominor(n), foothepa(n), fluxpeak(n), fluxtot(n), elongationo(n)
     &        , factnoise(n), contramin(n), contrast(n), dfpds(n), dfpdso(n), nxmin(n), nxmax(n), nymin(n), nymax(n), kk
     &        , (ktouching(k),k=1,kk)
     
           goto 20
  19       continue
             close ( 15 )
             write (iotty,'(/a)') '   SFINDER: ERROR: Trouble reading file '//oldcat(1:ioc)//'...'
             stop 62
  20       continue

           if (kk .gt. 0) then
             do k=1,nextr
               ktouch = 0
               do l=1,kk
                 if (k .eq. abs ( ktouching(l) )) then
                   ktouch = ktouching(l)
                   exit
                 endif
               enddo
               if (k .ne. n .and. k .eq. abs ( ktouch )) then
                 if (ktouch .gt. 0) then
                   ntouchino(n,k) = 1
                   ntouching(n,k) = 1
                 else
                   ntouchino(n,k) = 2
                   ntouching(n,k) = 2
                 endif
               else
                 ntouchino(n,k) = 0
                 ntouching(n,k) = 0
               endif            
             enddo
           else
             do k=1,nextr
               ntouchino(n,k) = 0
               ntouching(n,k) = 0
             enddo
           endif
           lcoordsdone(n) = .true.
           lisolated(n) = .false.
           fluxpo(n) = fluxpeak(n)
           fluxto(n) = fluxtot (n)
           elongation(n) = elongationo(n)
           sourcearea = pi * equivrad(n)**2
           nonzero(n) = nint ( sourcearea / sqpixel )
           if (flag(n) .eq. 'n') noisesources = noisesources + 1
           nxmino(n) = nxmin(n)
           nxmaxo(n) = nxmax(n)
           nymino(n) = nymin(n)
           nymaxo(n) = nymax(n)
         enddo
         
         rewind ( 15 )

         do m=1,nhead
           read (15,'(a)') cline
           if (cline(1:9) .eq. '# SCALES:') then
             cscales = cline
             exit
           endif
         enddo
         
         close ( 15 )
       endif             

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading names of images from '''//filewithswnames(1:ifwn)//'''...'
     
       open ( 25, file=filewithswnames(1:ifwn), status='old' )

! Read all file names for single-scale combined detection images.
       
       call skipcomm     ( 25, filewithswnames(1:ifwn), nheadf )
       call linescolumns ( 25, filewithswnames(1:ifwn), nheadf, nfiles, ncolumns )
     
       rewind ( 25 )
       do m=1,nheadf
         read (25,'(a)')
       enddo
                
       do m=1,nfiles
         read (25,*) sswname, sigma
         iss = lastc ( sswname )
         if (index ( sswname(1:iss-5), imagename(1:ifn-5-2) ) .gt. 0) exit
         if (m .eq. nfiles) then
           write (iotty,'(/a)') '   SFINDER: ERROR: Trouble finding image name in '//filewithswnames(1:ifwn)//':'
           write (iotty,'(a)' ) '                  ' //imagename(1:ifn-5)//' '//sswname(1:iss-5)//'.m'
           stop 60
         endif
       enddo
     
       close ( 25 )

       isl = lastc ( cscales )
       nextro = nextr
       nextroldscale = nextr

! When a source number becomes exactly equal to the pixel value, it creates problems with detection using the tint fill algorithm.
! Here I take care of this to avoid any possibility of such problems.

       imgmin =  1.0d+30
       imgmax = -1.0d+30
       do j=1,ny
         do i=1,nx
           if (image(i,j) .gt. almostzero) then
             imgmin = min ( imgmin, image(i,j) )
             imgmax = max ( imgmax, image(i,j) )
             if (imgmax .ge. 1.0d0) then
               write (iotty,'(/a)') '   SFINDER: ERROR: Detection image is not normalized to 1.0: '//imagename(1:ifn)
               stop 91
             endif
           endif
         enddo
       enddo

       do j=1,ny
         do i=1,nx
           if (image(i,j) .lt. imgmin) image(i,j) = 0.0d0
           if (soldimage .eq. 'none') simageo(i,j) = simage(i,j)
           if (sooldimage .eq. 'none') simageoo(i,j) = simage(i,j)
           foots(i,j) = 0.0d0
           foota(i,j) = 0.0d0
         enddo
       enddo

       goto 567
 566   continue
         write (iotty,'(/a)') '   SFINDER: ERROR: Trouble writing a pixel value in a character string: "'//charnum//'"'
         stop 61
  567  continue
  
       ns1min = 999
       do n=1,nextr
         ns1min = min ( ns1(n), ns1min )
       enddo
         
       lnothingsleft = .false.
       sfactor = sscale / sscaleo
       outerradius = 2.0d0 * sscaleo
       outerradius2 = outerradius**2

       if (nextr .eq. 0) then
         delta = 0.02d0
         nscaleo = 0
         nscaleoo = 0
         sscaleo = sscale
         do n=1,nextrmax
           contrast(n) = 1.0d-1
           contramin(n) = 0.0d0
           factnoise(n) = 0.0d0
         enddo
       else
         delta = 0.02d0

! Check whether we are done.

         do n=1,nextr
           if ((ns2(n) .eq. nscaleo .or. nscaleo .eq. 0) .and. (flag(n) .eq. ' ' .or. nsx(n) .eq. 0)) goto 68
         enddo
         if (lverbose .eq. '-verb2') write (iotty,'(/a)') '   SFINDER: All existing sources have been footprinted.'
         lnothingsleft = .true.
 68      continue
       endif
       
       if (contranoise .lt. almostzero) goto 666

       if (nscaleo .eq. 0) then
         do j=1,ny
           do i=1,nx
             osegm(i,j) = 0.0d0
           enddo
         enddo
       endif
       do j=1,ny
         do i=1,nx
           nsegm(i,j) = osegm(i,j)
         enddo
       enddo

       maximgmax = imgmax

       dlogmaxmin = max ( log ( maximgmax ) - log ( imgmin ), 0.0d0 )
   
       nlevs = nint ( dlogmaxmin / delta )

       if (nlevs .lt. nlevsmin) then
         nlevs = nlevsmin
         delta = dlogmaxmin / dble ( nlevs )
       endif
       
       pixmin = max ( (1.0d0 / 3.0d0) * pi * (sscale / 2.0d0)**2 / sqpixel, 9.0d0 )
       
       if (nlevs .lt. 10) then
         cfnl = '1'
       elseif (nlevs .lt. 100) then
         cfnl = '2'
       else
         cfnl = '3'
       endif
       if (nint ( pixmin ) .lt. 10) then
         cfpm = '1'
       elseif (nint ( pixmin ) .lt. 100) then
         cfpm = '2'
       elseif (nint ( pixmin ) .lt. 1000) then
         cfpm = '3'
       elseif (nint ( pixmin ) .lt. 10000) then
         cfpm = '4'
       else
         cfpm = '5'
       endif
       if (lverbose .ne. '-verb0') then
         write (iotty,'(/a,i'//cfnl//',a,f5.3,a,i'//cfpm//')') 
     &                '   Number of sub-levels: ', nlevs, ', relative spacing: ', delta, ', minimum new pixels: ', nint ( pixmin )
       endif
       
! NOTE: 'iworker' is the same as the single-scale image only here, in the beginning, before filling. 
! Calls to FILLAREA will replace initial intensity values with the segmentation mask values, so better be careful and
! do not interpret 'iworker' as a simple map of intensities.

       nlevsact = nlevs

       do lev=1,nlevs

         write (cl,'(i3)') lev
         if (cl(1:1) .eq. ' ') cl(1:1) = '0'
         if (cl(2:2) .eq. ' ') cl(2:2) = '0'
         segmentl = newsegm(1:ins-5)//'.'//cl//'.old.fits'
         isk = lastc( segmentl )
         segmentln = newsegm(1:ins-5)//'.'//cl//'.new.fits'
         iskn = lastc( segmentln )
         imagel = imagename(1:ifn-5)//'.'//cl//'.old.fits'
         iik = lastc( imagel )
         imageln = imagename(1:ifn-5)//'.'//cl//'.new.fits'
         iikn = lastc( imageln )
         catname = 'catalog.'//cl//'.cat'
         iocat = lastc ( catname )
         pixels = 0.0d0
                                      
         imglev = exp ( log ( imgmin * 0.9999d0 ) + dble ( nlevs - lev ) * delta )
         
         do j=1,ny
           do i=1,nx
             if (image(i,j) .ge. imglev) then
               iworker(i,j) = image(i,j)
               pixels = pixels + 1.0d0
             else
               iworker(i,j) = 0.0d0
             endif
             segmen(i,j) = iworker(i,j)
             osegm(i,j) = nsegm(i,j)
           enddo
         enddo

! If the current level has the same number of pixels as the previous one, skip it to save time.

         if (lev .gt. 1 .and. lev .lt. nlevs) then
           pixadd = pixels - oldpixels
           if (pixadd .le. pixmin) then
             nlevsact = nlevsact - 1
             if (lverbose .ne. '-verb0') then
               write (iotty,'(a,i'//cfnl//',a,i'//cfpm//',a,i'//cfnl//',a)') 
     &                      '   Level ', lev, ' added only ', nint ( pixadd )
     &                      , ' new pixels ~> skipping & reducing to ', nlevsact, ' levels...'
             endif
             goto 999
           endif
         endif
         oldpixels = pixels

! Correct pixel intensities in situations when they are zero under non-zero segmentation mask. To make sure that area filling
! works correctly, one needs to make the pixels non-zero, to make the entire segmentation mask for the source fully 4-connected
! in both intensities iworker(i,j) and segmentation values nsegm(i,j). An arbitrary value (better lower than 1) will work, as the
! filling method is 'positive'.

         l1st = .true.
         do n=1,nextr
           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
             do j=nymin(n),nymax(n)
               do i=nxmin(n),nxmax(n)
                 if (nsegm(i,j) .gt. almostzero) then
                   if (iworker(i,j) .lt. almostzero) then
                     if (lverbose .eq. '-verb2' .and. l1st) then
                       if (l1st) write (iotty,'(a)') '   Re-connecting image pixels for some sources...'
                       l1st = .false.
                     endif
                     iworker(i,j) = imgmin
                   endif
                 endif
               enddo
             enddo
           endif
         enddo
         
! Zero out the input image pixels that are connected to the others by only their corners, 
! but do that only in the areas still unoccupied (nsegm = 0) by detected sources.
! Here 'segmen' is a copy of 'iworker' to avoid possible problems.
         
         l1st = .true.
         do j=n1ymin,n2ymax
           jm1 = max (  1, j - 1 )
           jp1 = min ( ny, j + 1 )
           do i=n1x(j),n2x(j)
             if (nsegm(i,j) .lt. almostzero) then
               if (segmen(i,j) .gt. almostzero) then
                 im1 = max (  1, i - 1 )
                 ip1 = min ( nx, i + 1 )
                 ledgeszero = segmen(im1, j ) .le. almostzero .and. segmen(ip1, j ) .le. almostzero .and. 
     &                        segmen( i ,jm1) .le. almostzero .and. segmen( i ,jp1) .le. almostzero
                 lcornerpos = segmen(im1,jp1) .gt. almostzero .or.  segmen(ip1,jp1) .gt. almostzero .or. 
     &                        segmen(ip1,jm1) .gt. almostzero .or.  segmen(im1,jm1) .gt. almostzero
             
                 if (ledgeszero .and. lcornerpos) then
                   if (lverbose .eq. '-verb2') then
                     if (l1st) write (iotty,'(a)') '   Wiping out free isolated pixels...'
                     l1st = .false.
                   endif
                   iworker(i,j) = 0.0d0
                 endif
               endif
             endif
           enddo
         enddo
         
! Debugging output.

         if (ldebug) then
           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//imagel(1:iik)//'''...'
           
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, iworker, dx, dy, object, crval1
     &                , crval2, imagel(1:iik), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21
     &                , cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (lverbose .eq. '-verb2') write (iotty,'(a,$)') '   Analyzing old segmentation masks at sub-level '//cl//'... '

         if (ltiming) then
           cpu_filling_old = timer ( 'cpu', 0.0d0 )
           wal_filling_old = timer ( 'wal', 0.0d0 )
         endif

! First seed the sources found previously at smaller scales, if they are still visible at current scale.

         nextro = nextr
         cproblem = ':'
         
         do n=1,nextr
           if (mxco(n) .gt. 0.0d0 .and. myco(n) .gt. 0.0d0) then
             lcoordsdone(n) = .true.
           else
             lcoordsdone(n) = .false.
           endif       
           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
             if (lcoordsdone(n)) then
               do k=1,nextr
                 if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                   if (ntouching(n,k) .ge. 1) then
                     if (k .ne. n .and. lcoordsdone(k)) then
                       mxconmk = mxco(n) - mxco(k)
                       myconmk = myco(n) - myco(k)
                       imiddle = (mxco(n) + mxco(k)) / 2.0d0
                       jmiddle = (myco(n) + myco(k)) / 2.0d0
                       deltx(k) = 2.0d0 * (imiddle - mxco(k)) - mxconmk
                       delty(k) = 2.0d0 * (jmiddle - myco(k)) - myconmk
                     endif
                   endif
                 endif
               enddo
               nxco = nint ( mxco(n) )
               nyco = nint ( myco(n) )

               lfoundold = .false.
               if (nint ( nsegm(nxco,nyco) ) .eq. n .and. iworker(nxco,nyco) .gt. almostzero) then
                 is = nxco
                 js = nyco
                 lfoundold = .true.
                 goto 555
               endif
               do j=nymino(n),nymaxo(n)
                 do i=nxmino(n),nxmaxo(n)
                   if (nint ( nsegm(i,j) ) .eq. n .and. iworker(i,j) .gt. almostzero) then
                     is = i
                     js = j
                     lfoundold = .true.
                     goto 555
                   endif
                 enddo
               enddo
               if (lev .eq. nlevs) then
                 write (iotty,'(/a,8i5,1x,a3)') '   SFINDER: ERROR: Seed pixel for an old source not found: '
     &                                        , lev, n, nxco, nyco, nxmin(n), nxmax(n), nymin(n), nymax(n), '"'//flag(n)//'"'
                 stop 98
               endif
  555          continue
             
               if (lfoundold) then
                 newpixval = dble ( n )
              
                 call fillarea ( .true., is, js, nextrmax, nextr, newpixval, 'positive', almostzero, boupixval, nx, ny, n1x, n2x
     &                         , n1ymin, n2ymax, nxmin(n), nxmax(n), nymin(n), nymax(n), iworker, nsegm, osegm, mxco, myco, deltx
     &                         , delty, ntouching, nsx )
               
                 if (.not.laccelerate) then
                   nxmin(n) = n1xmin
                   nxmax(n) = n2xmax
                   nymin(n) = n1ymin
                   nymax(n) = n2ymax
                 endif

! Check if all segmentation pixels for this sources have been filled.
! Zero out those not filled in above with newpixval, as they must be detached from (not connected to) the main segmentation area.
                 
                 nxminn = min ( nxmin(n), nxmino(n) )
                 nxmaxn = max ( nxmax(n), nxmaxo(n) )
                 nyminn = min ( nymin(n), nymino(n) )
                 nymaxn = max ( nymax(n), nymaxo(n) )
             
                 chan = ' '
                 l1st = .true.
                 do j=nyminn,nymaxn
                   do i=nxminn,nxmaxn
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       if (iworker(i,j) .gt. almostzero) then
                         if (iworker(i,j) .lt. 1.0d0) then
                           if (l1st) then
                             l1st = .false.
                             write (chan,'(i5)') n
                           endif
                           nsegm(i,j) = 0.0d0
                         endif
                       endif
                     endif
                   enddo
                 enddo
  111            continue
                 nxmino(n) = nxmin(n)
                 nxmaxo(n) = nxmax(n)
                 nymino(n) = nymin(n)
                 nymaxo(n) = nymax(n)
             
                 icp = lastc ( cproblem )
                 cproblem = cproblem(1:icp)//chan
               endif
             endif
           endif
         enddo
         
         if (nextr .lt. 100) then
           if (lverbose .eq. '-verb2') write (iotty,'(i2,a,$)') nextr, ' sources'
         else if (nextr .lt. 1000) then         
           if (lverbose .eq. '-verb2') write (iotty,'(i3,a,$)') nextr, ' sources'
         else if (nextr .lt. 10000) then        
           if (lverbose .eq. '-verb2') write (iotty,'(i4,a,$)') nextr, ' sources'
         else                                   
           if (lverbose .eq. '-verb2') write (iotty,'(i5,a,$)') nextr, ' sources'
         endif
         if (noisesources .gt. 0) then
           if (noisesources .lt. 10) then
             if (lverbose .eq. '-verb2') write (iotty,'(a,i1,a,$)') ' (-', noisesources, ')'
           else if (noisesources .lt. 100) then               
             if (lverbose .eq. '-verb2') write (iotty,'(a,i2,a,$)') ' (-', noisesources, ')'
           else if (noisesources .lt. 1000) then              
             if (lverbose .eq. '-verb2') write (iotty,'(a,i3,a,$)') ' (-', noisesources, ')'
           else if (noisesources .lt. 10000) then             
             if (lverbose .eq. '-verb2') write (iotty,'(a,i4,a,$)') ' (-', noisesources, ')'
           else                                               
             if (lverbose .eq. '-verb2') write (iotty,'(a,i5,a,$)') ' (-', noisesources, ')'
           endif
         endif
         if (lverbose .eq. '-verb2') write (iotty,'()')

         icp = lastc ( cproblem )
         if (lverbose .ne. '-verb0' .and. icp .gt. 1) then
           write (iotty,'(/a/)') '     WARNING: SOME OLD SOURCES WERE SPLIT (FIXED)'//cproblem(1:icp)
         endif

         if (ltiming) then
           cput_filling_old = cput_filling_old + timer ( 'cpu', cpu_filling_old )
           walt_filling_old = walt_filling_old + timer ( 'wal', wal_filling_old )
         endif
         
! Debugging output.

         if (ldebug) then

! NOTE: 'iworker' is the same as the single-scale image only in the beginning. 
! Calls to FILLAREA replace initial intensity values with the segmentation mask values, so better be careful and
! do not interpret 'iworker' as simple intensity image.

           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//imageln(1:iikn)//'''...'
          
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, iworker, dx, dy, object, crval1
     &                , crval2, imageln(1:iikn), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )

           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//segmentl(1:isk)//'''...'
        
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, nsegm, dx, dy, object, crval1
     &                , crval2, segmentl(1:isk), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &                , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
         endif

         if ((nscale .lt. nscalemax .and. nscale .lt. 99) .or. nscalemax .eq. 0) then

           if (lverbose .eq. '-verb2') write (iotty,'(a,$)') '   Analyzing new segmentation masks at sub-level '//cl//'... '
                 
           if (ltiming) then
             cpu_filling_new = timer ( 'cpu', 0.0d0 )
             wal_filling_new = timer ( 'wal', 0.0d0 )
           endif

! Now look for new sources in addition to the previously found ones: find new sources and fill their segmentation areas.
     
           do js=n1ymin,n2ymax
             do is=n1x(js),n2x(js)
               if (iworker(is,js) .gt. almostzero .and. nsegm(is,js) .lt. almostzero) then
                 nextr = nextr + 1
                 if (nextr .gt. nextrmax) then
                   write (iotty,'(//a,i5)') '   SFINDER: ERROR: Number of sources reached NEXTRMAX = ', nextrmax
                   write (iotty,'(a     )') '            Increase the value, recompile SFINDER, and restart the detection.'
                   stop 89
                 endif
                 newpixval = dble ( nextr )
             
                 call fillarea ( .false., is, js, nextrmax, nextro, newpixval, 'positive', almostzero, boupixval, nx, ny, n1x, n2x
     &                         , n1ymin, n2ymax, nxmin(nextr), nxmax(nextr), nymin(nextr), nymax(nextr), iworker, nsegm, osegm, mxco
     &                         , myco, deltx, delty, ntouching, nsx )

                 ns1(nextr) = nscale
                 ns2(nextr) = nscale
               endif
             enddo
           enddo                   
                                          
           nextrnew = nextr - nextro
           if (max ( nextro, nextrnew ) .lt. 100) then
             if (lverbose .eq. '-verb2') write (iotty,'(i2,a)') nextrnew, ' new sources'
           else if (max ( nextro, nextrnew ) .lt. 1000) then
             if (lverbose .eq. '-verb2') write (iotty,'(i3,a)') nextrnew, ' new sources'
           else if (max ( nextro, nextrnew ) .lt. 10000) then
             if (lverbose .eq. '-verb2') write (iotty,'(i4,a)') nextrnew, ' new sources'
           else  
             if (lverbose .eq. '-verb2') write (iotty,'(i5,a)') nextrnew, ' new sources'
           endif
          
           if (ltiming) then
             cput_filling_new = cput_filling_new + timer ( 'cpu', cpu_filling_new )
             walt_filling_new = walt_filling_new + timer ( 'wal', wal_filling_new )
           endif

! Debugging output.

           if (ldebug) then
             if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing image '''//segmentln(1:iskn)//'''...'
        
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, nsegm, dx, dy, object, crval1
     &                  , crval2, segmentln(1:iskn), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &                  , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
           endif
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (nextr .gt. nextro) then
           do n=nextro+1,nextr
             if (.not.laccelerate) then
               nxmin(n) = n1xmin
               nxmax(n) = n2xmax
               nymin(n) = n1ymin
               nymax(n) = n2ymax
             endif
             do k=1,nextr
               ntouchino(n,k) = 0
               ntouching(n,k) = 0
             enddo
             lisolated(n) = .true.
             lgotanother(n) = .false.
             lcoordsdone(n) = .false.
             nxmino(n) = nxmin(n)
             nxmaxo(n) = nxmax(n)
             nymino(n) = nymin(n)
             nymaxo(n) = nymax(n)
           enddo
         
! Measure and catalog parameters of *new* sources using intensity moments.
                                 
           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Measuring properties of new sources...'
         
           call measure ( iotty, nextro+1, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image
     &                  , nsegm, dx, dy, mxco, myco, mxcor, mycor, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta
     &                  , equivrad, elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, .true.
     &                  , lverbose )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         do n=1,nextr
           if (flag(n) .eq. ' ' .or. flag(n) .eq. 'm') then
             nonzero(n) = 0
             nimglev(n) = 0
             do j=nymin(n),nymax(n)
               do i=nxmin(n),nxmax(n)
                 if (nint ( nsegm(i,j) ) .eq. n) then
                   if (image(i,j) .gt. almostzero) nonzero(n) = nonzero(n) + 1
                   if (image(i,j) .gt. imglev) nimglev(n) = nimglev(n) + 1
                 endif
               enddo
             enddo
           endif
         enddo
         
!-----------------------------------------------------------------------------------------------------------------------------------

         if (nscaleo .gt. 0) then
           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Identifying merging sources...'
           
           if (ltiming) then
             cpu_checkmerging = timer ( 'cpu', 0.0d0 )
             wal_checkmerging = timer ( 'wal', 0.0d0 )
           endif
           
           call checkmerging ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, mxco, myco, nx, ny, image, nsegm, almostzero, nonzero
     &                       , flag, ntouching, lisolated, lcoordsdone )
           
           if (ltiming) then
             cput_checkmerging = cput_checkmerging + timer ( 'cpu', cpu_checkmerging )
             walt_checkmerging = walt_checkmerging + timer ( 'wal', wal_checkmerging )
           endif
         endif
         
!-----------------------------------------------------------------------------------------------------------------------------------

         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Checking isolation of all sources...'
       
         if (ltiming) then
           cpu_checkisolation = timer ( 'cpu', 0.0d0 )
           wal_checkisolation = timer ( 'wal', 0.0d0 )
         endif

         call checkisolation ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, flag, nx, ny, image, nsegm, nonzero, imglev, ntouching
     &                       , intenstouch, lisolated, lcoordsdone )

         if (ltiming) then
           cput_checkisolation = cput_checkisolation + timer ( 'cpu', cpu_checkisolation )
           walt_checkisolation = walt_checkisolation + timer ( 'wal', wal_checkisolation )
         endif
         
!-----------------------------------------------------------------------------------------------------------------------------------

         do n=1,nextr
           flago(n) = flag(n)
         enddo
       
         do n=1,nextr
           if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
             if (lcoordsdone(n)) then
               if (nonzero(n) .gt. 0) then
                 ns2(n) = nscale
               else 
                 if (flag(n) .eq. ' ' .or. flag(n) .eq. 'm') then
                   flag(n) = 'z'
                 endif
               endif
             endif
           endif
         enddo

!-----------------------------------------------------------------------------------------------------------------------------------
         
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Measuring parameters of all sources...'

         if (ltiming) then
           cpu_measuring = timer ( 'cpu', 0.0d0 )
           wal_measuring = timer ( 'wal', 0.0d0 )
         endif

         call measure ( iotty, 1, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image, nsegm, dx
     &                , dy, mxco, myco, mxcor, mycor, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad
     &                , elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, .true., lverbose )
                               
         if (ltiming) then
           cput_measuring = cput_measuring + timer ( 'cpu', cpu_measuring )
           walt_measuring = walt_measuring + timer ( 'wal', wal_measuring )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Detecting and marking noise peaks...'
       
         if (ltiming) then
           cpu_identifynoise = timer ( 'cpu', 0.0d0 )
           wal_identifynoise = timer ( 'wal', 0.0d0 )
         endif

         call identifynoise ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, n1x, n2x, n1ymin, n2ymax, nscale, mxco, myco, deltx
     &                      , delty, almostzero, flag, flago, ns1, ns2, nsx, nx, ny, dx, dy, image, nsegm, segmen, nonzero, contrast
     &                      , contramin, factnoise, contranoise, elongation, imglev, ntouching, ntouchino, intenstouch, lisolated
     &                      , lgotanother, lcoordsdone )
        
         if (ltiming) then
           cput_identifynoise = cput_identifynoise + timer ( 'cpu', cpu_identifynoise )
           walt_identifynoise = walt_identifynoise + timer ( 'wal', wal_identifynoise )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Measuring parameters of special sources...'

         if (ltiming) then
           cpu_measurespecial = timer ( 'cpu', 0.0d0 )
           wal_measurespecial = timer ( 'wal', 0.0d0 )
         endif

         call measure ( iotty, 1, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image, nsegm, dx
     &                , dy, mxco, myco, mxcor, mycor, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad
     &                , elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, .false., lverbose )
                               
         if (ltiming) then
           cput_measurespecial = cput_measurespecial + timer ( 'cpu', cpu_measurespecial )
           walt_measurespecial = walt_measurespecial + timer ( 'wal', wal_measurespecial )
         endif

!-----------------------------------------------------------------------------------------------------------------------------------

         do n=1,nextr
           if (nonzero(n) .eq. 0) then
             if (lcoordsdone(n)) then
               l1st = .true.
               do j=nymin(n),nymax(n)
                 do i=nxmin(n),nxmax(n)
                   if (nint ( nsegm(i,j) ) .eq. n) then
                     if (l1st) then        
                       if (n .lt. 1000000) then
                         write (cnobj,'(i6)') n
                       else 
                         cnobj = 'xxxxxx'
                       endif
                       icno = lastc ( cnobj )
                       if (cnobj(1:1) .eq. ' ') ino1 = 2
                       if (cnobj(2:2) .eq. ' ') ino1 = 3
                       if (cnobj(3:3) .eq. ' ') ino1 = 4
                       if (cnobj(4:4) .eq. ' ') ino1 = 5
                       if (cnobj(5:5) .eq. ' ') ino1 = 6
                       if (lverbose .eq. '-verb2') 
     &                    write (iotty,'(a,i5)') '   Wiping out segmentation for fainted source # '//cnobj(ino1:icno)
                       l1st = .false.
                     endif
                     nsegm(i,j) = 0.0d0
                   endif
                 enddo
               enddo
             endif
           endif
         enddo
  
!-----------------------------------------------------------------------------------------------------------------------------------
                                 
         if (lev .eq. nlevs) then

           do n=1,nextr
           
             ldone = .false.
          
! Compute first derivatives of the peak flux for every source.

             if (nsx(n) .eq. 0) then
           
               if (flag(n) .eq. ' ') then
                 ratio = fluxpeak(n) / sigma
                 if (ratio .gt. sigglob(n)) sigglob(n) = ratio

                 if (lcoordsdone(n)) then

! Require that the maximum intensity over the source segmentation is separated from the segmentation border
! by at least one pixel on all sides. Otherwise, the source must be footprinted immediately.

                   smax = 0.0d0
                   imx = 0
                   jmx = 0
                   do j=nymin(n),nymax(n)
                     do i=nxmin(n),nxmax(n)
                       if (nint ( nsegm(i,j) ) .eq. n .and. abs ( image(i,j) ) .gt. smax) then
                         smax = abs ( image(i,j) )
                         imx = i
                         jmx = j
                       endif
                     enddo
                   enddo
                   linside = (nint ( nsegm(imx-1,jmx-1) ) .eq. n .or. nint ( nsegm(imx-1,jmx-1) ) .eq. 0) .and. 
     &                       (nint ( nsegm(imx  ,jmx-1) ) .eq. n .or. nint ( nsegm(imx  ,jmx-1) ) .eq. 0) .and.
     &                       (nint ( nsegm(imx+1,jmx-1) ) .eq. n .or. nint ( nsegm(imx+1,jmx-1) ) .eq. 0) .and. 
     &                       (nint ( nsegm(imx-1,jmx  ) ) .eq. n .or. nint ( nsegm(imx-1,jmx  ) ) .eq. 0) .and.
     &                       (nint ( nsegm(imx+1,jmx  ) ) .eq. n .or. nint ( nsegm(imx+1,jmx  ) ) .eq. 0) .and. 
     &                       (nint ( nsegm(imx-1,jmx+1) ) .eq. n .or. nint ( nsegm(imx-1,jmx+1) ) .eq. 0) .and.
     &                       (nint ( nsegm(imx  ,jmx+1) ) .eq. n .or. nint ( nsegm(imx  ,jmx+1) ) .eq. 0) .and. 
     &                       (nint ( nsegm(imx+1,jmx+1) ) .eq. n .or. nint ( nsegm(imx+1,jmx+1) ) .eq. 0)
                   
                   isa = nint ( mxcor(n) )                
                   jsa = nint ( mycor(n) )

                   if (.not.linside .and. (imx .ne. isa .or. jmx .ne. jsa) .and. sscale .gt. obsbeammin) then
                     flag(n) = 'f'
                     nsx(n) = nscaleo
                     scalensx(n) = sscaleo
                     ldone = .true.
                   endif

! If the above special case did not apply, check the usual conditions to footprint a source.

                   is = nint ( mxco(n) )                
                   js = nint ( myco(n) )
                   dfpdso(n) = simageo(is,js) - simageoo(is,js)
                   if (dfpds(n) .gt. almostzero .and. dfpdso(n) .lt. -almostzero) then
                     dfpdso(n) = dfpds(n)
                   endif
                   dfpds(n) = simage(is,js) - simageo(is,js)

                   if (.not.ldone .and. simageoo(is,js) .gt. almostzero .and. simageoo(is,js) .gt. almostzero .and. 
     &                  simage(is,js) .gt. almostzero .and. dfpdso(n) .gt. almostzero .and. dfpds(n) .lt. -almostzero) then
                     flag(n) = 'f'
                     nsx(n) = nscaleo
                     sscaleoh = (sscale + sscaleo) / 2.0d0
                     sscaleooh = (sscaleo + sscaleoo) / 2.0d0
                     dscale = - dfpdso(n) * (sscaleoh - sscaleooh) / (dfpds(n) - dfpdso(n))
                     scalensx(n) = sscaleooh + dscale
                     ldone = .true.
                   endif
                 endif
               endif
          
               if (flag(n) .eq. 'm') then
                 factincrease = 1.4d0
                 ndelta = min ( nint ( log ( factincrease ) / log ( sfactor ) ), nscalemax - 1 - nscale )
                 nsx(n) = nscale + ndelta
                 scalensx(n) = sscale * sfactor**ndelta
               endif
               if (flag(n) .eq. 'n') then
                 nsx(n) = nscale
                 ns2(n) = nsx(n)
                 scalensx(n) = sscale
               endif
               if (flag(n) .eq. 'z') then
                 nsx(n) = nscaleo
                 ns2(n) = nsx(n)
                 scalensx(n) = sscaleo
                 ldone = .true.

! 2018-02-04 FIX A.B.M: Those "sources" that appear and disappear on one scale, must be considered noise and not be footprinted. 
! Otherwise, they may interfere with the same source (same position!), which could appear on later scales.

                 if (ns1(n) .eq. ns2(n)) then
                   flag(n) = 'n'
                   ldone = .false.
                 endif
               endif
             endif
             
             if (flag(n) .eq. 'm' .and. nsx(n) .eq. nscale) then
               ldone = .true.
             endif

             if ((nscale .ge. nscalemax .or. nscale .eq. 99) .and. (flag(n) .eq. ' ' .or. nsx(n) .eq. 0)) then
               nsx(n) = ns2(n)
               scalensx(n) = sscale
               flag(n) = 'n'
               do j=nymin(n),nymax(n)
                 do i=nxmin(n),nxmax(n)
                   if (nint ( nsegm(i,j) ) .eq. n) then
                     nsegm(i,j) = 0.0d0
                   endif
                 enddo
               enddo
               nxmin(n) = -3
               nxmax(n) = -3
               nymin(n) = -3
               nymax(n) = -3
             endif
                  
! Outer sizes of an elliptical footprint for calculating total fluxes.

             if (flag(n) .ne. 'n') then
               tfluxradius = max ( factortotal * max ( obsbeammin, scalensx(n) ) / 2.0d0, aperture )
               footfact(n) = factortotal
               foomajor(n) = 2.0d0 * tfluxradius
               foominor(n) = foomajor(n)
               foothepa(n) = atheta(n)
             endif

! Create footprints of done sources.

             if (ldone) then

               call makefoots ( n, mxco, myco, tfluxradius, dx, dy, nx, ny, n1x, n2x, n1ymin, n2ymax, foots )

               lfoots = .true.
             endif
           enddo
         endif

         if (.not.lnothingsleft .and. (nscale .ge. nscalemax .or. nscale .eq. 99)) then
           lnothingsleft = .true.
         endif
 999     continue    
       enddo

 666   continue
       
! If no sources have been detected, create one fictitious source to allow further processing.
       
       if (contranoise .lt. almostzero .or. (lnothingsleft .and. nextr .eq. 0)) then
         lnothingsleft = .true.
         nextr = 1
         delta = 0.0d0
         nlevs = 0
         ns1       (1) = 1
         ns2       (1) = 1
         nsx       (1) = 1
         flag      (1) = 'n'
         mxco      (1) = dble ( nx ) / 2.0d0
         myco      (1) = dble ( ny ) / 2.0d0
         mxcor     (1) = mxco(1)
         mycor     (1) = myco(1)
         sigglob   (1) = 1.0d0
         flg       (1) = 0
         good      (1) = 1.0d-1
         sigmono   (1) = 1.0d-1
         flm       (1) = 0
         fxpbest   (1) = 1.0d0
         fxperror  (1) = 1.0d0
         fxtbest   (1) = 1.0d0
         fxterror  (1) = 1.0d0
         fluxgauss (1) = 1.0d0
         scalensx  (1) = 1.0d0
         afwhm     (1) = 1.0d0
         bfwhm     (1) = 1.0d0
         atheta    (1) = 1.0d0
         equivrad  (1) = 1.0d0
         footfact  (1) = 1.0d0
         foomajor  (1) = 1.0d0
         foominor  (1) = 1.0d0
         foothepa  (1) = 1.0d0
         fluxpeak  (1) = 1.0d0
         fluxtot   (1) = 1.0d0
         elongation(1) = 1.0d0
         factnoise (1) = 1.0d0
         contramin (1) = 1.0d0
         contrast  (1) = 1.0d0
         dfpds     (1) = 1.0d0
         dfpdso    (1) = 1.0d0
         nxmin     (1) = 1
         nxmax     (1) = nx
         nymin     (1) = 1
         nymax     (1) = ny
         ktouching (1) = 0
         ntouching (1,1) = 0
       endif

       if (ltiming) then
         cpu_writing_images = timer ( 'cpu', 0.0d0 )
         wal_writing_images = timer ( 'wal', 0.0d0 )
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing segmentation image '''//newsegm(1:ins)//'''...'
       
       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, nsegm, dx, dy, object, crval1
     &            , crval2, newsegm(1:ins), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12, cd21
     &            , cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )

       deallocate ( nsegm )
       
       if (lfoots) then
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing footprints image '''//footprint(1:ifp)//'''...'
       
         call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, foots, dx, dy, object, crval1
     &              , crval2, footprint(1:ifp), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11, cd12
     &              , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )

       endif

       deallocate ( foots )
       
       if (ltiming) then
         cput_writing_images = cput_writing_images + timer ( 'cpu', cpu_writing_images )
         walt_writing_images = walt_writing_images + timer ( 'wal', wal_writing_images )
       endif

       catname = newsegm(1:ins-5)//'.cat'
       iocat = lastc ( catname )

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing detection catalog '''//catname(1:iocat)//'''...'

       write (cpix,'(f6.3)') dx
       cpixx = cpix
       if (cpix(1:1) .eq. ' ') cpixx = cpix(2:6)
       lpix = lastc ( cpixx )

       write (cnx,'(i5)') nx
       write (cny,'(i5)') ny
       cnxx = cnx
       cnyy = cny
       if (cnx(1:1) .eq. ' '  ) cnxx = cnx(2:5)
       if (cnx(1:2) .eq. '  ' ) cnxx = cnx(3:5)
       if (cnx(1:3) .eq. '   ') cnxx = cnx(4:5)
       if (cny(1:1) .eq. ' '  ) cnyy = cny(2:5)
       if (cny(1:2) .eq. '  ' ) cnyy = cny(3:5)
       if (cny(1:3) .eq. '   ') cnyy = cny(4:5)
       lnx = lastc ( cnxx )
       lny = lastc ( cnyy )
     
       write (cne,'(i5)') nextr
       cneo = cne
       if (cne(1:1) .eq. ' '    ) cneo = cne(2:5)
       if (cne(1:2) .eq. '  '   ) cneo = cne(3:5)
       if (cne(1:3) .eq. '   '  ) cneo = cne(4:5)
       if (cne(1:4) .eq. '    ' ) cneo = cne(5:5)
       lneo = lastc ( cneo )

       write (cnn,'(i5)') noisesources
       cnno = cnn
       if (cnn(1:1) .eq. ' '    ) cnno = cnn(2:5)
       if (cnn(1:2) .eq. '  '   ) cnno = cnn(3:5)
       if (cnn(1:3) .eq. '   '  ) cnno = cnn(4:5)
       if (cnn(1:4) .eq. '    ' ) cnno = cnn(5:5)
       lnno = lastc ( cnno )

       write (cng,'(i5)') nextr - noisesources
       cngo = cng
       if (cng(1:1) .eq. ' '    ) cngo = cng(2:5)
       if (cng(1:2) .eq. '  '   ) cngo = cng(3:5)
       if (cng(1:3) .eq. '   '  ) cngo = cng(4:5)
       if (cng(1:4) .eq. '    ' ) cngo = cng(5:5)
       lngo = lastc ( cngo )

       cosrota = - cd11 / dxdeg
       sinrota = - cd12 / dxdeg
       rotangle = acos ( cosrota ) * 180.0d0 / pi
       
       if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rotangle = rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rotangle = 180.0d0 - rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rotangle = 180.0d0 + rotangle
       elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rotangle = - rotangle
       endif
       write (crotangle,'(f7.2)') rotangle
       icr = 1
       icre = 7
       if (crotangle(1:1) .eq. ' ' .or. crotangle(1:1) .eq. '-') icr = 1
       if (crotangle(2:2) .eq. ' ' .or. crotangle(2:2) .eq. '-') icr = 2
       if (rotangle .ge. 0.0d0) crotangle(icr:icr) = '-'
       if (rotangle .lt. 0.0d0) crotangle(icr:icr) = '+'
       if (abs ( rotangle ) .lt. almostzero) icre = 1

! Compute coordinates in an un-rotated image to feed them later to the XY2SKY utility to calculate world coordinates.

       if (lnothingsleft) then
         mxcomin = +1.0e+30
         mxcomax = -1.0e+30
         mycomin = +1.0e+30
         mycomax = -1.0e+30

         do n=1,nextr
           mxcor(n) = - ( mxco(n) - crpix1 ) * cd11 / dxdeg - ( myco(n) - crpix2 ) * cd12 / dydeg
           mycor(n) =   ( mxco(n) - crpix1 ) * cd21 / dxdeg + ( myco(n) - crpix2 ) * cd22 / dydeg
           if (mxcor(n) .lt. mxcomin) mxcomin = mxcor(n)
           if (mxcor(n) .gt. mxcomax) mxcomax = mxcor(n)
           if (mycor(n) .lt. mycomin) mycomin = mycor(n)
           if (mycor(n) .gt. mycomax) mycomax = mycor(n)
         enddo
         mxcomin = mxcomin - 1.0d0
         mxcomax = mxcomax
         mycomin = mycomin - 1.0d0
         mycomax = mycomax
         
         crpix1n = dble ( max ( - int ( mxcomin ), 1 ) + 1 ) + (crpix1 - dble ( int ( crpix1 ) ))
         crpix2n = dble ( max ( - int ( mycomin ), 1 ) + 1 ) + (crpix2 - dble ( int ( crpix2 ) ))
         nxn = nint ( crpix1n + mxcomax )
         nyn = nint ( crpix2n + mycomax )
         
         allocate ( unrotated(nxn,nyn), stat=irc )

         if (irc .ne. 0) then
           write (iotty,'(/a)') '   SFINDER: ERROR: Trouble allocating memory (77).'
           stop 77
         endif
  
         do j=1,nyn
           do i=1,nxn
             unrotated(i,j) = 0.0d0
           enddo
         enddo
  
         do n=1,nextr
           mxcor(n) = mxcor(n) + crpix1n
           mycor(n) = mycor(n) + crpix2n
           nxco = nint ( mxcor(n) )
           nyco = nint ( mycor(n) )
           unrotated(nxco,nyco) = float ( n ) 
         enddo

         nx1 = nint ( crpix1 + mxcomin )
         ny1 = nint ( crpix2 + mycomin )
       else
         do n=1,nextr
           mxcor(n) = mxco(n)
           mycor(n) = myco(n)
         enddo
         nx1 = 1
         ny1 = 1
       endif

       write (cnx1,'(i5)') nx1
       cnx1o = cnx1
       if (cnx1(1:1) .eq. ' '    ) cnx1o = cnx1(2:5)
       if (cnx1(1:2) .eq. '  '   ) cnx1o = cnx1(3:5)
       if (cnx1(1:3) .eq. '   '  ) cnx1o = cnx1(4:5)
       if (cnx1(1:4) .eq. '    ' ) cnx1o = cnx1(5:5)
       lnx1o = lastc ( cnx1o )

       write (cny1,'(i5)') ny1
       cny1o = cny1
       if (cny1(1:1) .eq. ' '    ) cny1o = cny1(2:5)
       if (cny1(1:2) .eq. '  '   ) cny1o = cny1(3:5)
       if (cny1(1:3) .eq. '   '  ) cny1o = cny1(4:5)
       if (cny1(1:4) .eq. '    ' ) cny1o = cny1(5:5)
       lny1o = lastc ( cny1o )
         
       open ( 55, file=catname(1:iocat), status='unknown' )

       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'
       write (55,'(a)') getstitle
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'
       write (55,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by SFINDER compiled on '//compda
       write (55,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (55,'(a)') '# Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                //'(william.d.pence@nasa.gov)'
       write (55,'(a)') '#'
       write (55,'(a)') '# DETECTION TABLE for image '''//imagename(1:ifn)//''' (pixel: '//cpixx(1:lpix)//' arcsec,'
     &                //' size: '//cnxx(1:lnx)//' x '//cnyy(1:lny)//' pixels, units: '//bunit(1:iu)//')'
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       if (ncfglines .gt. 0) then
         write (55,'(a)') '#'
         write (55,'(a)') '# CONFIGURATION PARAMETERS USED BY GETSOURCES:'
         write (55,'(a)') '#'
         do i=1,ncfglines
           if (cfgline(i)(1:1) .ne. '#' .and. cfgline(i)(1:1) .ne. '!') then
             lcfg = lastc ( cfgline(i) )
             if (index ( cfgline(i)(1:lcfg), '| usm ...' ) .gt. 0) exit
             write (55,'(a)') '#'//cfgline(i)(1:lcfg)
           endif
         enddo
         write (55,'(a)') '#_______________________________________________________________________________________________'
     &                  //'____________________________________'  
       endif
       write (55,'(a)') '#'
       write (55,'(a)') cscales(1:isl)//cns(1:lcns)//' '//csscale
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'
       write (55,'(a,f6.3,a,i3,a)') '# TABULATED QUANTITIES, TOTAL OF '//cneo(1:lneo)//' SOURCES ('
     &                //cngo(1:lngo)//' GOOD + '//cnno(1:lnno)//' NOISE); delta:', delta,', sub-levels: ', nlevs,'.'
       write (55,'(a)') '#'
       write (55,'(a)') '#   NO ............ Source''s running number ..................................'
       write (55,'(a)') '#   S1 ............ Number of the smallest scale where source first appears ..'
       write (55,'(a)') '#   S2 ............ Number of the largest  scale where source still exists ...'
       write (55,'(a)') '#   SX ............ Number of the footprinting scale for current source ......'
       write (55,'(a)') '#   F ............. Detection flag (m: merged, z: fainted, f: footprinted, n: noise)'
       write (55,'(a)') '#   XCO_PIXEL ..... X-coordinate of current source ........................... (pixels)'
     &                //' relative to the lower-left pixel (1,1)'
       write (55,'(a)') '#   YCO_PIXEL ..... Y-coordinate of current source ........................... (pixels)'
     &                //' relative to the lower-left pixel (1,1)'
       write (55,'(a)') '#   XCO_PIXRO ..... X-coordinate of current source (un-rotated) .............. (pixels)'
     &                //' relative to the pixel ('//cnx1o(1:lnx1o)//','//cny1o(1:lny1o)//')'
       write (55,'(a)') '#   YCO_PIXRO ..... Y-coordinate of current source (un-rotated) .............. (pixels)'
     &                //' relative to the pixel ('//cnx1o(1:lnx1o)//','//cny1o(1:lny1o)//')'
       write (55,'(a)') '#   SIG_GLOB ...... Global detection significance over all wavelengths ....... SIG_GLOB='
     &                //'sqrt(sum(SIG_MONO#^2))'
       write (55,'(a)') '#   FG ............ Flag identifying global properties over all wavelengths ..'
     &                //' see definitions below'
       write (55,'(a)') '#   GOOD .......... Global goodness combining SIG_GLOB and SNR_GLOB ..........'
     &                //' GOOD=min{(SIG_GLOB*min{SNR_GLOB,1}/SEGM_ELONG/SOURCE_ELONG)/STENTATIVE,9.99}'
       write (55,'(a)') '#   SIG_MONO ...... Detection significance from monochromatic single scales .. SSPEAK/STDEV ~'
     &                //' single-scale analog of S/N ratio'
       write (55,'(a)') '#   FM ............ Flag identifying monochromatic properties ................'
     &                //' see definitions below'
       write (55,'(a)') '#   FXP_BEST ...... Estimate of peak flux for current source ................. ('//bunit(1:iu)//')'
       write (55,'(a)') '#   FXP_ERROR ..... Estimate of peak flux error for current source ........... ('//bunit(1:iu)//')'
       if (bunit(1:iu) .eq. 'no-units') then
       write (55,'(a)') '#   FXT_BEST ...... Estimate of total flux for current source ................ ('//bunit(1:iu)//')'
       write (55,'(a)') '#   FXT_ERROR ..... Estimate of total flux error for current source .......... ('//bunit(1:iu)//')'
       write (55,'(a)') '#   FXT_GAUSS ..... Estimate of total flux assuming elliptical Gaussian ...... ('//bunit(1:iu)//')'
       else
       write (55,'(a)') '#   FXT_BEST ...... Estimate of total flux for current source ................ ('//funits(1:fu)//')'
       write (55,'(a)') '#   FXT_ERROR ..... Estimate of total flux error for current source .......... ('//funits(1:fu)//')'
       write (55,'(a)') '#   FXT_GAUSS ..... Estimate of total flux assuming elliptical Gaussian ...... ('//funits(1:fu)//')'
       endif
       write (55,'(a)') '#   SCALE_SX ...... Size estimate from smoothing beam at scale SX ............ (arcsec) characteristic'
     &                //' size (scale where source is brightest)'
       write (55,'(a)') '#   AFWHM_MOM ..... Major size estimate for current source ................... (arcsec) this is FWHM'
     &                //' *only if* source has Gaussian intensity distribution'
       write (55,'(a)') '#   BFWHM_MOM ..... Minor size estimate for current source ................... (arcsec) this is FWHM'
     &                //' *only if* source has Gaussian intensity distribution'
       write (55,'(a)') '#   THEPA_MOM ..... Major axis rotation angle (east of the vertical axis) .... (degrees) position angle'
     &                //' PA=THEPA_MOM'//crotangle(icr:icre)//' (east of north)'
       write (55,'(a)') '#   RADEQUIVA ..... Equivalent-area outer radius of a circular source ........ (arcsec)'
       write (55,'(a)') '#   FOOT_FACT ..... Footprint expansion scaling factor .......................'
       write (55,'(a)') '#   FOOAMAJOR ..... Full major axis of an elliptical footprint ............... (arcsec)'
       write (55,'(a)') '#   FOOBMINOR ..... Full minor axis of an elliptical footprint ............... (arcsec)'
       write (55,'(a)') '#   FOOTHEPAN ..... Major axis rotation angle (east of the vertical axis) .... (degrees) position angle'
     &                //' PA=FOOTHEPAN'//crotangle(icr:icre)//' (east of north)'
       write (55,'(a)') '#   PEAKFLUX ...... Peak flux at current scale ............................... ('//bunit(1:iu)//')'
       if (bunit(1:iu) .eq. 'no-units') then                                             
       write (55,'(a)') '#   TOTALFLUX ..... Total flux at current scale .............................. ('//bunit(1:iu)//')'
       else                                                                         
       write (55,'(a)') '#   TOTALFLUX ..... Total flux at current scale .............................. ('//funits(1:fu)//')'
       endif
       write (55,'(a)') '#   PEAKFSUM ...... Peak flux integrated over scales ......................... ('//bunit(1:iu)//')'
       if (bunit(1:iu) .eq. 'no-units') then                                             
       write (55,'(a)') '#   TOTALFSUM ..... Total flux integrated over scales ........................ ('//bunit(1:iu)//')'
       else                                                                         
       write (55,'(a)') '#   TOTALFSUM ..... Total flux integrated over scales ........................ ('//funits(1:fu)//')'
       endif
       write (55,'(a)') '#   NXMIN ......... Minimum X-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#   NXMAX ......... Maximum X-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#   NYMIN ......... Minimum Y-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#   NYMAX ......... Maximum Y-coordinate of segmentation mask ................ (pixels)'
       write (55,'(a)') '#_______________________________________________________________________________________________'
     &                //'____________________________________'  
       write (55,'(a)') '#'                                                           
       write (55,'(a)') '#   NO S1 S2 SX  F  XCO_PIXEL  YCO_PIXEL  XCO_PIXRO  YCO_PIXRO  SIG_GLOB  FG  GOOD  SIG_MONO   FM'
     &                //'   FXP_BEST   FXP_ERROR  FXT_BEST   FXT_ERROR  FXT_GAUSS  SCALE_SX   AFWHM_MOM  BFWHM_MOM  THEPA_MOM'
     &                //'  RADEQUIVA  FOOT_FACT  FOOAMAJOR  FOOBMINOR  FOOTHEPAN  PEAKFLUX   TOTALFLUX  ELONGATIO  FACTNOISE'
     &                //'  CONTRAMIN  CONTRAST   dPFdS     dPFdSo    NXMIN  NXMAX  NYMIN  NYMAX'              
       write (55,'(a)') '#'

       do n=1,nextr
         kk = 0
         do k=1,nextr
           if (k .ne. n) then
             if (ntouching(n,k) .ge. 1 .or. ntouchino(n,k) .ge. 1) then
               kk = kk + 1
               if (kk .gt. maxtouch) then
                 write (iotty,'(/a,i5)') '   SFINDER: ERROR: Too many sources touching the source # ', n
                 stop 92
               endif
               if (ntouching(n,k) .eq. 2) then
                 ktouching(kk) = -k
               else
                 ktouching(kk) = k
               endif
             endif
           endif     
         enddo
         write (cfmt,'(i6)') kk + 1

         write (55,'(i6,3i3,2x,a,4(f11.4),1pe11.3,i3,0pf6.2,1pe11.3,i5,20(1pe11.3),2(e10.2),4i7,1x,i3,'//cfmt//'i6)') 
     &         n, ns1(n), ns2(n), nsx(n), flag(n), mxco(n), myco(n), mxcor(n), mycor(n), sigglob(n), flg(n), good(n), sigmono(n)
     &       , flm(n), fxpbest(n), fxperror(n), fxtbest(n), fxterror(n), fluxgauss(n), scalensx(n), afwhm(n), bfwhm(n), atheta(n)
     &       , equivrad(n), footfact(n), foomajor(n), foominor(n), foothepa(n), fluxpeak(n), fluxtot(n), elongation(n), factnoise(n)
     &       , contramin(n), contrast(n), dfpds(n), dfpdso(n), nxmin(n), nxmax(n), nymin(n), nymax(n), kk, (ktouching(k),k=1,kk)
       enddo
       
       close ( 55 )

       if (lnothingsleft) then
         idot1 = index ( imagename, '.' )
         idot2 = index ( imagename(idot1+1:ifn), '.' ) + idot1
         idot3 = index ( imagename(idot2+1:ifn), '.' ) + idot2
         unrotname = 'sm.'//imagename(1:idot3-1)//'.unrotated.fits'
         iun = lastc ( unrotname )
  
! Rotation matrix set to no-rotation values.

         cd11n = - dx / 3600.0d0
         cd12n = 0.0d0
         cd21n = 0.0d0
         cd22n = dy / 3600.0d0
  
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing unrotated image '''//unrotname(1:iun)//'''...'
         
         call wfits ( cfitsversion, nxn, nyn, bunit, ctype1, ctype2, crpix1n, crpix2n, crval1, crval2, unrotated, dx, dy, object
     &              , crval1, crval2, unrotname(1:iun), header, footer, cdate, ctime, creator, beam, blank, crota1, crota2, cd11n
     &              , cd12n, cd21n, cd22n, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )

         deallocate ( unrotated )
       endif

       deallocate ( lisolated, lgotanother, ntouching, ntouchino, intenstouch, nimglev, momxx, momyy, momxy, lcoordsdone )

       deallocate ( mxco, myco, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad, foomajor, foominor, sigmono, ns1, ns2, flag
     &            , flago, nxmin, nxmax, nymin, nymax, nonzero, fluxpo, fluxto, dfpds, dfpdso, elongationo, elongation, contramin
     &            , nsx, fxpbest, fxtbest, fxperror, fxterror, mxcor, mycor, scalensx, contrast, fluxgauss, foothepa, sigglob, flg
     &            , factnoise, ktouching, deltx, delty, nxmino, nxmaxo, nymino, nymaxo, flm, good, footfact )

       deallocate ( image, iworker, osegm, segmen, n1x, n2x, simage, simageo, simageoo, foota )

       if (lverbose .eq. '-verb2') write (iotty,'(/a)') ' Done.'

       if (ltiming) then
         cpu_sum = cpu_sum + cput_reading_images + cput_filling_old + cput_filling_new + cput_checkmerging
     &                     + cput_checkisolation + cput_measuring + cput_identifynoise + cput_measurespecial
     &                     + cput_writing_images
         wal_sum = wal_sum + walt_reading_images + walt_filling_old + walt_filling_new + walt_checkmerging
     &                     + walt_checkisolation + walt_measuring + walt_identifynoise + walt_measurespecial
     &                     + walt_writing_images

! Total cpu usage, expressed in hours, minutes, and seconds.

         cputot = cpu_sum
         cpuhours = int ( cputot / 3600.0d0 )
         cpumins  = int ( cputot / 60.0d0 ) -  60 * cpuhours
         cpusecs  = int ( cputot + 0.5d0 ) - 3600 * cpuhours - 60 * cpumins

! Final wall clock time, expressed in hours, minutes, and seconds.

         wctot  = wal_sum
         wchours  = int ( wctot / 3600.0d0 )
         wcmins   = int ( wctot / 60.0d0 ) -  60 * wchours
         wcsecs   = int ( wctot + 0.5d0 ) - 3600 * wchours - 60 * wcmins

         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' Total ''READING IMAGES''  CPU',cput_reading_images,' REAL',walt_reading_images,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FILLING OLD''     CPU',cput_filling_old   ,' REAL',walt_filling_old   ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FILLING NEW''     CPU',cput_filling_new   ,' REAL',walt_filling_new   ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''CHECK MERGING''   CPU',cput_checkmerging  ,' REAL',walt_checkmerging  ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''CHECK ISOLATION'' CPU',cput_checkisolation,' REAL',walt_checkisolation,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''MEASURE PARAMS''  CPU',cput_measuring     ,' REAL',walt_measuring     ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''IDENTIFY NOISE''  CPU',cput_identifynoise ,' REAL',walt_identifynoise ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''MEASURE SPECIAL'' CPU',cput_measurespecial,' REAL',walt_measurespecial,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''WRITING IMAGES''  CPU',cput_writing_images,' REAL',walt_writing_images,' sec'
         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' ACCUMULATED CPU & REAL TIME' ,cpu_sum             ,' sec ',wal_sum            ,' sec'
         write (60,'(a,i3.2,a,i2.2,a,i2.2,a,i3.2,a,i2.2,a,i2.2,a,f7.2,a)')
     &             ' ---------------------------',cpuhours,':',cpumins,':',cpusecs,' ----',wchours,':',wcmins,':',wcsecs,' ---'
  
         call when ( lunix, ctime, cdate, ndate, 4 )
  
         write (60,'(a)') ' SFINDER finished: '//cdate//' '//ctime
         close ( 60 )
       endif
       
       if (lnothingsleft) then
         stop 9
       else
!!       stop !<-- commented out because it would lead to run-time messages about denormalized values, when using gfortran.
       endif
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine checkmerging
         
     &            ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, mxco, myco, nx, ny, image, nsegm, almostzero, nonzero, flag
     &            , ntouching, lisolated, lcoordsdone )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, SAp IRFU CEA Saclay, France, on May 18, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       lisolated(*), lcoordsdone(*), lpeakatedge
       character*(*) flag(*)
       integer       i, j, n, nx, ny, nextr, ipvmax, jpvmax, ipvmaxm1, ipvmaxp1, jpvmaxm1, jpvmaxp1, iminz, jminz, numpixmin, lastc
     &             , iotty, nextrmax, nxco, nyco, axco, ayco
                                                                                                              
       parameter   ( iotty = 6, numpixmin = 9 )
                                                                                                              
       logical       lothertouch(4)
       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), nonzero(*), ntouching(nextrmax,*), asource(4)
       real*8        imagemin, pixvalmax, almostzero, image(nx,ny), nsegm(nx,ny), innsegm(4), inimage(4), mxco(*), myco(*)

       external      lastc
!__________________________________________________________________________________________________________________________________
!                    
       do n=1,nextr
              
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'm' .and. flag(n) .ne. 'z') then
           if (.not.lisolated(n)) then
             if (nonzero(n) .ge. numpixmin) then
               if (lcoordsdone(n)) then
                 pixvalmax = 0.0d0
                 ipvmax = 0
                 jpvmax = 0
             
! Find the source's peak intensity (at this scale) and its pixel; full single-scale image (not above the level) must be used here.

                 do j=nymin(n),nymax(n)
                   do i=nxmin(n),nxmax(n)
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       if (image(i,j) .gt. pixvalmax) then
                         pixvalmax = image(i,j)
                         ipvmax = i
                         jpvmax = j
                       endif
                     endif
                   enddo
                 enddo
         
! Find if the source has its peak intensity located at the edge of the segmentation mask. 

                 if (ipvmax .gt. 0 .and. jpvmax .gt. 0) then
                   nxco = nint ( mxco(n) )
                   nyco = nint ( myco(n) )
                   if (ipvmax .ne. nxco .and. jpvmax .ne. nyco) then
       
! Check if there is a saddle point somewhere between the source position and the brightest pixel.

                     call findmin ( mxco(n), myco(n), dble ( ipvmax ), dble ( jpvmax ), nx, ny, image, iminz, jminz, imagemin )
       
                     if (imagemin .gt. almostzero .and. iminz .eq. nxco .and. jminz .eq. nyco) then

! Look at the 4-connected pixels around the brightest pixel within the segmentation mask of the current source n.

                       ipvmaxm1 = max (  1, ipvmax - 1 )
                       ipvmaxp1 = min ( nx, ipvmax + 1 )
                       jpvmaxm1 = max (  1, jpvmax - 1 )
                       jpvmaxp1 = min ( ny, jpvmax + 1 )
                  
! Determine the touching source number from the 4-connected pixels; full single-scale image (not above the level) must be used here.

                       inimage(1) = image(ipvmaxm1,jpvmax  )
                       inimage(2) = image(ipvmaxp1,jpvmax  )
                       inimage(3) = image(ipvmax  ,jpvmaxm1)
                       inimage(4) = image(ipvmax  ,jpvmaxp1)
                   
                       innsegm(1) = nsegm(ipvmaxm1,jpvmax  )
                       innsegm(2) = nsegm(ipvmaxp1,jpvmax  )
                       innsegm(3) = nsegm(ipvmax  ,jpvmaxm1)
                       innsegm(4) = nsegm(ipvmax  ,jpvmaxp1)
                   
                       asource(1) = nint ( innsegm(1) )
                       asource(2) = nint ( innsegm(2) )
                       asource(3) = nint ( innsegm(3) )
                       asource(4) = nint ( innsegm(4) )

! The condition for a source n to have the brightest pixel right at the edge of its segmentation mask.
! If so, it must be merging with a brighter touching source. 

                       lothertouch(1) = asource(1) .ne. n .and. innsegm(1) .ge. 1.0d0
                       lothertouch(2) = asource(2) .ne. n .and. innsegm(2) .ge. 1.0d0
                       lothertouch(3) = asource(3) .ne. n .and. innsegm(3) .ge. 1.0d0
                       lothertouch(4) = asource(4) .ne. n .and. innsegm(4) .ge. 1.0d0
                
                       lpeakatedge = lothertouch(1) .or. lothertouch(2) .or. lothertouch(3) .or. lothertouch(4)

! Flag the current source n as merged with a more prominent touching source.

                       if (lpeakatedge) then
                         if (lothertouch(1)) then
                           axco = nint ( mxco(asource(1)) )
                           ayco = nint ( myco(asource(1)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(1),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                         if (lothertouch(2)) then
                           axco = nint ( mxco(asource(2)) )
                           ayco = nint ( myco(asource(2)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(2),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                         if (lothertouch(3)) then
                           axco = nint ( mxco(asource(3)) )
                           ayco = nint ( myco(asource(3)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(3),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                         if (lothertouch(4)) then
                           axco = nint ( mxco(asource(4)) )
                           ayco = nint ( myco(asource(4)) )
                           if (image(axco,ayco) .gt. 1.5d0 * image(nxco,nyco)) then
                             ntouching(asource(4),n) = 2
                             flag(n) = 'm'
                           endif
                         endif
                       endif
                     endif
                   endif
                 endif
               endif
             endif
           endif               
         endif
       enddo  
       
       return
       end
        
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine checkisolation
         
     &            ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, flag, nx, ny, image, nsegm, nonzero, imglev, ntouching, intenstouch
     &            , lisolated, lcoordsdone )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, SAp IRFU CEA Saclay, France, on May 18, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       lisolated(*), lcoordsdone(*)
       character*(*) flag(*)
       integer       i, j, l, k, n, nx, ny, nextr, im1, ip1, jm1, jp1, iotty, nextrmax
                                            
       parameter   ( iotty = 6 )

       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), nonzero(*), ntouching(nextrmax,*), asource(4)
       real*8        imglev, image(nx,ny), nsegm(nx,ny), innsegm(4), inimage(4), intenstouch(nextrmax,*)
!__________________________________________________________________________________________________________________________________
!                    
       do n=1,nextr
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           if (lcoordsdone(n)) then
             do k=n,nextr
               if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                 if (lcoordsdone(k)) then
                   intenstouch(n,k) = imglev
                   intenstouch(k,n) = imglev
                 endif
               endif
             enddo
           endif
         endif
       enddo
         
! Make a list of all sources touching any pixel along the outer edge of every source.

       do n=1,nextr
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           if (lcoordsdone(n)) then
             do j=nymin(n),nymax(n)
               jm1 = max ( 1, j - 1 )
               jp1 = min ( ny, j + 1 )
               do i=nxmin(n),nxmax(n)
                 if (image(i,j) .ge. imglev) then
                   if (nint ( nsegm(i,j) ) .eq. n) then
                     im1 = max ( 1, i - 1 )
                     ip1 = min ( nx, i + 1 )
                   
                     inimage(1) = image(im1,j  )
                     inimage(2) = image(ip1,j  )
                     inimage(3) = image(i  ,jm1)
                     inimage(4) = image(i  ,jp1)
                   
                     innsegm(1) = nsegm(im1,j  )
                     innsegm(2) = nsegm(ip1,j  )
                     innsegm(3) = nsegm(i  ,jm1)
                     innsegm(4) = nsegm(i  ,jp1)
                   
                     asource(1) = nint ( innsegm(1) )
                     asource(2) = nint ( innsegm(2) )
                     asource(3) = nint ( innsegm(3) )
                     asource(4) = nint ( innsegm(4) )

! Go over all surrounding pixels of the current pixel (i,j) and determine if any other source touches current source (n).

                     do l=1,4
                       if (inimage(l) .ge. imglev) then
                         if (innsegm(l) .ge. 1.0d0) then
                           if (asource(l) .ne. n) then
                             if (flag(asource(l)) .ne. 'n' .and. flag(asource(l)) .ne. 'z') then
                               if (lcoordsdone(asource(l))) then
                                 ntouching(n,asource(l)) = 1
                                 if (inimage(l) .gt. intenstouch(n,asource(l))) then
                                   intenstouch(n,asource(l)) = inimage(l)
                                 endif
                               endif
                             endif
                           endif
                         endif
                       endif
                     enddo
                   endif
                 endif
               enddo
             enddo
           endif
         endif
       enddo
            
       do n=1,nextr
         if (flag(n) .ne. 'n' .and. flag(n) .ne. 'z') then
           if (lcoordsdone(n)) then
             if (flag(n) .eq. 'm') then
               lisolated(n) = .false.
             else
               lisolated(n) = .true.
             endif
             do k=1,nextr
               if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                 if (lcoordsdone(k)) then
                   if (k .ne. n .and. ntouching(n,k) .ge. 1 .and. flag(k) .eq. ' ') then
                     lisolated(n) = .false.
                     exit
                   endif
                 endif
               endif
             enddo
             do k=n,nextr
               if (flag(k) .ne. 'n' .and. flag(k) .ne. 'z') then
                 if (lcoordsdone(k)) then
                   if (ntouching(n,k) .eq. 1) then
                     if (ntouching(k,n) .eq. 0) then
                       if (nonzero(n) .gt. 0 .and. nonzero(k) .gt. 0) then
                         write (iotty,'(/a,14i5)') '   SFINDER: ERROR: No symmetry in touching: '
     &                               , n, k, ntouching(n,k), ntouching(k,n), nxmin(n), nxmax(n), nymin(n), nymax(n)
     &                               , nxmin(k), nxmax(k), nymin(k), nymax(k), nonzero(n), nonzero(k)
                         stop 93
                       endif
                     endif
                     intenstouch(n,k) = min ( intenstouch(n,k), intenstouch(k,n) )
                   endif
                 endif
               endif
             enddo
           endif
         endif
       enddo
         
       return
       end
        
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine identifynoise
         
     &            ( nextrmax, nextr, nxmin, nxmax, nymin, nymax, n1x, n2x, n1ymin, n2ymax, nscale, mxco, myco, deltx, delty
     &            , almostzero, flag, flago, ns1, ns2, nsx, nx, ny, dx, dy, image, nsegm, segmen, nonzero, contrast, contramin
     &            , factnoise, contranoise, elongation, imglev, ntouching, ntouchino, intenstouch, lisolated, lgotanother
     &            , lcoordsdone )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, SAp IRFU CEA Saclay, France, on May 18, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       lisolated(*), lgotanother(*), lcoordsdone(*)
       character*(*) flag(*), flago(*)
       integer       i, j, k, n, nx, ny, nextr, lastc, nmaxflux, nscale, ipvmax, jpvmax, npix, irc, iotty, n1ymin, n2ymax, nxxmin
     &             , nxxmax, nyymin, nyymax, nextrmax, nxco, nyco
       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), nonzero(*), ns1(*), ns2(*), nsx(*), ntouching(nextrmax,*)
     &             , ntouchino(nextrmax,*), n1x(*), n2x(*)
       real*8        sqpixel, dx, dy, almostzero, imglev, contranoise, pi, fluxmax, intensmin, fluxtotn, newpixval, boupixval
     &             , fluxtotk, fluxedge, dxn2, dyn2, dxk2, dyk2, radpixn2, radpixk2, radpixk2min, radpixn2min
     &             , radpixmin, radpixn, radpixk, elongationbarrier, factnoisebarrier, intenstouchm, pixvalmax
       real*8        image(nx,ny), nsegm(nx,ny), segmen(nx,ny), mxco(*), myco(*), contrast(*), contramin(*), factnoise(*)
     &             , elongation(*), intenstouch(nextrmax,*), deltx(*), delty(*)
                                                      
       real*8 , allocatable :: worker(:,:), distn2kmin(:)

       parameter   ( pi = 3.14159265358979d0, boupixval = 0.0d0, iotty = 6 )

       external      lastc
!__________________________________________________________________________________________________________________________________
!                    
! Identify and mark noise peaks. 

       sqpixel = dx * dy
       
       do n=1,nextr

         lgotanother(n) = .false.
         
         if (lcoordsdone(n) .and. flag(n) .ne. 'n' .and. flag(n) .ne. 'z' .and. flag(n) .ne. 'm' .and. nsx(n) .eq. 0) then
           
           pixvalmax = 0.0d0
           ipvmax = 0
           jpvmax = 0
             
! Find the source's peak intensity (at this scale) and its pixel; full single-scale image (not above the level) must be used here.

           do j=nymin(n),nymax(n)
             do i=nxmin(n),nxmax(n)
               if (nint ( nsegm(i,j) ) .eq. n) then
                 if (image(i,j) .gt. pixvalmax) then
                   pixvalmax = image(i,j)
                   ipvmax = i
                   jpvmax = j
                 endif
               endif
             enddo
           enddo

           nxco = nint ( mxco(n) )
           nyco = nint ( myco(n) )

           if (.not.lisolated(n) .and. image(ipvmax,jpvmax) .ge. imglev) then

! Check all other sources touching the current source for the first time.

             intensmin = 1.0d+33
             fluxmax = 0.0d0
             nmaxflux = 0
          
             do k=1,nextr                                                                         
               
               if (k .ne. n .and. lcoordsdone(k) .and. flago(k) .ne. 'n' .and. flago(k) .ne. 'z') then
                 
                 if (nsx(k) .eq. 0 .and. ntouching(n,k) .ge. 1 .and. ntouchino(n,k) .eq. 0) then
          
                   ntouchino(n,k) = ntouching(n,k)
                        
                   intenstouchm = min ( intenstouch(n,k), intenstouch(k,n) )
                   if (intenstouchm .lt. intensmin) intensmin = intenstouchm
          
! New contact of the current source 'n' with another source 'k' is detected.
! Find the total flux of the source 'k' over its segmentation above the current sub-level.
                  
                   fluxtotn = 0.0d0
                   do j=nymin(n),nymax(n)
                     do i=nxmin(n),nxmax(n)
                       if (nint ( nsegm(i,j) ) .eq. n .and. image(i,j) .ge. intenstouch(n,k)) then
                         fluxtotn = fluxtotn + image(i,j)
                       endif
                     enddo
                   enddo
                   if (fluxtotn .gt. fluxmax) then
                     fluxmax = fluxtotn
                     nmaxflux = n
                   endif
          
                   fluxtotk = 0.0d0
                   do j=nymin(k),nymax(k)
                     do i=nxmin(k),nxmax(k)
                       if (nint ( nsegm(i,j) ) .eq. k .and. image(i,j) .ge. intenstouch(k,n)) then
                         fluxtotk = fluxtotk + image(i,j)
                       endif
                     enddo
                   enddo
                   if (fluxtotk .gt. fluxmax) then
                     fluxmax = fluxtotk
                     nmaxflux = k
                   endif
                 endif
               endif
             enddo
          
             if (intensmin .lt. almostzero) then
               write (iotty,'(/a,2(1pd10.2),i5,2(d10.2),4i5)') '   IDENTIFYNOISE: ERROR: INTENSMIN is too small: '
     &                     , intensmin, imglev, n, mxco(n), myco(n), nxmin(n), nxmax(n), nymin(n), nymax(n)
               do k=1,nextr
                 if (max ( ntouching(n,k), ntouching(k,n) ) .ge. 1) then
                   write (iotty,'(5i5,2(1pd10.2))') n, k, ntouchino(n,k), ntouching(n,k), ntouching(k,n)
     &                                            , intenstouch(n,k), intenstouch(k,n)
                 endif
               enddo
               stop 94
             endif

! If the current source has a lower total flux than another touching source, it is possibly a noise peak.
! Do more tests to decide.

             if (nmaxflux .gt. 0 .and. n .ne. nmaxflux) then    !!!!!!!!! .and. fluxmax / fluxtotn .gt. 1.5d0
             
               npix = 0
               fluxtotn = 0.0d0
               do j=nymin(n),nymax(n)
                 do i=nxmin(n),nxmax(n)
                   if (image(i,j) .ge. intensmin) then
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       npix = npix + 1
                       fluxtotn = fluxtotn + image(i,j)
                     endif
                   endif
                 enddo
               enddo
          
               if (fluxtotn .lt. almostzero) then
                 write (iotty,'(/a,3(1pd10.2),2i5,2(d10.2),4i5)') '   IDENTIFYNOISE: ERROR: FLUXTOTN is too small: '
     &                       , fluxtotn, imglev, intensmin, n, npix, mxco(n), myco(n), nxmin(n), nxmax(n), nymin(n), nymax(n)
                 do k=1,nextr
                   if (max ( ntouching(n,k), ntouching(k,n) ) .ge. 1) then
                     write (iotty,'(5i5)') n, k, ntouchino(n,k), ntouching(n,k), ntouching(k,n)
                   endif
                 enddo
                 stop 95
               endif
          
               allocate ( worker(nx,ny), distn2kmin(nextr), stat=irc )
          
               if (irc .ne. 0) then
                 write (iotty,'(/a)') '   IDENTIFYNOISE: ERROR: Trouble allocating memory (75).'
                 stop 75
               endif
          
               do j=1,ny
                 do i=1,nx
                   worker(i,j) = image(i,j)
                   segmen(i,j) = 0.0d0
                 enddo
               enddo
          
               newpixval = dble ( n )
                 
               call fillarea ( .false., nxco, nyco, nextrmax, nextr, newpixval, 'positive', almostzero, boupixval, nx, ny, n1x, n2x
     &                       , n1ymin, n2ymax, nxxmin, nxxmax, nyymin, nyymax, worker, segmen, segmen, mxco, myco, deltx, delty
     &                       , ntouching, nsx )
          
               do j=nyymin,nyymax
                 do i=nxxmin,nxxmax
                   if (image(i,j) .ge. intensmin) then
                     if (nint ( segmen(i,j) ) .eq. n .and. nint ( nsegm(i,j) ) .eq. n) then
                       segmen(i,j) = 0.0d0
                     endif
                   endif
                 enddo
               enddo
          
               do k=1,nextr                                                                         
                 if (k .ne. n .and. lcoordsdone(k) .and. flago(k) .ne. 'n' .and. flago(k) .ne. 'z') then
                   radpixk2min = 1.0e+33
                   radpixn2min = 1.0e+33
                   do j=nyymin,nyymax
                     do i=nxxmin,nxxmax
                       if (image(i,j) .ge. intensmin) then
                         if (nint ( nsegm(i,j) ) .eq. n) then
                           radpixk2 = (dble ( i ) - mxco(k))**2 + (dble ( j ) - myco(k))**2
                           if (radpixk2 .lt. radpixk2min) radpixk2min = radpixk2
                         endif
                         if (nint ( nsegm(i,j) ) .eq. k .and. nint ( segmen(i,j) ) .eq. n) then
                           radpixn2 = (dble ( i ) - mxco(n))**2 + (dble ( j ) - myco(n))**2
                           if (radpixn2 .lt. radpixn2min) radpixn2min = radpixn2
                         endif
                       endif
                     enddo
                   enddo
                   distn2kmin(k) = sqrt ( radpixn2min / radpixk2min )
                 endif
               enddo
               
               do k=1,nextr                                                                         
                 if (k .ne. n .and. lcoordsdone(k) .and. flago(k) .ne. 'n' .and. flago(k) .ne. 'z') then
                   do j=nyymin,nyymax
                     do i=nxxmin,nxxmax
                       if (image(i,j) .ge. intensmin) then
                         if (nint ( segmen(i,j) ) .eq. n .and. nint ( nsegm(i,j) ) .eq. k) then
                           segmen(i,j) = 0.0d0
                         endif
                       endif
                     enddo
                   enddo
                 endif
               enddo
          
               fluxedge = 0.0d0
               do j=nyymin,nyymax
                 dyn2 = (dble ( j ) - myco(n))**2
                 do i=nxxmin,nxxmax
                   if (nint ( segmen(i,j) ) .eq. n) then
                     dxn2 = (dble ( i ) - mxco(n))**2
                     radpixn = sqrt ( dxn2 + dyn2 )
                     radpixmin = 1.0e+33
                     do k=1,nextr                                                                         
                       if (k .ne. n .and. lcoordsdone(k) .and. flago(k) .ne. 'n' .and. flago(k) .ne. 'z') then
                         dyk2 = (dble ( j ) - myco(k))**2
                         dxk2 = (dble ( i ) - mxco(k))**2
                         radpixk = sqrt ( dxk2 + dyk2 ) * distn2kmin(k)
                         if (radpixk .lt. radpixmin) radpixmin = radpixk
                       endif
                     enddo
                     if (radpixn .le. radpixmin) then
                       fluxedge = fluxedge + image(i,j)
                     endif
                   endif
                 enddo
               enddo
               
               deallocate ( worker, distn2kmin )
          
               factnoise(n) = fluxedge / fluxtotn
                                                              
               factnoisebarrier = max ( factnoise(n) / 2.0d0, 1.0d0 )
                                                              
               elongationbarrier = max ( elongation(n) / 2.2d0, 1.0d0 )
                                                              
               contramin(n) = contranoise * max ( factnoisebarrier * elongationbarrier, 1.0d0 )
          
               contrast(n) = image(ipvmax,jpvmax) / intensmin

! Check if the source is actually a noise peak. 
! Round the computed contrast values to only 2 digits as it makes no sense to use more of the "precision".

               call round1d ( contrast (n), 1, 3 )
               call round1d ( contramin(n), 1, 3 )
                     
               if (contrast(n) .lt. contramin(n)) then
             
                 flag(n) = 'n'
                 flago(n) = flag(n)
                 ns2(n) = nscale
          
! Assign the noise peak pixels to the other touching source that eats it.
                     
                 nxmin(nmaxflux) = min ( nxmin(n), nxmin(nmaxflux) )
                 nxmax(nmaxflux) = max ( nxmax(n), nxmax(nmaxflux) )
                 nymin(nmaxflux) = min ( nymin(n), nymin(nmaxflux) )
                 nymax(nmaxflux) = max ( nymax(n), nymax(nmaxflux) )
             
                 do j=nymin(nmaxflux),nymax(nmaxflux)
                   do i=nxmin(nmaxflux),nxmax(nmaxflux)
                     if (nint ( nsegm(i,j) ) .eq. n) then
                       nsegm(i,j) = nmaxflux
                     endif
                   enddo
                 enddo

! Re-compute a new number of non-zero pixels for the source which ate the noise peak.

                 nonzero(nmaxflux) = 0
                 do j=nymin(nmaxflux),nymax(nmaxflux)
                   do i=nxmin(nmaxflux),nxmax(nmaxflux)
                     if (nint ( nsegm(i,j) ) .eq. nmaxflux .and. image(i,j) .gt. almostzero) then
                       nonzero(nmaxflux) = nonzero(nmaxflux) + 1
                     endif
                   enddo
                 enddo
          
                 ns1(nmaxflux) = ns1(nmaxflux)
          
                 nxmin(n) = -1
                 nxmax(n) = -1
                 nymin(n) = -1
                 nymax(n) = -1
               endif
             endif
           endif
         endif
       enddo

       return
       end
        
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine measure 
       
     &            ( iotty, nbeg, nextr, nxmin, nxmax, nymin, nymax, sfactor, sscale, nscale, ns1, nsx, nx, ny, image, segmn, dx
     &            , dy, momxco, momyco, npxcoa, npycoa, momxx, momyy, momxy, fluxpeak, fluxtot, afwhm, bfwhm, atheta, equivrad
     &            , elongation, nonzero, nimglev, almostzero, flag, lisolated, lgotanother, lcoordsdone, lfirstpass, lverbose )
!__________________________________________________________________________________________________________________________________
!
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       lfirstpass, lisolated(*), lgotanother(*), lcoordsdone(*)
       character*(*) flag(*), lverbose

       integer       n, nx, ny, l, m, nextr, irc, nbeg, nscale, iotty, nxco, nyco
       integer       nonzero(*), nimglev(*), ns1(*), nsx(*), nxmin(*), nxmax(*), nymin(*), nymax(*)
 
       real*8        dx, dy, pi, sqpixel, sourcearea, dblm, dbll, sscale, sfactor, intensmax, convtodegrees, sqreightlogtwo, pixel
     &             , intsxx, intsyy, intsxy, xcorsc, ycorsc, momp2, momm2, sqrmo, asig, bsig, intsd, ints0m, ints0
     &             , almostzero, intx, inty, int0, int0m, intd, asize, bsize
     
       real*8        image(nx,ny), segmn(nx,ny), momxco(*), momyco(*), fluxpeak(*), fluxtot(*), afwhm(*), bfwhm(*), atheta(*)
     &             , equivrad(*), elongation(*), momxx(*), momyy(*), momxy(*), npxcoa(*), npycoa(*)

       logical, allocatable :: lgetcoord(:)

       parameter   ( pi = 3.14159265358979d0, convtodegrees = 180.0d0 / pi )
!__________________________________________________________________________________________________________________________________
!                  
       sqreightlogtwo = sqrt ( 8.0d0 * log ( 2.0d0 ) )

       allocate ( lgetcoord(nextr), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   MEASURE: ERROR: Trouble allocating memory (76).'
         stop 76
       endif

       pixel = dx
       sqpixel = dx * dy
       sscale = sscale

! Compute coordinates only when current scale is not too big compared to the scale where source first appeared
! and only until the source gets footprinted.
       
       do n=nbeg,nextr
         lgetcoord(n) = .false.

         if (flag(n) .eq. ' ' .and. nsx(n) .eq. 0) then 

           if (lfirstpass) then
             lgetcoord(n) = nimglev(n) .gt. 0 .and. lisolated(n) .and. sfactor**(nscale - ns1(n)) .le. 4.0d0
           endif

           if (nimglev(n) .gt. 0) then

! Compute total flux in the single-scale image over the segmentation mask.

             fluxtot(n) = 0.0d0
             do m=nymin(n),nymax(n)
               do l=nxmin(n),nxmax(n)
                 if (n .eq. nint ( segmn(l,m) )) then
                   if (image(l,m) .gt. almostzero) then
                     fluxtot(n) = fluxtot(n) + image(l,m) * sqpixel
                   endif
                 endif
               enddo
             enddo

! Find maximum intensity in the single-scale image over the segmentation mask.

             intensmax = -1.0d0
             do m=nymin(n),nymax(n)
               do l=nxmin(n),nxmax(n)
                 if (n .eq. nint ( segmn(l,m) )) then
                   if (image(l,m) .gt. intensmax) then
                     nxco = l
                     nyco = m
                     intensmax = image(nxco,nyco)
                   endif
                 endif
               enddo
             enddo
             if (intensmax .ge. 0.0d0) then
               fluxpeak(n) = max ( intensmax, 0.0d0 )
             endif
           
! Update the source coordinates.

             if (lgetcoord(n) .and. intensmax .gt. almostzero) then                
               intx = 0.0d0                        
               inty = 0.0d0                        
               int0 = 0.0d0                        
               do m=nymin(n),nymax(n)              
                 dblm = dble ( m )                 
                 do l=nxmin(n),nxmax(n)            
                   dbll = dble ( l )               
                   if (n .eq. nint ( segmn(l,m) )) then
                     if (image(l,m) .ge. fluxpeak(n) / 1.4d0) then
                       intd = image(l,m) * sqpixel
                       int0 = int0 + intd
                       intx = intx + dbll * intd
                       inty = inty + dblm * intd
                     endif
                   endif
                 enddo
               enddo
               int0m = int0 + almostzero
               momxco(n) = intx / int0m
               momyco(n) = inty / int0m
               npxcoa(n) = dble ( nxco )
               npycoa(n) = dble ( nyco )
               lcoordsdone(n) = .true.
             endif  
           endif
         endif  
       enddo
       
! Compute second moments.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Computing second intensity moments for each segmentation mask...'

       do n=nbeg,nextr
         if (lfirstpass .or. lgotanother(n)) then
           ints0 = 0.0d0
           intsxx = 0.0d0
           intsyy = 0.0d0
           intsxy = 0.0d0           
           if (flag(n) .eq. ' ' .and. nsx(n) .eq. 0) then
             do m=nymin(n),nymax(n)
               dblm = dble ( m )
               do l=nxmin(n),nxmax(n)
                 dbll = dble ( l )       
                 if (n .eq. nint ( segmn(l,m) )) then
                   intsd = segmn(l,m) * sqpixel
                   ints0 = ints0 + intsd
                   xcorsc = dbll - momxco(n)
                   ycorsc = dblm - momyco(n)
                   intsxx = intsxx + xcorsc * xcorsc * intsd
                   intsyy = intsyy + ycorsc * ycorsc * intsd
                   intsxy = intsxy + xcorsc * ycorsc * intsd
                 endif
               enddo
             enddo
           endif
           ints0m = ints0 + 1.0d-30
           momxx(n) = intsxx / ints0m
           momyy(n) = intsyy / ints0m
           momxy(n) = intsxy / ints0m
         endif
       enddo

! Compute FWHM sizes using the intensity moments.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Computing FWHM sizes of segmentation masks using intensity moments...'
       
       do n=nbeg,nextr
         if (lfirstpass .or. lgotanother(n)) then
           if (flag(n) .eq. ' ' .and. nsx(n) .eq. 0) then
             momp2 = (momxx(n) + momyy(n)) / 2.0d0
             momm2 = (momxx(n) - momyy(n)) / 2.0d0
      
             if (abs ( momxy(n) ) .lt. almostzero) then
               if (momxx(n) .gt. momyy(n)) then
                 momp2 = momxx(n)
                 momm2 = momyy(n)
                 atheta(n) = 90.0d0
               else
                 momp2 = momyy(n)
                 momm2 = momxx(n)
                 atheta(n) = 0.0d0
               endif
               sqrmo = sqrt ( momm2**2 + momxy(n)**2 )
               asig  = sqrt ( momp2 + sqrmo ) * pixel
               if (momp2 .gt. sqrmo) then 
                 bsig = sqrt ( momp2 - sqrmo ) * pixel
               else
                 asig = 0.0d0
                 bsig = 0.0d0
               endif
             else       
               sqrmo = sqrt ( momm2**2 + momxy(n)**2 )
               if (momp2 + sqrmo .ge. 0.0d0) then 
                 asig  = sqrt ( momp2 + sqrmo ) * pixel
               endif
               if (momp2 - sqrmo .ge. 0.0d0) then 
                 bsig  = sqrt ( momp2 - sqrmo ) * pixel
               endif
               if (momp2 + sqrmo .lt. 0.0d0 .or. momp2 - sqrmo .lt. 0.0d0) then 
                 asig = 0.0d0
                 bsig = 0.0d0
               endif
               atheta(n) = 180.0d0 - atan2 ( sqrmo + momm2, momxy(n) ) * convtodegrees
             endif                                        

             asize = sqreightlogtwo * max ( asig, pixel )
             bsize = sqreightlogtwo * max ( bsig, pixel )

             afwhm(n) = max ( asize, sscale )
             bfwhm(n) = max ( bsize, sscale )

             elongation(n) = asize / bsize
           endif
      
           if (.not.lgotanother(n)) then
             sourcearea = dble ( nonzero(n) ) * sqpixel
             equivrad(n) = sqrt ( sourcearea / pi )
           endif
         endif
       enddo

       deallocate ( lgetcoord )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine makefoots

     &            ( n, mxco, myco, maxradius, dx, dy, nx, ny, n1x, n2x, n1ymin, n2ymax, foots )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, SAp IRFU CEA Saclay, France, on April 20, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       integer       i, j, n, nx, ny, n1ymin, n2ymax
       integer       n1x(*), n2x(*)
       real*8        maxradius, rxy, dbli, dblj, dxco2, dyco2, dx, dy
       real*8        mxco(*), myco(*), foots(nx,ny)
!__________________________________________________________________________________________________________________________________
!                     
       if (mxco(n) .gt. 0.0d0 .and. myco(n) .gt. 0.0d0) then

! Make footprint for a source. 
         
         do j=n1ymin,n2ymax
           dblj = dble ( j )
           dyco2 = ((dblj - myco(n)) * dy)**2
           do i=n1x(j),n2x(j)
             dbli = dble ( i )
             dxco2 = ((dbli - mxco(n)) * dx)**2
             rxy = sqrt ( dxco2 + dyco2 )
             if (rxy .le. maxradius) then
               foots(i,j) = foots(i,j) + dble ( n )
             endif
           enddo
         enddo
       endif
       
       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine limitbox 

     &            ( n, nx, ny, segmentation, n1x, n2x, n1xmin, n2xmax, n1ymin, n2ymax, nxmin, nxmax, nymin, nymax, laccelerate )
!__________________________________________________________________________________________________________________________________
!
! Alexander Men'shchikov, SAp IRFU CEA Saclay, France, on April 6, 2009
!__________________________________________________________________________________________________________________________________
!                     
       implicit      none
       logical       laccelerate
       integer       nxmin(*), nxmax(*), nymin(*), nymax(*), n1x(*), n2x(*), nx, ny, i, j, n, n1xmin, n2xmax, n1ymin, n2ymax
       real*8        segmentation(nx,ny)
!__________________________________________________________________________________________________________________________________
!                     
       if (laccelerate) then
         nxmin(n) = 100000      
         nxmax(n) = 0
         nymin(n) = 100000
         nymax(n) = 0
         do j=n1ymin,n2ymax
           do i=n1x(j),n2x(j)
             if (nint ( segmentation(i,j) ) .eq. n) then
               nxmin(n) = min ( i, nxmin(n) )
               nxmax(n) = max ( i, nxmax(n) )
               nymin(n) = min ( j, nymin(n) )
               nymax(n) = max ( j, nymax(n) )
             endif
           enddo
         enddo
         if (nxmin(n) .eq. 100000) nxmin(n) = n1xmin
         if (nxmax(n) .eq. 0     ) nxmax(n) = n2xmax
         if (nymin(n) .eq. 100000) nymin(n) = n1ymin
         if (nymax(n) .eq. 0     ) nymax(n) = n2ymax
       else
         nxmin(n) = n1xmin
         nxmax(n) = n2xmax
         nymin(n) = n1ymin
         nymax(n) = n2ymax
       endif
       
       return
       end
       
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header, footer, iotty
     &            , iolog, creator, beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history, lverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend, anynull, myfile
       character*(*) ctype1, ctype2, creator, fname, header, footer(2), bunit, object, history, lverbose
       character*25  cdatetime
       character*80  footer1, footer2, comment
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, lastc, iotty, iolog, maxdim
     &             , ilc1, ilc2, rw, nfound, blank, stat01, stat02, stat03, stat04, stat05, stat06, stat07, stat08, stat09
     &             , stat10, stat11, stat12, stat13, stat14, stat15, stat16, stat17, stat18, stat19, stat20, stat21, stat22
     &             , stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30, stat31, stat32, stat0, nan
       parameter   ( maxdim = 2 )
       integer       naxes(maxdim)
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22
       real*8        fun(nx,ny)
       real*8        as2deg, datamx, datamn
       parameter   ( as2deg = 1.0d0 / 3600.0d0 )
       external      lastc, ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat01 = 0
       stat02 = 0
       stat03 = 0
       stat04 = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:22) .eq. 'Alexander Men`shchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'SFINDER'
       endif

       header = 'FITS Plot Header'

       if (myfile) then
         call ftgkys ( unit, 'HEADER' , header , comment, stat01 )
         call ftgkys ( unit, 'FOOTER1', footer1, comment, stat02 )
         call ftgkys ( unit, 'FOOTER2', footer2, comment, stat03 )
         ilc1 = lastc ( footer1 )
         ilc2 = lastc ( footer2 )
         if (ilc1 .ne. 0 .and. ilc2 .ne. 0) then
           footer(1) = footer1(1:ilc1)//footer2(1:ilc2)
         else
           footer(1) = 'Footer'
         endif
       else
         call ftgkys ( unit, 'OBJECT' , header, comment, stat04 )
         if (stat04 .ne. 0 .or. header(1:10) .eq. '          ') header = fname
         footer(1) = header
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. Maybe
! there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat08 = 0
       stat0 = stat01 + stat02 + stat03 + stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15
     &       + stat16 + stat17 + stat18 + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28
     &       + stat29 + stat30 + stat31

       if (lverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat01 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword HEADER absent or error'
         if (stat02 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER1 absent or error'
         if (stat03 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER2 absent or error'
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat29 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EPOCH absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = 'No object specified'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       nan = 0
       do j=1,ny
         do i=1,nx
           if (isnan ( fun(i,j) )) then  
             nan = nan + 1
             if (lverbose .ne. '-verb0') then
               if (nan .lt. 100) then
                 write (iotty,'(a,i4,a,i4,a)') '   RFITS: Element (', i,',', j, ') contains not a number (NaN)...'
               elseif (nan .eq. 100) then
                 write (iotty,'(a)') '   RFITS: Many NaNs, no more info on the elements.'
               endif
             endif
           else
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header
     &            , footer, cdate, ctime, creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, header, footer(2), ctime, cdate, bunit, cfitsversion, history
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), iat, iflen
     &             , lastc, blank
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, dfun, rot1, rot2, epoch, equinox, datamn
     &             , cosrota, sinrota, rotangle, datamx, dxdeg, dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      lastc
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny

! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       do j=1,ny
         do i=1,nx
           dfun = fun(i,j)
           if (dfun .lt. datamn ) datamn = dfun
           if (dfun .gt. datamx ) datamx = dfun
         enddo
       enddo

       bitpix = -32     !<-- single precision floating-point values

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator,'Alexander Men`shchikov, SAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'HEADER' , header, 'title', status )

       iat = 0
       iat = index ( footer(1), ' |F' )
       if (iat .eq. 0) iat = index ( footer(1), ' mm ' )
       iflen = lastc ( footer(1) )

       if (iat .gt. 0) then
         call ftpkys ( unit, 'FOOTER1', footer(1)(1:iat-1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', footer(1)(iat:iflen), 'part 2', status )
       else
         call ftpkys ( unit, 'FOOTER1', footer(1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', ' ', 'part 2', status )
       endif
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = dx * as2deg
       dydeg = dy * as2deg

! Correct if the input images had cd11 or cd22 set to zero.

       if (abs ( cd11 ) .lt. almostzero .or. abs ( cd11 ) .gt. dxdeg) then
         cd11 = -dxdeg
         cd12 = 0.0d0
       endif
       if (abs ( cd22 ) .lt. almostzero .or. abs ( cd22 ) .gt. dxdeg) then
         cd21 = 0.0d0
         cd22 = dydeg
       endif

       cosrota = - cd11 / dxdeg
       sinrota = - cd12 / dxdeg
       rotangle = acos ( cosrota ) * 180.0d0 / pi
       
       if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = 180.0d0 - rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = 180.0d0 + rotangle
       elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = - rotangle
       endif
       rot2 = rot1

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
       if  (blank .gt. 0)
     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , -dxdeg, 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftpkyd ( unit, 'EPOCH'  , epoch  , 13, ' ', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, ' ', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'image was convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||