
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program finalcat
!__________________________________________________________________________________________________________________________________
!
! Produce final extraction catalogs.
!
! This code is part of GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay   
!
! Return codes:
!
!   10-29 ... problems with the input parameters
!   30-49 ... non-existing files or directories
!   50-69 ... problems with reading/writing files or values
!   70-89 ... problems with memory allocation
!   90-99 ... other code-specific problems
!__________________________________________________________________________________________________________________________________
!                 
       implicit      none

       integer       iotty, nwavemax, ncolmax
       parameter   ( nwavemax=100, ncolmax = 100, iotty = 6 )

       logical       lfname, lunix, loneormoresnhigh, lallnoise, ltooclose, ldone, lok, lfnvers, lmysimsky, lconverge, lapertures
     &             , lfinishing_mode, lnotdetection, lfirstiteration, ltiming, ltime, liter_phase1, liter_phase2, liter_phase3
     &             , lcreate_profiles_images, lhandlesubstruc, inellipse, lfnamefc, lallsmall, lfdone(nwavemax), lwcscoord
     &             , ldetectionwave(nwavemax), lherschel(nwavemax), ltoobig
                                  
       character*1   converge(100,nwavemax)
       character*2   cwav, cnwaves, cnwavs
       character*3   colskip, cwave1, cwave2, cflag, cfmon
       character*4   cwave(nwavemax),cwave0(nwavemax)
       character*5   cnextrbad, cnextrgood, cntentative, cnreliable, cnextr, cfpptime, cgood
       character*6   cfitsversion, czno, czok, cocc, fmtwcs, lverbose   
       character*7   clibname
       character*8   ctime, creldiffmax   
       character*10  cdate, peakfunits(nwavemax)
       character*11  cncolf, cncolc, convfact
       character*13  colhead(ncolmax), colheadout(ncolmax)
       character*14  ccrpix1, ccrpix2, ccrval1, ccrval2
       character*21  compda
       character*80  cbarf(nwavemax)
       character*80  object, creator, ctype1, ctype2, bunit, history, cbadwave, cbigwave, csubwave, clowwave
       character*128 cobeam, csnt, csnr, csn1, csn2, cnwd, cowave, crdx, csrcmaxsize(nwavemax), callsrcmaxsizes, header, footer(2)
     &             , cmaxsize, caperture, callapertures
       character*132 cbars, getstitle, coccup
       character*134 formt
       character*142 cbar(nwavemax)
       character*400 cfgline(200)
       character*500 semifinalcatname, finalcatalogrelitent, finalcatalogreliable, cat(nwavemax), arg1, arg2, arg3, arg4, arg5
     &             , arg6, arg7, detimagestring, obsimagestring(nwavemax), finalcolorsrelitent, catreliable, catsubstruc, versfile
     &             , finalcatalogrelitentok, finalcatalogreliableok, finalcolorsrelitentok, finalcolorsreliable, footitname, cfgfile
     &             , finalcolorsreliableok, obsname(nwavemax), obsfsname(nwavemax), obsbsfsname(nwavemax), obscbname(nwavemax)
     &             , obscbsmoname(nwavemax), finbgrname, finbgrtname, finbgfsrname, finbgfsrtname, coordinates, deblendname
     &             , addcatalogrelitent, addcatalogreliable, addcatalogrelitentok, addcatalogreliableok, bsomaskname(nwavemax)
     &             , finfootname(nwavemax), noisename(nwavemax), subsfootpr(nwavemax), individintpro, individimages, filecombo
     &             , originpath, detimageline(nwavemax), finmoffatrname, finmoffatrtname, finfootnama(nwavemax), semifinalcatokname
       character*2000 headline(nwavemax,1000), addhead(100), headfpitline(100), cwfmt
       character*100000 headlineout(1000), headrelitent(1000), headreliable(1000), headcols, numbcols, conversionfacts

       integer       i, j, k, l, m, kk, ku, lh, ic, ifrt, firstb, lastc, ia1, ia2, ia3, id, ie, nhead(nwavemax), nextr(nwavemax)
     &             , ncolumns(nwavemax), nwaves, icat(nwavemax), lencolh(ncolmax), lencolhout(ncolmax), ncolhead(ncolmax), ibad
     &             , iob(nwavemax), nheadout, lhl, lhlo, ndate, ide, lcw, ncolumn, nquantities, ifui, irc, ii, iii, lcl, lfti, iopa
     &             , nextrbad, igood, lb, lcno, ibo, isnt, isnr, inwd, idot1, idot2, idot3, iow, isigg, nx, ihfp, iocc, icgw, icats
     &             , ny, blank, idot4, nplus, nbra1, nbra2, nextrgood, nextrgoodold, nextrbadold, lastp, itot, isemi, ihc, irdx
     &             , ixcopx, iycopx, ixcoas, iycoas, isigm, ifxpb, ifxpe, ifxtb, ifxte, ifxtg, iscsx, ifooa, iafwh, ibfwh, ithep
     &             , irade, ifoob, ifoot, idotf, icwf, itent, irely, ntentative, nreliable, idott, ifr, icatr, inc, ncol, mm, nn
     &             , nextrgoodvold, nextrbadvold, ifrok, ifrtok, ifcrt, ifcr, ifcrtok, ifcrok, nhrt, nhr, icrt, icr, icort, icor
     &             , nhart, nhar, ire, iobs(nwavemax), nxco, nyco, kmax, iro, nhrtstand, indint, indimg, iobsbsfs(nwavemax), last
     &             , ifbr, ifgr,ifbrt, ifgrt, icrp1, icrp2, icrv1, icrv2, ica, beta, idb, ll, iart, iar, iartok, iarok, kmx, ifmt
     &             , iocb(nwavemax), iocbs(nwavemax), ncolskipfoo, nwavesdetect, nr, isn1, nheadfc, idim1, idim2, ndetwaves, ismx
     &             , nheadfpit, nfpiter, nfpitcols, ih, it, itfp(100), nextrgoodit(100), nextrbadit(100), l0, m0, l1, l2, m1, m2
     &             , iff(nwavemax), inn(nwavemax), isf(nwavemax), ibm(nwavemax), iflag, fsflag, lcfg, ncfglines, nconfigend, icsw
     &             , ncolskipfsflg, lver, ncolskipafw, icbw, nwtentativelevel, nwreliablelevel, nsubstruc, nextrbadnew, isemok
     &             , nextrgoodnew, iasmx, iclw, ifmrt, ifmr, iter_phase(100), wchours, wcmins, wcsecs, cpuhours, cpumins, cpusecs
     &             , ielon, igod, nnoisebgr, nnotdetec, nspurious, nposition, ifmon, ncolskipfmflg, fmflag, igodn, icar, imx1, imx2
     &             , ifa(nwavemax), iaps, nwtoobig, ntoolarge, isn2, ifofa, lcf, iobsfs(nwavemax)
     
       real          fitsvers                                                                                                
       
       real*8        cpu_flagsources, wal_flagsources, cput_flagsources, walt_flagsources, cpu_substructured, wal_substructured
     &             , cput_substructured, walt_substructured, cpu_semifinalcat, wal_semifinalcat, cput_semifinalcat
     &             , walt_semifinalcat, cpu_finalcats, wal_finalcats, cput_finalcats, walt_finalcats, cpu_additioncats
     &             , wal_additioncats, cput_additioncats, walt_additioncats, cpu_profimages, wal_profimages, cput_profimages
     &             , walt_profimages, cpu_updatefoots, wal_updatefoots, cput_updatefoots, walt_updatefoots, cpu_updatecats
     &             , wal_updatecats, cput_updatecats, walt_updatecats, cpu_backfitsrc, wal_backfitsrc, cput_backfitsrc
     &             , walt_backfitsrc, cpu_sum, wal_sum, cputot, wctot, dfoo, radfwhm, radfoot, dlnr
       
       real*8        stentative, sreliable, nsigmacutss, obsbeam(nwavemax), obswave(nwavemax), qq, dxcon2, dycon2, rxy2, dist2
     &             , dx, dy, wave, crpix1, crpix2, crval1, crval2, ra, dec, beamd, funmin, funmax, crota1, crota2, epoch, equinox
     &             , bzero, bscale, datamin, datamax, color(nwavemax,nwavemax), colerr(nwavemax,nwavemax), correct, changemax 
     &             , pi, angle, aa, bb, cc, sigmaa2, sigmab2, dxcon, dycon, argmoffat, moffatfun, dbll, dblm, convtoradians, ff
     &             , cosa2, sina2, sin2a, funn, funk, funsum, dxcok, dycok, dxcok2, dycok2, obsbeammax, changemaxpa, sizemean
     &             , sq_arcsecs_per_sterad, sq_arcsecs_per_beam_area, convMJysr2Jybeam, smoobeam, qsigna, qsignb, almostzero, timer
     &             , reldiffmax, dfootarea(nwavemax), nfootareait(100,nwavemax), dfootareait(100,nwavemax), foomajor, foominor
     &             , foothepa, semimajor, pixsize, sigglob, snr1min, snr2min, snratio1min, obsbeammin, footobsbeam
     &             , SPIRE_250_beamarea, SPIRE_350_beamarea, SPIRE_500_beamarea, oldfootarea(nwavemax), newfootarea(nwavemax)
     &             , sourcemaxsize(nwavemax), sq_arcsecs_per_beam_area_approx, sterad_per_beam_area, goodness, foomax(nwavemax)
     &             , segmask_elongation, source_elongation, reliability, maxsizex, rxy, aperture(nwavemax), reliamin, reliamax
     &             , snratio2min, cd11, cd12, cd21, cd22

       logical         , allocatable :: lhighatwave(:,:), lgoodatwave(:,:), lsubatwave(:,:), lnormalsize(:,:), lnormalgood(:)
       character*1     , allocatable :: flag(:,:), badsource(:,:)
       character*5     , allocatable :: cfmflag(:)
       character*6     , allocatable :: cno(:)
       character*200   , allocatable :: comment(:)
       character*100000, allocatable :: catline(:,:), catlinereliable(:), catlinerelitent(:), colorlinereliable(:)
     &                              , colorlinerelitent(:)
       integer       , allocatable :: no(:,:), ns1(:,:), ns2(:,:), nsx(:,:), nok(:), intersection(:), intersectionff(:)
     &                              , ellipsearea(:,:), sfm(:,:)
       real*8        , allocatable :: quantity(:,:,:), factor(:,:,:), foots(:,:), obsimage(:,:), obsbsfsimage(:,:), profileob(:,:)
     &                              , profilebs(:,:), profilebd(:,:), rad(:), rad2(:), npts(:), dxco2(:), dyco2(:), individ(:,:)
     &                              , obscbr(:,:), obscbrt(:,:), obscbfsr(:,:), obscbfsrt(:,:), deblended(:,:)
     &                              , factsmoo(:,:), obscbimage(:,:), obscbsmoimage(:,:), backgint(:,:), backgsmoint(:,:)
     &                              , profilebdrms(:,:), bsomask(:,:), footlimit(:,:), foomajoro(:), foominoro(:), foothepao(:)
     &                              , noise(:,:), subsfp(:,:), snrglobal(:), flatfoots(:,:), moffatr(:,:), moffatrt(:,:)
     &                              , dist2peaks(:), dist2foots(:), profileob1st(:,:), profileob2nd(:,:), profileob3rd(:,:)
     &                              , foota(:,:), globelong(:), profileod(:,:), obsfsimage(:,:)

       parameter   ( beta = 10, correct = 1.0d0 / (2.0d0**(1.0d0 / dble ( beta )) - 1.0d0), pi = 3.14159265358979d0
     &             , convtoradians = pi / 180.0d0, sq_arcsecs_per_sterad = 3282.80635d0 * 3600.0d0**2, almostzero = 1.0d-30 )
     
       parameter   ( ltiming = .true. )
       
!!! VERY IMPORTANT !!!
! IF YOU MODIFY THE SPIRE 'BEAMAREA' VALUES BELOW, DON'T FORGET TO MODIFY THEM IN 'PREPAREOBS' ACCORDINGLY
! Beam areas from SPIRE Observer's Manual v.2.2 (Nov. 2010), page 75: 426, 771, 1626 arcsec^2
! Beam areas for SPIRE (Feb. 2013, N. Schneider): 465, 822, 1769 arcsec^2

       data          SPIRE_250_beamarea / 426 /, SPIRE_350_beamarea / 771 /, SPIRE_500_beamarea / 1626 /

       external      firstb, lastc, lastp, last, when, timer
!__________________________________________________________________________________________________________________________________
!
! Determine operating system

       call osystem ( lunix )

       call ftvers ( fitsvers )

       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       compda = __DATE__//' '//cfpptime

! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )

! Get command line parameters.

       call getarg ( 1, arg1 )
       call getarg ( 2, arg2 )
       call getarg ( 3, arg3 )
       call getarg ( 4, arg4 )
       call getarg ( 5, arg5 )
       call getarg ( 6, arg6 )
       call getarg ( 7, arg7 )

       isnt = lastc ( arg1 )
       isnr = lastc ( arg2 )
       isn1 = lastc ( arg3 )
       isn2 = lastc ( arg4 )
       inwd = lastc ( arg5 )
       irdx = lastc ( arg6 )
       iopa = lastc ( arg7 )
       csnt = arg1(1:isnt)
       csnr = arg2(1:isnr)
       csn1 = arg3(1:isn1)
       csn2 = arg4(1:isn2)
       cnwd = arg5(1:inwd)
       crdx = arg6(1:irdx)
       originpath = arg7(1:iopa)
       lverbose = '-verb2'

       if (isnt .gt. 0 .and. csnt(1:isnt) .ne. ':') then

         do i=1,nwavemax
           call getarg ( i+7, cat(i) )
           icat(i) = lastc ( cat(i) )
           read (cat(i),*,end=1,err=1) qq
           exit
  1        continue
           if (i .eq. nwavemax) then
             write (iotty,'(/a)') '   FINALCAT: ERROR: Too many wavecats, try increasing NWAVEMAX and recompiling me.'
             goto 195
           endif
         enddo
         nwaves = i - 1
       
         read (csnt(1:isnt),*,end=4,err=4) stentative
         goto 5
  4      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading STENTATIVE: '//csnt(1:isnt)
         goto 195
  5      continue
         read (csnr(1:isnr),*,end=6,err=6) sreliable
         goto 7
  6      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SRELIABLE: '//csnr(1:isnr)
         goto 195
  7      continue
         read (csn1(1:isn1),*,end=8,err=8) snr1min
         goto 9
  8      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SNR1MIN: '//csn1(1:isn1)
         goto 195
  9      continue
         read (csn2(1:isn2),*,end=28,err=28) snr2min
         goto 29
 28      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SNR2MIN: '//csn2(1:isn2)
         goto 195
 29      continue
         read (cnwd(1:inwd),*,end=10,err=10) nwavesdetect
         goto 11
 10      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading NWAVESDETECT: '//cnwd(1:inwd)
         goto 195
 11      continue
         read (crdx(1:irdx),*,end=12,err=12) reldiffmax
         write (creldiffmax,'(f8.5)') reldiffmax
         goto 13
 12      write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading RELDIFFMAX: '//crdx(1:irdx)
         goto 195
 13      continue
         lfirstiteration = .false.
         if (nwavesdetect .eq. 0) then
           lfirstiteration = .true.
         endif
         
         do i=1,nwaves
           call getarg ( i+7+nwaves, cowave )
           iow = lastc ( cowave )
           lherschel(i) = .false.
           if (cowave(1:1) .eq. '+') then
             lherschel(i) = .true.
           endif
           read (cowave(1:iow),*,err=81) obswave(i)     !<-- wavelength (microns)
           goto 2
 81        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading OBSWAVE: '//cowave(1:iow)
           goto 195
  2        continue
         enddo
         do i=1,nwaves
           call getarg ( i+7+2*nwaves, cobeam )
           ibo = lastc ( cobeam )
           read (cobeam(1:ibo),*,err=82) obsbeam(i)     !<-- beam size (arcsec)
           goto 3
 82        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading BEAMSIZE: '//cobeam(1:ibo)
           goto 195
  3        continue
         enddo
         do i=1,nwaves
           call getarg ( i+7+3*nwaves, csrcmaxsize(i) )
           ismx = lastc ( csrcmaxsize(i) )
           read (csrcmaxsize(i)(1:ismx),*,err=83) sourcemaxsize(i)     !<-- maximum size of a source (arcsec)
           goto 14
 83        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading SRCMAXSIZE: '//csrcmaxsize(i)(1:ismx)
           goto 195
 14        continue
         enddo
         lapertures = .false.
         callapertures = ' '
         iaps = 0
         do i=1,nwaves
           call getarg ( i+7+4*nwaves, caperture )
           icar = lastc ( caperture )
           read (caperture(1:icar),*,err=84) aperture(i)     !<-- aperture radius (arcsec)
           callapertures = callapertures(1:iaps)//' '//caperture(1:icar)
           iaps = lastc ( callapertures )
           goto 15
 84        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading APERTURE: '//caperture(1:icar)
           goto 195
 15        continue
           if (aperture(i) .gt. almostzero) lapertures = .true.
         enddo
         callsrcmaxsizes = ' '
         iasmx = 0
         do i=1,nwaves
           write (cmaxsize,*) max ( nint ( sourcemaxsize(i) ), nint ( aperture(i) ) )
           imx2 = lastc ( cmaxsize )
           imx1 = last ( ' ', cmaxsize(1:imx2) ) + 1
           callsrcmaxsizes = callsrcmaxsizes(1:iasmx)//' '//cmaxsize(imx1:imx2)
           iasmx = lastc ( callsrcmaxsizes )
         enddo
         callsrcmaxsizes = callsrcmaxsizes(2:iasmx)
         iasmx = lastc ( callsrcmaxsizes )

         call getarg ( 5*nwaves+ 8, arg1 )
         call getarg ( 5*nwaves+ 9, arg2 )
         call getarg ( 5*nwaves+10, arg3 )
         ia1 = lastc ( arg1 )
         ia2 = lastc ( arg2 )
         ia3 = lastc ( arg3 )
    
         if (ia3 .gt. 0 .and. arg3(1:ia3-1) .eq. '-verb') lverbose = arg3(1:ia3)
         if (ia2 .gt. 0 .and. arg2(1:ia2-1) .eq. '-verb') lverbose = arg2(1:ia2)
         if (ia1 .gt. 0 .and. arg1(1:ia1-1) .eq. '-verb') lverbose = arg1(1:ia1)
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(/a$)') ' FINALCAT = Make Final Catalogs = '//compda
       if (csnt(1:isnt) .eq. ':') stop
       if (lverbose .eq. '-verb2') write (iotty,'()')
       if (lverbose .eq. '-verb2') write (iotty,'( a)') ' Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'

       if (icat(1) .eq. 0 .or. nwaves .lt. 1) goto 195
       goto 196
 195   write (iotty,'(/a)') ' USAGE: finalcat <sigt> <sigr> <sn1min> <sn2min> <nwdetect> <rdiffmax> <origpath> <cat1> [<cat2> ...]'
     &                    //' <owave1> [<owave2> ...] <obeam1> [<obeam2> ...] <sxsize1> [<sxsize2> ...] <apert1> [<apert2> ...]'
     &                    //' [-o <finalcat>] [-verb{0|1|2}]'
       stop 99
 196   continue
       
       if (ia1 .gt. 0 .and. arg1(1:ia1) .ne. '-o' .and. arg1(1:ia1-1) .ne. '-verb') then
         finalcatalogrelitent = arg1(1:ia1)
       elseif (ia2 .gt. 0 .and. arg1(1:ia1) .eq. '-o' .and. arg2(1:ia2-1) .ne. '-verb') then
         finalcatalogrelitent = arg2(1:ia2)
       else
         finalcatalogrelitent = 'sm.final.catalog.relitent.cat'
       endif
       ifrt = lastc ( finalcatalogrelitent )

       addcatalogrelitent = finalcatalogrelitent(1:ifrt-4)//'.add.cat'
       iart = lastc ( addcatalogrelitent )

       idott = index ( finalcatalogrelitent(1:ifrt), '.relitent.cat' )

       if (idott .eq. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Output catalog file name is not ''*.relitent.cat'','
         write (iotty,'(a )') '             it is: '''//finalcatalogrelitent(1:ifrt)//''''
         stop 11
       endif

       finalcatalogrelitentok = finalcatalogrelitent(1:ifrt-4)//'.ok.cat'
       ifrtok = lastc ( finalcatalogrelitentok )
       finalcatalogreliable = finalcatalogrelitent(1:idott-1)//'.reliable.cat'
       ifr = lastc ( finalcatalogreliable )
       finalcatalogreliableok = finalcatalogreliable(1:ifr-4)//'.ok.cat'
       ifrok = lastc ( finalcatalogreliableok )

       addcatalogrelitentok = addcatalogrelitent(1:iart-4)//'.ok.cat'
       iartok = lastc ( addcatalogrelitentok )
       addcatalogreliable = addcatalogrelitent(1:idott-1)//'.reliable.add.cat'
       iar = lastc ( addcatalogreliable )
       addcatalogreliableok = addcatalogreliable(1:iar-4)//'.ok.cat'
       iarok = lastc ( addcatalogreliableok )

       idotf = index ( finalcatalogrelitent(1:ifrt), '.final' )
       semifinalcatname = finalcatalogrelitent(1:idotf-1)//'.semif'//finalcatalogrelitent(idotf+6:ifrt)
       isemi = lastc ( semifinalcatname )
       semifinalcatokname = finalcatalogrelitentok(1:ifrt-4)//'.sem.ok.cat'
       isemok = lastc ( semifinalcatokname )

       finalcolorsrelitent = finalcatalogrelitent(1:idotf+5)//'.colors.relitent.cat'
       ifcrt = lastc ( finalcolorsrelitent )
       finalcolorsreliable = finalcatalogrelitent(1:idotf+5)//'.colors.reliable.cat'
       ifcr = lastc ( finalcolorsreliable )
       finalcolorsrelitentok = finalcolorsrelitent(1:ifcrt-4)//'.ok.cat'
       ifcrtok = lastc ( finalcolorsrelitentok )
       finalcolorsreliableok = finalcolorsreliable(1:ifcr-4)//'.ok.cat'
       ifcrok = lastc ( finalcolorsreliableok )

       if (ltiming) then
         inquire ( file='+timing.finalcat', exist=ltime )
         open ( 60, file='+timing.finalcat', status='unknown' )
         if (ltime) then
           do 
             read (60,'()',end=71)
           enddo
  71       backspace ( 60 )
         endif
         if (lfirstiteration) then
           write (60,'(/a)') ' FINALCAT started: '//cdate//' '//ctime//' Cat: '//finalcatalogrelitent(1:ifrt)//' <~ 1ST ITERATION'
         else
           write (60,'(/a)') ' FINALCAT started: '//cdate//' '//ctime//' Cat: '//finalcatalogrelitent(1:ifrt)
         endif
         
         cput_flagsources   = 0.0d0
         walt_flagsources   = 0.0d0
         cput_substructured = 0.0d0
         walt_substructured = 0.0d0
         cput_semifinalcat  = 0.0d0
         walt_semifinalcat  = 0.0d0
         cput_finalcats     = 0.0d0
         walt_finalcats     = 0.0d0
         cput_additioncats  = 0.0d0
         walt_additioncats  = 0.0d0
         cput_profimages    = 0.0d0
         walt_profimages    = 0.0d0
         cput_updatefoots   = 0.0d0
         walt_updatefoots   = 0.0d0
         cput_updatecats    = 0.0d0
         walt_updatecats    = 0.0d0
         cput_backfitsrc    = 0.0d0
         walt_backfitsrc    = 0.0d0
         cpu_sum = 0.0d0
         wal_sum = 0.0d0
       endif
  
       lmysimsky = .false.
       lconverge = .false.
       lhandlesubstruc = .false.
       liter_phase1 = .false.
       liter_phase2 = .false.
       liter_phase3 = .false.
       lfinishing_mode = .false.
       lcreate_profiles_images = .false.

       if (csnt(1:1) .eq. '+') then
         liter_phase1 = .true.
       endif
       if (csnr(1:1) .eq. '+') then
         liter_phase2 = .true.
       endif
       if (csn1(1:1) .eq. '+' .or. csn1(1:1) .eq. '-') then
         liter_phase3 = .true.
       endif
       if (csn1(1:1) .eq. '-') then
         lfinishing_mode = .true.
       endif
       if (lfinishing_mode .and. csnr(1:1) .eq. '+') then
         lcreate_profiles_images = .true.
       endif

       if (csnt(1:1) .eq. '+') then
         csnt = csnt(2:isnt)
       endif
       if (csnt(1:1) .eq. '-') then
         stentative = abs ( stentative )
         csnt = csnt(2:isnt)
       endif
       if (csnr(1:1) .eq. '+') then
         csnr = csnr(2:isnr)
       endif
       if (csnr(1:1) .eq. '-') then
         sreliable = abs ( sreliable )
         csnr = csnr(2:isnr)
       endif
       if (csn1(1:1) .eq. '+') then
         csn1 = csn1(2:isn1)
       endif
       if (csn1(1:1) .eq. '-') then
         snr1min = abs ( snr1min )
         csn1 = csn1(2:isn1)
       endif

       isnt = lastc ( csnt )
       isnr = lastc ( csnr )
       isn1 = lastc ( csn1 )
       
       if (cat(1)(1:3) .ne. 'sm.' .and. cat(1)(1:3) .ne. 'sx.') then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File name does not begin with "sm." or "sx.":'
         write (iotty,'(a )') '             '//cat(1)(1:icat(1))
         stop 12
       endif
       
! Check if the input files exist and get scales and their numbering.

       do i=1,nwaves
         inquire ( file=cat(i)(1:icat(i)), exist=lfname )
         if (.not.lfname) goto 91
         idot1 = index ( cat(i)(1:icat(i)), '.' )
         idot2 = index ( cat(i)(idot1+1:icat(i)), '.' ) + idot1
         idot3 = index ( cat(i)(idot2+1:), '.' ) + idot2
         idot4 = index ( cat(i)(idot3+1:), '.' ) + idot3
         if (idot2 .gt. 0 .and. idot3 .gt. 0) then 
           read (cat(i)(idot2+1:idot3-1),*,end=41,err=41) cwave0(i)
           lcw = lastc ( cwave0(i) )
           cwave(i) = cwave0(i)
           if (lcw .eq. 1) cwave(i) = '   '//cwave0(i)(1:1)
           if (lcw .eq. 2) cwave(i) = '  '//cwave0(i)(1:2)
           if (lcw .eq. 3) cwave(i) = ' '//cwave0(i)(1:3)
           goto 42
 41        write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading wavelength: "'//cwave(i)//'"'
           stop 51
 42        continue
         else
           write (iotty,'(/a   )') '   FINALCAT: ERROR: Trouble finding wavelength in file name:'
           write (iotty,'(a,2i3)') '             '//cat(i)(1:icat(i)), idot2, idot3
           stop 52
         endif
         if (cwave(i)(1:3) .eq. '000') cwave(i)(1:3) = '   '
         if (cwave(i)(1:2) .eq. '00' ) cwave(i)(1:2) = '  '
         if (cwave(i)(1:1) .eq. '0'  ) cwave(i)(1:1) = ' '
         cbar(i) = '____________________________________________________________________________________________________________'
     &           //'__________________________________'
         cbarf(i) = '________________________________________________________________________________'
         peakfunits(i) = ''
       enddo
       cbars = '!_______________________________________________________________________________________________________________'
     &       //'____________________'
       
       goto 92
 91    continue
       if (.not.lfname) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//cat(i)(1:icat(i))//''' not found.'
         stop 31
       endif
 92    continue
       write (cnwaves,'(i2)') nwaves

       do i=1,nwaves
         bsomaskname(i) = cat(i)(4:idot3-1)//'.bs.omask.fits'
         ibm(i) = lastc ( bsomaskname(i) )
         finfootname(i) = cat(i)(1:idot4-1)//'.foots.fits'
         iff(i) = lastc ( finfootname(i) )
         finfootnama(i) = cat(i)(1:idot4-1)//'.foota.fits'
         ifa(i) = lastc ( finfootnama(i) )
         noisename(i) = cat(i)(1:idot4-1)//'.noise.fits'
         inn(i) = lastc ( noisename(i) )
         subsfootpr(i) = cat(i)(1:idot4-1)//'.subsfp.fits'
         isf(i) = lastc ( subsfootpr(i) )
       enddo

       footitname = '+log.FOOTPRINTS.iter'
       lfti = lastc ( footitname )

       if (lverbose .eq. '-verb1') write (iotty,'(/a)') ' FINALCAT: '//csnt(1:isnt)//' '//csnr(1:isnr)//' '
     &                                                               //cat(1)(1:icat(1))//' '//semifinalcatname(1:isemi)
       if (lverbose .eq. '-verb2') write (iotty,'()')

       versfile='+log.VERSION'
       lver = lastc ( versfile )
       getstitle='# GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction'
       inquire ( file=versfile(1:lver), exist=lfnvers )
       if (lfnvers) then
         open ( 25, file=versfile(1:lver), status='old' )
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading version file '''//versfile(1:lver)//'''...'
         do i=1,3
           read (25,'(a)',end=67,err=61) getstitle
         enddo
         getstitle = getstitle(1:1)//getstitle(4:)
         goto 67
  61     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading file '''//versfile(1:lver)//'''.'
         close (25)
         stop 32
  67     continue
         close (25)
       else        
         if (lverbose .eq. '-verb2') write (iotty,'(/a)') '   FINALCAT: WARNING: File '''//versfile(1:lver)//''' not found.'
       endif
       
       nextrgoodold = 0
       nextrbadold = 0
       nextrgoodvold = 0
       nextrbadvold = 0

       colhead(1) = 'NO S1 S2'
       lencolh(1) = 8
       colhead(2) = 'S1 S2 '
       lencolh(2) = 6
       colhead(3) = 'S1 S2 '
       lencolh(3) = 6
       colhead(4) = 'SX '
       lencolh(4) = 3
       ixcopx = 5
       colhead(ixcopx) = 'XCO_PIXEL '
       lencolh(ixcopx) = 10
       iycopx = 6
       colhead(iycopx) = 'YCO_PIXEL '
       lencolh(iycopx) = 10
       ixcoas = 7
       colhead(ixcoas) = 'XCO_PIXRO '
       lencolh(ixcoas) = 10
       iycoas = 8
       colhead(iycoas) = 'YCO_PIXRO '
       lencolh(iycoas) = 10
       isigg = 9
       colhead(isigg) = 'SIG_GLOB '
       lencolh(isigg) = 9
       iflag = 10
       colhead(iflag) = 'FG '
       lencolh(iflag) = 3
       igodn = 11
       colhead(igodn) = 'GOOD '
       lencolh(igodn) = 5
       isigm = 12
       colhead(isigm) = 'SIG_MONO '
       lencolh(isigm) = 9
       ifmon = 13
       colhead(ifmon) = 'FM '
       lencolh(ifmon) = 3
       ifxpb = 14
       colhead(ifxpb) = 'FXP_BEST '
       lencolh(ifxpb) = 9
       ifxpe = 15
       colhead(ifxpe) = 'FXP_ERROR '
       lencolh(ifxpe) = 10
       ifxtb = 16
       colhead(ifxtb) = 'FXT_BEST '
       lencolh(ifxtb) = 9
       ifxte = 17
       colhead(ifxte) = 'FXT_ERROR '
       lencolh(ifxte) = 10
       ifxtg = 18
       colhead(ifxtg) = 'FXT_GAUSS '
       lencolh(ifxtg) = 10
       iscsx = 19
       colhead(iscsx) = 'SCALE_SX '
       lencolh(iscsx) = 9
       iafwh = 20
       colhead(iafwh) = 'AFWHM_MOM '
       lencolh(iafwh) = 10
       ibfwh = 21
       colhead(ibfwh) = 'BFWHM_MOM '
       lencolh(ibfwh) = 10
       ithep = 22
       colhead(ithep) = 'THEPA_MOM '
       lencolh(ithep) = 10
       irade = 23
       colhead(irade) = 'RADEQUIVA '
       lencolh(irade) = 10
       ifofa = 24
       colhead(ifofa) = 'FOOT_FACT '
       lencolh(ifofa) = 10
       ifooa = 25
       colhead(ifooa) = 'FOOAMAJOR '
       lencolh(ifooa) = 10
       ifoob = 26
       colhead(ifoob) = 'FOOBMINOR '
       lencolh(ifoob) = 10
       ifoot = 27
       colhead(ifoot) = 'FOOTHEPAN '
       lencolh(ifoot) = 10
       nquantities = 27
! Elongation is an extra quantity to be treated in a special way.
       ielon = 28
       colhead(ielon) = 'ELONGATIO '
       lencolh(ielon) = 10

       open ( 15, file=cat(1)(1:icat(1)), status='old' )
  
       call skipcomm     ( 15, cat(1)(1:icat(1)), nhead(1) )
       call linescolumns ( 15, cat(1)(1:icat(1)), nhead(1), nextr(1), ncolumns(1) )
  
       close ( 15 )

       allocate ( no(nwaves,nextr(1)), ns1(nwaves,nextr(1)), ns2(nwaves,nextr(1)), nsx(nwaves,nextr(1)), catline(nwaves,nextr(1))
     &          , quantity(nwaves,nextr(1),nquantities+1), factor(nwaves,nextr(1),nquantities+1), factsmoo(nwaves,nextr(1))
     &          , cno(nextr(1)), comment(nextr(1)), flag(nwaves,nextr(1)), badsource(nwaves,nextr(1)), backgint(nwaves,nextr(1))
     &          , backgsmoint(nwaves,nextr(1)), nok(nextr(1)), lhighatwave(nwaves,nextr(1)), lgoodatwave(nwaves,nextr(1))
     &          , lnormalsize(nwaves,nextr(1)), lnormalgood(nextr(1)), lsubatwave(nwaves,nextr(1)), snrglobal(nextr(1))
     &          , globelong(nextr(1)), dist2peaks(nextr(1)), dist2foots(nextr(1)), sfm(nwaves,nextr(1)), cfmflag(nwaves)
     &          , stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (71).'
         stop 71
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_flagsources = timer ( 'cpu', 0.0d0 )
         wal_flagsources = timer ( 'wal', 0.0d0 )
       endif

       do i=1,nwavemax
         obsimagestring(i) = '???'
       enddo
       
! Read measurement catalogs at each wavelength.

       do i=1,nwaves       
       
         do j=1,nextr(1)
           do l=1,nquantities
             factor(i,j,l) = 1.0d0
           enddo
         enddo
         
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading catalog '''//cat(i)(1:icat(i))//'''...'
       
         open ( 15, file=cat(i)(1:icat(i)), status='old' )

         call skipcomm     ( 15, cat(i)(1:icat(i)), nhead(i) )
         call linescolumns ( 15, cat(i)(1:icat(i)), nhead(i), nextr(i), ncolumns(i) )
         
         do ii=1,i
           if (nhead(ii) .ne. nhead(1) .or. ncolumns(ii) .ne. ncolumns(1) .or. nextr(ii) .ne. nextr(1)) then
             write (iotty,'(/a)') '   FINALCAT: ERROR: Tables differ in numbers of headers, columns, or data lines.'
             do iii=1,ii
               write (iotty,'(i5,a,3i5)') iii, cat(iii)(1:icat(iii)), nhead(iii), ncolumns(iii), nextr(iii)
             enddo
             stop 11
           endif
         enddo
         
         rewind ( 15 )

         nsigmacutss = 0.0d0
         detimagestring = '???'
         ide = lastc ( detimagestring )
         iob(i) = lastc ( obsimagestring(i) )
         lwcscoord = .false.
         fmtwcs='2f8.1 '

         do k=1,nhead(i)
           read (15,'(a)') headline(i,k)
           lhl = lastc ( headline(i,k) )

! Get names of the files with the detection image and observed (measurement) image.

           ncolumn = index ( headline(i,k)(1:lhl), '# DETECTION TABLE for image ' )
           if (ncolumn .gt. 0) then
             detimagestring = headline(i,k)(ncolumn+28:lhl)
             ide = lastc ( detimagestring )

             ncolumn = index ( detimagestring(1:ide), 'pixel: ' )
             if (ncolumn .gt. 0) then
               read(detimagestring(ncolumn+6:ncolumn+12),*) pixsize
             else    
               write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble finding pixel size in the line:'
               write (iotty,'(a )') '   '''//headline(i,k)(1:lhl)//''''
               stop 99
             endif
           endif
    
           ncolumn = index ( headline(i,k)(1:lhl), '#         measurement image ' )
           if (ncolumn .gt. 0) then
             obsimagestring(i) = headline(i,k)(ncolumn+28:lhl)
             iob(i) = lastc ( obsimagestring(i) )
           endif
           
           ncolumn = index ( headline(i,k)(1:lhl), '| nsigmacutss ' )
           if (ncolumn .gt. 0) then
             read(headline(i,k)(2:lhl),*) nsigmacutss
           endif

! Get units of the peak flux at current wavelength.

           ku = 0
           ncolumn = index ( headline(i,k)(1:lhl), '(MJy/sr)' )
           if (ncolumn .gt. 0) then
             peakfunits(i) = 'MJy/sr'
             ku = k
           endif

           ncolumn = index ( headline(i,k)(1:lhl), 'WCS_ACOOR' )
           if (ncolumn .gt. 0) then
             lwcscoord = .true.
             colhead(7) = 'WCS_ACOOR'
             colhead(8) = 'WCS_DCOOR'
             fmtwcs='2f11.5'
           endif
           
           ncolumn = index ( headline(i,k)(1:lhl), colhead(1)(1:lencolh(1)) )
           if (ncolumn .gt. 0) then
             ncolhead(1) = ncolumn
             do l=2,nquantities+1
               ncolumn = index ( headline(i,k)(1:lhl), colhead(l)(1:lencolh(l)) )
               if (ncolumn .gt. 0) then
                 ncolhead(l) = ncolumn
               else
                 write (iotty,'(/a)') '   FINALCAT: ERROR: Header '''//colhead(l)(1:lencolh(l))//''' not found in the line:'
                 write (iotty,'(a )') '   '''//headline(i,k)(1:133)//''''
                 stop 99
               endif
             enddo
           endif
         enddo

         if (nsigmacutss .lt. 1.0d-30) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Line with NSIGMACUTSS not found in the catalog''s header.'
           stop 99
         endif

         do j=1,nextr(i)
           read (15,'(a)') catline(i,j)

           read (catline(i,j),'(a1)') badsource(i,j)

           read  (catline(i,j),'(1x,i5)') no(i,j)

           write (colskip,'(i3)') ncolhead(2) - 2
           read  (catline(i,j),'('//colskip//'x,i3)') ns1(i,j)

           write (colskip,'(i3)') ncolhead(3) + 1
           read  (catline(i,j),'('//colskip//'x,i3)') ns2(i,j)

           write (colskip,'(i3)') ncolhead(4) - 1
           read  (catline(i,j),'('//colskip//'x,i3)') nsx(i,j)

           write (colskip,'(i3)') ncolhead(4) + 3
           read  (catline(i,j),'('//colskip//'x,a)') flag(i,j)
           
           do l=ixcopx,iycopx
             write (colskip,'(i3)') ncolhead(l) - 3
             read  (catline(i,j),'('//colskip//'x,f11.4)') quantity(i,j,l)
           enddo

           do l=ixcoas,iycoas
             write (colskip,'(i3)') ncolhead(l) - 3
             if (lwcscoord) then
               read (catline(i,j),'('//colskip//'x,f11.5)') quantity(i,j,l)
             else   
               read (catline(i,j),'('//colskip//'x,f11.4)') quantity(i,j,l)
             endif
           enddo

           write (colskip,'(i3)') ncolhead(isigg) - 3
           read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,isigg)

           write (colskip,'(i3)') ncolhead(iflag) - 2
           read  (catline(i,j),'('//colskip//'x,i3)') fsflag
           quantity(i,j,iflag) = dble ( fsflag )
           if (colhead(iflag)(1:lencolh(iflag)) .eq. 'FG ') ncolskipfsflg = ncolhead(iflag) - 2

           write (colskip,'(i3)') ncolhead(igodn) - 3
           read  (catline(i,j),'('//colskip//'x,f6.2)') quantity(i,j,igodn)

           write (colskip,'(i3)') ncolhead(isigm) - 3
           read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,isigm)

           write (colskip,'(i3)') ncolhead(ifmon) - 2
           read  (catline(i,j),'('//colskip//'x,a5)') cfmflag(i)
           if (index ( cfmflag(i), '-' ) .eq. 0) then
             sfm(i,j) = 1
           else
             sfm(i,j) = -1
           endif
           read (cfmflag(i),'(i5)') fmflag
           quantity(i,j,ifmon) = dble ( abs ( fmflag ) )
           if (colhead(ifmon)(1:lencolh(ifmon)) .eq. 'FM ') ncolskipfmflg = ncolhead(ifmon) - 2

           do l=ifxpb,nquantities+1
             write (colskip,'(i3)') ncolhead(l) - 3
             read  (catline(i,j),'('//colskip//'x,1pe11.3)') quantity(i,j,l)
             if (colhead(l)(1:lencolh(l)) .eq. 'AFWHM_MOM ') ncolskipafw = ncolhead(l) - 3
             if (colhead(l)(1:lencolh(l)) .eq. 'FOOAMAJOR ') ncolskipfoo = ncolhead(l) - 3
             if (l .eq. ifooa) quantity(i,j,l) = abs ( quantity(i,j,l) )
             if (l .eq. ifoob) quantity(i,j,l) = abs ( quantity(i,j,l) )
             if (l .eq. ifoot) quantity(i,j,l) = abs ( quantity(i,j,l) )
           enddo
         enddo

         close ( 15 )
       enddo        
       
       id = index ( detimagestring(1:ide), '.sw.det.' ) + 6
       filecombo = detimagestring(2:id)//'.combined'
       ic = lastc ( filecombo )

       inquire ( file=filecombo(1:ic), exist=lfnamefc )
       if (.not.lfnamefc) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//filecombo(1:ic)//''' not found.'
         stop 33
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading file '''//filecombo(1:ic)//'''...'
      
       open ( 25, file=filecombo(1:ic), status='old' )
      
       call skipcomm ( 25, filecombo(1:ic), nheadfc )
       
       ndetwaves = 0
       do i=1,nwaves
         read (25,'(a)',end=77,err=77) detimageline(i)
         ndetwaves= ndetwaves + 1
       enddo
   77  continue

       close ( 25 )

! Mark those wavelengths which were used to create combined detection images.
       
       do i=1,nwaves
         ldetectionwave(i) = .false.
         lcw = lastc ( cwave0(i) )
         do ii=1,ndetwaves
           idim1 = index ( detimageline(ii), '.' )
           idim2 = index ( detimageline(ii), '.det.' )
           if (detimageline(ii)(idim1+1:idim2-1) .eq. cwave0(i)(1:lcw)) then
             ldetectionwave(i) = .true.
             exit
           endif
         enddo
       enddo

       conversionfacts = ' conversion factors (MJy/sr ~> Jy/beam_obs): '
       lcf = lastc ( conversionfacts )
       
       do i=1,nwaves
        
         if (liter_phase2 .or. liter_phase3) then

           ifui = lastc ( peakfunits(i) )

           if (peakfunits(i)(1:ifui) .eq. 'MJy/sr') then

             lcw = lastc ( cwave0(i) )

             sq_arcsecs_per_beam_area_approx = pi * (obsbeam(i) / 2.0)**2 / log ( 2.0d0 )

             if (lherschel(i) .and. 
     &           (cwave0(i)(1:lcw) .eq. '250' .or. cwave0(i)(1:lcw) .eq. '0250' .or. 
     &            cwave0(i)(1:lcw) .eq. '350' .or. cwave0(i)(1:lcw) .eq. '0350' .or. 
     &            cwave0(i)(1:lcw) .eq. '500' .or. cwave0(i)(1:lcw) .eq. '0500')) then
  
               if (cwave0(i)(1:lcw) .eq. '250' .or. cwave0(i)(1:lcw) .eq. '0250') sq_arcsecs_per_beam_area = SPIRE_250_beamarea
               if (cwave0(i)(1:lcw) .eq. '350' .or. cwave0(i)(1:lcw) .eq. '0350') sq_arcsecs_per_beam_area = SPIRE_350_beamarea
               if (cwave0(i)(1:lcw) .eq. '500' .or. cwave0(i)(1:lcw) .eq. '0500') sq_arcsecs_per_beam_area = SPIRE_500_beamarea
             else
               sq_arcsecs_per_beam_area = sq_arcsecs_per_beam_area_approx
             endif

             sterad_per_beam_area = sq_arcsecs_per_beam_area / sq_arcsecs_per_sterad

             convMJysr2Jybeam = 1.0d6 * sterad_per_beam_area  !<-- intensity in MJy/sr to Jy/beam

             write (convfact,'(1pe11.4)') convMJysr2Jybeam
             
             conversionfacts = conversionfacts(1:lcf)//convfact
             lcf = lastc ( conversionfacts )

             do j=1,nextr(i)
      
               if (flag(i,j) .ne. 'n') then

! Convert peak fluxes from MJy/sr into Jy/beam.

                 factor(i,j,ifxpb) = factor(i,j,ifxpb) * convMJysr2Jybeam

                 if (abs ( quantity(i,j,ifxpb) ) * factor(i,j,ifxpb) .lt. 9.999d-31) then
                   if (abs ( quantity(i,j,ifxpb) ) .gt. 1.0d-90) then
                     quantity(i,j,ifxpb) = sign ( 1.0d0, quantity(i,j,ifxpb) ) * 9.999d-31
                   endif
                   factor(i,j,ifxpb) = 1.0d0
                 endif
       
! Convert errors in peak fluxes from MJy/sr into Jy/beam.

                 factor(i,j,ifxpe) = factor(i,j,ifxpe) * convMJysr2Jybeam
       
                 if (quantity(i,j,ifxpe) * factor(i,j,ifxpe) .lt. 9.999d-31) then
                   if (abs ( quantity(i,j,ifxpe) ) .gt. 1.0d-90) then
                     quantity(i,j,ifxpe) = 9.999d-31
                   endif
                   factor(i,j,ifxpe) = 1.0d0
                 endif

                 if (abs ( quantity(i,j,ifxtb) ) * factor(i,j,ifxtb) .lt. 9.999d-31) then
                   if (abs ( quantity(i,j,ifxtb) ) .gt. 1.0d-90) then
                     quantity(i,j,ifxtb) = sign ( 1.0d0, quantity(i,j,ifxtb) ) * 9.999d-31
                   endif
                   factor(i,j,ifxtb) = 1.0d0
                 endif
    
                 if (quantity(i,j,ifxte) * factor(i,j,ifxte) .lt. 9.999d-31) then
                   if (abs ( quantity(i,j,ifxte) ) .gt. 1.0d-90) then
                     quantity(i,j,ifxte) = 9.999d-31
                   endif
                   factor(i,j,ifxte) = 1.0d0
                 endif

                 if (abs ( quantity(i,j,ifxtg) ) * factor(i,j,ifxtg) .lt. 9.999d-31) then
                   if (abs ( quantity(i,j,ifxtg) ) .gt. 1.0d-90) then
                     quantity(i,j,ifxtg) = sign ( 1.0d0, quantity(i,j,ifxtg) ) * 9.999d-31
                   endif
                   factor(i,j,ifxtg) = 1.0d0
                 endif
               endif
             enddo
           endif
         endif
       enddo

! Find minimum and maximum observational beams.
       
       obsbeammin = 1.0d30
       obsbeammax = 0.0d0
       do i=1,nwaves
         obsbeammin = min ( obsbeam(i), obsbeammin )
         obsbeammax = max ( obsbeam(i), obsbeammax )
       enddo
       
! Find a factor by which the peak intensity of a source would be lowered due to a convolution with a smoothing beam.

       do i=1,nwaves
         do j=1,nextr(i)
           if (lfinishing_mode) then
             smoobeam = sqrt ( obsbeammax**2 - obsbeam(i)**2 )
             factsmoo(i,j) = quantity(i,j,iafwh) * quantity(i,j,ibfwh) / 
     &                       sqrt ( (quantity(i,j,iafwh)**2 + smoobeam**2) * (quantity(i,j,ibfwh)**2 + smoobeam**2) )
           endif
           lsubatwave(i,j) = .false.
         enddo
       enddo

! Compute the global significance from the ones at the individual wavelengths.           
           
       do j=1,nextr(1)
         sigglob = 0.0d0
         do i=1,nwaves
           if (ldetectionwave(i)) then
             sigglob = sigglob + quantity(i,j,isigm)**2
           endif
         enddo
         do i=1,nwaves
           quantity(i,j,isigg) = sqrt ( sigglob )
         enddo
       enddo

! Compute the global S/N ratio from the ones at the individual wavelengths.           
           
       do j=1,nextr(1)
         snrglobal(j) = 0.0d0
         if (liter_phase2 .or. liter_phase3) then
           do i=1,nwaves
             if (ldetectionwave(i) .and. quantity(i,j,isigm) .gt. almostzero .and. 
     &           quantity(i,j,ifxpb) .gt. almostzero .and. quantity(i,j,ifxpe) .gt. almostzero) then
               snrglobal(j) = snrglobal(j) + (quantity(i,j,ifxpb) / quantity(i,j,ifxpe))**2
             endif
           enddo
           snrglobal(j) = sqrt ( snrglobal(j) )
         endif
         globelong(j) = 0.0d0
         if (liter_phase3) then
           do i=1,nwaves
             if (quantity(i,j,isigm) .gt. stentative .and.
     &           quantity(i,j,ifxpb) .gt. almostzero .and. quantity(i,j,ifxpe) .gt. almostzero) then
               globelong(j) = globelong(j) + (quantity(i,j,iafwh) / quantity(i,j,ibfwh))**2
             endif
           enddo
           globelong(j) = sqrt ( globelong(j) )
         endif
       enddo

! source is bad and rejected if either total fluxes at all waves or sizes from moments are zero or negative.

       nextrbad = 0
       nextrbadnew = 0
       ntentative = 0

       if (lverbose .eq. '-verb2') then
         write (iotty,'(a)') '   Commenting out bad sources at all wavelengths...'
       endif
       
       do j=1,nextr(1)
         write (cno(j),'(i6)') no(1,j)
         cno(j)(1:1) = ' '
         comment(j) = '   '
         lcno = 1

         do i=1,nwaves
           quantity(i,j,iflag) = 0.0d0
           quantity(i,j,ifmon) = 0.0d0
         enddo       
         
         lallnoise = .true.
         do i=1,nwaves
           if (flag(i,j) .ne. 'n') lallnoise = .false.
         enddo       
         
         loneormoresnhigh = .false.
         do i=1,nwaves
           if (flag(i,j) .ne. 'n' .and. ldetectionwave(i) .and. quantity(i,j,isigm) .ge. sreliable) then
             loneormoresnhigh = .true.
           endif
         enddo       

! Source is too close to another and has almost same size (within a factor of 2) 
! and a lower product of global significance and global S/N ratio and range of scales.
           
         coccup = ' '
         iocc = 0
         ltooclose = .false.
         if (liter_phase3) then
           do i=1,nwaves
             if (ldetectionwave(i)) then
               do k=1,nextr(1)
                 if (k .ne. j .and. flag(i,j) .ne. 'n' .and. flag(i,k) .ne. 'n' .and. badsource(1,k) .ne. '!') then
                   rxy = sqrt ( (quantity(i,j,ixcopx) - quantity(i,k,ixcopx))**2 
     &                        + (quantity(i,j,iycopx) - quantity(i,k,iycopx))**2 )

                   call round1d ( rxy, 1, 2 )
                   
                   if (rxy .lt. max ( 3.3d0, obsbeammin / pixsize ) .and.
     &                 snrglobal(j) * quantity(i,j,isigg) * (ns2(1,j) - ns1(1,j)) .lt. 
     &                 snrglobal(k) * quantity(i,k,isigg) * (ns2(1,k) - ns1(1,k))) then
                     ltooclose = .true.
                     if (k .lt. 10) then
                       write (cocc,'(i1)') k
                     else if (k .lt. 100) then
                       write (cocc,'(i2)') k
                     else if (k .lt. 1000) then
                       write (cocc,'(i3)') k
                     else if (k .lt. 10000) then
                       write (cocc,'(i4)') k
                     else if (k .lt. 100000) then
                       write (cocc,'(i5)') k
                     else if (k .lt. 1000000) then
                       write (cocc,'(i6)') k
                     endif
                     coccup = coccup(1:iocc)//' '//cocc
                     iocc = lastc ( coccup )
                     exit
                   endif
                 endif
               enddo
             endif
           enddo
         endif

! Source must have SIG_MONO or SIG_GLOB high enough to be considered a detection.

         lnotdetection = .true.
         nwtentativelevel = 0
         nwreliablelevel = 0
         do i=1,nwaves
           if (ldetectionwave(i) .and. flag(i,j) .ne. 'n') then
             if (quantity(i,j,isigm) .ge. sreliable) then
               nwreliablelevel = nwreliablelevel + 1
             endif
             if (quantity(i,j,isigm) .ge. stentative) then
               nwtentativelevel = nwtentativelevel + 1
             endif
           endif
         enddo
         if (nwtentativelevel .ge. max ( nwavesdetect, 1 ) .or. nwreliablelevel .ge. 1) then
           lnotdetection = .false.
         endif

! Definition of the global goodness.

         goodness = 1.0d0
         lnormalgood(j) = .true.
         if (flag(1,j) .ne. 'n') then
           if (liter_phase3) then
             reliamax = 1.0d0 * stentative
             reliamin = 0.0d0 * stentative
             segmask_elongation = max ( quantity(1,j,ielon) - 1.0d0, 1.0d0 )
             source_elongation = max ( globelong(j) - 0.3d0, 1.0d0 )
             reliability = quantity(1,j,isigg) * min ( snrglobal(j), 1.0d0 ) / (segmask_elongation * source_elongation)
             goodness = 0.0d0
             if (reliability .gt. reliamin) then
               goodness = min ( (reliability - reliamin) / (reliamax - reliamin), 9.990d0 )
             endif
             if (goodness .ge. 1.0d0) then
               lnormalgood(j) = .true.
             else                     
               lnormalgood(j) = .false.
             endif
             if (loneormoresnhigh) then
               quantity(1,j,igodn) = goodness
             else
               quantity(1,j,igodn) = -goodness
             endif
             write (cgood,'(f5.2)') goodness
             igod = lastc ( cgood )
           else
             quantity(1,j,igodn) = 1.11d0
           endif
         endif

         cbigwave = ' '
         icgw = 0
         do i=1,nwaves
           if (liter_phase2 .or. liter_phase3) then
             if (liter_phase2) then
               maxsizex = quantity(i,j,ifooa)
             else
               maxsizex = max ( sourcemaxsize(i), aperture(i) )
             endif
             lnormalsize(i,j) = .false.
             sizemean = (quantity(i,j,iafwh) + quantity(i,j,ibfwh)) / 2.0d0
             if (flag(i,j) .ne. 'n') then
               if (sizemean .gt. max ( quantity(i,j,iscsx), obsbeam(i), aperture(i) )) then
                 quantity(i,j,ifmon) = quantity(i,j,ifmon) + 1.0d0
               endif
               if (sizemean .gt. maxsizex) then
                 quantity(i,j,ifmon) = quantity(i,j,ifmon) + 2.0d0
                 write (cwav,'(i2.2)') i
                 cbigwave = cbigwave(1:icgw)//' '//cwav
                 icgw = lastc ( cbigwave )
               else
                 lnormalsize(i,j) = .true.
               endif
             endif
           else
             lnormalsize(i,j) = .true.
           endif
         enddo

         ltoobig = .false.
         if (liter_phase3) then
           nwtoobig = 0
           do i=1,nwaves
             if (ldetectionwave(i) .and. flag(i,j) .ne. 'n') then
               maxsizex = max ( sourcemaxsize(i), aperture(i) )
               sizemean = (quantity(i,j,iafwh) + quantity(i,j,ibfwh)) / 2.0d0
               if (sizemean .gt. maxsizex) then
                 nwtoobig = nwtoobig + 1
               endif
             endif
           enddo
           if (nwtoobig .eq. ndetwaves) then
             ltoobig = .true.
           endif
         endif
           
         cbadwave = ' '
         icbw = 0
         if (liter_phase2) then
           snratio1min = snr1min / 2.0d0
           snratio2min = snr2min / 2.0d0
         endif
         if (liter_phase3) then
           snratio1min = snr1min
           snratio2min = snr2min
         endif
         do i=1,nwaves
           if (liter_phase2 .or. liter_phase3) then
             lgoodatwave(i,j) = .false.
             if (flag(i,j) .ne. 'n') then
               if (abs ( quantity(i,j,ifxpb) ) .lt. snratio1min * quantity(i,j,ifxpe) .or.
     &             abs ( quantity(i,j,ifxtb) ) .lt. snratio2min * quantity(i,j,ifxte)) then
                 write (cwav,'(i2.2)') i
                 cbadwave = cbadwave(1:icbw)//' '//cwav
                 icbw = lastc ( cbadwave )
                 if (abs ( quantity(i,j,ifxpb) ) .lt. snratio1min * quantity(i,j,ifxpe)) then
                   quantity(i,j,ifmon) = quantity(i,j,ifmon) + 10.0d0
                 endif
                 if (abs ( quantity(i,j,ifxtb) ) .lt. snratio2min * quantity(i,j,ifxte)) then
                   quantity(i,j,ifmon) = quantity(i,j,ifmon) + 20.0d0
                 endif
               else
                 lgoodatwave(i,j) = .true.
               endif
             endif
           else
             lgoodatwave(i,j) = .true.
           endif
         enddo

         clowwave = ' '
         iclw = 0
         do i=1,nwaves
           lhighatwave(i,j) = .false.
           if (flag(i,j) .ne. 'n') then
             if (quantity(i,j,isigm) .ge. stentative) then
               lhighatwave(i,j) = .true.
             elseif (abs ( quantity(i,j,isigm) ) .lt. stentative) then
               quantity(i,j,ifmon) = quantity(i,j,ifmon) + 200.0d0
               write (cwav,'(i2.2)') i
               clowwave = clowwave(1:iclw)//' '//cwav
               iclw = lastc ( clowwave )
             endif
           endif
         enddo

! Indicate which condition led to the decision to comment the sources out. Count the number of bad sources.
           
         if (lallnoise .or. lnotdetection .or. ltooclose .or. ltoobig) then
           cno(j)(1:1) = '!'
           nextrbad = nextrbad + 1
           nextrbadnew = nextrbad
           comment(j) = '  #'
           lcno = 3
           if (lallnoise) then
             lcno = lastc ( comment(j) )
             comment(j) = comment(j)(1:lcno)//' background or noise,'
           elseif (lnotdetection) then
             lcno = lastc ( comment(j) )
             comment(j) = comment(j)(1:lcno)//' too few detectable waves (< '//cnwd(1:inwd)//'),'
           elseif (ltooclose) then
             lcno = lastc ( comment(j) )
             comment(j) = comment(j)(1:lcno)//' position occupied by sources:'//coccup(1:iocc)//','
           elseif (ltoobig) then
             lcno = lastc ( comment(j) )
             comment(j) = comment(j)(1:lcno)//' too large at all detection waves,'
           endif
         endif

! Count tentative sources.

         if (.not.lallnoise .and. .not.lnotdetection .and. .not.ltooclose .and. .not.ltoobig) then
           if (cno(j)(1:1) .ne. '!' .and. .not.loneormoresnhigh) then
             ntentative = ntentative + 1
           endif
         endif
       enddo

       if (ltiming) then
         cput_flagsources = cput_flagsources + timer ( 'cpu', cpu_flagsources )
         walt_flagsources = walt_flagsources + timer ( 'wal', wal_flagsources )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       nextrgoodnew = nextr(1) - nextrbadnew
     
       do i=1,nwaves
         obsname(i) = cat(i)(idot1+1:idot4-1)//'.fits'
         iobs(i) = lastc ( obsname(i) )
         inquire ( file=obsname(i)(1:iobs(i)), exist=lfname )
         if (.not.lfname) goto 93
       enddo
       goto 897
 93    continue
       if (.not.lfname) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obsname(i)(1:iobs(i))//''' not found.'
         stop 34
       endif
 897   continue

       do i=1,nwaves
         obsfsname(i) = cat(i)(idot1+1:idot4-1)//'.fs.fits'
         iobsfs(i) = lastc ( obsfsname(i) )
         inquire ( file=obsfsname(i)(1:iobsfs(i)), exist=lfname )
         if (.not.lfname) goto 94
       enddo
       
       goto 797
 94    continue
       if (.not.lfname) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obsfsname(i)(1:iobsfs(i))//''' not found.'
         stop 35
       endif
 797   continue
        
       do i=1,nwaves
         obsbsfsname(i) = cat(i)(idot1+1:idot4-1)//'.bs.fs.fits'
         iobsbsfs(i) = lastc ( obsbsfsname(i) )
         inquire ( file=obsbsfsname(i)(1:iobsbsfs(i)), exist=lfname )
         if (.not.lfname) goto 95
       enddo
       
       goto 697
 95    continue
       if (.not.lfname) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obsbsfsname(i)(1:iobsbsfs(i))//''' not found.'
         stop 36
       endif
 697   continue
       
! Determine numbers of pixels in the 1st FITS image.

       call getnumpix ( obsname(1)(1:iobs(1)), nx, ny )

! Determine sources that are blended (overlapping with their footprints by an area larger than 20%) 
! in at least one band.

       if (lfinishing_mode) then

         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Identifying and flagging special cases...'
     
         if (ltiming) then
           cpu_substructured = timer ( 'cpu', 0.0d0 )
           wal_substructured = timer ( 'wal', 0.0d0 )
         endif
     
         allocate ( ellipsearea(nwaves,nextr(1)), intersection(nextr(1)), intersectionff(nextr(1)), stat=irc )
         
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (80).'
           stop 80
         endif
     
! Compute areas of the footprint ellipses for all extracted sources.

         do j=1,nextr(1)
           if (flag(1,j) .ne. 'n' .and. cno(j)(1:1) .ne. '!') then
             do i=1,nwaves
               semimajor = quantity(i,j,ifooa) / 2.0d0
               nr = nint ( semimajor / pixsize )
               l0 = nint ( quantity(1,j,ixcopx) )
               m0 = nint ( quantity(1,j,iycopx) )
               l1 = max ( l0 - nr , 1 )
               l2 = min ( l0 + nr , nx )
               m1 = max ( m0 - nr , 1 )
               m2 = min ( m0 + nr , ny )
               ellipsearea(i,j) = 0
               do m=m1,m2
                 dblm = dble ( m )
                 do l=l1,l2
                   dbll = dble ( l )
                   if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,j,ixcopx), quantity(1,j,iycopx)
     &                           , quantity(i,j,ifooa), quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                     ellipsearea(i,j) = ellipsearea(i,j) + 1
                   endif
                 enddo
               enddo
             enddo
           endif
         enddo
         
         ff = 0.50d0
             
         do j=1,nextr(1)
       
           icsw = 0
           if (flag(1,j) .ne. 'n' .and. cno(j)(1:1) .ne. '!') then
             csubwave = ' '
       
             do k=1,nextr(1)
               if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                 dist2peaks(k) = (quantity(1,j,ixcopx) - quantity(1,k,ixcopx))**2 + (quantity(1,j,iycopx) - quantity(1,k,iycopx))**2
               endif
             enddo

! Consider all wavelengths in turn.

             do i=1,nwaves
               semimajor = quantity(i,j,ifooa) / 2.0d0
               nr = nint ( semimajor / pixsize )
               l0 = nint ( quantity(1,j,ixcopx) )
               m0 = nint ( quantity(1,j,iycopx) )
               l1 = max ( l0 - nr , 1 )
               l2 = min ( l0 + nr , nx )
               m1 = max ( m0 - nr , 1 )
               m2 = min ( m0 + nr , ny )

               do k=1,nextr(1)
                 if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                   intersection(k) = 0
                   intersectionff(k) = 0
                   dist2foots(k) = (quantity(i,j,ifooa) / 2.0d0 + quantity(i,k,ifooa) / 2.0d0)**2
                 endif
               enddo
          
               do m=m1,m2
                 dblm = dble ( m )
                 do l=l1,l2
                   dbll = dble ( l )

! Compute intersection area for all sources that intersect with the current source 'j'.

                   if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,j,ixcopx), quantity(1,j,iycopx)
     &                           , quantity(i,j,ifooa), quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                     do k=1,nextr(1)
                       if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                         if (dist2peaks(k) .lt. dist2foots(k) / dx) then
                           if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,k,ixcopx), quantity(1,k,iycopx)
     &                                   , quantity(i,k,ifooa), quantity(i,k,ifoob), quantity(i,k,ifoot) )) then
                             intersection(k) = intersection(k) + 1
                           endif
                         endif
                       endif
                     enddo
                   endif

! Compute full intersection areas of all sources that intersect with the central radial fraction 'ff' of the current source 'j'.

                   if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,j,ixcopx), quantity(1,j,iycopx)
     &                           , ff * quantity(i,j,ifooa), ff * quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                     do k=1,nextr(1)
                       if (k .ne. j .and. flag(1,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then
                         if (dist2peaks(k) .lt. dist2foots(k) / dx) then
                           if (inellipse ( dbll, dblm, pixsize, pixsize, quantity(1,k,ixcopx), quantity(1,k,iycopx)
     &                                   , quantity(i,k,ifooa), quantity(i,k,ifoob), quantity(i,k,ifoot) )) then
                             intersectionff(k) = intersectionff(k) + 1
                           endif
                         endif
                       endif
                     enddo
                   endif
                 enddo
               enddo

! Flag sub-structured and blended sources. Substructured are also necessarily blended.

               do k=1,nextr(1)
                 if (k .ne. j .and. flag(i,k) .ne. 'n' .and. cno(k)(1:1) .ne. '!') then

! Sub-structured (footprint of at least one smaller source is fully within the footprint of the large source) in at least one band.

                   if (intersectionff(k) .gt. 0) then
                     if (ellipsearea(i,k) .gt. 0 .and. intersectionff(k) .eq. ellipsearea(i,k)) then
                       quantity(1,j,iflag) = 2.0d0
                       quantity(1,k,iflag) = 3.0d0

! Monochromatic flag for substructured sources is only raised when the substructuring sources are measurable.
     
                       if (quantity(i,k,ifxpb) .gt. almostzero .and. quantity(i,k,ifxpe) .gt. almostzero .and.
     &                     quantity(i,k,ifxpb) .gt. quantity(i,k,ifxpe)) then
                           quantity(i,j,iflag) = 2.0d0
                           quantity(i,k,iflag) = 3.0d0
                       endif
                     endif
                   endif

! Flag blended sources (overlapping in the one or the other footprint by an area larger than 20%) in at least one band.

                   if (intersection(k) .gt. 0) then
                     if (ellipsearea(i,k) .gt. 0 .and. ellipsearea(i,j) .gt. 0) then 
                       if (dble ( intersection(k) ) .gt. 0.2d0 * dble ( ellipsearea(i,j) ) .or.
     &                     dble ( intersection(k) ) .gt. 0.2d0 * dble ( ellipsearea(i,k) )) then
                         if (nint ( abs ( quantity(i,j,iflag) ) ) .lt. 2) then
                           quantity(i,j,iflag) = 1.0d0
                         endif
                       endif
                     endif
                   endif
                 endif
               enddo      

               if (flag(i,j) .ne. 'n') then
                 if (nint ( abs ( quantity(i,j,iflag) ) ) .eq. 2) then
                   write (cwav,'(i2.2)') i
                   csubwave = csubwave(1:icsw)//' '//cwav
                   icsw = lastc ( csubwave )
                   lsubatwave(i,j) = .true.
                   if (nint ( quantity(i,j,ifmon) ) .lt. 200) then
                     quantity(i,j,ifmon) = quantity(i,j,ifmon) + 100.0d0
                   endif
                 endif
               endif      
             enddo        
           endif          
         enddo
     
         deallocate ( ellipsearea, intersection, intersectionff )
     
         if (ltiming) then
           cput_substructured = cput_substructured + timer ( 'cpu', cpu_substructured )
           walt_substructured = walt_substructured + timer ( 'wal', wal_substructured )
         endif
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_semifinalcat = timer ( 'cpu', 0.0d0 )
         wal_semifinalcat = timer ( 'wal', 0.0d0 )
       endif

       itot = 1
       ibad = 1
       igood = 1
       itent = 1
       irely = 1
       write (cnextrbad,'(i5)') nextrbad
       if (cnextrbad(1:1) .eq. ' '   ) ibad = 2
       if (cnextrbad(1:2) .eq. '  '  ) ibad = 3
       if (cnextrbad(1:3) .eq. '   ' ) ibad = 4
       if (cnextrbad(1:4) .eq. '    ') ibad = 5
       nextrgood = nextr(1) - nextrbad
       write (cnextrgood,'(i5)') nextrgood
       if (cnextrgood(1:1) .eq. ' '   ) igood = 2
       if (cnextrgood(1:2) .eq. '  '  ) igood = 3
       if (cnextrgood(1:3) .eq. '   ' ) igood = 4
       if (cnextrgood(1:4) .eq. '    ') igood = 5
       write (cntentative,'(i5)') ntentative
       if (cntentative(1:1) .eq. ' '   ) itent = 2
       if (cntentative(1:2) .eq. '  '  ) itent = 3
       if (cntentative(1:3) .eq. '   ' ) itent = 4
       if (cntentative(1:4) .eq. '    ') itent = 5
       nreliable = nextrgood - ntentative
       write (cnreliable,'(i5)') nreliable
       if (cnreliable(1:1) .eq. ' '   ) irely = 2
       if (cnreliable(1:2) .eq. '  '  ) irely = 3
       if (cnreliable(1:3) .eq. '   ' ) irely = 4
       if (cnreliable(1:4) .eq. '    ') irely = 5
       write (cnextr,'(i5)') nextr(1)
       if (cnextr(1:1) .eq. ' '   ) itot = 2
       if (cnextr(1:2) .eq. '  '  ) itot = 3
       if (cnextr(1:3) .eq. '   ' ) itot = 4
       if (cnextr(1:4) .eq. '    ') itot = 5
       
! Read in the configuration file of GETSOURCES just for documenting catalogs.

       inquire ( file='+getsources.cfg', exist=lfname )
       if (.not.lfname) then
         inquire ( file='+GETSOURCES.CFG', exist=lfname )
         if (.not.lfname) then
           inquire ( file='+getsources.'//cwave(1)//'.cfg', exist=lfname )
           if (.not.lfname) then
             inquire ( file='+GETSOURCES.'//cwave(1)//'.CFG', exist=lfname )
             if (.not.lfname) then
               write (iotty,'(/a)') '   WARNING: Config file for GETSOURCES not found.'
               cfgfile = ''
             else
               cfgfile='+GETSOURCES.'//cwave(1)//'.CFG'
             endif
           else
             cfgfile='+getsources.'//cwave(1)//'.cfg'
           endif
         else
           cfgfile = '+GETSOURCES.CFG'
         endif                  
       else
         cfgfile = '+getsources.cfg'
       endif
       lcfg = lastc ( cfgfile )
       ncfglines = 0
              
       if (lfname) then
         open ( 25, file=cfgfile(1:lcfg), status='old' )
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading configuration file '''//cfgfile(1:lcfg)//'''...'
         do i=1,200
           read (25,'(a)',end=98,err=90) cfgline(i)
         enddo
  90     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble reading file '''//cfgfile(1:lcfg)//'''.'
         close (25)
         stop 99
  98     continue
         close (25)
         ncfglines = i - 1
       endif

! Prepare header lines for the final output catalog.
       
       m = 0
       do k=1,nhead(1)
         lhl = lastc ( headline(1,k) )
         ncolumn = index ( headline(1,k)(1:lhl), '# Configuration parameters ' )
         if (ncolumn .eq. 0) then
           ncolumn = index ( headline(1,k)(1:lhl), '# CONFIGURATION PARAMETERS ' )
         endif
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
           m = m + 1
           headlineout(m) = '!'
           do kk=9,ncfglines-1
             m = m + 1
             lh = lastc ( cfgline(kk) )
             headlineout(m) = '!'//cfgline(kk)(1:lh)
           enddo
           nconfigend = m
           m = m + 1
           lhl = lastc ( headline(1,k-2) )
           headlineout(m) = '!'//headline(1,k-2)(2:lhl)
           m = m + 1
           headlineout(m) = '!'
         endif
       
         ncolumn = index ( headline(1,k)(1:lhl), '# SCALES: ' )
         if (ncolumn .gt. 0) then
           do kk=1,100
             m = m + 1
             lh = lastc ( headline(1,k+kk-1) )
             headlineout(m) = '!'//headline(1,k+kk-1)(2:lh)
             if (headlineout(m)(1:10) .eq. '!_________') then
               m = m + 1
               headlineout(m) = '!'
               goto 17
             endif
           enddo
           write (iotty,'(/a)') '   FINALCAT: ERROR: Portion of the header not found (17).'
           stop 99
 17        continue
         endif
       
         ncolumn = index ( headline(1,k)(1:lhl), '# Tabulated quantities' )
         if (ncolumn .eq. 0) then
           ncolumn = index ( headline(1,k)(1:lhl), '# TABULATED QUANTITIES' )
         endif

         if (ncolumn .gt. 0) then
           nbra2 = index ( headline(1,k)(1:lhl), ' bad):' )
           if (nbra2 .eq. 0) then
             nbra2 = index ( headline(1,k)(1:lhl), ' BAD):' )
           endif
           if (nbra2 .gt. 0) then
             nplus = index ( headline(1,k)(nbra2-15:nbra2), '+' )
             if (nplus .gt. 0) then
               nplus = nbra2 - 16 + nplus
               nbra1 = index ( headline(1,k)(nplus-15:nplus), '(' )
               if (nbra1 .gt. 0) then
                 nbra1 = nplus - 16 + nbra1
                 read (headline(1,k)(nbra1+1:nplus-7),*) nextrgoodold
                 read (headline(1,k)(nplus+2:nbra2-1),*) nextrbadold
                 nbra1 = nbra1 - 2
                 nbra2 = index ( headline(1,k)(nbra1-4:nbra1+3), ' bad)' )
                 if (nbra2 .eq. 0) then
                   nbra2 = index ( headline(1,k)(nbra1-4:nbra1+3), ' BAD)' )
                 endif
                 if (nbra2 .gt. 0) then
                   nbra2 = nbra2 + nbra1 - 4 - 1
                   nplus = index ( headline(1,k)(nbra2-15:nbra2), '+' )
                   if (nplus .gt. 0) then
                     nplus = nbra2 - 16 + nplus
                     nbra1 = index ( headline(1,k)(nplus-15:nplus), '(' )
                     if (nbra1 .gt. 0) then
                       nbra1 = nplus - 16 + nbra1
                       read (headline(1,k)(nbra1+1:nplus-7),*) nextrgoodvold
                       read (headline(1,k)(nplus+2:nbra2-1),*) nextrbadvold
                     endif
                   endif
                 endif
               endif
             endif
           endif
           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Total number of sources: '//cnextr(itot:5)
     &                         //' ('//cnextrgood(igood:5)//' good + '//cnextrbad(ibad:5)//' bad)'
           endif

           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl-1)//' ('//cnextrgood(igood:5)//' good + '//cnextrbad(ibad:5)//' bad):'
           m = m + 1
           headlineout(m) = '!'
         endif

         ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(1)(1:2) )
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
         endif
         ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(2)(1:2) )
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
         endif
         ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(3)(4:5) )
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'//headline(1,k)(2:lhl)
         endif

! Some of the column headers have to be shortened.
       
         do l=4,nquantities
           ncolumn = index ( headline(1,k)(1:lhl), '#   '//colhead(l)(1:lencolh(l)) )
           if (ncolumn .gt. 0) then
             m = m + 1
             headlineout(m) = '!'//headline(1,k)(2:lhl)
             ncolumn = index ( headlineout(m), '(MJy/sr)' )
             if (ncolumn .gt. 0) then
               lcf = lastc ( conversionfacts )
               headlineout(m) = headlineout(m)(1:ncolumn-1)//'(Jy/beam_obs)'//conversionfacts(1:lcf)
             endif
             if (l .eq. ixcopx .or. l .eq. iycopx) then
               ncolumn = index ( headlineout(m), 'IXEL' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+4) = ' ....'
               endif
             endif
             if (l .eq. ixcoas .or. l .eq. iycoas) then
               ncolumn = index ( headlineout(m), 'XCO_PIXRO' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+8) = 'XCO_R ...'
               endif
               ncolumn = index ( headlineout(m), 'YCO_PIXRO' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+8) = 'YCO_R ...'
               endif
             endif
             if (l .eq. ifxpe .or. l .eq. ifxte) then
               ncolumn = index ( headlineout(m), '_ERROR' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn+5:ncolumn+6) = ' .'
               endif
             endif
             if (l .eq. ifxtg) then
               ncolumn = index ( headlineout(m), '_GAUSS' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn+5:ncolumn+6) = ' .'
               endif
             endif
             if (l .eq. iscsx) then
               ncolumn = index ( headlineout(m), '_SX' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+3) = ' ...'
               endif
             endif
             if (l .ge. iafwh .and. l .le. ithep) then
               ncolumn = index ( headlineout(m), '_MOM' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+4) = ' ....'
               endif
             endif
             if (l .eq. irade) then
               ncolumn = index ( headlineout(m), 'QUIV' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+5) = ' .....'
               endif
             endif
             if (l .eq. ifofa) then
               ncolumn = index ( headlineout(m), 'FOOT_FACT' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+13) = 'FOFA .........'
               endif
             endif
             if (l .eq. ifooa) then
               ncolumn = index ( headlineout(m), 'FOOAMAJOR' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+13) = 'FOOA .........'
               endif
             endif
             if (l .eq. ifoob) then
               ncolumn = index ( headlineout(m), 'FOOBMINOR' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+13) = 'FOOB .........'
               endif
             endif
             if (l .eq. ifoot) then
               ncolumn = index ( headlineout(m), 'FOOTHEPAN' )
               if (ncolumn .gt. 0) then
                 headlineout(m)(ncolumn:ncolumn+13) = 'FOOT .........'
               endif
             endif
           endif
         enddo

! Prepare output line with columns' headers.
       
         ncolumn = index ( headline(1,k)(1:lhl), colhead(1)(1:lencolh(1)) )
         if (ncolumn .gt. 0) then
           m = m + 1
           headlineout(m) = '!'
           m = m + 1
           headlineout(m) = '!   '//colhead(1)(1:lencolh(1))//' '//colhead(4)(1:lencolh(4))
           lhlo = 4 + lencolh(1) + lencolh(4) + 3

! Headers for the coordinates columns.

           l = ixcopx
           colheadout(l) = ' '//colhead(l)(1:5)//'  '
           lencolhout(l) = 8
           headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)
           l = iycopx
           colheadout(l) = ' '//colhead(l)(1:5)//'   '
           lencolhout(l) = 9
           headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)
           if (lwcscoord) then
             lhlo = lhlo - 1
             l = ixcoas
             colheadout(l) = colhead(l)//'  '
             lencolhout(l) = 11
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)
             l = iycoas
             colheadout(l) = colhead(l)//'  '
             lencolhout(l) = 11
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)
           else
             l = ixcoas
             colheadout(l) = colhead(l)(1:5)//'   '
             lencolhout(l) = 8
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)
             l = iycoas
             colheadout(l) = colhead(l)(1:5)//'  '
             lencolhout(l) = 7
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)
           endif
           l = isigg
           colheadout(l) = colhead(l)(1:8)//'   '
           lencolhout(l) = 10
           headlineout(m) = headlineout(m)(1:lhlo)//' '//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)
           l = iflag
           colheadout(l) = colhead(l)(1:lencolh(l))//'  '
           lencolhout(l) = lencolh(l)
           headlineout(m) = headlineout(m)(1:lhlo)//' '//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)
           l = igodn
           colheadout(l) = colhead(l)(1:5)//' '
           lencolhout(l) = 6
           headlineout(m) = headlineout(m)(1:lhlo)//' '//colheadout(l)(1:lencolhout(l))
           lhlo = lhlo + lencolhout(l)

           lhlo = lhlo + 1
           headlineout(m)(lhlo:lhlo) = ' '

! Headers for the fluxes.

           do i=1,nwaves
             write (colhead(isigm)(9:10),'(i2.2)') i
             colheadout(isigm) = colhead(isigm)(1:10)//' '
             lencolhout(isigm) = 11
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(isigm)(1:lencolhout(isigm))
             lhlo = lhlo + lencolhout(isigm)
             write (colhead(ifmon)(3:4),'(i2.2)') i
             colheadout(ifmon) = colhead(ifmon)(1:lencolh(ifmon)+1)//' '
             lencolhout(ifmon) = 5
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(ifmon)(1:lencolhout(ifmon))
             lhlo = lhlo + lencolhout(ifmon)
             do l=ifxpb,ifxtg
               if (l .eq. ifxtg .or. l .eq. ifxpe .or. l .eq. ifxte) then
                 write (colhead(l)(9:10),'(i2.2)') i
                 colheadout(l) = colhead(l)(1:lencolh(l))//' '
                 lencolhout(l) = 11
               else
                 write (colhead(l)(lencolh(l):lencolh(l)+1),'(i2.2)') i
                 colheadout(l) = colhead(l)(1:lencolh(l)+1)//' '
                 if (l .eq. ifxpb .or. l .eq. ifxtb) then
                   lencolhout(l) = lencolh(l) + 2
                 else
                   lencolhout(l) = lencolh(l) + 1
                 endif
               endif
               headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
               lhlo = lhlo + lencolhout(l)
             enddo
                                       
             colheadout(iscsx) = colhead(iscsx)(1:lencolh(iscsx))
             lencolhout(iscsx) = lencolh(iscsx)
             write (colhead(iscsx)(6:7),'(i2.2)') i
             colheadout(iscsx) = colhead(iscsx)(1:7)//' '
             lencolhout(iscsx) = 9
             headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
             lhlo = lhlo + lencolhout(l)

             do l=iafwh,ithep
               colheadout(l) = colhead(l)(1:lencolh(l))
               lencolhout(l) = lencolh(l)
               write (colhead(l)(5:6),'(i2.2)') i
               colheadout(l) = colhead(l)(1:6)//'  '
               lencolhout(l) = 8
               headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
               lhlo = lhlo + lencolhout(l)
             enddo
             
! Headers for the remaining part.
    
             do l=irade,nquantities
               colheadout(l) = colhead(l)(1:lencolh(l))
               lencolhout(l) = lencolh(l)
               if (l .eq. ifofa) then
                 write (colhead(l)(5:6),'(i2.2)') i
                 colheadout(l) = 'FOFA'//colhead(l)(5:6)//'  '
                 lencolhout(l) = 8
               else
                 write (colhead(l)(5:6),'(i2.2)') i
                 colheadout(l) = colhead(l)(1:6)//'  '
                 lencolhout(l) = 8
               endif
               headlineout(m) = headlineout(m)(1:lhlo)//colheadout(l)(1:lencolhout(l))
               lhlo = lhlo + lencolhout(l)
             enddo
           enddo
           headlineout(m) = headlineout(m)(1:lhlo)
           m = m + 1
           headlineout(m) = '!'
         endif
       enddo
       nheadout = m
       headlineout(nheadout) = '!~'

       allocate ( catlinereliable(nextr(1)), catlinerelitent(nextr(1)), colorlinereliable(nextr(1)), colorlinerelitent(nextr(1))
     &          , stat=irc )
       
       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (72).'
         stop 72
       endif

! Write the semifinal catalog's header.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//semifinalcatname(1:isemi)//'''...'
       
       open ( 15, file=semifinalcatname(1:isemi), status='unknown' )
       
       id = index ( detimagestring(1:ide), '.sw.det.' ) + 7
       ie = index ( detimagestring(id+1:), 'as.an.' ) + 2 + id
       
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       write (15,'(a)') '!'//getstitle(2:)
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       write (15,'(a)') '! Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
       write (15,'(a)') '! Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (15,'(a)') '! Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence '
     &                //'(william.d.pence@nasa.gov)'
       write (15,'(a)') '! and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
       write (15,'(a)') '!'
       write (15,'(a)') '! SEMIFINAL CATALOG OF SOURCES'
       write (15,'(a)') '!'
       write (15,'(a)') '! detected in '//detimagestring(1:id)//'*'//detimagestring(ie:ide)

       do i=1,ndetwaves
         ica = lastc ( detimageline(i) )
         write (15,'(a)') '!'//detimageline(i)(1:ica)
       enddo
       
       do i=1,nwaves
         if (i .eq. 1) then
           write (15,'(a)') '! measured in '//obsimagestring(i)(1:iob(i))
         else
           write (15,'(a)') '!      and in '//obsimagestring(i)(1:iob(i))
         endif
         foomax(i) = 0.0d0
       enddo
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       do m=1,nheadout-4
         ic = lastc ( headlineout(m) )
         write (15,'(a)') headlineout(m)(1:ic)
       enddo
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       if (lwcscoord) then
         write (15,'(a,28x,'//cnwaves//'(115x,a,22x))') '!',(cwave(i)//' um',i=1,nwaves)
         write (15,'(a,73x,'//cnwaves//'(2x,a))') '!',(cbar(i),i=1,nwaves)
       else
         write (15,'(a,22x,'//cnwaves//'(115x,a,22x))') '!',(cwave(i)//' um',i=1,nwaves)
         write (15,'(a,67x,'//cnwaves//'(2x,a))') '!',(cbar(i),i=1,nwaves)
       endif
                                  
! Write the line with columns' headers.

       do m=nheadout-2,nheadout
         ic = lastc ( headlineout(m) )
         write (15,'(a)') headlineout(m)(1:ic)
       enddo

! Write the semifinal catalog columns commenting out bad entries.

       do j=1,nextr(1)
         lcno = lastc ( comment(j) ) - 1
         write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
         do i=1,nwaves
           write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
           if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
         enddo
         
         write (15,'(a,3i3,1x,2f8.1,'//fmtwcs//',(1pe11.3),a3,0pf6.2,'//cnwaves
     &           //'(1x,1pe11.3,a5,5(1pe11.3),5(0pf8.1),f8.2,3(f8.1)),a)') 
     &              cno(j), ns1(1,j), ns2(1,j), nsx(1,j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(1,j,l), l=ixcoas,iycoas)
     &            , quantity(1,j,isigg), cflag, quantity(1,j,igodn), (quantity(i,j,isigm), cfmflag(i)
     &            , (factor(i,j,l) * quantity(i,j,l), l=ifxpb,ifxtg), (quantity(i,j,l), l=iscsx,nquantities), i=1,nwaves)
     &            , comment(j)(1:lcno)
       enddo

       close ( 15 )

! Gather some statistics.

       if (lfinishing_mode) then
         nnoisebgr = 0
         nnotdetec = 0
         nspurious = 0
         nposition = 0
         ntoolarge = 0
         nsubstruc = 0
  
         do j=1,nextr(1)
           if (cno(j)(1:1) .eq. '!') then
             lcno = lastc ( comment(j) ) - 1
             if (index ( comment(j)(1:lcno), ' background or noise' ) .gt. 0) nnoisebgr = nnoisebgr + 1
             if (index ( comment(j)(1:lcno), ' too few detectable'  ) .gt. 0) nnotdetec = nnotdetec + 1
             if (index ( comment(j)(1:lcno), ' spurious (goodness'  ) .gt. 0) nspurious = nspurious + 1
             if (index ( comment(j)(1:lcno), ' position occupied'   ) .gt. 0) nposition = nposition + 1
             if (index ( comment(j)(1:lcno), ' too large at all'    ) .gt. 0) ntoolarge = ntoolarge + 1
           endif
         enddo
           
         do j=1,nextr(1)
           if (cno(j)(1:1) .ne. '!') then
             do i=1,nwaves
               write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
               if (cfmon(1:1) .eq. '1') then
                 nsubstruc = nsubstruc + 1
                 exit
               endif
             enddo
           endif
         enddo
             
! Find maximum source size over all good, detectable, measurable, positive sources at each wave.

         do i=1,nwaves
           do j=1,nextr(1)
             if (cno(j)(1:1) .ne. '!') then
               write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
               if ((cfmon(1:3) .eq. '000' .or. cfmon(1:2) .eq. '10') .and. quantity(1,j,igodn) .gt. 1.50d0 .and.
     &             lhighatwave(i,j) .and. lgoodatwave(i,j) .and. lnormalsize(i,j) .and. lnormalgood(j) .and.
     &             quantity(i,j,ifxpb) .gt. almostzero .and. quantity(i,j,ifxtb) .gt. almostzero) then
                 dfoo = min ( 1.2d0 * max ( quantity(i,j,iafwh), obsbeam(i) ), quantity(i,j,ifooa) )
                 if (dfoo .gt. foomax(i)) then
                   foomax(i) = dfoo
                 endif
               endif
             endif
           enddo

! Soften the criteria if no maximum size has been found at this wave.

           if (foomax(i) .lt. almostzero) then
             do j=1,nextr(1)
               if (cno(j)(1:1) .ne. '!') then
                 write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
                 if ((cfmon(1:3) .eq. '000' .or. cfmon(1:2) .eq. '10') .and.
     &               lgoodatwave(i,j) .and. lnormalsize(i,j) .and. lnormalgood(j) .and.
     &               quantity(i,j,ifxpb) .gt. almostzero .and. quantity(i,j,ifxtb) .gt. almostzero) then
                   dfoo = min ( 1.2d0 * max ( quantity(i,j,iafwh), obsbeam(i) ), quantity(i,j,ifooa) )
                   if (dfoo .gt. foomax(i)) then
                     foomax(i) = dfoo
                   endif
                 endif
               endif
             enddo
           endif
         enddo

         open ( 65, file='+log.SUMMARY', status='unknown' )
         
         write (65,'(a,i6)') ' totalbad:', nextrbad
         write (65,'(a,i6)') ' noisebgr:', nnoisebgr
         write (65,'(a,i6)') ' notdetec:', nnotdetec
         write (65,'(a,i6)') ' spurious:', nspurious
         write (65,'(a,i6)') ' position:', nposition
         write (65,'(a,i6)') ' toolarge:', ntoolarge
         write (65,'(a,i6)') ' totalgod:', nextrgood
         write (65,'(a,i6)') ' substruc:', nsubstruc

         do i=1,nwaves
           write (cwav,'(i2.2)') i
           write (65,'(a,1x,f7.1)') ' foomax_'//cwav//':', foomax(i)
         enddo
         
         close ( 65 )
       endif

       if (ltiming) then
         cput_semifinalcat = cput_semifinalcat + timer ( 'cpu', cpu_semifinalcat )
         walt_semifinalcat = walt_semifinalcat + timer ( 'wal', wal_semifinalcat )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_finalcats = timer ( 'cpu', 0.0d0 )
         wal_finalcats = timer ( 'wal', 0.0d0 )
       endif

! Write the final catalog's header.

       id = index ( detimagestring(1:ide), '.sw.det.' ) + 7
       ie = index ( detimagestring(id+1:), 'as.an.' ) + 2 + id
                     
       nhrt = 1
       nhr  = 1
       headrelitent(nhrt) = cbars
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'//getstitle(2:)
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = cbars
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                    //'(william.d.pence@nasa.gov)'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu) '
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! CATALOG OF RELIABLE & TENTATIVE SOURCES'
       headreliable(nhr ) = '! CATALOG OF RELIABLE SOURCES'
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! detected in '//detimagestring(1:id)//'*'//detimagestring(ie:ide)
       headreliable(nhr ) = headrelitent(nhrt)

       do i=1,ndetwaves
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         ica = lastc ( detimageline(i) )
         headrelitent(nhrt) = '!'//detimageline(i)(1:ica)
         headreliable(nhr ) = '!'//detimageline(i)(1:ica)
       enddo
       
       allocate ( obsimage(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (73).'
         stop 73
       endif

       do i=1,nwaves
      
! Read image just for getting reference pixel and its coordinates.

         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsimage, dx, dy, object, ra, dec
     &              , obsname(i)(1:iobs(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2
     &              , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
           
         write (ccrpix1,'(1pe12.5)') crpix1
         write (ccrpix2,'(1pe12.5)') crpix2
         write (ccrval1,'(1pe14.7)') crval1
         write (ccrval2,'(1pe14.7)') crval2
         icrp1 = lastc ( ccrpix1 )
         icrp2 = lastc ( ccrpix2 )
         icrv1 = lastc ( ccrval1 )
         icrv2 = lastc ( ccrval2 )
         coordinates = '(crpix1:'//ccrpix1(1:icrp1)//', crpix2:'//ccrpix2(1:icrp2)//','
     &               //' crval1:'//ccrval1(1:icrv2)//', crval2:'//ccrval2(1:icrv2)//')'
         ica = lastc ( coordinates )
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         if (i .eq. 1) then
           headrelitent(nhrt) = '! measured in '//obsimagestring(i)(1:iob(i))//' '//coordinates(1:ica)
           headreliable(nhr ) = headrelitent(nhrt)
         else
           headrelitent(nhrt) = '!      and in '//obsimagestring(i)(1:iob(i))//' '//coordinates(1:ica)
           headreliable(nhr ) = headrelitent(nhrt)
         endif
       enddo
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = cbars
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       do m=1,nheadout-4
         ic = lastc ( headlineout(m) )
         if (index ( headlineout(m)(1:ic), '!   S1 ......' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   S2 ......' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   SX ......' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   FXT_GAUS ' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   SCALE ...' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   RADE ....' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   FOFA ....' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   FOOA ....' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   FOOB ....' ) .eq. 0 .and.
     &       index ( headlineout(m)(1:ic), '!   FOOT ....' ) .eq. 0) then
           nhrt = nhrt + 1
           nhr  = nhr  + 1
           if (headlineout(m)(1:32) .eq. '! Tabulated quantities, total of' .or.
     &         headlineout(m)(1:32) .eq. '! TABULATED QUANTITIES, TOTAL OF') then
             headrelitent(nhrt) = '! TABULATED QUANTITIES, TOTAL OF '//cnextrgood(igood:5)//' GOOD SOURCES ('
     &                          //cnreliable(irely:5)//' RELIABLE + '//cntentative(itent:5)//' TENTATIVE):'
             headreliable(nhr ) = '! TABULATED QUANTITIES, TOTAL OF '//cnreliable(irely:5)//' GOOD RELIABLE SOURCES:'
           elseif (headlineout(m)(1:43) .eq. '!   NO ............ Source''s running number' ) then
             headrelitent(nhrt) = headlineout(m)(1:ic)//' may not be sequential (bad sources excluded)'
             headreliable(nhr ) = headlineout(m)(1:ic)//' may not be sequential (bad sources excluded)'
           else
             headrelitent(nhrt) = headlineout(m)(1:ic)
             headreliable(nhr ) = headlineout(m)(1:ic)
           endif
         endif
       enddo
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! DEFINITIONS AND COMMENTS:'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  1. Catalog entries may have a value of 0.000E+00 for sources outside the observational mask.'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  2. SIG_MONO# has a special value of 9.999E-31 if a source is not visible in clean single scales.'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  3. FX*_BEST# and FX*_ERRO# have a special value of 9.999E-31 if their measurements are < 1.0E-30.'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  4. Monochromatic S/N ratio can be computed from the data columns: SNR_MONO#=FXP_BEST#/FXP_ERRO#.'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  5. Global S/N ratio is defined similarly to SIG_GLOB: SNR_GLOB=sqrt(sum(SNR_MONO#^2)).'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  6. Source is considered tentative when '//csnt(1:isnt)//'<SIG_MONO#<'//csnr(1:isnr)//' at'
     &                    //' all wavelengths used in detection.'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  7. Global goodness GOOD is negative (multiplied by -1) only to indicate tentative sources.'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  8. One should always use only sources with GOOD>1~3: small values may indicate spurious sources.'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  9. Meaning of the global flag FG:'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FG=0 ...... isolated source (not blended with any other source in any waveband)'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FG=1 ...... blended source (footprints intersect by more than 20% in at least one waveband)'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FG=2 ...... sub-structured source (inner 25% area of its footprint contains an entire'
     &                    //' footprint of at least one source)'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FG=3 ...... sub-structuring source (causing a larger source to be flagged as sub-structured)'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! 10. Meaning of the monochromatic flag FM (negative if deblending iterations have not converged):'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#=  0 ... no problems identified for the source at this wavelength #'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#=  1 ... larger than its characteristic scale size:'
     &                    //' AFWHM#>max{OBSBEAM#,SCALE#,APERTURE#}'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#=  2 ... larger than the desired maximum of ['//callsrcmaxsizes(1:iasmx)//']'
     &                    //' arcsec: AFWHM#>max{SRCMAXSIZE#,APERTURE#}'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#=  3 ... larger than both the characteristic size and the desired maximum size or aperture'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#= 10 ... peak intensity is not measurable: FXP_BEST#/FXP_ERRO#<'//csn1(1:isn1)
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#= 20 ... total flux is not measurable: FXT_BEST#/FXT_ERRO#<'//csn2(1:isn2)
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#= 30 ... both total flux and peak intensity are not measurable'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#=100 ... sub-structured (the inner 25% area of its footprint contains'
     &                    //' an entire footprint of at least one measurable source)'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!     FM#=200 ... significance is low: SIG_MONO#<'//csnt(1:isnt)
       headreliable(nhr ) = headrelitent(nhrt)

       if (lapertures) then
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!             __________________________________________________________________ '
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |                                                                  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  You have chosen to apply user-defined MEASUREMENT APERTURES in  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  this extraction. Note that indiscriminate use of the apertures  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  may easily lead to meaningless results, as they would strongly  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  influence the background subtraction and deblending. Since the  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  observed astrophysical backgrounds are highly-variable on all   |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  scales, the fixed apertures may result in overestimating the    |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  fluxes (or sizes) for some sources and in underestimating them  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  for other sources. All this may introduce biases, depending on  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  the actual size and location of a source, that are impossible   |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  to predict in a general case.                                   |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |                                                                  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  THE AUTHOR DOES NOT GUARANTEE CORRECT RESULTS WHEN ARBITRARY    |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  APERTURES ARE USED FOR BACKGROUND SUBTRACTION & MEASUREMENTS.   |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  THIS IS *NOT* A STANDARD WAY OF SOURCE EXTRACTION; ONE HAS TO   |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  TEST THE EFFECTS EXTENSIVELY BEFORE PUBLISHING ANY RESULTS.     |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |                                                                  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  THE USER SHOULD KNOW EXACTLY WHAT IS BEING DONE AND WILL TAKE   |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |  FULL RESPONSIBILITY FOR ACTIVATING THIS FEATURE OF GETSOURCES.  |'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING* |__________________________________________________________________|'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!'
         headreliable(nhr ) = headrelitent(nhrt)
         nhrt = nhrt + 1
         nhr  = nhr  + 1
         headrelitent(nhrt) = '!  *WARNING*  MEASUREMENT APERTURES:'//callapertures(1:iaps)//' ARCSEC'
         headreliable(nhr ) = headrelitent(nhrt)
       endif
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!  __________________________________________________________________ '
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |                                                                  |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |  NEVER USE ALL SOURCES FROM MULTI-WAVELENGTH CATALOGS BLINDLY!   |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |  Select (and use) only significant sources in each waveband, on  |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |  the basis of quantities provided in the catalog. Those are the  |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |  global significance SIG_GLOB, global flag FG and goodness GOOD, |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |  monochromatic significance SIG_MONO and flag FM, as well as the |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |  S/N ratios FXP_BEST/FXP_ERRO, FXT_BEST/FXT_ERRO, and possibly   |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |  the measured sizes AFWHM, BFWHM in one or more wavebands.       |'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '! |__________________________________________________________________|'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       nhrtstand = nhrt
       if (lwcscoord) then
         write (headrelitent(nhrt),'(a,28x,'//cnwaves//'(74x,a))') '!',(cwave(i)//' um',i=1,nwaves)
         write (headreliable(nhr ),'(a,28x,'//cnwaves//'(74x,a))') '!',(cwave(i)//' um',i=1,nwaves)
       else  
         write (headrelitent(nhrt),'(a,22x,'//cnwaves//'(74x,a))') '!',(cwave(i)//' um',i=1,nwaves)
         write (headreliable(nhr ),'(a,22x,'//cnwaves//'(74x,a))') '!',(cwave(i)//' um',i=1,nwaves)
       endif
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       if (lwcscoord) then
         write (headrelitent(nhrt),'(a,64x,'//cnwaves//'(1x,a))') '!',(cbarf(i),i=1,nwaves)
         write (headreliable(nhr ),'(a,64x,'//cnwaves//'(1x,a))') '!',(cbarf(i),i=1,nwaves)
       else
         write (headrelitent(nhrt),'(a,58x,'//cnwaves//'(1x,a))') '!',(cbarf(i),i=1,nwaves)
         write (headreliable(nhr ),'(a,58x,'//cnwaves//'(1x,a))') '!',(cbarf(i),i=1,nwaves)
       endif
                                   
! Write the line with columns' headers.

       ncol = 8
       if (lwcscoord) then
         numbcols = '!    1      2       3        4          5          6      7    8'
         inc = lastc ( numbcols )
         headcols = '!   NO    XCO_P   YCO_P  WCS_ACOOR  WCS_DCOOR  SIG_GLOB  FG  GOOD'
         ihc = lastc ( headcols )
       else
         numbcols = '!    1      2       3       4       5        6      7    8'
         inc = lastc ( numbcols )
         headcols = '!   NO    XCO_P   YCO_P   XCO_R   YCO_R  SIG_GLOB  FG  GOOD'
         ihc = lastc ( headcols )
       endif
       do i=1,nwaves
         if (i .gt. 1) then
           numbcols = numbcols(1:inc)//' '
           inc = lastc ( numbcols ) + 1
         endif
         write (cwav,'(i2.2)') i
         do l=isigm,ifxte
           if (l .eq. ifmon) then
             headcols = headcols(1:ihc)//' '//colhead(l)(1:2)//cwav
           else
             headcols = headcols(1:ihc)//' '//colhead(l)(1:8)//cwav
           endif
           ihc = lastc ( headcols )
           ncol = ncol + 1
           if (l .eq. isigm) then
             write (cncolf,'(i8)') ncol
           elseif (l .eq. ifmon .or. l .eq. ifxpb) then
             write (cncolf,'(i8)') ncol
           else
             write (cncolf,'(i11)') ncol
           endif
           numbcols = numbcols(1:inc)//cncolf
           inc = lastc ( numbcols )
         enddo
         numbcols = numbcols(1:inc)//'  '
         inc = lastc ( numbcols ) + 2
         do l=iafwh,ithep
           headcols = headcols(1:ihc)//' '//colhead(l)(1:4)//cwav
           ihc = lastc ( headcols )
           ncol = ncol + 1
           write (cncolf,'(i7)') ncol
           numbcols = numbcols(1:inc)//cncolf
           inc = lastc ( numbcols )
         enddo
       enddo
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       write (headrelitent(nhrt),'(a)') numbcols(1:inc)
       write (headreliable(nhr ),'(a)') numbcols(1:inc)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       write (headrelitent(nhrt),'(a)') headcols(1:ihc)
       write (headreliable(nhr ),'(a)') headcols(1:ihc)
       nhrt = nhrt + 1
       nhr  = nhr  + 1
       headrelitent(nhrt) = '!'
       headreliable(nhr ) = headrelitent(nhrt)
       
       if (lverbose .eq. '-verb2') then
         write (iotty,'(a)') '   Writing catalog '''//finalcatalogrelitent(1:ifrt)//'''...'
         write (iotty,'(a)') '   Writing catalog '''//finalcatalogreliable(1:ifr)//'''...'
       endif
                                      
       open ( 15, file=finalcatalogrelitent(1:ifrt), status='unknown' )
       open ( 16, file=finalcatalogreliable(1:ifr), status='unknown' )
       
       do m=1,nhrt
         ihc = lastc ( headrelitent(m) )
         write (15,'(a)') headrelitent(m)(1:ihc)
       enddo
       do m=1,nhr
         ihc = lastc ( headreliable(m) )
         write (16,'(a)') headreliable(m)(1:ihc)
       enddo
       
! Write the final catalog columns commenting out bad entries.

       do j=1,nextr(1)
         if (cno(j)(1:1) .ne. '!') then
           lcno = lastc ( comment(j) ) - 1
           write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
           do i=1,nwaves
             write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
             if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
           enddo
      
           write (catlinerelitent(j),'(a,1x,2f8.1,'//fmtwcs//',1pe11.3,a3,0pf6.2,'//cnwaves//'(1pe11.3,a5,4(1pe11.3),3(0pf7.1)),a)') 
     &             cno(j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(1,j,l), l=ixcoas,iycoas), quantity(1,j,isigg)
     &           , cflag, quantity(1,j,igodn), (quantity(i,j,isigm), cfmflag(i), (factor(i,j,l) * quantity(i,j,l), l=ifxpb,ifxte)
     &           , (quantity(i,j,l), l=iafwh,ithep), i=1,nwaves), comment(j)(1:lcno)
           icrt = lastc ( catlinerelitent(j) )
           write (15,'(a)') catlinerelitent(j)(1:icrt)
         endif
         if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
           lcno = lastc ( comment(j) ) - 1
           write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
           do i=1,nwaves
             write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
             if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
           enddo
      
           write (catlinereliable(j),'(a,1x,2f8.1,'//fmtwcs//',1pe11.3,a3,0pf6.2,'//cnwaves//'(1pe11.3,a5,4(1pe11.3),3(0pf7.1)),a)') 
     &             cno(j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(1,j,l), l=ixcoas,iycoas), quantity(1,j,isigg)
     &           , cflag, quantity(1,j,igodn), (quantity(i,j,isigm), cfmflag(i), (factor(i,j,l) * quantity(i,j,l), l=ifxpb,ifxte)
     &           , (quantity(i,j,l), l=iafwh,ithep), i=1,nwaves), comment(j)(1:lcno)
           icr = lastc ( catlinereliable(j) )
           write (16,'(a)') catlinereliable(j)(1:icr)
         endif
       enddo
       
       close ( 15 )
       close ( 16 )
       
       if (lverbose .eq. '-verb2') then
         write (iotty,'(a)') '   Writing catalog '''//finalcatalogrelitentok(1:ifrtok)//'''...'
         write (iotty,'(a)') '   Writing catalog '''//finalcatalogreliableok(1:ifrok)//'''...'
       endif
       
       open ( 17, file=finalcatalogrelitentok(1:ifrtok), status='unknown' )
       open ( 18, file=finalcatalogreliableok(1:ifrok), status='unknown' )
       
       do m=1,nhrt
         ihc = lastc ( headrelitent(m) )
         iro = index ( headrelitent(m), '! CATALOG OF RELIABLE' )
         ire = index ( headrelitent(m), ' may not be sequential' )
         if (iro .eq. 0 .and. ire .eq. 0) then
           write (17,'(a)') headrelitent(m)(1:ihc)
         else
           if (iro .gt. 0) write (17,'(a)') headrelitent(m)(1:ihc)//' (ok: renumbered)'
           if (ire .gt. 0) write (17,'(a)') headrelitent(m)(1:ire)//'sequential numbering'
         endif
       enddo
       do m=1,nhr
         ihc = lastc ( headreliable(m) )
         iro = index ( headreliable(m), '! CATALOG OF RELIABLE' )
         ire = index ( headreliable(m), ' may not be sequential' )
         if (iro .eq. 0 .and. ire .eq. 0) then
           write (18,'(a)') headreliable(m)(1:ihc)
         else
           if (iro .gt. 0) write (18,'(a)') headreliable(m)(1:ihc)//' (ok: renumbered)'
           if (ire .gt. 0) write (18,'(a)') headreliable(m)(1:ire)//'sequential numbering'
         endif
       enddo

! Write the final catalog columns commenting out bad entries.

       nn = 0
       do j=1,nextr(1)
         if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
           nn = nn + 1
           nok(j) = nn
           icrt = lastc ( catlinerelitent(j) )
           write (17,'(i6,a)') nok(j), catlinerelitent(j)(7:icrt)
           icr = lastc ( catlinereliable(j) )
           write (18,'(i6,a)') nok(j), catlinereliable(j)(7:icr)
         endif
       enddo
       do j=1,nextr(1)
         if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .le. 0.0d0) then
           nn = nn + 1
           nok(j) = nn
           icrt = lastc ( catlinerelitent(j) )
           write (17,'(i6,a)') nok(j), catlinerelitent(j)(7:icrt)
         endif
       enddo
       
       close ( 17 )
       close ( 18 )

! Write the "ok-semi" final catalog's header.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//semifinalcatokname(1:isemok)//'''...'

       open ( 15, file=semifinalcatokname(1:isemok), status='unknown' )

       id = index ( detimagestring(1:ide), '.sw.det.' ) + 7
       ie = index ( detimagestring(id+1:), 'as.an.' ) + 2 + id

       write (15,'(a)') cbars
       write (15,'(a)') '!'
       write (15,'(a)') '!'//getstitle(2:)
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       write (15,'(a)') '! Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
       write (15,'(a)') '! Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (15,'(a)') '! Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence '
     &                //'(william.d.pence@nasa.gov)'
       write (15,'(a)') '! and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
       write (15,'(a)') '!'
       write (15,'(a)') '! EXTRA (SEMI) FINAL CATALOG OF SOURCES (ok: renumbered)'
       write (15,'(a)') '!'
       write (15,'(a)') '! detected in '//detimagestring(1:id)//'*'//detimagestring(ie:ide)

       do i=1,ndetwaves
         ica = lastc ( detimageline(i) )
         write (15,'(a)') '!'//detimageline(i)(1:ica)
       enddo

       do i=1,nwaves
         if (i .eq. 1) then
           write (15,'(a)') '! measured in '//obsimagestring(i)(1:iob(i))
         else
           write (15,'(a)') '!      and in '//obsimagestring(i)(1:iob(i))
         endif
         foomax(i) = 0.0d0
       enddo
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       do m=1,nheadout-4
         ic = lastc ( headlineout(m) )
         write (15,'(a)') headlineout(m)(1:ic)
       enddo
       write (15,'(a)') cbars
       write (15,'(a)') '!'
       if (lwcscoord) then
         write (15,'(a,28x,'//cnwaves//'(115x,a,22x))') '!',(cwave(i)//' um',i=1,nwaves)
         write (15,'(a,73x,'//cnwaves//'(2x,a))') '!',(cbar(i),i=1,nwaves)
       else
         write (15,'(a,22x,'//cnwaves//'(115x,a,22x))') '!',(cwave(i)//' um',i=1,nwaves)
         write (15,'(a,67x,'//cnwaves//'(2x,a))') '!',(cbar(i),i=1,nwaves)
       endif
                                  
! Write the line with columns' headers.

       do m=nheadout-2,nheadout
         ic = lastc ( headlineout(m) )
         write (15,'(a)') headlineout(m)(1:ic)
       enddo

! Write the extra (semi) final catalog columns removing bad entries.

       do j=1,nextr(1)
         if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
           lcno = lastc ( comment(j) ) - 1
           write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
           do i=1,nwaves
             write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
             if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
           enddo
  
           write (15,'(i6,3i3,1x,2f8.1,'//fmtwcs//',(1pe11.3),a3,0pf6.2,'//cnwaves
     &             //'(1x,1pe11.3,a5,5(1pe11.3),5(0pf8.1),f8.2,3(f8.1)),a)') 
     &                nok(j), ns1(1,j), ns2(1,j), nsx(1,j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(1,j,l), l=ixcoas,iycoas)
     &              , quantity(1,j,isigg), cflag, quantity(1,j,igodn), (quantity(i,j,isigm), cfmflag(i)
     &              , (factor(i,j,l) * quantity(i,j,l), l=ifxpb,ifxtg), (quantity(i,j,l), l=iscsx,nquantities), i=1,nwaves)
     &              , comment(j)(1:lcno)
         endif
       enddo
       do j=1,nextr(1)
         if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .le. 0.0d0) then
           lcno = lastc ( comment(j) ) - 1
           write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
           do i=1,nwaves
             write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
             if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
           enddo
  
           write (15,'(i6,3i3,1x,2f8.1,'//fmtwcs//',(1pe11.3),a3,0pf6.2,'//cnwaves
     &             //'(1x,1pe11.3,a5,5(1pe11.3),5(0pf8.1),f8.2,3(f8.1)),a)') 
     &                nok(j), ns1(1,j), ns2(1,j), nsx(1,j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(1,j,l), l=ixcoas,iycoas)
     &              , quantity(1,j,isigg), cflag, quantity(1,j,igodn), (quantity(i,j,isigm), cfmflag(i)
     &              , (factor(i,j,l) * quantity(i,j,l), l=ifxpb,ifxtg), (quantity(i,j,l), l=iscsx,nquantities), i=1,nwaves)
     &              , comment(j)(1:lcno)
         endif
       enddo

       close ( 15 )

       if (ltiming) then
         cput_finalcats = cput_finalcats + timer ( 'cpu', cpu_finalcats )
         walt_finalcats = walt_finalcats + timer ( 'wal', wal_finalcats )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

! Create an additional catalog with derived quantities: peak intensities in a matching (worst) beam and background intensities 
! under the sources. Do it only when iterations in GETSOURCES have converged.

       if (lfinishing_mode) then

         if (ltiming) then
           cpu_additioncats = timer ( 'cpu', 0.0d0 )
           wal_additioncats = timer ( 'wal', 0.0d0 )
         endif

         do i=1,nwaves
           obscbname(i) = cat(i)(idot1+1:idot4-1)//'.cb.fits'
           iocb(i) = lastc ( obscbname(i) )
           inquire ( file=obscbname(i)(1:iocb(i)), exist=lfname )
           if (.not.lfname) goto 96
           obscbsmoname(i) = cat(i)(idot1+1:idot4-1)//'.cb.smo.fits'
           iocbs(i) = lastc ( obscbsmoname(i) )
           inquire ( file=obscbsmoname(i)(1:iocbs(i)), exist=lfname )
           if (.not.lfname) goto 97
         enddo
     
         goto 997
 96      continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obscbname(i)(1:iocb(i))//''' not found.'
           stop 37
         endif
 97      continue
         if (.not.lfname) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: File '''//obscbsmoname(i)(1:iocbs(i))//''' not found.'
           stop 38
         endif
 997     continue
       
         allocate ( obscbimage(nx,ny), obscbsmoimage(nx,ny), stat=irc )
         
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (74).'
           stop 74
         endif
         
         do i=1,nwaves
           
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbimage, dx, dy, object, ra, dec
     &                , obscbname(i)(1:iocb(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1
     &                , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
         
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbsmoimage, dx, dy, object, ra, dec
     &                , obscbsmoname(i)(1:iocbs(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1
     &                , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
         
           do j=1,nextr(1)
             nxco = nint ( quantity(1,j,ixcopx) )
             nyco = nint ( quantity(1,j,iycopx) )
             backgint(i,j) = obscbimage(nxco,nyco)
             backgsmoint(i,j) = obscbsmoimage(nxco,nyco)
           enddo
         enddo
                      
         deallocate ( obscbimage, obscbsmoimage )
         
         if (lverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Writing catalog '''//addcatalogrelitent(1:iart)//'''...'
           write (iotty,'(a)') '   Writing catalog '''//addcatalogreliable(1:iar)//'''...'
         endif
                                        
         open ( 75, file=addcatalogrelitent(1:iart), status='unknown' )
         open ( 76, file=addcatalogreliable(1:iar), status='unknown' )
         
         write (cobeam,'(1pe9.2)') obsbeammax
         ibo = lastc ( cobeam )
         addhead(1) = '!   PEAK_SRC ...... Estimate of peak intensity for current source ............ (MJy/sr)'
         addhead(2) = '!   PEAK_BGF ...... Estimate of background+filaments intensity for source .... (MJy/sr)'
         addhead(3) = '!   CONV_SRC ...... Estimate of peak intensity for current source ............ (MJy/sr) convolved to'
     &              //cobeam(1:ibo)//' arcsec resolution'
         addhead(4) = '!   CONV_BGF ...... Estimate of background+filaments intensity for source .... (MJy/sr) convolved to'
     &              //cobeam(1:ibo)//' arcsec resolution'
         
         do m=1,nhrt
           ihc = lastc ( headrelitent(m) )
           if (index ( headrelitent(m), '!   XCO_R ...' ) .gt. 0 .or. index ( headrelitent(m), '!   WCS_ACOOR ...' ) .gt. 0) exit
           if (index ( headrelitent(m), '! CATALOG OF RELIABLE & TENTATIVE SOURCES' ) .gt. 0) then
             write (75,'(a)') '! CATALOG OF ADDITIONAL DERIVED QUANTITIES FOR RELIABLE & TENTATIVE SOURCES'
           else  
             write (75,'(a)') headrelitent(m)(1:ihc)
           endif
         enddo
         do m=1,4
           ihc = lastc ( addhead(m) )
           write (75,'(a)') addhead(m)(1:ihc)
         enddo
         do m=1,nhr
           ihc = lastc ( headreliable(m) )
           if (index ( headreliable(m), '!   XCO_R ...' ) .gt. 0 .or. index ( headreliable(m), '!   WCS_ACOOR ...' ) .gt. 0) exit
           if (index ( headreliable(m), '! CATALOG OF RELIABLE SOURCES' ) .gt. 0) then
             write (76,'(a)') '! CATALOG OF ADDITIONAL DERIVED QUANTITIES FOR RELIABLE SOURCES'
           else  
             write (76,'(a)') headreliable(m)(1:ihc)
           endif
         enddo
         do m=1,4
           ihc = lastc ( addhead(m) )
           write (76,'(a)') addhead(m)(1:ihc)
         enddo

! Write the line with columns' headers.

         ncol = 3
         numbcols = '!    1      2       3'
         inc = lastc ( numbcols )
         headcols = '!   NO    XCO_P   YCO_P'
         ihc = lastc ( headcols )
         do i=1,nwaves
           write (cwav,'(i2.2)') i
           headcols = headcols(1:ihc)//' PEAK_SRC'//cwav//' PEAK_BGF'//cwav//' CONV_SRC'//cwav//' CONV_BGF'//cwav
           ihc = lastc ( headcols )
           ncol = ncol + 1
           write (cncolf,'(i9)') ncol
           numbcols = numbcols(1:inc)//cncolf
           inc = lastc ( numbcols )
           do ii=1,3
             ncol = ncol + 1
             write (cncolf,'(i11)') ncol
             numbcols = numbcols(1:inc)//cncolf
             inc = lastc ( numbcols )
           enddo
           numbcols = numbcols(1:inc)//'  '
           inc = inc + 2
         enddo
         
         write (75,'(a)') cbars
         write (75,'(a)') '!'
         write (75,'(a)') numbcols(1:inc)
         write (75,'(a)') headcols(1:ihc)
         write (75,'(a)') '!'
         write (76,'(a)') cbars
         write (76,'(a)') '!'
         write (76,'(a)') numbcols(1:inc)
         write (76,'(a)') headcols(1:ihc)
         write (76,'(a)') '!'

! Write the final catalog columns commenting out bad entries.

         do j=1,nextr(1)
           if (cno(j)(1:1) .ne. '!') then
             lcno = lastc ( comment(j) ) - 1
             write (catlinerelitent(j),'(a,1x,2f8.1,'//cnwaves//'(4(1pe11.3)),a)') 
     &               cno(j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(i,j,ifxpb), backgint(i,j)
     &             , factsmoo(i,j) * quantity(i,j,ifxpb), backgsmoint(i,j), i=1,nwaves), comment(j)(1:lcno)
             icrt = lastc ( catlinerelitent(j) )
             write (75,'(a)') catlinerelitent(j)(1:icrt)
           endif
           if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
             lcno = lastc ( comment(j) ) - 1
             write (catlinereliable(j),'(a,1x,2f8.1,'//cnwaves//'(4(1pe11.3)),a)') 
     &               cno(j), (quantity(1,j,l), l=ixcopx,iycopx), (quantity(i,j,ifxpb), backgint(i,j)
     &             , factsmoo(i,j) * quantity(i,j,ifxpb), backgsmoint(i,j), i=1,nwaves), comment(j)(1:lcno)
             icr = lastc ( catlinereliable(j) )
             write (76,'(a)') catlinereliable(j)(1:icr)
           endif
         enddo
         
         close ( 75 )
         close ( 76 )
         
         if (lverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Writing catalog '''//addcatalogrelitentok(1:iartok)//'''...'
           write (iotty,'(a)') '   Writing catalog '''//addcatalogreliableok(1:iarok)//'''...'
         endif
         
         open ( 77, file=addcatalogrelitentok(1:iartok), status='unknown' )
         open ( 78, file=addcatalogreliableok(1:iarok), status='unknown' )
         
         do m=1,nhrt
           ic = lastc ( headrelitent(m) )
           if (index ( headrelitent(m), '!   XCO_R ...' ) .gt. 0 .or. index ( headrelitent(m), '!   WCS_ACOOR ...' ) .gt. 0) exit
           iro = index ( headrelitent(m), '! CATALOG OF RELIABLE & TENTATIVE SOURCES' )
           ire = index ( headrelitent(m), ' may not be sequential' )
           
           if (iro .eq. 0 .and. ire .eq. 0) then
             write (77,'(a)') headrelitent(m)(1:ic)
           else
             if (iro .gt. 0) 
     &         write (77,'(a)') '! CATALOG OF ADDITIONAL DERIVED QUANTITIES FOR RELIABLE & TENTATIVE SOURCES (ok: renumbered)'
             if (ire .gt. 0) write (77,'(a)') headrelitent(m)(1:ire)//'sequential numbering'
           endif
         enddo
         do m=1,4
           ic = lastc ( addhead(m) )
           write (77,'(a)') addhead(m)(1:ic)
         enddo
         do m=1,nhr
           ic = lastc ( headreliable(m) )
           if (index ( headreliable(m), '!   XCO_R ...' ) .gt. 0 .or. index ( headreliable(m), '!   WCS_ACOOR ...' ) .gt. 0) exit
           iro = index ( headreliable(m), '! CATALOG OF RELIABLE SOURCES' )
           ire = index ( headreliable(m), ' may not be sequential' )
           if (iro .eq. 0 .and. ire .eq. 0) then
             write (78,'(a)') headreliable(m)(1:ic)
           else
             if (iro .gt. 0) 
     &         write (78,'(a)') '! CATALOG OF ADDITIONAL DERIVED QUANTITIES FOR RELIABLE SOURCES (ok: renumbered)'
             if (ire .gt. 0) write (78,'(a)') headreliable(m)(1:ire)//'sequential numbering'
           endif
         enddo
         do m=1,4
           ic = lastc ( addhead(m) )
           write (78,'(a)') addhead(m)(1:ic)
         enddo
         
         write (77,'(a)') cbars
         write (77,'(a)') '!'
         write (77,'(a,24x,'//cnwaves//'(17x,a,20x))') '!',(cwave(i)//' um',i=1,nwaves)
         write (77,'(a,22x,'//cnwaves//'(1x,a))') '!',(cbar(i)(1:43),i=1,nwaves)
         write (77,'(a)') '!'
         write (77,'(a)') numbcols(1:inc)
         write (77,'(a)') headcols(1:ihc)
         write (77,'(a)') '!'
         write (78,'(a)') cbars
         write (78,'(a)') '!'
         write (78,'(a)') numbcols(1:inc)
         write (78,'(a)') headcols(1:ihc)
         write (78,'(a)') '!'

! Write the final catalog columns commenting out bad entries.

         do j=1,nextr(1)
           if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
             icrt = lastc ( catlinerelitent(j) )
             write (77,'(i6,a)') nok(j), catlinerelitent(j)(7:icrt)
             icr = lastc ( catlinereliable(j) )
             write (78,'(i6,a)') nok(j), catlinereliable(j)(7:icr)
           endif
         enddo
         do j=1,nextr(1)
           if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .le. 0.0d0) then
             icrt = lastc ( catlinerelitent(j) )
             write (77,'(i6,a)') nok(j), catlinerelitent(j)(7:icrt)
           endif
         enddo
         
         close ( 77 )
         close ( 78 )

!-----------------------------------------------------------------------------------------------------------------------------------

! Compute and write all the colors in separate catalogs.

         if (nwaves .gt. 1) then
                
           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//finalcolorsrelitent(1:ifcrt)//'''...'
           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//finalcolorsreliable(1:ifcr)//'''...'
           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//finalcolorsrelitentok(1:ifcrtok)//'''...'
           if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing catalog '''//finalcolorsreliableok(1:ifcrok)//'''...'
         
           open ( 15, file=finalcolorsrelitent(1:ifcrt), status='unknown' )
           open ( 16, file=finalcolorsreliable(1:ifcr), status='unknown' )
           open ( 17, file=finalcolorsrelitentok(1:ifcrtok), status='unknown' )
           open ( 18, file=finalcolorsreliableok(1:ifcrok), status='unknown' )
         
           nhart = nhrt + 1
           nhar  = nhr  + 1
           nhrt = nhart
           nhr  = nhar
           headrelitent(nhrt) = '!   YYYCXXX ....... Colors ...................................................'
     &                        //' log10(FXT_BEST_YYY/FXT_BEST_XXX)'
           headreliable(nhr ) = headrelitent(nhrt)
           nhrt = nhrt + 1
           nhr  = nhr  + 1
           headrelitent(nhrt) = '!   YYYEXXX ....... Errors in colors .........................................'
     &                       //' log10(2) x sqrt((FXT_ERRO_YYY/FXT_BEST_YYY)^2+(FXT_ERRO_XXX/FXT_BEST_XXX)^2)'
           headreliable(nhr ) = headrelitent(nhrt)
           nhrt = nhrt + 1
           nhr  = nhr  + 1
           headrelitent(nhrt) = '!'
           headreliable(nhr ) = headrelitent(nhrt)
           nhrt = nhrt + 1
           nhr  = nhr  + 1
           headrelitent(nhrt) = '! Colors equal to 7.77777 correspond to tentative positive fluxes.'
           headreliable(nhr ) = headrelitent(nhrt)
           nhrt = nhrt + 1
           nhr  = nhr  + 1
           headrelitent(nhrt) = '! Colors equal to 8.88888 correspond to unreliable positive fluxes.'
           headreliable(nhr ) = headrelitent(nhrt)
           nhrt = nhrt + 1
           nhr  = nhr  + 1
           headrelitent(nhrt) = '! Colors equal to 9.99999 correspond to one or two non-positive fluxes.'
           headreliable(nhr ) = headrelitent(nhrt)
           nhrt = nhrt + 1
           nhr  = nhr  + 1
           headrelitent(nhrt) = cbars
           headreliable(nhr ) = headrelitent(nhrt)
         
           ldone = .false.
           lok = .true.
           ire = 0
           do m=1,nhrt
             iro = index ( headrelitent(m), '! CATALOG OF RELIABLE & TENTATIVE SOURCES' )
             if (iro .gt. 0 ) then
               headrelitent(m) = '! COLORS & FLUXES OF RELIABLE & TENTATIVE SOURCES'
             endif
             if (index ( headrelitent(m), '!   NO ............ Source''s running number' ) .gt. 0) then
               ire = index ( headrelitent(m), ' may not be sequential' )
               ldone = .true.
             endif
             if (lok .or. ldone) then
               ihc = lastc ( headrelitent(m) )
               if (iro .eq. 0 .and. ire .eq. 0) then
                 write (15,'(a)') headrelitent(m)(1:ihc)
                 write (17,'(a)') headrelitent(m)(1:ihc)
               else
                 if (iro .gt. 0) then
                   write (15,'(a)') headrelitent(m)(1:ihc)
                   write (17,'(a)') headrelitent(m)(1:ihc)//' (ok: renumbered)'
                   iro = 0
                 endif
                 if (ire .gt. 0) then
                   write (15,'(a)') headrelitent(m)(1:ihc)
                   write (17,'(a)') headrelitent(m)(1:ire)//'sequential numbering'
                   ire = 0
                 endif
               endif
             endif
             if (ldone) exit
           enddo
           do mm=m+12,m+13
             ihc = lastc ( headrelitent(mm) )
             write (15,'(a)') headrelitent(mm)(1:ihc)
             write (17,'(a)') headrelitent(mm)(1:ihc)
           enddo
           do mm=nhart,nhart+6
             ihc = lastc ( headrelitent(mm) )
             write (15,'(a)') headrelitent(mm)(1:ihc)
             write (17,'(a)') headrelitent(mm)(1:ihc)
           enddo
          
           ldone = .false.
           lok = .true.
           ire = 0
           do m=1,nhr
             iro = index ( headreliable(m), '! CATALOG OF RELIABLE SOURCES' )
             if (iro .gt. 0 ) then
               headreliable(m) = '! COLORS & FLUXES OF RELIABLE SOURCES'
             endif  
             if (index ( headreliable(m), '!   NO ............ Source''s running number' ) .gt. 0) then
               ire = index ( headreliable(m), ' may not be sequential' )
               ldone = .true.
             endif
             ihc = lastc ( headreliable(m) )
             if (lok .or. ldone) then
               ihc = lastc ( headreliable(m) )
               if (iro .eq. 0 .and. ire .eq. 0) then
                 write (16,'(a)') headreliable(m)(1:ihc)
                 write (18,'(a)') headreliable(m)(1:ihc)
               else
                 if (iro .gt. 0) then
                   write (16,'(a)') headreliable(m)(1:ihc)
                   write (18,'(a)') headreliable(m)(1:ihc)//' (ok: renumbered)'
                   iro = 0
                 endif
                 if (ire .gt. 0) then
                   write (16,'(a)') headreliable(m)(1:ihc)
                   write (18,'(a)') headreliable(m)(1:ire)//'sequential numbering'
                   ire = 0
                 endif
               endif
             endif
             if (ldone) exit
           enddo
           do mm=m+12,m+13
             ihc = lastc ( headreliable(mm) )
             write (16,'(a)') headreliable(mm)(1:ihc)
             write (18,'(a)') headreliable(mm)(1:ihc)
           enddo
           do mm=nhar,nhar+6
             ihc = lastc ( headreliable(mm) )
             write (16,'(a)') headreliable(mm)(1:ihc)
             write (18,'(a)') headreliable(mm)(1:ihc)
           enddo
                                    
! Write the line with columns' headers.
       
           ncol = 1
           numbcols = '!    1       2          3'
           inc = lastc ( numbcols )
           headcols = '!   NO'
           ihc = lastc ( headcols ) + 1
           do i=1,nwaves-1
             headcols = headcols(1:ihc)//' '
             ihc = lastc ( headcols ) + 1
             write (cwav,'(i2.2)') i
             do l=ifxtb,ifxte
               headcols = headcols(1:ihc)//' '//colhead(l)(1:8)//cwav
               ihc = lastc ( headcols )
               ncol = ncol + 1
               if (i .gt. 1) then
                 write (cncolf,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolf
                 inc = lastc ( numbcols )
               endif
             enddo
             numbcols = numbcols(1:inc)//'  '
             inc = lastc ( numbcols ) + 2
             cwave1 = cwave(i)(2:4)
             if (cwave1(1:1) .eq. ' ') cwave1(1:1) = '0'
             if (cwave1(2:2) .eq. ' ') cwave1(2:2) = '0'
             headcols = headcols(1:ihc)//' '
             ihc = lastc ( headcols ) + 1
             do ii=i+1,nwaves
               cwave2 = cwave(ii)(2:4)
               if (cwave2(1:1) .eq. ' ') cwave2(1:1) = '0'
               if (cwave2(2:2) .eq. ' ') cwave2(2:2) = '0'
               headcols = headcols(1:ihc)//'  '//cwave2//'C'//cwave1//'  '//cwave2//'E'//cwave1
               ihc = lastc ( headcols )
               ncol = ncol + 1
               write (cncolc,'(i9)') ncol
               numbcols = numbcols(1:inc)//cncolc
               inc = lastc ( numbcols )
               ncol = ncol + 1
               write (cncolc,'(i9)') ncol
               numbcols = numbcols(1:inc)//cncolc
               inc = lastc ( numbcols )
             enddo
           enddo
           headcols = headcols(1:ihc)//' '
           ihc = lastc ( headcols ) + 1
           write (cwav,'(i2.2)') nwaves
           do l=ifxtb,ifxte
             headcols = headcols(1:ihc)//' '//colhead(l)(1:8)//cwav
             ihc = lastc ( headcols )
             ncol = ncol + 1
             write (cncolf,'(i11)') ncol
             numbcols = numbcols(1:inc)//cncolf
             inc = lastc ( numbcols )
           enddo
         
           write (15,'(a)') '!'
           write (17,'(a)') '!'
           write (16,'(a)') '!'
           write (18,'(a)') '!'
           write (15,'(a)') numbcols(1:inc)
           write (17,'(a)') numbcols(1:inc)
           write (16,'(a)') numbcols(1:inc)
           write (18,'(a)') numbcols(1:inc)
           write (15,'(a)') headcols(1:ihc)
           write (17,'(a)') headcols(1:ihc)
           write (16,'(a)') headcols(1:ihc)
           write (18,'(a)') headcols(1:ihc)
           write (15,'(a)') '!'
           write (17,'(a)') '!'
           write (16,'(a)') '!'
           write (18,'(a)') '!'
         
           cwfmt = ' '
           icwf = 1
           do i=1,nwaves-1
             write (cnwavs,'(i2)') nwaves - i
             cwfmt = cwfmt(1:icwf)//',1x,2(1pe11.3),1x,'//cnwavs//'(2(0pf9.5))'
             icwf = lastc ( cwfmt )
           enddo                     
           cwfmt = cwfmt(1:icwf)//',1x,2(1pe11.3)'
           icwf = lastc ( cwfmt )
           
           do j=1,nextr(1)
             if (cno(j)(1:1) .ne. '!') then
               do i=1,nwaves-1
                 do ii=i+1,nwaves
                   if (quantity(ii,j,ifxtb) .gt. quantity(ii,j,ifxte) .and. quantity(i,j,ifxtb) .gt. quantity(i,j,ifxte) .and.
     &                 quantity(ii,j,isigm) .ge. stentative .and. quantity(i ,j,isigm) .ge. stentative) then
                     color (ii,i) = log10 ( quantity(ii,j,ifxtb) / quantity(i,j,ifxtb) )
                     colerr(ii,i) = log10 ( 2.0d0 ) * sqrt ( (quantity(ii,j,ifxte) / quantity(ii,j,ifxtb))**2
     &                                                     + (quantity(i ,j,ifxte) / quantity(i ,j,ifxtb))**2 )
                     if (color (ii,i) .lt.-9.99998d0) color (ii,i) =-9.99998d0
                     if (color (ii,i) .gt. 9.99998d0) color (ii,i) = 9.99998d0
                     if (colerr(ii,i) .lt. 0.00001d0) colerr(ii,i) = 0.00001d0
                     if (colerr(ii,i) .gt. 9.99998d0) colerr(ii,i) = 9.99998d0
                   else
                     if (quantity(ii,j,ifxtb) .le. quantity(ii,j,ifxte) .or. quantity(i,j,ifxtb) .le. quantity(i,j,ifxte)) then
                       color (ii,i) = 9.99999d0
                       colerr(ii,i) = 0.0d0
                     else
                       color (ii,i) = 8.88888d0
                       colerr(ii,i) = 0.0d0
                     endif
                   endif
                 enddo
               enddo
               lcno = lastc ( comment(j) ) - 1
               write (colorlinerelitent(j),'(a'//cwfmt(1:icwf)//',a)') 
     &                 cno(j), ((factor(i,j,l) * quantity(i,j,l), l=ifxtb,ifxte)
     &               , (color(ii,i), colerr(ii,i), ii=i+1,nwaves), i=1,nwaves-1)
     &               , (factor(nwaves,j,l) * quantity(nwaves,j,l), l=ifxtb,ifxte), comment(j)(1:lcno)
               icort = lastc ( colorlinerelitent(j) )
               write (15,'(a)') colorlinerelitent(j)(1:icort)
             endif
             if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
               do i=1,nwaves-1
                 do ii=i+1,nwaves
                   if (quantity(ii,j,ifxtb) .gt. quantity(ii,j,ifxte) .and. quantity(i,j,ifxtb) .gt. quantity(i,j,ifxte) .and.
     &                 quantity(ii,j,isigm) .ge. sreliable .and. quantity(i ,j,isigm) .ge. sreliable) then
                     color (ii,i) = log10 ( quantity(ii,j,ifxtb) / quantity(i,j,ifxtb) )
                     colerr(ii,i) = log10 ( 2.0d0 ) * sqrt ( (quantity(ii,j,ifxte) / quantity(ii,j,ifxtb))**2
     &                                                     + (quantity(i ,j,ifxte) / quantity(i ,j,ifxtb))**2 )
                     if (color (ii,i) .lt.-9.99998d0) color (ii,i) =-9.99998d0
                     if (color (ii,i) .gt. 9.99998d0) color (ii,i) = 9.99998d0
                     if (colerr(ii,i) .lt. 0.00001d0) colerr(ii,i) = 0.00001d0
                     if (colerr(ii,i) .gt. 9.99998d0) colerr(ii,i) = 9.99998d0
                   else
                     if (quantity(ii,j,ifxtb) .le. quantity(ii,j,ifxte) .or. quantity(i,j,ifxtb) .le. quantity(i,j,ifxte)) then
                       color (ii,i) = 9.99999d0
                       colerr(ii,i) = 0.0d0
                     elseif ((quantity(ii,j,isigm) .lt. sreliable .or. quantity(i ,j,isigm) .lt. sreliable) .and.
     &                       quantity(ii,j,isigm) .ge. stentative .and. quantity(i ,j,isigm) .ge. stentative) then
                       color (ii,i) = 7.77777d0
                       colerr(ii,i) = 0.0d0
                     else
                       color (ii,i) = 8.88888d0
                       colerr(ii,i) = 0.0d0
                     endif
                   endif
                 enddo
               enddo
               lcno = lastc ( comment(j) ) - 1
               write (colorlinereliable(j),'(a'//cwfmt(1:icwf)//',a)') 
     &                 cno(j), ((factor(i,j,l) * quantity(i,j,l), l=ifxtb,ifxte)
     &               , (color(ii,i), colerr(ii,i), ii=i+1,nwaves), i=1,nwaves-1)
     &               , (factor(nwaves,j,l) * quantity(nwaves,j,l), l=ifxtb,ifxte), comment(j)(1:lcno)
               icor = lastc ( colorlinereliable(j) )
               write (16,'(a)') colorlinereliable(j)(1:icor)
             endif
           enddo
         
           do j=1,nextr(1)
             if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
               icort = lastc ( colorlinerelitent(j) )
               write (17,'(i6,a)') nok(j), colorlinerelitent(j)(7:icort)
               icor = lastc ( colorlinereliable(j) )
               write (18,'(i6,a)') nok(j), colorlinereliable(j)(7:icor)
             endif
           enddo
           do j=1,nextr(1)
             if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .le. 0.0d0) then
               icort = lastc ( colorlinerelitent(j) )
               write (17,'(i6,a)') nok(j), colorlinerelitent(j)(7:icort)
             endif
           enddo
         
           close ( 15 )
           close ( 17 )
           close ( 16 )
           close ( 18 )
         endif

         if (ltiming) then
           cput_additioncats = cput_additioncats + timer ( 'cpu', cpu_additioncats )
           walt_additioncats = walt_additioncats + timer ( 'wal', wal_additioncats )
         endif
       endif
       
       deallocate ( catlinereliable, catlinerelitent, colorlinereliable, colorlinerelitent )

!-----------------------------------------------------------------------------------------------------------------------------------
       
       allocate ( obsbsfsimage(nx,ny), stat=irc )
       
       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (75).'
         stop 75
       endif

       allocate ( footlimit(nwaves,nextr(1)), stat=irc )
       
       if (irc .ne. 0) then
         write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (76).'
         stop 76
       endif

! Extract intensity profiles for reliable and tentative sources.

       if (lfinishing_mode .and. lcreate_profiles_images) then

         if (ltiming) then
           cpu_profimages = timer ( 'cpu', 0.0d0 )
           wal_profimages = timer ( 'wal', 0.0d0 )
         endif

         if (lverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Computing deblended images and intensity profiles...'
         endif
         
         allocate ( profilebd(nwaves,max(nx,ny)), profilebs(nwaves,max(nx,ny)), profileob(nwaves,max(nx,ny)), rad(max(nx,ny))
     &            , rad2(max(nx,ny)), npts(max(nx,ny)), dxco2(max(nx,ny)), dyco2(max(nx,ny)), deblended(nx,ny)
     &            , profilebdrms(nwaves,max(nx,ny)), profileob1st(nwaves,max(nx,ny)), profileob2nd(nwaves,max(nx,ny))
     &            , profileob3rd(nwaves,max(nx,ny)), profileod(nwaves,max(nx,ny)), stat=irc )
         
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (77).'
           stop 77
         endif
              
! Check whether subdirectory of current directory exists.
       
         individintpro = originpath(1:iopa)//'/+sources/+profiles'
         indint = lastc ( individintpro )
       
         open (88, file=individintpro(1:indint)//'/README', status='unknown', err=24 )
         goto 25
  24     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Directory '''//individintpro(1:indint)//''' does not exist?..'
         stop 99
  25     continue
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '#'//getstitle(2:)
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
         write (88,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (88,'(a)') '# Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'
         write (88,'(a)') '# and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
         write (88,'(a)') '#'
         write (88,'(a)') '# This directory contains intensity profiles of reliable and tentative sources.'
         close (88)
       
         individimages = originpath(1:iopa)//'/+sources'
         indimg = lastc ( individimages )
       
         open (88, file=individimages(1:indimg)//'/README', status='unknown', err=26 )
         goto 27
  26     continue
         write (iotty,'(/a)') '   FINALCAT: ERROR: Directory '''//individimages(1:indimg)//''' does not exist?..'
         stop 99
  27     continue
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '#'//getstitle(2:)
         write (88,'(a)') '#'//cbars(2:)
         write (88,'(a)') '#'
         write (88,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
         write (88,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (88,'(a)') '# Used '//clibname(lb:7)//' library version'//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'
         write (88,'(a)') '# and the utility XY2SKY from WCSTOOLS by Jessica Mink (jmink@cfa.harvard.edu)'
         write (88,'(a)') '#'
         write (88,'(a)') '# This directory contains background-subtracted and deblended images of reliable and tentative sources.'
         close (88)
       
         do j=1,nextr(1)
                
           if (cno(j)(1:1) .ne. '!') then
             nxco = nint ( quantity(1,j,ixcopx) )
             nyco = nint ( quantity(1,j,iycopx) )
         
             if (lfinishing_mode) then
               czno = cno(j)
               if (czno(2:2) .eq. ' ') czno(2:2) = '0'
               if (czno(3:3) .eq. ' ') czno(3:3) = '0'
               if (czno(4:4) .eq. ' ') czno(4:4) = '0'
               if (czno(5:5) .eq. ' ') czno(5:5) = '0'
               write (czok,'(i6)') nok(j)
               if (czok(2:2) .eq. ' ') czok(2:2) = '0'
               if (czok(3:3) .eq. ' ') czok(3:3) = '0'
               if (czok(4:4) .eq. ' ') czok(4:4) = '0'
               if (czok(5:5) .eq. ' ') czok(5:5) = '0'
         
               open ( 55, file=individintpro(1:indint)//'/'//'sm.intensity.profiles.ok'//czok(2:6)//'.no'//czno(2:6)//'.dat'
     &                  , status='unknown' )
       
! Write the standard header.

               do m=1,nhrtstand-1
                 ihc = lastc ( headrelitent(m) )
                 iro = index ( headrelitent(m), '! CATALOG OF RELIABLE' )
                 if (iro .eq. 0) then
                   iro = index ( headrelitent(m), '! COLORS & FLUXES' )
                 endif
                 if (iro .gt. 0) then
                   headrelitent(m) = '! INTENSITY PROFILES OF INDIVIDUAL SOURCES'
                   ihc = lastc ( headrelitent(m) )
                 endif
                 iro = index ( headrelitent(m), ' may not be sequential (bad sources excluded)' )
                 if (iro .gt. 0) then
                   write (55,'(a)') '!   OK'//headrelitent(m)(7:iro-1)//' renumbered sequentially'
                 endif
                 write (55,'(a)') headrelitent(m)(1:ihc)
               enddo
               write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
               do i=1,nwaves
                 write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
                 if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'
               enddo
               ihc = lastc ( cbars )
               write (55,'(a)') cbars(1:ihc)
               write (55,'(a)') '!'
               write (55,'(a,i5)'  ) '!   OK ............', nok(j)
               write (55,'(a,i5)'  ) '!   NO ............', no(1,j)
               write (55,'(a,f8.1)') '!   XCO_P .........', quantity(1,j,ixcopx)
               write (55,'(a,f8.1)') '!   YCO_P .........', quantity(1,j,iycopx)
               if (lwcscoord) then
                 write (55,'(a,'//fmtwcs//')') '!   WCS_ACOOR .....', quantity(1,j,ixcoas)
                 write (55,'(a,'//fmtwcs//')') '!   WCS_DCOOR .....', quantity(1,j,iycoas)
               else
                 write (55,'(a,'//fmtwcs//')') '!   XCO_R .........', quantity(1,j,ixcoas)
                 write (55,'(a,'//fmtwcs//')') '!   YCO_R .........', quantity(1,j,iycoas)
               endif
               write (55,'(a,(1pe11.3))')              '!   SIG_GLOB ......', quantity(1,j,isigg)
               write (55,'(a,a5)')                     '!   FS ............', cflag
               write (55,'(a,(f6.2))')                 '!   GOOD ..........', quantity(1,j,igodn)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   SIG_MONO ......', (quantity(i,j,isigm), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(2x,a5))'  ) '!   FM ............', (cfmflag(i), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXP_BEST ......', (quantity(i,j,ifxpb), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXP_ERRO ......', (quantity(i,j,ifxpe), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXT_BEST ......', (quantity(i,j,ifxtb), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(1pe11.3))') '!   FXT_ERRO ......', (quantity(i,j,ifxte), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(f7.1))'   ) '!   AFWHM .........', (quantity(i,j,iafwh), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(f7.1))'   ) '!   BFWHM .........', (quantity(i,j,ibfwh), i=1,nwaves)
               write (55,'(a,'//cnwaves//'(f7.1))'   ) '!   THEPA .........', (quantity(i,j,ithep), i=1,nwaves)
               ihc = lastc ( cbars )
               write (55,'(a)') cbars(1:ihc)
               write (55,'(a)') '!'
               write (55,'(a)') '! TABULATED QUANTITIES:'
               write (55,'(a)') '!'
               write (55,'(a)') '!   N ........... Running number of radial zone ...............................................'
               write (55,'(a)') '!   RADIUS ...... Radial distance of the radial zone from source position .....................'
     &                        //' (arcsec)'
               write (55,'(a)') '!   INTBD# ...... Intensity profiles at waves (background & filament-subtracted, deblended) ...'
     &                        //' (MJy/sr) azimuthally averaged'
               write (55,'(a)') '!   INTBS# ...... Intensity profiles at waves (background & filament-subtracted) ..............'
     &                        //' (MJy/sr) azimuthally averaged'
               write (55,'(a)') '!   INTOB# ...... Intensity profiles at waves (full observed image) ...........................'
     &                        //' (MJy/sr) azimuthally averaged'
               write (55,'(a)') '!   NPTS ........ Number of pixels used in the azimuthal averaging ............................'
               write (55,'(a)') '!   OSQRTNPTS ... Inverse of the square root of NPTS: 1.0 / sqrt ( NPTS ) .....................'
               write (55,'(a)') '!   RMSBD# ...... Standard deviation of the intensity profiles within radial annuli ...........'
     &                        //' (MJy/sr) azimuthal direction'
               write (55,'(a)') '!   DE1OB# ...... Logarithmic first derivative of full intensity profile ......................'
     &                        //' (MJy/sr/arcsec)'
               write (55,'(a)') '!   DE1OD# ...... Logarithmic first derivative of filament-subtracted & deblended profile .....'
     &                        //' (MJy/sr/arcsec)'
               write (55,'(a)') '!   DE2OD# ...... Logarithmic first derivative of filament-subtracted & deblended profile .....'
     &                        //' (MJy/sr/arcsec) radially averaged'
               ihc = lastc ( cbars )
               write (55,'(a)') cbars(1:ihc)
       
! Write the line with columns' headers.

               ncol = 3
               numbcols = '!  1      2         3'
               inc = lastc ( numbcols )
               headcols = '!  N   RADIUS '
               ihc = lastc ( headcols ) + 1
               do i=1,nwaves
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
                 headcols = headcols(1:ihc)//'  INTBD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 if (i .gt. 1) then
                   ncol = ncol + 1
                   write (cncolc,'(i11)') ncol
                   numbcols = numbcols(1:inc)//cncolc
                   inc = lastc ( numbcols )
                 endif
               enddo
               do i=1,nwaves
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
                 headcols = headcols(1:ihc)//'  INTBS'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo
               do i=1,nwaves
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
                 headcols = headcols(1:ihc)//'  INTOB'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo
         
               headcols = headcols(1:ihc)//'     NPTS    OSQRTNPTS'
               ihc = lastc ( headcols )
               ncol = ncol + 1
               write (cncolc,'(i11)') ncol
               numbcols = numbcols(1:inc)//cncolc
               inc = lastc ( numbcols )
               ncol = ncol + 1
               write (cncolc,'(i11)') ncol
               numbcols = numbcols(1:inc)//cncolc
               inc = lastc ( numbcols )
         
               do i=1,nwaves
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
                 headcols = headcols(1:ihc)//'  RMSBD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               do i=1,nwaves
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
                 headcols = headcols(1:ihc)//'  DE1OB'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               do i=1,nwaves
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
                 headcols = headcols(1:ihc)//'  DE1OD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               do i=1,nwaves
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
                 headcols = headcols(1:ihc)//'  DE2OD'//cowave(1:iow)
                 ihc = lastc ( headcols )
                 ncol = ncol + 1
                 write (cncolc,'(i11)') ncol
                 numbcols = numbcols(1:inc)//cncolc
                 inc = lastc ( numbcols )
               enddo

               write (55,'(a)') '!'
               write (55,'(a)') numbcols(1:inc)
               write (55,'(a)') headcols(1:ihc)
               write (55,'(a)') '!'
             endif

! Compute azimuthally-averaged intensity profiles.

             kmax = 0
             do i=1,nwaves
               kmx = min ( nint ( quantity(i,j,ifooa) / dx ), max ( nx - 1, ny - 1 ) )
               if (kmx .gt. kmax) kmax = kmx
             enddo
             
             do i=1,nwaves
             
               call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsimage, dx, dy, object, ra, dec
     &                    , obsname(i)(1:iobs(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1
     &                    , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history
     &                    , lverbose )
             
               call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsbsfsimage, dx, dy, object, ra, dec
     &                    , obsbsfsname(i)(1:iobsbsfs(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1
     &                    , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history
     &                    , lverbose )
             
               do k=1,kmax
                 npts(k) = 0.0d0
                 profilebd(i,k) = 0.0d0
                 profilebs(i,k) = 0.0d0
                 profileob(i,k) = 0.0d0
                 profileod(i,k) = 0.0d0
                 profilebdrms(i,k) = 0.0d0
               enddo
               do k=1,kmax+1
                 rad(k) = dble ( k - 1 ) * dx
                 rad2(k) = rad(k)**2
                 if (rad(k) .le. quantity(i,j,ibfwh) / 2.0d0) radfwhm = rad(k)
                 if (rad(k) .le. quantity(i,j,ifoob) / 2.0d0) radfoot = rad(k)
               enddo
               do l=max(nxco-kmax,1),min(nxco+kmax,nx)
                 dxco2(l) = (dble ( l - nxco ) * dx)**2
               enddo
               do m=max(nyco-kmax,1),min(nyco+kmax,ny)
                 dyco2(m) = (dble ( m - nyco ) * dy)**2
               enddo

! Produce full, background-subtracted, and deblended profiles for each source.
        
               do m=1,ny
                 do l=1,nx
                   deblended(l,m) = 0.0d0
                 enddo
               enddo
          
               semimajor = quantity(i,j,ifooa) / 2.0d0
               nr = nint ( semimajor / pixsize )
               l0 = nint ( quantity(1,j,ixcopx) )
               m0 = nint ( quantity(1,j,iycopx) )
               l1 = max ( l0 - nr , 1 )
               l2 = min ( l0 + nr , nx )
               m1 = max ( m0 - nr , 1 )
               m2 = min ( m0 + nr , ny )
               do m=m1,m2
                 dblm = dble ( m )
                 dycon = (dblm - quantity(1,j,iycopx)) * dy
                 dycon2 = dycon**2
                 do l=l1,l2
                   dbll = dble ( l )
                   dxcon = (dbll - quantity(1,j,ixcopx)) * dx
                   dxcon2 = dxcon**2
                   if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                           , quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                     sigmaa2 = (quantity(i,j,iafwh) / 2.0d0)**2 * correct
                     sigmab2 = (quantity(i,j,ibfwh) / 2.0d0)**2 * correct
                     angle = (90.0d0 - quantity(i,j,ithep)) * convtoradians
                     cosa2 = cos ( angle )**2
                     sina2 = sin ( angle )**2
                     sin2a = sin ( 2.0d0 * angle )
                     aa =  cosa2 / sigmaa2 + sina2 / sigmab2
                     bb = -sin2a / sigmaa2 + sin2a / sigmab2
                     cc =  sina2 / sigmaa2 + cosa2 / sigmab2
                     argmoffat = aa * dxcon2 + bb * dxcon * dycon + cc * dycon2
                     funn = quantity(i,j,ifxpb) / (1.0d0 + argmoffat)**beta
                     funn = abs ( funn )
                     funsum = funn
                     do kk=1,nextr(1)
                       if (kk .ne. j .and. cno(kk)(1:1) .ne. '!' .and. quantity(i,kk,ifxpb) .gt. almostzero) then
                         dist2 = (quantity(1,j,ixcopx) - quantity(1,kk,ixcopx))**2
     &                         + (quantity(1,j,iycopx) - quantity(1,kk,iycopx))**2
                         if (dist2 .lt. (quantity(i,j,ifooa) / dx / 2.0d0 + quantity(i,kk,ifooa) / dx / 2.0d0)**2) then
                           dxcok = (dbll - quantity(1,kk,ixcopx)) * dx
                           dycok = (dblm - quantity(1,kk,iycopx)) * dy
                           dxcok2 = dxcok**2
                           dycok2 = dycok**2
                           if (inellipse ( dbll, dblm, dx, dy, quantity(1,kk,ixcopx), quantity(1,kk,iycopx), quantity(i,kk,ifooa)
     &                                   , quantity(i,kk,ifoob), quantity(i,kk,ifoot) )) then
                             sigmaa2 = (quantity(i,kk,iafwh) / 2.0d0)**2 * correct
                             sigmab2 = (quantity(i,kk,ibfwh) / 2.0d0)**2 * correct
                             angle = (90.0d0 - quantity(i,kk,ithep)) * convtoradians
                             cosa2 = cos ( angle )**2
                             sina2 = sin ( angle )**2
                             sin2a = sin ( 2.0d0 * angle )
                             aa =  cosa2 / sigmaa2 + sina2 / sigmab2
                             bb = -sin2a / sigmaa2 + sin2a / sigmab2
                             cc =  sina2 / sigmaa2 + cosa2 / sigmab2
                             argmoffat = aa * dxcok2 + bb * dxcok * dycok + cc * dycok2
                             funk = quantity(i,kk,ifxpb) / (1.0d0 + argmoffat)**beta
                             funsum = funsum + abs ( funk )
                           endif
                         endif
                       endif
                     enddo
                     deblended(l,m) = (funn / (funsum + almostzero)) * max ( obsbsfsimage(l,m), 0.0d0 )
                   else
                     deblended(l,m) = 0.0d0
                   endif
                 enddo
               enddo
          
               if (lfinishing_mode) then
          
                 allocate ( individ(2*kmax+1,2*kmax+1), stat=irc )
          
                 if (irc .ne. 0) then
                   write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (80).'
                   stop 80
                 endif
               
                 mm = 0
                 do m=nyco-kmax,nyco+kmax
                   mm = mm + 1
                   ll = 0
                   do l=nxco-kmax,nxco+kmax
                     ll = ll + 1
                     if (l .ge. 1 .and. l .le. nx .and. m .ge. 1 .and. m .le. ny) then
                       individ(ll,mm) = deblended(l,m)
                     else
                       individ(ll,mm) = 0.0d0
                     endif
                   enddo
                 enddo
          
                 write (cowave,'(i4)') nint ( obswave(i) )
                 iow = lastc ( cowave )
                 if (cowave(1:1) .eq. ' ') cowave(1:1) = '0'
                 if (cowave(2:2) .eq. ' ') cowave(2:2) = '0'
                 if (cowave(3:3) .eq. ' ') cowave(3:3) = '0'
          
                 deblendname = individimages(1:indimg)//'/'//'sm.deblended.source.'//cowave(1:iow)
     &                                                //'.ok'//czok(2:6)//'.no'//czno(2:6)//'.fits'
                 idb = lastc ( deblendname )
          
                 if (lverbose .eq. '-verb2') then
                   write (iotty,'(a)') '   Writing '''//deblendname(1:idb)//'''...'
                 endif
          
                 call wfits ( cfitsversion, 2*kmax+1, 2*kmax+1, bunit, ctype1, ctype2, kmax+1.0d0, kmax+1.0d0, quantity(1,j,ixcopx)
     &                      , quantity(1,j,iycopx), individ, dx, dy, object, quantity(1,j,ixcoas), quantity(1,j,iycoas)
     &                      , deblendname(1:idb), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2, cd11, cd12
     &                      , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
          
                 deallocate ( individ )
          
               endif
               
               do m=max(nyco-kmax,1),min(nyco+kmax,ny)
                 do l=max(nxco-kmax,1),min(nxco+kmax,nx)
                   rxy2 = dxco2(l) + dyco2(m)
                   do k=1,kmax
                     if (rxy2 .ge. rad2(k) .and. rxy2 .lt. rad2(k+1)) then 
                       npts(k) = npts(k) + 1.0d0
                       profilebd(i,k) = profilebd(i,k) + deblended(l,m)
                       profilebs(i,k) = profilebs(i,k) + obsbsfsimage(l,m)
                       profileob(i,k) = profileob(i,k) + obsimage(l,m)
                       profileod(i,k) = profileod(i,k) + (obsimage(l,m) - obsbsfsimage(l,m)) + deblended(l,m)
                     endif
                   enddo
                 enddo
               enddo
          
               do k=1,kmax
                 profilebd(i,k) = profilebd(i,k) / npts(k)
                 profilebs(i,k) = profilebs(i,k) / npts(k)
                 profileob(i,k) = profileob(i,k) / npts(k)
                 profileod(i,k) = profileod(i,k) / npts(k)
                 profileob1st(i,k) = 0.0d0
                 profileob2nd(i,k) = 0.0d0
                 profileob3rd(i,k) = 0.0d0
               enddo

! Compute rms at the current radial distance from the source and logarithmic derivative of intensity profile.

               do m=max(nyco-kmax,1),min(nyco+kmax,ny)
                 do l=max(nxco-kmax,1),min(nxco+kmax,nx)
                   rxy2 = dxco2(l) + dyco2(m)
                   do k=1,kmax
                     if (rxy2 .ge. rad2(k) .and. rxy2 .lt. rad2(k+1)) then 
                       profilebdrms(i,k) = profilebdrms(i,k) + (deblended(l,m) - profilebd(i,k))**2
                     endif
                   enddo
                 enddo
               enddo

               do k=1,kmax-1
                 dlnr = (rad(k+1) - rad(k)) / rad(k)
                 if (profileob(i,k) .gt. almostzero) then
                   profileob1st(i,k) = (profileob(i,k+1) - profileob(i,k)) / profileob(i,k) / dlnr
                 endif
                 if (profileod(i,k) .gt. almostzero) then
                   profileob2nd(i,k) = (profileod(i,k+1) - profileod(i,k)) / profileod(i,k) / dlnr
                 endif
               enddo
               profileob1st(i,kmax) = profileob1st(i,kmax-1)
        
! Finalize rms and average the above intensity derivative over a substantially large range of radial distances.

               do k=1,kmax
                 if (npts(k) .gt. 1.0d0) profilebdrms(i,k) = sqrt ( profilebdrms(i,k) / (npts(k) - 1.0d0) )
                 mm = 1
                 profileob3rd(i,k) = profileob2nd(i,k)
                 do kk=1,max(k-1,1)
                   if (rad(kk) .gt. radfwhm .and. rad(kk) .lt. radfoot) then
                     mm = mm + 1
                     profileob3rd(i,k) = profileob3rd(i,k) + profileob2nd(i,kk)
                   endif
                 enddo
                 profileob3rd(i,k) = profileob3rd(i,k) / dble ( mm )
               enddo
             enddo
             
             if (lfinishing_mode) then
               formt = '(i4,1pe10.2,3('//cnwaves//'(e11.3)),2(e11.3),4('//cnwaves//'(e11.3)))'
               ifmt = lastc ( formt )
               do k=1,kmax
                 write (55,formt(1:ifmt)) 
     &                 k, rad(k), (profilebd(i,k), i=1,nwaves), (profilebs(i,k), i=1,nwaves), (profileob(i,k), i=1,nwaves)
     &               , npts(k), 1.0d0 / sqrt ( npts(k) ), (profilebdrms(i,k), i=1,nwaves), (profileob1st(i,k), i=1,nwaves)
     &               , (profileob2nd(i,k), i=1,nwaves), (profileob3rd(i,k), i=1,nwaves)
               enddo
               close ( 55 )
             endif
             
           endif
         enddo
         
         deallocate ( profilebd, profilebs, profileob, rad, rad2, npts, dxco2, dyco2, deblended, profilebdrms, profileob1st
     &              , profileob2nd, profileob3rd, profileod )

         if (ltiming) then
           cput_profimages = cput_profimages + timer ( 'cpu', cpu_profimages )
           walt_profimages = walt_profimages + timer ( 'wal', wal_profimages )
         endif
       endif
       
!-----------------------------------------------------------------------------------------------------------------------------------

! Correct footprints images.

       if (ltiming) then
         cpu_updatefoots = timer ( 'cpu', 0.0d0 )
         wal_updatefoots = timer ( 'wal', 0.0d0 )
       endif

       if (lfirstiteration) then
         do i=1,nwaves
           if (liter_phase1) iter_phase(1) = 1
           if (liter_phase2) iter_phase(1) = 2
           if (liter_phase3) iter_phase(1) = 3
           converge(1,i) = 'n'
           nfootareait(1,i) = 0.0d0
           dfootareait(1,i) = 0.0d0
           dfootarea(i) = 0.0d0
         enddo
         nfpiter = 0
         nheadfpit = 21 + nwaves     
         headfpitline( 1) = '#'//cbars(2:)
         headfpitline( 2) = '#'
         headfpitline( 3) = '#'//getstitle(2:)
         headfpitline( 4) = '#'//cbars(2:)
         headfpitline( 5) = '#'
         headfpitline( 6) = '# Date: '//cdate//' Time: '//ctime//'  Created by FINALCAT compiled on '//compda
         headfpitline( 7) = '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         headfpitline( 8) = '#'
         headfpitline( 9) = '# ITERATION OF FOOTPRINT IMAGES TO A RELATIVE ACCURACY OF'//creldiffmax
         headfpitline(10) = '#'
         do i=1,nwaves
           write (cwav,'(i2.2)') i
           headfpitline(10+i) = '# FOOTPRINTS AT WAVE'//cwav//': '//finfootname(i)(1:iff(i))
         enddo
         headfpitline(11+nwaves) = '#'
         headfpitline(12+nwaves) = '# IT .............. NUMBER OF ITERATION'
         headfpitline(13+nwaves) = '# NGOOD ........... NUMBER OF THE SOURCES CONSIDERED AS GOOD'
         headfpitline(14+nwaves) = '# NBAD ............ NUMBER OF THE SOURCES FLAGGED AS BAD'
         headfpitline(15+nwaves) = '# Q ............... INDICATOR OF THE QUALITY PHASE FOR THE ITERATIONS'
         headfpitline(16+nwaves) = '# C# .............. SHOWS WHETHER ITERATIONS HAVE CONVERGED OR NOT AT WAVE #'
         headfpitline(17+nwaves) = '# DFAREA# ......... RELATIVE CHANGE OF THE TOTAL AREA OF ALL FOOTPRINTS AT WAVE #'
         headfpitline(18+nwaves) = '# TOTFOOTSAREA# ... TOTAL FOOTPRINT AREA OF ALL FOOTPRINTS AT WAVE #'
         headfpitline(19+nwaves) = '#'
         headfpitline(20+nwaves) = '# IT  NGOOD   NBAD   Q'
         do i=1,nwaves
           write (cwav,'(i2.2)') i
           ihfp = lastc ( headfpitline(20+nwaves) )
           headfpitline(20+nwaves) = headfpitline(20+nwaves)(1:ihfp)//'  C'//cwav
           ihfp = lastc ( headfpitline(20+nwaves) )
           headfpitline(20+nwaves) = headfpitline(20+nwaves)(1:ihfp)//' DFAREA'//cwav
           ihfp = lastc ( headfpitline(20+nwaves) )
           headfpitline(20+nwaves) = headfpitline(20+nwaves)(1:ihfp)//' TOTFOOTSAREA'//cwav
         enddo
         headfpitline(21+nwaves) = '#'
       else
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading iterations from '''//footitname(1:lfti)//'''...'
       
         open ( 15, file=footitname(1:lfti), status='old' )
      
         call skipcomm     ( 15, footitname(1:lfti), nheadfpit )
         call linescolumns ( 15, footitname(1:lfti), nheadfpit, nfpiter, nfpitcols )
      
         rewind ( 15 )
         
         do ih=1,nheadfpit
           read (15,'(a)') headfpitline(ih)
         enddo
         headfpitline( 9) = '# ITERATION OF FOOTPRINT IMAGES TO A RELATIVE ACCURACY OF'//creldiffmax
      
         do it=1,nfpiter
           read (15,'(i4,2i7,3x,i1,20(3x,a1,f10.5,1pe15.7,0p))') itfp(it), nextrgoodit(it), nextrbadit(it), iter_phase(it)
     &                                                         , (converge(it,i), dfootareait(it,i), nfootareait(it,i), i=1,nwaves)
         enddo
         
         close ( 15 )
       endif
       nfpiter = nfpiter + 1
       itfp(nfpiter) = nfpiter
       nextrgoodit(nfpiter) = nextrgood
       nextrbadit(nfpiter) = nextrbad
       if (liter_phase1) iter_phase(nfpiter) = 1
       if (liter_phase2) iter_phase(nfpiter) = 2
       if (liter_phase3) iter_phase(nfpiter) = 3

       if (.not.lfirstiteration) then
         do i=1,nwaves
           converge(nfpiter,i) = 'n'
           if (converge(nfpiter-1,i) .eq. '-') then
             if ((iter_phase(nfpiter) .eq. 2 .and. iter_phase(nfpiter-1) .eq. 1) .or.
     &           (iter_phase(nfpiter) .eq. 3 .and. iter_phase(nfpiter-1) .eq. 2)) then
               converge(nfpiter,i) = 'n'
             else
               converge(nfpiter,i) = '-'
             endif
           endif
         enddo
       endif
       if (lfinishing_mode) then
         do i=1,nwaves
           converge(nfpiter,i) = '-'
           nfootareait(nfpiter,i) = 0.0d0
           dfootareait(nfpiter,i) = 0.0d0
           lfdone(i) = .true.
         enddo
       endif
       
       if (.not.lfinishing_mode) then

         do i=1,nwaves
           lfdone(i) = .false.
         enddo

         if (lverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Updating footprints for all sources and wavelengths...'
         endif
       
         allocate ( foots(nx,ny), foota(nx,ny), bsomask(nx,ny), flatfoots(nx,ny), foomajoro(nextr(1)), foominoro(nextr(1))
     &            , foothepao(nextr(1)), stat=irc )
       
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (81).'
           stop 81
         endif

         if (liter_phase2 .or. liter_phase3) then
           
           allocate ( noise(nx,ny), stat=irc )
       
           if (irc .ne. 0) then
             write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (82).'
             stop 82
           endif
         endif

         if (.not.lhandlesubstruc) then
           
           allocate ( subsfp(nx,ny), stat=irc )
       
           if (irc .ne. 0) then
             write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (83).'
             stop 83
           endif
         endif
         
         do i=1,nwaves
           newfootarea(i) = 0.0d0
           if (.not.lfirstiteration) then
             oldfootarea(i) = nfootareait(nfpiter-1,i)
           endif
         enddo

! NOTE: quantity(1,j,iscsx) is very important below, don't remove it! It has to remain in the total radii limits, because
! without it the footprint iterations converge to extremely small footprints, completely unrealistic. This is the property
! of the iterations: there has to be a firm limit like that does not depend directly on the resulting footprint. Only then 
! the iterations seem to converge nicely to stable and reasonable footprints.

         do j=1,nextr(1)
           if (cno(j)(1:1) .ne. '!') then
             do i=1,nwaves
               footlimit(i,j) = abs ( quantity(i,j,ifofa) ) * max ( obsbeam(i), quantity(i,j,iscsx) )
               footlimit(i,j) = max ( footlimit(i,j), 2.0d0 * aperture(i) )
             enddo     
           endif
         enddo

         changemax = 0.20d0
         changemaxpa = 5.0d0

         do i=1,nwaves
           do j=1,nextr(1)
             footobsbeam = abs ( quantity(i,j,ifofa) ) * obsbeam(i)
             footobsbeam = max ( footobsbeam, 2.0d0 * aperture(i) )

             if (cno(j)(1:1) .ne. '!') then
               if (converge(nfpiter,i) .ne. '-') then 
                  
! Store old values at the previous iteration.

                 foomajoro(j) = quantity(i,j,ifooa)
                 foominoro(j) = quantity(i,j,ifoob)
                 foothepao(j) = quantity(i,j,ifoot)
                 
! Define the new current values of the *full size* of the footprint ellipse, i.e. the full major and minor axes.

                 foomajor = footlimit(i,j)
                 foominor = max ( footobsbeam, foomajor * quantity(i,j,ibfwh) / quantity(i,j,iafwh) )
                 foothepa = quantity(i,j,ithep)
               
! Find signs of the changes between iterations.

                 qsigna = sign ( 1.0d0, foomajor - foomajoro(j) )
                 qsignb = sign ( 1.0d0, foominor - foominoro(j) )
              
! Bound possible drastic changes in the quantities to reasonable limits.

                 if (abs ( foomajor - foomajoro(j) ) .gt. changemax * foomajoro(j)) then
                   quantity(i,j,ifooa) = (1.0d0 + qsigna * changemax) * foomajoro(j)
                   if (qsigna .gt. 0.0d0) quantity(i,j,ifooa) = min ( quantity(i,j,ifooa), foomajor )
                   if (qsigna .lt. 0.0d0) quantity(i,j,ifooa) = max ( quantity(i,j,ifooa), foomajor )
                 else
                   quantity(i,j,ifooa) = foomajor
                 endif
                                                 
                 if (abs ( foominor - foominoro(j) ) .gt. changemax * foominoro(j)) then
                   quantity(i,j,ifoob) = (1.0d0 + qsignb * changemax) * foominoro(j)
                   if (qsignb .gt. 0.0d0) quantity(i,j,ifoob) = min ( quantity(i,j,ifoob), foominor )
                   if (qsignb .lt. 0.0d0) quantity(i,j,ifoob) = max ( quantity(i,j,ifoob), foominor )
                 else
                   quantity(i,j,ifoob) = foominor
                 endif

                 quantity(i,j,ifoot) = foothepa
                 if (quantity(i,j,ifoot) .le. 0.0d0) then
                   quantity(i,j,ifoot) = quantity(i,j,ifoot) + 180.0d0
                 elseif (quantity(i,j,ifoot) .gt. 180.0d0) then
                   quantity(i,j,ifoot) = quantity(i,j,ifoot) - 180.0d0
                 endif
               endif
             endif
           enddo
         enddo
         
! Determine improved footprints.
                                                        
         do i=1,nwaves

           lcw = lastc ( cwave0(i) )

           do m=1,ny
             do l=1,nx
               if (converge(nfpiter,i) .ne. '-') then 
                 foots(l,m) = 0.0d0
                 foota(l,m) = 0.0d0
                 flatfoots(l,m) = 0.0d0
               endif
               if (liter_phase2 .or. liter_phase3) then
                 noise(l,m) = 0.0d0
               endif
               if (.not.lhandlesubstruc) then
                 subsfp(l,m) = 0.0d0
               endif
             enddo
           enddo

           do j=1,nextr(1)
             semimajor = quantity(i,j,ifooa) / 2.0d0
             nr = nint ( semimajor / pixsize )
             l0 = nint ( quantity(1,j,ixcopx) )
             m0 = nint ( quantity(1,j,iycopx) )
             l1 = max ( l0 - nr , 1 )
             l2 = min ( l0 + nr , nx )
             m1 = max ( m0 - nr , 1 )
             m2 = min ( m0 + nr , ny )

             if (converge(nfpiter,i) .ne. '-') then 
               if (cno(j)(1:1) .ne. '!' .and. 
     &             lhighatwave(i,j) .and. lgoodatwave(i,j) .and. lnormalsize(i,j) .and. lnormalgood(j)) then
                 do m=m1,m2
                   dblm = dble ( m )
                   do l=l1,l2
                     dbll = dble ( l )
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                             , quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                       foots(l,m) = dble ( j )
                     endif
                     if (aperture(i) .gt. almostzero) then
                       if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), 2.0d0 * aperture(i)
     &                               , 2.0d0 * aperture(i), quantity(i,j,ifoot) )) then
                         foota(l,m) = dble ( j )
                       endif
                     else  
                       foota(l,m) = foots(l,m)
                     endif
                   enddo
                 enddo

                 do m=m1,m2
                   dblm = dble ( m )
                   do l=l1,l2
                     dbll = dble ( l )
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                             , quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                       flatfoots(l,m) = dble ( j )
                     endif
                   enddo
                 enddo
               endif
             endif

             if (liter_phase2 .or. liter_phase3) then
               if (cno(j)(1:1) .ne. '!') then
                 do m=m1,m2
                   dblm = dble ( m )
                   do l=l1,l2
                     dbll = dble ( l )
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                             , quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                       noise(l,m) = quantity(i,j,ifxpe)
                     endif
                   enddo
                 enddo
               endif
             endif
             
             if (.not.lhandlesubstruc) then
               if (lsubatwave(i,j)) then
                 do m=m1,m2
                   dblm = dble ( m )
                   do l=l1,l2
                     dbll = dble ( l )
                     if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                             , quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                       subsfp(l,m) = dble ( j )
                     endif
                   enddo
                 enddo
               endif
             endif
           enddo
           
           if (converge(nfpiter,i) .ne. '-') then 
           
             call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, bsomask, dx, dy, object, ra, dec
     &                  , bsomaskname(i)(1:ibm(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1
     &                  , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
             do m=1,ny
               do l=1,nx
                 newfootarea(i) = newfootarea(i) + min ( foots(l,m), 1.0d0 ) * bsomask(l,m)
               enddo
             enddo
             nfootareait(nfpiter,i) = newfootarea(i)

             if (.not.lfirstiteration) then
               dfootarea(i) = 0.0d0
               if (newfootarea(i) + oldfootarea(i) .gt. 0.0d0) then
                 dfootarea(i) = (newfootarea(i) - oldfootarea(i)) * 2.0d0 / (newfootarea(i) + oldfootarea(i))
               endif
             endif
             dfootareait(nfpiter,i) = dfootarea(i)
           else
             nfootareait(nfpiter,i) = oldfootarea(i)
           endif
           
           if (converge(nfpiter,i) .ne. '-') then 
             if (lverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing footprints '''//finfootname(i)(1:iff(i))//'''...'
             endif
           
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, foots, dx, dy, object, crval1
     &                  , crval2, finfootname(i)(1:iff(i)), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2
     &                  , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )

             if (lverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing aperture footprints '''//finfootnama(i)(1:ifa(i))//'''...'
             endif
            
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, foota, dx, dy, object, crval1
     &                  , crval2, finfootnama(i)(1:ifa(i)), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2
     &                  , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
            
             if (lverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing flattening footprints '''//'flatfoot.'//cwave0(i)(1:lcw)//'.fits'//'''...'
             endif
         
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, flatfoots, dx, dy, object
     &                  , crval1, crval2, 'flatfoot.'//cwave0(i)(1:lcw)//'.fits', header, footer, cdate, ctime, creator, beamd
     &                  , blank, crota1, crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax
     &                  , history )
           endif
    
           if (liter_phase2 .or. liter_phase3) then
             if (lverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing noise image '''//noisename(i)(1:inn(i))//'''...'
             endif
         
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, noise, dx, dy, object, crval1
     &                  , crval2, noisename(i)(1:inn(i)), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2, cd11
     &                  , cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
           endif
           
           if (.not.lhandlesubstruc) then
             if (lverbose .eq. '-verb2') then
               write (iotty,'(a)') '   Writing subs footprints image '''//subsfootpr(i)(1:isf(i))//'''...'
             endif
        
             call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, subsfp, dx, dy, object
     &                  , crval1, crval2, subsfootpr(i)(1:isf(i)), header, footer, cdate, ctime, creator, beamd, blank, crota1
     &                  , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
           endif
         enddo 

         if (.not.lfirstiteration) then
           lallsmall = .true.
           do i=1,nwaves
             lcw = lastc ( cwave0(i) )
             inquire ( file='+wave.'//cwave0(i)(1:lcw)//'.done', exist=lfdone(i) )
             if (abs ( dfootarea(i) ) .lt. reldiffmax .or. (converge(nfpiter,i) .ne. 'n' .and. converge(nfpiter-1,i) .eq. '-')) then
               converge(nfpiter,i) = '-'
               if (.not.lfdone(i)) then
                 open ( 65, file='+wave.'//cwave0(i)(1:lcw)//'.done', status='new' )
                 write (65,'(a,i2,a)') 'wave '//cwave0(i)(1:lcw)//' converged in ', nfpiter,' iterations.'
                 close ( 65 )
                 lfdone(i) = .true.
               endif
             endif
             if (converge(nfpiter,i) .ne. '-') lallsmall = .false.
           enddo

           if (nextrgoodvold .gt. 0 .and. nextrgoodold .gt. 0 .and. lallsmall) then 
           
             if (lverbose .eq. '-verb2') then
               write (iotty,'(a,3i5,20(f9.5))') 
     &                      '   Converged: ', nextrgoodvold, nextrgoodold, nextrgoodnew, (dfootarea(i), i=1,nwaves)
             endif
             lconverge = .true.
           else  
             if (lverbose .eq. '-verb2') then
               write (iotty,'(a,3i5,20(f9.5))') 
     &                      '   Iterating: ', nextrgoodvold, nextrgoodold, nextrgoodnew, (dfootarea(i), i=1,nwaves)
             endif
           endif
         endif

         if (liter_phase2 .or. liter_phase3) then
           deallocate ( noise )
         endif

         if (.not.lhandlesubstruc) then
           deallocate ( subsfp )
         endif
         
         deallocate ( foots, foota, bsomask, flatfoots, foomajoro, foominoro, foothepao )
       endif                
                            
       deallocate ( footlimit )
       
       do i=1,nwaves
         do j=1,nextr(1)
           if (cno(j)(1:1) .ne. '!' .and. 
     &         (.not.lhighatwave(i,j) .or. .not.lgoodatwave(i,j) .or. .not.lnormalsize(i,j) .or. .not.lnormalgood(j))) then 
             quantity(i,j,ifooa) = -quantity(i,j,ifooa)
             quantity(i,j,ifoob) = -quantity(i,j,ifoob)
             quantity(i,j,ifoot) = -quantity(i,j,ifoot)
           endif
         enddo
       enddo

       if (ltiming) then
         cput_updatefoots = cput_updatefoots + timer ( 'cpu', cpu_updatefoots )
         walt_updatefoots = walt_updatefoots + timer ( 'wal', wal_updatefoots )
       endif
       
!-----------------------------------------------------------------------------------------------------------------------------------

! Rewrite the input catalogs at each wavelength, flagging all bad entries.

       if (ltiming) then
         cpu_updatecats = timer ( 'cpu', 0.0d0 )
         wal_updatecats = timer ( 'wal', 0.0d0 )
       endif

       do i=1,nwaves       
         if (lverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Rewriting catalog '''//cat(i)(1:icat(i))//'''...'
         endif
      
         open ( 15, file=cat(i)(1:icat(i)), status='unknown' )
      
         m = 0
         do k=1,nhead(i)
           lhl = lastc ( headline(i,k) )
           ncolumn = index ( headline(i,k)(1:lhl), '# Configuration parameters ' )
           if (ncolumn .eq. 0) then
             ncolumn = index ( headline(i,k)(1:lhl), '# CONFIGURATION PARAMETERS ' )
           endif
           if (ncolumn .gt. 0 .or. (m .gt. 0 .and. m .le. nconfigend)) then
             m = m + 1
             lh = lastc ( headlineout(m) )
             write (15,'(a)') '#'//headlineout(m)(2:lh)
           else
             write (15,'(a)') headline(i,k)(1:lhl)
           endif
         enddo
         lcl = lastc ( headline(i,nhead(i)-1) )
         do j=1,nextr(i)
           catline(i,j)(1:1) = cno(j)(1:1)                                                                                                       
           lcno = lastc ( comment(j) ) - 1
           write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
           write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
           if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'

! Update the values of FS, FOOAMAJO, FOOBMINO, and FOOTHEPA modified above.

           write (catline(i,j)(ncolskipfsflg+1:ncolskipfsflg+3),'(a3)') cflag
           write (catline(i,j)(ncolskipfmflg:ncolskipfmflg+4),'(a5)') cfmflag(i)
           write (catline(i,j)(ncolskipafw+1:ncolskipafw+33),'(3(1pe11.3))') 
     &           quantity(i,j,iafwh), quantity(i,j,ibfwh), quantity(i,j,ithep)
           write (catline(i,j)(ncolskipfoo+1:ncolskipfoo+33),'(3(1pe11.3))') 
     &           quantity(i,j,ifooa), quantity(i,j,ifoob), quantity(i,j,ifoot)
           write (15,'(a)') catline(i,j)(1:lcl)//comment(j)(1:lcno)
         enddo

         close ( 15 )
       enddo
      
       do i=1,nwaves       
         catreliable = cat(i)(1:icat(i)-4)//'.reliable.cat'
         icatr = lastc ( catreliable )
         
         if (lverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Writing catalog '''//catreliable(1:icatr)//'''...'
         endif
      
         open ( 16, file=catreliable(1:icatr), status='unknown' )
      
         m = 0
         do k=1,nhead(i)
           lhl = lastc ( headline(i,k) )
           ncolumn = index ( headline(i,k)(1:lhl), '# Configuration parameters ' )
           if (ncolumn .eq. 0) then
             ncolumn = index ( headline(i,k)(1:lhl), '# CONFIGURATION PARAMETERS ' )
           endif
           if (ncolumn .gt. 0 .or. (m .gt. 0 .and. m .le. nconfigend)) then
             m = m + 1
             lh = lastc ( headlineout(m) )
             write (16,'(a)') '#'//headlineout(m)(2:lh)
           else
             write (16,'(a)') headline(i,k)(1:lhl)
           endif
         enddo
         lcl = lastc ( headline(i,nhead(i)-1) )
         do j=1,nextr(i)
           if (cno(j)(1:1) .ne. '!' .and. quantity(1,j,igodn) .gt. 0.0d0) then
             catline(i,j)(1:1) = cno(j)(1:1)                                                                                                       
             lcno = lastc ( comment(j) ) - 1
             write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
             write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
             if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'

! Update the values of FS, FOOAMAJO, FOOBMINO, and FOOTHEPA modified above.

             write (catline(i,j)(ncolskipfsflg+1:ncolskipfsflg+3),'(a3)') cflag
             write (catline(i,j)(ncolskipfmflg:ncolskipfmflg+4),'(a5)') cfmflag(i)
             write (catline(i,j)(ncolskipafw+1:ncolskipafw+33),'(3(1pe11.3))') 
     &             quantity(i,j,iafwh), quantity(i,j,ibfwh), quantity(i,j,ithep)
             write (catline(i,j)(ncolskipfoo+1:ncolskipfoo+33),'(3(1pe11.3))')
     &             quantity(i,j,ifooa), quantity(i,j,ifoob), quantity(i,j,ifoot)
             write (16,'(a)') catline(i,j)(1:lcl)//comment(j)(1:lcno)
           endif
         enddo
      
         close ( 16 )
       enddo

       nsubstruc = 0

       if (lfinishing_mode .and. lhandlesubstruc) then
         do i=1,nwaves       
           catsubstruc = cat(i)(1:icat(i)-4)//'.substruc.cat'
           icats = lastc ( catsubstruc )
           
           do j=1,nextr(i)
             write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
             if (cno(j)(1:1) .eq. '!' .and. cfmon(1:1) .eq. '1') then
               nsubstruc = nsubstruc + 1
               exit
             endif
           enddo
           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Writing catalog '''//catsubstruc(1:icats)//'''...'
           endif
        
           open ( 17, file=catsubstruc(1:icats), status='unknown' )
        
           m = 0
           do k=1,nhead(i)
             lhl = lastc ( headline(i,k) )
             ncolumn = index ( headline(i,k)(1:lhl), '# Configuration parameters ' )
             if (ncolumn .eq. 0) then
               ncolumn = index ( headline(i,k)(1:lhl), '# CONFIGURATION PARAMETERS ' )
             endif
             if (ncolumn .gt. 0 .or. (m .gt. 0 .and. m .le. nconfigend)) then
               m = m + 1
               lh = lastc ( headlineout(m) )
               write (17,'(a)') '#'//headlineout(m)(2:lh)
             else
               write (17,'(a)') headline(i,k)(1:lhl)
             endif
           enddo
           lcl = lastc ( headline(i,nhead(i)-1) )
           do j=1,nextr(i)
             write (cfmon,'(i3.3)') nint ( quantity(i,j,ifmon) ) 
             if (cfmon(1:1) .eq. '1') then
               catline(i,j)(1:1) = ' '
               lcno = lastc ( comment(j) ) - 1
               write (cflag,'(i3)') nint ( quantity(1,j,iflag) )
               write (cfmflag(i),'(i5)') sfm(i,j) * nint ( quantity(i,j,ifmon) )
               if (sfm(i,j) .eq. -1 .and. cfmflag(i) .eq. '    0') cfmflag(i) = '   -0'

! Update the values of FS, FOOAMAJO, FOOBMINO, and FOOTHEPA modified above.

               write (catline(i,j)(ncolskipfsflg+1:ncolskipfsflg+3),'(a3)') cflag
               write (catline(i,j)(ncolskipfmflg:ncolskipfmflg+4),'(a5)') cfmflag(i)
               write (catline(i,j)(ncolskipafw+1:ncolskipafw+33),'(3(1pe11.3))') 
     &               quantity(i,j,iafwh), quantity(i,j,ibfwh), quantity(i,j,ithep)
               write (catline(i,j)(ncolskipfoo+1:ncolskipfoo+33),'(3(1pe11.3))')
     &               quantity(i,j,ifooa), quantity(i,j,ifoob), quantity(i,j,ifoot)
               write (17,'(a)') catline(i,j)(1:lcl)//comment(j)(1:lcno)
             endif
           enddo
        
           close ( 17 )
         enddo
       endif

       if (ltiming) then
         cput_updatecats = cput_updatecats + timer ( 'cpu', cpu_updatecats )
         walt_updatecats = walt_updatecats + timer ( 'wal', wal_updatecats )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

! Following will be computed only when the iterations in GETSOURCES have converged.       
       
       if (lfinishing_mode) then
              
         if (ltiming) then
           cpu_backfitsrc = timer ( 'cpu', 0.0d0 )
           wal_backfitsrc = timer ( 'wal', 0.0d0 )
         endif

! Write intensity distributions for fitted elliptical sources.

         allocate ( obsfsimage(nx,ny), obscbr(nx,ny), obscbrt(nx,ny), obscbfsr(nx,ny), obscbfsrt(nx,ny), moffatr(nx,ny)
     &            , moffatrt(nx,ny), stat=irc )
       
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   FINALCAT: ERROR: Trouble allocating memory (84).'
           stop 84
         endif
       
         if (lverbose .eq. '-verb2') then
           write (iotty,'(a)') '   Computing images of background and fitted sources...'
         endif

         do i=1,nwaves
       
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsimage, dx, dy, object, ra, dec
     &                , obsname(i)(1:iobs(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
       
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsfsimage, dx, dy, object, ra, dec
     &                , obsfsname(i)(1:iobsfs(i)), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
          
           do m=1,ny
             do l=1,nx
               obscbr(l,m) = obsimage(l,m)
               obscbrt(l,m) = obsimage(l,m)
               obscbfsr(l,m) = obsfsimage(l,m)
               obscbfsrt(l,m) = obsfsimage(l,m)
               moffatr(l,m) = 0.0d0
               moffatrt(l,m) = 0.0d0
             enddo
           enddo

! good: SIG_MONO > 5 and FXP_BEST / FXP_ERRO > 1 and AFWHM < SRCMAXSIZE and (FXP_BEST / FXP_ERRO > 2 * 1 or  AFWHM / BFWHM < 3)
!  bad: SIG_MONO < 5 or  FXP_BEST / FXP_ERRO < 1  or AFWHM > SRCMAXSIZE  or (FXP_BEST / FXP_ERRO < 2 * 1 and AFWHM / BFWHM > 3)
       
           do j=1,nextr(1)
             if (cno(j)(1:1) .ne. '!') then
               sigmaa2 = (quantity(i,j,iafwh) / 2.0d0)**2 * correct
               sigmab2 = (quantity(i,j,ibfwh) / 2.0d0)**2 * correct
               angle = (90.0d0 - quantity(i,j,ithep)) * convtoradians
               cosa2 = cos ( angle )**2
               sina2 = sin ( angle )**2
               sin2a = sin ( 2.0d0 * angle )
               aa =  cosa2 / sigmaa2 + sina2 / sigmab2
               bb = -sin2a / sigmaa2 + sin2a / sigmab2
               cc =  sina2 / sigmaa2 + cosa2 / sigmab2
               semimajor = quantity(i,j,ifooa) / 2.0d0
               nr = nint ( semimajor / pixsize )
               l0 = nint ( quantity(1,j,ixcopx) )
               m0 = nint ( quantity(1,j,iycopx) )
               l1 = max ( l0 - nr , 1 )
               l2 = min ( l0 + nr , nx )
               m1 = max ( m0 - nr , 1 )
               m2 = min ( m0 + nr , ny )
               do m=m1,m2
                 dblm = dble ( m )
                 dycon = (dblm - quantity(1,j,iycopx)) * dy
                 dycon2 = dycon**2
                 do l=l1,l2
                   dbll = dble ( l )
                   dxcon = (dbll - quantity(1,j,ixcopx)) * dx
                   dxcon2 = dxcon**2
                   if (inellipse ( dbll, dblm, dx, dy, quantity(1,j,ixcopx), quantity(1,j,iycopx), quantity(i,j,ifooa)
     &                           , quantity(i,j,ifoob), quantity(i,j,ifoot) )) then
                     argmoffat = aa * dxcon2 + bb * dxcon * dycon + cc * dycon2
                     moffatfun = quantity(i,j,ifxpb) / (1.0d0 + argmoffat)**beta

                     if (quantity(i,j,isigm) .ge. stentative) then
                       moffatr(l,m) = moffatr(l,m) + moffatfun
                     endif
                     if (quantity(i,j,isigm) .gt. sreliable .and. quantity(1,j,igodn) .gt. 0.0d0) then
                       moffatrt(l,m) = moffatrt(l,m) + moffatfun
                     endif

                     if (quantity(i,j,isigm) .ge. stentative) then
                       obscbrt(l,m) = obscbrt(l,m) - moffatfun
                       obscbfsrt(l,m) = obscbfsrt(l,m) - moffatfun
                     endif
                     if (quantity(i,j,isigm) .gt. sreliable .and. quantity(1,j,igodn) .gt. 0.0d0) then
                       obscbr(l,m) = obscbr(l,m) - moffatfun
                       obscbfsr(l,m) = obscbfsr(l,m) - moffatfun
                     endif
                   endif
                 enddo
               enddo
             endif
           enddo
       
           finbgrname = cat(i)(1:idot4-1)//'.bg.reliable.fits'
           ifbr = lastc ( finbgrname )
           finbgrtname = cat(i)(1:idot4-1)//'.bg.relitent.fits'
           ifbrt = lastc ( finbgrtname )
           finbgfsrname = cat(i)(1:idot4-1)//'.bg.fs.reliable.fits'
           ifgr = lastc ( finbgfsrname )
           finbgfsrtname = cat(i)(1:idot4-1)//'.bg.fs.relitent.fits'
           ifgrt = lastc ( finbgfsrtname )
           finmoffatrname = cat(i)(1:idot4-1)//'.mo.reliable.fits'
           ifmr = lastc ( finmoffatrname )
           finmoffatrtname = cat(i)(1:idot4-1)//'.mo.relitent.fits'
           ifmrt = lastc ( finmoffatrtname )

           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Writing (filamentary) background '''//finbgrname(1:ifbr)//'''...'
           endif
       
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbr, dx, dy, object
     &                , crval1, crval2, finbgrname(1:ifbr), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
       
           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Writing (filamentary) background '''//finbgrtname(1:ifbrt)//'''...'
           endif
       
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbrt, dx, dy, object
     &                , crval1, crval2, finbgrtname(1:ifbrt), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
       
           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Writing (filament-subtracted) background '''//finbgfsrname(1:ifgr)//'''...'
           endif
       
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbfsr, dx, dy, object
     &                , crval1, crval2, finbgfsrname(1:ifgr), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
       
           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Writing (filament-subtracted) background '''//finbgfsrtname(1:ifgrt)//'''...'
           endif
       
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obscbfsrt, dx, dy, object
     &                , crval1, crval2, finbgfsrtname(1:ifgrt), header, footer, cdate, ctime, creator, beamd, blank, crota1
     &                , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
       
           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Writing sources (as deblending shapes) '''//finmoffatrname(1:ifgr)//'''...'
           endif
       
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, moffatr, dx, dy, object
     &                , crval1, crval2, finmoffatrname(1:ifgr), header, footer, cdate, ctime, creator, beamd, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
       
           if (lverbose .eq. '-verb2') then
             write (iotty,'(a)') '   Writing sources (as deblending shapes) '''//finmoffatrtname(1:ifgrt)//'''...'
           endif
       
           call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, moffatrt, dx, dy, object
     &                , crval1, crval2, finmoffatrtname(1:ifgrt), header, footer, cdate, ctime, creator, beamd, blank, crota1
     &                , crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
         enddo
         
         deallocate ( obsbsfsimage )

         deallocate ( obsimage )

         deallocate ( obsfsimage, obscbr, obscbrt, obscbfsr, obscbfsrt, moffatr, moffatrt )

         if (ltiming) then
           cput_backfitsrc = cput_backfitsrc + timer ( 'cpu', cpu_backfitsrc )
           walt_backfitsrc = walt_backfitsrc + timer ( 'wal', wal_backfitsrc )
         endif
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing iterations in '''//footitname(1:lfti)//'''...'
       
       open ( 15, file=footitname(1:lfti), status='unknown' )
       
       do ih=1,nheadfpit
         lhl = lastc ( headfpitline(ih) )
         write (15,'(a)') headfpitline(ih)(1:lhl)
       enddo
       
       do it=1,nfpiter
         write (15,'(i4,2i7,3x,i1,20(3x,a1,f10.5,1pe15.7,0p))') itfp(it), nextrgoodit(it), nextrbadit(it), iter_phase(it)
     &                                                        , (converge(it,i), dfootareait(it,i), nfootareait(it,i), i=1,nwaves)
       enddo
       
       close ( 15 )
       
       deallocate ( no, ns1, ns2, nsx, catline, quantity, factor, factsmoo, cno, comment, flag, badsource, backgint, backgsmoint
     &            , nok, lhighatwave, lgoodatwave, lnormalsize, lnormalgood, lsubatwave, snrglobal, globelong, dist2peaks
     &            , dist2foots, sfm, cfmflag )
       
!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_sum = cpu_sum + cput_flagsources + cput_substructured + cput_semifinalcat + cput_finalcats
     &                     + cput_additioncats + cput_profimages + cput_updatefoots + cput_updatecats + cput_backfitsrc
         wal_sum = wal_sum + walt_flagsources + walt_substructured + walt_semifinalcat + walt_finalcats
     &                     + walt_additioncats + walt_profimages + walt_updatefoots + walt_updatecats + walt_backfitsrc

! Total cpu usage, expressed in hours, minutes, and seconds.

         cputot = cpu_sum
         cpuhours = int ( cputot / 3600.0d0 )
         cpumins  = int ( cputot / 60.0d0 ) -  60 * cpuhours
         cpusecs  = int ( cputot + 0.5d0 ) - 3600 * cpuhours - 60 * cpumins

! Final wall clock time, expressed in hours, minutes, and seconds.

         wctot  = wal_sum
         wchours  = int ( wctot / 3600.0d0 )
         wcmins   = int ( wctot / 60.0d0 ) -  60 * wchours
         wcsecs   = int ( wctot + 0.5d0 ) - 3600 * wchours - 60 * wcmins

         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLAG SOURCES''    CPU',cput_flagsources  ,' REAL',cput_flagsources  ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''SUBSTRUCTURED''   CPU',cput_substructured,' REAL',cput_substructured,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''SEMIFINAL CAT''   CPU',cput_semifinalcat ,' REAL',cput_semifinalcat ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FINAL CATS''      CPU',cput_finalcats    ,' REAL',cput_finalcats    ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''ADDITIONAL CATS'' CPU',cput_additioncats ,' REAL',cput_additioncats ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''PROFILES IMAGES'' CPU',cput_profimages   ,' REAL',cput_profimages   ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''UPDATE FOOTS''    CPU',cput_updatefoots  ,' REAL',cput_updatefoots  ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''UPDATE CATS''     CPU',cput_updatecats   ,' REAL',cput_updatecats   ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''BACKGR FITSRC''   CPU',cput_backfitsrc   ,' REAL',cput_backfitsrc   ,' sec'
         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' ACCUMULATED CPU & REAL TIME' ,cpu_sum             ,' sec ',wal_sum            ,' sec'
         write (60,'(a,i3.2,a,i2.2,a,i2.2,a,i3.2,a,i2.2,a,i2.2,a,f7.2,a)')
     &             ' ---------------------------',cpuhours,':',cpumins,':',cpusecs,' ----',wchours,':',wcmins,':',wcsecs,' ---'
  
         call when ( lunix, ctime, cdate, ndate, 4 )
  
         write (60,'(a)') ' FINALCAT finished: '//cdate//' '//ctime
         close ( 60 )
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(/a)') ' Done.'

       if (lconverge .or. lfinishing_mode) then
         if (lfinishing_mode) then
           if (nsubstruc .gt. 0) then
             stop 100
           else
             stop 10
           endif
         else
           stop 9
         endif
       endif

!!       stop !<-- commented out because it would lead to run-time messages about denormalized values, when using gfortran.
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header, footer, iotty
     &            , iolog, creator, beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history, lverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend, anynull, myfile
       character*(*) ctype1, ctype2, creator, fname, header, footer(2), bunit, object, history, lverbose
       character*25  cdatetime
       character*80  footer1, footer2, comment
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, lastc, iotty, iolog, maxdim
     &             , ilc1, ilc2, rw, nfound, blank, stat01, stat02, stat03, stat04, stat05, stat06, stat07, stat08, stat09
     &             , stat10, stat11, stat12, stat13, stat14, stat15, stat16, stat17, stat18, stat19, stat20, stat21, stat22
     &             , stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30, stat31, stat32, stat0, nan
       parameter   ( maxdim = 2 )
       integer       naxes(maxdim)
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22
       real*8        fun(nx,ny)
       real*8        as2deg, datamx, datamn
       parameter   ( as2deg = 1.0d0 / 3600.0d0 )
       external      lastc, ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat01 = 0
       stat02 = 0
       stat03 = 0
       stat04 = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:22) .eq. 'Alexander Men`shchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'FINALCAT'
       endif

       header = 'FITS Plot Header'

       if (myfile) then
         call ftgkys ( unit, 'HEADER' , header , comment, stat01 )
         call ftgkys ( unit, 'FOOTER1', footer1, comment, stat02 )
         call ftgkys ( unit, 'FOOTER2', footer2, comment, stat03 )
         ilc1 = lastc ( footer1 )
         ilc2 = lastc ( footer2 )
         if (ilc1 .ne. 0 .and. ilc2 .ne. 0) then
           footer(1) = footer1(1:ilc1)//footer2(1:ilc2)
         else
           footer(1) = 'Footer'
         endif
       else
         call ftgkys ( unit, 'OBJECT' , header, comment, stat04 )
         if (stat04 .ne. 0 .or. header(1:10) .eq. '          ') header = fname
         footer(1) = header
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. Maybe
! there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat08 = 0
       stat0 = stat01 + stat02 + stat03 + stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15
     &       + stat16 + stat17 + stat18 + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28
     &       + stat29 + stat30 + stat31

       if (lverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat01 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword HEADER absent or error'
         if (stat02 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER1 absent or error'
         if (stat03 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER2 absent or error'
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat29 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EPOCH absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = 'No object specified'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       nan = 0
       do j=1,ny
         do i=1,nx
           if (isnan ( fun(i,j) )) then  
             nan = nan + 1
             if (lverbose .ne. '-verb0') then
               if (nan .lt. 100) then
                 write (iotty,'(a,i4,a,i4,a)') '   RFITS: Element (', i,',', j, ') contains not a number (NaN)...'
               elseif (nan .eq. 100) then
                 write (iotty,'(a)') '   RFITS: Many NaNs, no more info on the elements.'
               endif
             endif
           else
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header
     &            , footer, cdate, ctime, creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, header, footer(2), ctime, cdate, bunit, cfitsversion, history
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), iat, iflen
     &             , lastc, blank
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, dfun, rot1, rot2, epoch, equinox, datamn
     &             , cosrota, sinrota, rotangle, datamx, dxdeg, dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      lastc
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny

! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       do j=1,ny
         do i=1,nx
           dfun = fun(i,j)
           if (dfun .lt. datamn ) datamn = dfun
           if (dfun .gt. datamx ) datamx = dfun
         enddo
       enddo

       bitpix = -32     !<-- single precision floating-point values

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator,'Alexander Men`shchikov, SAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'HEADER' , header, 'title', status )

       iat = 0
       iat = index ( footer(1), ' |F' )
       if (iat .eq. 0) iat = index ( footer(1), ' mm ' )
       iflen = lastc ( footer(1) )

       if (iat .gt. 0) then
         call ftpkys ( unit, 'FOOTER1', footer(1)(1:iat-1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', footer(1)(iat:iflen), 'part 2', status )
       else
         call ftpkys ( unit, 'FOOTER1', footer(1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', ' ', 'part 2', status )
       endif
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = dx * as2deg
       dydeg = dy * as2deg

! Correct if the input images had cd11 or cd22 set to zero.

       if (abs ( cd11 ) .lt. almostzero .or. abs ( cd11 ) .gt. dxdeg) then
         cd11 = -dxdeg
         cd12 = 0.0d0
       endif
       if (abs ( cd22 ) .lt. almostzero .or. abs ( cd22 ) .gt. dxdeg) then
         cd21 = 0.0d0
         cd22 = dydeg
       endif
       
       cosrota = - cd11 / dxdeg
       sinrota = - cd12 / dxdeg
       rotangle = acos ( cosrota ) * 180.0d0 / pi
       
       if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = 180.0d0 - rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = 180.0d0 + rotangle
       elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = - rotangle
       endif
       rot2 = rot1

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
       if  (blank .gt. 0)
     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , -dxdeg, 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftpkyd ( unit, 'EPOCH'  , epoch  , 13, ' ', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, ' ', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'image was convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||