
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       program smeasure
!__________________________________________________________________________________________________________________________________
!
! Measure fluxes and shapes for each identified source.
!
! This code is part of GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay
!
! Return codes:
!
!   10-29 ... problems with the input parameters
!   30-49 ... non-existing files or directories
!   50-69 ... problems with reading/writing files or values
!   70-89 ... problems with memory allocation
!   90-99 ... other code-specific problems
!__________________________________________________________________________________________________________________________________
!
       implicit      none
 
       integer       iotty, ncolmax

       parameter   ( ncolmax = 100, iotty = 6 )
 
       logical       inellipse, lfnam1, lfnam3, lfnam5, lfnam6, lfnam7, lfnam8, lfnam9, lunix, lnotwarned, lallsmall, lfirstcall
     &             , ldevelopment, lmysimsky, lfnwcs, ltiming, ltime, liter_phase1, liter_phase2, liter_phase3, lfinishing_mode
     &             , ltruebacknoise, lann1usable, lann2usable, lann3usable, lonlypositives
                                                                          
       character*1   capcorr
       character*2   cniter
       character*3   cskipsigglo, cskipfluxes, cskipcoords
       character*5   con, cnextrbad, cnextrgood, cfpptime, coosystem
       character*6   cfitsversion, lverbose, czno
       character*7   clibname                                             
       character*8   ctime
       character*10  cdate, intensunits, fmtwcs
       character*21  compda
       character*40  cpixel, cbeam, cowave, caprad
       character*80  object, creator, ctype1, ctype2, bunit, history
       character*128 header, footer(2), csnt, cnwd, csnr, cfto
       character*500 dirmono, obsbsfsname, icatname, ocatname, obsfsname, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9
     &             , argA, argB, argC, argD, argE, argF, argG, obsname, maskname, bgname, filewithnames, originpath, truebgnoname
     &             , wcsfile, annulusname, cbfsname, sswavename(100)
       character*12000 headline(1000)
 
       integer       firstb, lastc, lasts, i, ic, iobsbsfs, nx, ny, ia1, ia2, ia3, ia4, ia5, ia6, ia7, ia8, ia9, iaA, iaB, iaC, iaD
     &             , iaE, l, m, n, j, nhead, nextr, ncolumns, iicat, iocat, blank, icp, icb, iu, ncolumn, iobscb, iobs, iaF, irc
     &             , icon, nsigglo, nfluxes, nxcopix, npeakfx, k, iter, ndate, idot2, idot3, idot4, nbad, ibad, igood, iobsn, ibs
     &             , ibg, ibav, isw, ncolumn1, isnt, isnr, beta, nfiles, iss, nheadf, nfiles1, ian, ibavf, ibrmsf, iaG, nfiles2, no
     &             , ns1, ns2, nsx, kk, isca, inwd, l1, l2, m1, m2, nr, imsk, ifdn, iopa, na070, na100, na160, na250, na350, na500
     &             , icw, ica, idmon, idot, lb, iann, ir, ntry, n1xmin, n2xmax, n1ymin, n2ymax, iwcs, l1x, ifto, l2x, m1x, m2x
     &             , nwavesdetect, n1y, n2y, wchours, wcmins, wcsecs, cpuhours, cpumins, cpusecs, icar, ibav0, ibav1, ibav2, ibrms0
     &             , ibrms1, ibrms2, nrz, l1z, l2z, m1z, m2z, itruebg, ibav3, ibrms3, icbfs, nkovl
 
       parameter   ( na070 = 141, na100 = 141, na160 = 141, na250 = 700, na350 = 700, na500 = 700 )
       
       real          fitsvers
       real*8        dx, dy, wave, crpix1, crpix2, crval1, crval2, ra, dec, beamd, funmin, funmax, crota1, crota2, epoch, equinox
     &             , bzero, bscale, datamin, datamax, pixel, beam, sq_arcsecs_per_sterad, pi, sq_arcsecs_per_beam_area, convftot1
     &             , sqpixel, intd, xcorc, ycorc, intxx, intyy, intxy, dblm, dbll, int0m, sqreightlogtwo, convtodegrees, funn
     &             , funk, funsum, deblend, sigmarms, ratio1, factor, factoff, intx, inty, obsbsfsmin, changemax, qsign, factrms
     &             , obsbsfsmax, stentative, sreliable, correct, convtoradians, sigmaa2, sigmab2, angle, cosa2, sina2, sin2a
     &             , amoffat, rmsav, sigma(100), cutoff(100), sigmas(100), sscale(100), semimajor, major1, minor1, major2, minor2
     &             , areapix1, areapix2, thickpix, rad2, rad2x, rad2min, rad2max, dist2, aperture, semimajor1, semiminor1, sfactor
     &             , semimajor2, semiminor2, owave, frac, factortotal, almostzero, newpixval, radmin, radmax, annulusarea, aaa, bbb
     &             , ccc, sterad_per_beam_area, cd11, cd12, cd21, cd22, backav0, backrms0, annulusareait, deficit, dxdeg, dydeg
     &             , major1a, minor1a, semimajor1a, semiminor1a, semimajor2a, semiminor2a, major2a, minor2a, absobsfsatpos
     &             , cutoffmax, sigmamax, deblended, fp2error, ft2error, fprat1, ftrat1, fprat2, ftrat2, upperlimit
     
       real*8        cpu_readimages, wal_readimages, cpu_iteratepeaks, wal_iteratepeaks, cpu_secondmoments, wal_secondmoments
     &             , cpu_totalfluxes, wal_totalfluxes, cpu_fittedfluxes, wal_fittedfluxes, cpu_createannuli, wal_createannuli
     &             , cpu_fluctuations, wal_fluctuations, cpu_significances, wal_significances, cpu_fluctuations1, cpu_fluctuations2
     &             , cpu_fluctuations3, cpu_fluctuations4, cpu_fluctuations5, wal_fluctuations1, wal_fluctuations2
     &             , wal_fluctuations3, wal_fluctuations4, wal_fluctuations5
     
       real*8        cput_readimages, walt_readimages, cput_iteratepeaks, walt_iteratepeaks, cput_secondmoments, walt_secondmoments
     &             , cput_totalfluxes, walt_totalfluxes, cput_fittedfluxes, walt_fittedfluxes, cput_createannuli, walt_createannuli
     &             , cput_fluctuations, walt_fluctuations, cput_significances, timer, walt_significances, cpu_sum, wal_sum, cputot
     &             , wctot, cput_fluctuations1, cput_fluctuations2, cput_fluctuations3, cput_fluctuations4, cput_fluctuations5
     &             , walt_fluctuations1, walt_fluctuations2, walt_fluctuations3, walt_fluctuations4, walt_fluctuations5
     
       real*8        ar070(na070), af070(na070), ar100(na100), af100(na100), ar160(na160), af160(na160)
     &             , ar250(na250), af250(na250), ar350(na350), af350(na350), ar500(na500), af500(na500)
     
       logical        , allocatable :: lconverged(:), lfootprint(:), lfootexpandable(:)
       character*1    , allocatable :: flag(:), badsource(:)
       character*5    , allocatable :: cflm(:)
       character*12000, allocatable :: catline(:)
       integer        , allocatable :: numpix(:), numpixbg(:), flg(:), flm(:), n1x(:), n2x(:), nxco(:), nyco(:)
       real*8         , allocatable :: obsbsfsimage(:,:), obsfsimage(:,:), momxco(:), momyco(:), momxx(:), momyy(:), slope(:)
     &                               , momxy(:), int0(:), afwhm(:), bfwhm(:), atheta(:), fluxpeakbest(:), fluxpko(:), fluxtotfit(:)
     &                               , fluxtotbest(:), equivrad(:), sigmono(:), scalensx(:), sigglob(:), apcorrect(:), fluxpksso(:)
     &                               , backrms(:), fluxperror(:), fluxterror(:), dxcon2(:,:), backrms3(:), surround(:), nkovlap(:)
     &                               , dycon2(:,:), ssimage(:,:), aa(:), bb(:), cc(:), fluxpkss(:), footfact(:), foomajor(:)
     &                               , foominor(:), foothepa(:), convdelta(:,:), maskimage(:,:), bigfoot(:,:), smafoot(:,:), good(:)
     &                               , annulus(:,:), wcsxco(:), wcsyco(:), ratiomax(:), ssimagemax(:), worker(:,:), workerf(:,:)
     &                               , foamajor(:), foaminor(:), foathepa(:), truebacknoise(:,:), cbfsimage(:,:), pedestal(:)
     &                               , backav1(:), backav2(:), backav3(:), backavf(:), backrmsf(:), backrms1(:), backrms2(:)

       parameter   ( sq_arcsecs_per_sterad = 3282.80635d0 * 3600.0d0**2, pi = 3.14159265358979d0, convtodegrees = 180.0d0 / pi 
     &             , convtoradians = pi / 180.0d0, factor = 2.0d0 / 2.0d0**2 / log ( 4.0d0 ), almostzero = 1.0d-30
     &             , factoff = 1.3d0 )

       parameter   ( beta = 10, correct = 1.0d0 / (2.0d0**(1.0d0 / dble ( beta )) - 1.0d0) )

       parameter   ( ltiming = .true. )
       
! Tables for the aperture corrections at all Herschel wavelengths. The PACS tables were taken in the early days of March 2011 from 
! the Herschel Science Centre's web site. The SPIRE tables were computed in early March 2011 by Philippe Andre using the images of 
! measured PSFs for SPIRE. 

       data (ar070(i),i=1,na070)
     &    / 1.0417, 1.0853, 1.1306, 1.1779, 1.2271, 1.2784, 1.3318, 1.3875, 1.4455, 1.5059, 1.5689, 1.6344, 1.7027, 1.7739, 1.8480,
     &      1.9253, 2.0057, 2.0896, 2.1769, 2.2679, 2.3627, 2.4614, 2.5643, 2.6715, 2.7831, 2.8994, 3.0206, 3.1468, 3.2784, 3.4154,
     &      3.5581, 3.7068, 3.8618, 4.0231, 4.1913, 4.3665, 4.5490, 4.7391, 4.9371, 5.1435, 5.3584, 5.5824, 5.8157, 6.0587, 6.3120,
     &      6.5758, 6.8506, 7.1369, 7.4352, 7.7459, 8.0696, 8.4069, 8.7583, 9.1243, 9.5056, 9.9029, 10.316, 10.748, 11.197, 11.665,
     &      12.152, 12.660, 13.189, 13.740, 14.315, 14.913, 15.536, 16.186, 16.862, 17.567, 18.301, 19.066, 19.863, 20.693, 21.558,
     &      22.459, 23.397, 24.375, 25.394, 26.455, 27.561, 28.713, 29.913, 31.163, 32.465, 33.822, 35.236, 36.709, 38.243, 39.841,
     &      41.506, 43.241, 45.048, 46.931, 48.892, 50.936, 53.064, 55.282, 57.593, 60.000, 63.095, 67.608, 72.443, 77.624, 83.176,
     &      89.125, 95.499, 102.32, 109.64, 117.48, 125.89, 134.89, 144.54, 154.88, 165.95, 177.82, 190.54, 204.17, 218.77, 234.42,
     &      251.18, 269.15, 288.40, 309.02, 331.13, 354.81, 380.18, 407.38, 436.51, 467.73, 501.18, 537.03, 575.43, 616.59, 660.69,
     &      707.94, 758.57, 812.83, 870.96, 933.25, 1000.0 /
       data (af070(i),i=1,na070)
     &    / 0.0568, 0.0614, 0.0664, 0.0718, 0.0776, 0.0840, 0.0908, 0.0983, 0.1064, 0.1151, 0.1239, 0.1330, 0.1426, 0.1527, 0.1634,
     &      0.1748, 0.1869, 0.1998, 0.2136, 0.2283, 0.2441, 0.2611, 0.2785, 0.2951, 0.3119, 0.3290, 0.3466, 0.3650, 0.3842, 0.4044,
     &      0.4248, 0.4433, 0.4609, 0.4785, 0.4961, 0.5139, 0.5319, 0.5476, 0.5622, 0.5764, 0.5905, 0.6046, 0.6170, 0.6292, 0.6413,
     &      0.6536, 0.6653, 0.6771, 0.6891, 0.7009, 0.7124, 0.7239, 0.7348, 0.7449, 0.7547, 0.7633, 0.7711, 0.7783, 0.7845, 0.7903,
     &      0.7955, 0.8004, 0.8052, 0.8099, 0.8148, 0.8198, 0.8251, 0.8304, 0.8358, 0.8411, 0.8460, 0.8504, 0.8544, 0.8580, 0.8613,
     &      0.8644, 0.8674, 0.8704, 0.8734, 0.8764, 0.8793, 0.8821, 0.8848, 0.8875, 0.8901, 0.8927, 0.8953, 0.8978, 0.9004, 0.9030,
     &      0.9056, 0.9081, 0.9107, 0.9132, 0.9158, 0.9184, 0.9211, 0.9239, 0.9268, 0.9297, 0.9319, 0.9362, 0.9404, 0.9446, 0.9486,
     &      0.9522, 0.9556, 0.9589, 0.9624, 0.9660, 0.9694, 0.9726, 0.9754, 0.9779, 0.9802, 0.9823, 0.9842, 0.9860, 0.9875, 0.9889,
     &      0.9901, 0.9912, 0.9921, 0.9930, 0.9937, 0.9944, 0.9950, 0.9956, 0.9960, 0.9965, 0.9970, 0.9974, 0.9978, 0.9983, 0.9987,
     &      0.9990, 0.9993, 0.9995, 0.9997, 0.9998, 1.0000 /   
       data (ar100(i),i=1,na100)
     &    / 1.0417, 1.0853, 1.1306, 1.1779, 1.2271, 1.2784, 1.3318, 1.3875, 1.4455, 1.5059, 1.5689, 1.6344, 1.7027, 1.7739, 1.8480,
     &      1.9253, 2.0057, 2.0896, 2.1769, 2.2679, 2.3627, 2.4614, 2.5643, 2.6715, 2.7831, 2.8994, 3.0206, 3.1468, 3.2784, 3.4154,
     &      3.5581, 3.7068, 3.8618, 4.0231, 4.1913, 4.3665, 4.5490, 4.7391, 4.9371, 5.1435, 5.3584, 5.5824, 5.8157, 6.0587, 6.3120,
     &      6.5758, 6.8506, 7.1369, 7.4352, 7.7459, 8.0696, 8.4069, 8.7583, 9.1243, 9.5056, 9.9029, 10.316, 10.748, 11.197, 11.665,
     &      12.152, 12.660, 13.189, 13.740, 14.315, 14.913, 15.536, 16.186, 16.862, 17.567, 18.301, 19.066, 19.863, 20.693, 21.558,
     &      22.459, 23.397, 24.375, 25.394, 26.455, 27.561, 28.713, 29.913, 31.163, 32.465, 33.822, 35.236, 36.709, 38.243, 39.841,
     &      41.506, 43.241, 45.048, 46.931, 48.892, 50.936, 53.064, 55.282, 57.593, 60.000, 63.095, 67.608, 72.443, 77.624, 83.176,
     &      89.125, 95.499, 102.32, 109.64, 117.48, 125.89, 134.89, 144.54, 154.88, 165.95, 177.82, 190.54, 204.17, 218.77, 234.42,
     &      251.18, 269.15, 288.40, 309.02, 331.13, 354.81, 380.18, 407.38, 436.51, 467.73, 501.18, 537.03, 575.43, 616.59, 660.69,
     &      707.94, 758.57, 812.83, 870.96, 933.25, 1000.0 /
       data (af100(i),i=1,na100)
     &    / 0.0405, 0.0439, 0.0475, 0.0515, 0.0558, 0.0604, 0.0654, 0.0708, 0.0767, 0.0831, 0.0897, 0.0967, 0.1041, 0.1120, 0.1204,
     &      0.1295, 0.1391, 0.1495, 0.1607, 0.1727, 0.1856, 0.1995, 0.2140, 0.2285, 0.2435, 0.2592, 0.2756, 0.2929, 0.3113, 0.3308,
     &      0.3509, 0.3701, 0.3892, 0.4087, 0.4286, 0.4492, 0.4703, 0.4894, 0.5076, 0.5254, 0.5432, 0.5607, 0.5757, 0.5896, 0.6029,
     &      0.6158, 0.6268, 0.6370, 0.6469, 0.6563, 0.6653, 0.6744, 0.6838, 0.6935, 0.7037, 0.7144, 0.7254, 0.7368, 0.7479, 0.7589,
     &      0.7691, 0.7787, 0.7872, 0.7948, 0.8013, 0.8070, 0.8120, 0.8163, 0.8202, 0.8239, 0.8275, 0.8312, 0.8352, 0.8396, 0.8443,
     &      0.8492, 0.8539, 0.8584, 0.8627, 0.8665, 0.8700, 0.8732, 0.8761, 0.8788, 0.8814, 0.8840, 0.8865, 0.8891, 0.8917, 0.8943,
     &      0.8969, 0.8994, 0.9018, 0.9042, 0.9066, 0.9090, 0.9114, 0.9140, 0.9167, 0.9194, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000 /
       data (ar160(i),i=1,na160)
     &    / 1.0417, 1.0853, 1.1306, 1.1779, 1.2271, 1.2784, 1.3318, 1.3875, 1.4455, 1.5059, 1.5689, 1.6344, 1.7027, 1.7739, 1.8480,
     &      1.9253, 2.0057, 2.0896, 2.1769, 2.2679, 2.3627, 2.4614, 2.5643, 2.6715, 2.7831, 2.8994, 3.0206, 3.1468, 3.2784, 3.4154,
     &      3.5581, 3.7068, 3.8618, 4.0231, 4.1913, 4.3665, 4.5490, 4.7391, 4.9371, 5.1435, 5.3584, 5.5824, 5.8157, 6.0587, 6.3120,
     &      6.5758, 6.8506, 7.1369, 7.4352, 7.7459, 8.0696, 8.4069, 8.7583, 9.1243, 9.5056, 9.9029, 10.316, 10.748, 11.197, 11.665,
     &      12.152, 12.660, 13.189, 13.740, 14.315, 14.913, 15.536, 16.186, 16.862, 17.567, 18.301, 19.066, 19.863, 20.693, 21.558,
     &      22.459, 23.397, 24.375, 25.394, 26.455, 27.561, 28.713, 29.913, 31.163, 32.465, 33.822, 35.236, 36.709, 38.243, 39.841,
     &      41.506, 43.241, 45.048, 46.931, 48.892, 50.936, 53.064, 55.282, 57.593, 60.000, 63.095, 67.608, 72.443, 77.624, 83.176,
     &      89.125, 95.499, 102.32, 109.64, 117.48, 125.89, 134.89, 144.54, 154.88, 165.95, 177.82, 190.54, 204.17, 218.77, 234.42,
     &      251.18, 269.15, 288.40, 309.02, 331.13, 354.81, 380.18, 407.38, 436.51, 467.73, 501.18, 537.03, 575.43, 616.59, 660.69,
     &      707.94, 758.57, 812.83, 870.96, 933.25, 1000.0 /
       data (af160(i),i=1,na160)
     &    / 0.0163, 0.0177, 0.0192, 0.0208, 0.0226, 0.0245, 0.0266, 0.0288, 0.0313, 0.0339, 0.0367, 0.0398, 0.0430, 0.0465, 0.0503,
     &      0.0544, 0.0588, 0.0636, 0.0688, 0.0743, 0.0804, 0.0869, 0.0939, 0.1012, 0.1090, 0.1174, 0.1264, 0.1360, 0.1463, 0.1575,
     &      0.1693, 0.1816, 0.1945, 0.2081, 0.2226, 0.2381, 0.2544, 0.2710, 0.2882, 0.3061, 0.3249, 0.3446, 0.3640, 0.3837, 0.4041,
     &      0.4251, 0.4453, 0.4655, 0.4860, 0.5059, 0.5248, 0.5436, 0.5615, 0.5782, 0.5944, 0.6092, 0.6231, 0.6363, 0.6482, 0.6597,
     &      0.6703, 0.6807, 0.6907, 0.7008, 0.7108, 0.7210, 0.7314, 0.7419, 0.7524, 0.7628, 0.7728, 0.7824, 0.7913, 0.7995, 0.8069,
     &      0.8134, 0.8193, 0.8246, 0.8293, 0.8337, 0.8378, 0.8419, 0.8460, 0.8503, 0.8547, 0.8593, 0.8638, 0.8682, 0.8724, 0.8763,
     &      0.8801, 0.8836, 0.8870, 0.8903, 0.8936, 0.8968, 0.8998, 0.9027, 0.9054, 0.9081, 0.9109, 0.9151, 0.9191, 0.9231, 0.9270,
     &      0.9308, 0.9345, 0.9381, 0.9414, 0.9446, 0.9477, 0.9507, 0.9537, 0.9567, 0.9595, 0.9623, 0.9650, 0.9677, 0.9704, 0.9730,
     &      0.9754, 0.9778, 0.9801, 0.9823, 0.9844, 0.9864, 0.9883, 0.9900, 0.9916, 0.9930, 0.9945, 0.9958, 0.9970, 0.9980, 0.9989,
     &      0.9995, 0.9998, 1.0000, 0.9999, 0.9997, 0.9996 /
       data (ar250(i),i=1,na250)
     &    / 1.0000, 2.0000, 3.0000, 4.0000, 5.0000, 6.0000, 7.0000, 8.0000, 9.0000, 10.000, 11.000, 12.000, 13.000, 14.000, 15.000,
     &      16.000, 17.000, 18.000, 19.000, 20.000, 21.000, 22.000, 23.000, 24.000, 25.000, 26.000, 27.000, 28.000, 29.000, 30.000,
     &      31.000, 32.000, 33.000, 34.000, 35.000, 36.000, 37.000, 38.000, 39.000, 40.000, 41.000, 42.000, 43.000, 44.000, 45.000,
     &      46.000, 47.000, 48.000, 49.000, 50.000, 51.000, 52.000, 53.000, 54.000, 55.000, 56.000, 57.000, 58.000, 59.000, 60.000,
     &      61.000, 62.000, 63.000, 64.000, 65.000, 66.000, 67.000, 68.000, 69.000, 70.000, 71.000, 72.000, 73.000, 74.000, 75.000,
     &      76.000, 77.000, 78.000, 79.000, 80.000, 81.000, 82.000, 83.000, 84.000, 85.000, 86.000, 87.000, 88.000, 89.000, 90.000,
     &      91.000, 92.000, 93.000, 94.000, 95.000, 96.000, 97.000, 98.000, 99.000, 100.00, 101.00, 102.00, 103.00, 104.00, 105.00,
     &      106.00, 107.00, 108.00, 109.00, 110.00, 111.00, 112.00, 113.00, 114.00, 115.00, 116.00, 117.00, 118.00, 119.00, 120.00,
     &      121.00, 122.00, 123.00, 124.00, 125.00, 126.00, 127.00, 128.00, 129.00, 130.00, 131.00, 132.00, 133.00, 134.00, 135.00,
     &      136.00, 137.00, 138.00, 139.00, 140.00, 141.00, 142.00, 143.00, 144.00, 145.00, 146.00, 147.00, 148.00, 149.00, 150.00,
     &      151.00, 152.00, 153.00, 154.00, 155.00, 156.00, 157.00, 158.00, 159.00, 160.00, 161.00, 162.00, 163.00, 164.00, 165.00,
     &      166.00, 167.00, 168.00, 169.00, 170.00, 171.00, 172.00, 173.00, 174.00, 175.00, 176.00, 177.00, 178.00, 179.00, 180.00,
     &      181.00, 182.00, 183.00, 184.00, 185.00, 186.00, 187.00, 188.00, 189.00, 190.00, 191.00, 192.00, 193.00, 194.00, 195.00,
     &      196.00, 197.00, 198.00, 199.00, 200.00, 201.00, 202.00, 203.00, 204.00, 205.00, 206.00, 207.00, 208.00, 209.00, 210.00,
     &      211.00, 212.00, 213.00, 214.00, 215.00, 216.00, 217.00, 218.00, 219.00, 220.00, 221.00, 222.00, 223.00, 224.00, 225.00,
     &      226.00, 227.00, 228.00, 229.00, 230.00, 231.00, 232.00, 233.00, 234.00, 235.00, 236.00, 237.00, 238.00, 239.00, 240.00,
     &      241.00, 242.00, 243.00, 244.00, 245.00, 246.00, 247.00, 248.00, 249.00, 250.00, 251.00, 252.00, 253.00, 254.00, 255.00,
     &      256.00, 257.00, 258.00, 259.00, 260.00, 261.00, 262.00, 263.00, 264.00, 265.00, 266.00, 267.00, 268.00, 269.00, 270.00,
     &      271.00, 272.00, 273.00, 274.00, 275.00, 276.00, 277.00, 278.00, 279.00, 280.00, 281.00, 282.00, 283.00, 284.00, 285.00,
     &      286.00, 287.00, 288.00, 289.00, 290.00, 291.00, 292.00, 293.00, 294.00, 295.00, 296.00, 297.00, 298.00, 299.00, 300.00,
     &      301.00, 302.00, 303.00, 304.00, 305.00, 306.00, 307.00, 308.00, 309.00, 310.00, 311.00, 312.00, 313.00, 314.00, 315.00,
     &      316.00, 317.00, 318.00, 319.00, 320.00, 321.00, 322.00, 323.00, 324.00, 325.00, 326.00, 327.00, 328.00, 329.00, 330.00,
     &      331.00, 332.00, 333.00, 334.00, 335.00, 336.00, 337.00, 338.00, 339.00, 340.00, 341.00, 342.00, 343.00, 344.00, 345.00,
     &      346.00, 347.00, 348.00, 349.00, 350.00, 351.00, 352.00, 353.00, 354.00, 355.00, 356.00, 357.00, 358.00, 359.00, 360.00,
     &      361.00, 362.00, 363.00, 364.00, 365.00, 366.00, 367.00, 368.00, 369.00, 370.00, 371.00, 372.00, 373.00, 374.00, 375.00,
     &      376.00, 377.00, 378.00, 379.00, 380.00, 381.00, 382.00, 383.00, 384.00, 385.00, 386.00, 387.00, 388.00, 389.00, 390.00,
     &      391.00, 392.00, 393.00, 394.00, 395.00, 396.00, 397.00, 398.00, 399.00, 400.00, 401.00, 402.00, 403.00, 404.00, 405.00,
     &      406.00, 407.00, 408.00, 409.00, 410.00, 411.00, 412.00, 413.00, 414.00, 415.00, 416.00, 417.00, 418.00, 419.00, 420.00,
     &      421.00, 422.00, 423.00, 424.00, 425.00, 426.00, 427.00, 428.00, 429.00, 430.00, 431.00, 432.00, 433.00, 434.00, 435.00,
     &      436.00, 437.00, 438.00, 439.00, 440.00, 441.00, 442.00, 443.00, 444.00, 445.00, 446.00, 447.00, 448.00, 449.00, 450.00,
     &      451.00, 452.00, 453.00, 454.00, 455.00, 456.00, 457.00, 458.00, 459.00, 460.00, 461.00, 462.00, 463.00, 464.00, 465.00,
     &      466.00, 467.00, 468.00, 469.00, 470.00, 471.00, 472.00, 473.00, 474.00, 475.00, 476.00, 477.00, 478.00, 479.00, 480.00,
     &      481.00, 482.00, 483.00, 484.00, 485.00, 486.00, 487.00, 488.00, 489.00, 490.00, 491.00, 492.00, 493.00, 494.00, 495.00,
     &      496.00, 497.00, 498.00, 499.00, 500.00, 501.00, 502.00, 503.00, 504.00, 505.00, 506.00, 507.00, 508.00, 509.00, 510.00,
     &      511.00, 512.00, 513.00, 514.00, 515.00, 516.00, 517.00, 518.00, 519.00, 520.00, 521.00, 522.00, 523.00, 524.00, 525.00,
     &      526.00, 527.00, 528.00, 529.00, 530.00, 531.00, 532.00, 533.00, 534.00, 535.00, 536.00, 537.00, 538.00, 539.00, 540.00,
     &      541.00, 542.00, 543.00, 544.00, 545.00, 546.00, 547.00, 548.00, 549.00, 550.00, 551.00, 552.00, 553.00, 554.00, 555.00,
     &      556.00, 557.00, 558.00, 559.00, 560.00, 561.00, 562.00, 563.00, 564.00, 565.00, 566.00, 567.00, 568.00, 569.00, 570.00,
     &      571.00, 572.00, 573.00, 574.00, 575.00, 576.00, 577.00, 578.00, 579.00, 580.00, 581.00, 582.00, 583.00, 584.00, 585.00,
     &      586.00, 587.00, 588.00, 589.00, 590.00, 591.00, 592.00, 593.00, 594.00, 595.00, 596.00, 597.00, 598.00, 599.00, 600.00,
     &      601.00, 602.00, 603.00, 604.00, 605.00, 606.00, 607.00, 608.00, 609.00, 610.00, 611.00, 612.00, 613.00, 614.00, 615.00,
     &      616.00, 617.00, 618.00, 619.00, 620.00, 621.00, 622.00, 623.00, 624.00, 625.00, 626.00, 627.00, 628.00, 629.00, 630.00,
     &      631.00, 632.00, 633.00, 634.00, 635.00, 636.00, 637.00, 638.00, 639.00, 640.00, 641.00, 642.00, 643.00, 644.00, 645.00,
     &      646.00, 647.00, 648.00, 649.00, 650.00, 651.00, 652.00, 653.00, 654.00, 655.00, 656.00, 657.00, 658.00, 659.00, 660.00,
     &      661.00, 662.00, 663.00, 664.00, 665.00, 666.00, 667.00, 668.00, 669.00, 670.00, 671.00, 672.00, 673.00, 674.00, 675.00,
     &      676.00, 677.00, 678.00, 679.00, 680.00, 681.00, 682.00, 683.00, 684.00, 685.00, 686.00, 687.00, 688.00, 689.00, 690.00,
     &      691.00, 692.00, 693.00, 694.00, 695.00, 696.00, 697.00, 698.00, 699.00, 700.00 /
       data (af250(i),i=1,na250)
     &    / 0.0205, 0.0493, 0.0959, 0.1476, 0.2065, 0.2717, 0.3397, 0.4065, 0.4731, 0.5331, 0.5894, 0.6371, 0.6780, 0.7115, 0.7386,
     &      0.7598, 0.7757, 0.7869, 0.7954, 0.8022, 0.8076, 0.8126, 0.8176, 0.8232, 0.8295, 0.8362, 0.8437, 0.8517, 0.8595, 0.8674,
     &      0.8745, 0.8818, 0.8881, 0.8938, 0.8989, 0.9032, 0.9070, 0.9100, 0.9127, 0.9149, 0.9168, 0.9185, 0.9200, 0.9214, 0.9226,
     &      0.9238, 0.9250, 0.9262, 0.9275, 0.9287, 0.9301, 0.9315, 0.9330, 0.9346, 0.9362, 0.9378, 0.9396, 0.9413, 0.9430, 0.9448,
     &      0.9465, 0.9481, 0.9497, 0.9512, 0.9527, 0.9540, 0.9552, 0.9564, 0.9574, 0.9583, 0.9592, 0.9600, 0.9607, 0.9613, 0.9619,
     &      0.9625, 0.9630, 0.9635, 0.9640, 0.9645, 0.9649, 0.9654, 0.9658, 0.9663, 0.9667, 0.9671, 0.9676, 0.9680, 0.9684, 0.9688,
     &      0.9693, 0.9697, 0.9700, 0.9704, 0.9708, 0.9712, 0.9715, 0.9719, 0.9722, 0.9726, 0.9729, 0.9733, 0.9736, 0.9739, 0.9743,
     &      0.9746, 0.9749, 0.9752, 0.9755, 0.9759, 0.9762, 0.9765, 0.9768, 0.9771, 0.9774, 0.9777, 0.9780, 0.9783, 0.9786, 0.9789,
     &      0.9792, 0.9794, 0.9797, 0.9800, 0.9802, 0.9805, 0.9807, 0.9810, 0.9812, 0.9815, 0.9817, 0.9819, 0.9822, 0.9824, 0.9827,
     &      0.9829, 0.9831, 0.9834, 0.9836, 0.9838, 0.9841, 0.9843, 0.9845, 0.9848, 0.9850, 0.9852, 0.9855, 0.9857, 0.9859, 0.9861,
     &      0.9863, 0.9865, 0.9867, 0.9869, 0.9871, 0.9873, 0.9875, 0.9877, 0.9879, 0.9881, 0.9882, 0.9884, 0.9886, 0.9887, 0.9889,
     &      0.9891, 0.9892, 0.9894, 0.9895, 0.9897, 0.9899, 0.9900, 0.9901, 0.9903, 0.9904, 0.9906, 0.9907, 0.9908, 0.9909, 0.9911,
     &      0.9912, 0.9913, 0.9914, 0.9915, 0.9916, 0.9917, 0.9918, 0.9919, 0.9920, 0.9921, 0.9922, 0.9923, 0.9924, 0.9925, 0.9925,
     &      0.9926, 0.9927, 0.9928, 0.9929, 0.9930, 0.9931, 0.9931, 0.9932, 0.9933, 0.9934, 0.9935, 0.9936, 0.9937, 0.9938, 0.9939,
     &      0.9940, 0.9940, 0.9941, 0.9942, 0.9943, 0.9944, 0.9945, 0.9946, 0.9946, 0.9947, 0.9948, 0.9948, 0.9949, 0.9950, 0.9950,
     &      0.9951, 0.9951, 0.9952, 0.9952, 0.9953, 0.9953, 0.9954, 0.9954, 0.9955, 0.9955, 0.9955, 0.9956, 0.9956, 0.9957, 0.9957,
     &      0.9958, 0.9958, 0.9959, 0.9959, 0.9960, 0.9961, 0.9961, 0.9962, 0.9962, 0.9963, 0.9963, 0.9964, 0.9965, 0.9965, 0.9966,
     &      0.9966, 0.9966, 0.9967, 0.9967, 0.9968, 0.9968, 0.9968, 0.9969, 0.9969, 0.9969, 0.9969, 0.9969, 0.9970, 0.9970, 0.9970,
     &      0.9970, 0.9970, 0.9970, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9972,
     &      0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9973, 0.9973,
     &      0.9973, 0.9973, 0.9973, 0.9973, 0.9974, 0.9974, 0.9974, 0.9974, 0.9974, 0.9975, 0.9975, 0.9975, 0.9975, 0.9976, 0.9976,
     &      0.9976, 0.9976, 0.9976, 0.9977, 0.9977, 0.9977, 0.9977, 0.9978, 0.9978, 0.9978, 0.9978, 0.9979, 0.9979, 0.9979, 0.9980,
     &      0.9980, 0.9980, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982,
     &      0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9981, 0.9981, 0.9981,
     &      0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981, 0.9981,
     &      0.9982, 0.9982, 0.9982, 0.9982, 0.9982, 0.9983, 0.9983, 0.9983, 0.9984, 0.9984, 0.9984, 0.9985, 0.9985, 0.9986, 0.9986,
     &      0.9987, 0.9987, 0.9988, 0.9989, 0.9989, 0.9990, 0.9991, 0.9992, 0.9992, 0.9993, 0.9994, 0.9995, 0.9996, 0.9997, 0.9997,
     &      0.9998, 0.9999, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000 /
       data (ar350(i),i=1,na350)
     &    / 1.0000, 2.0000, 3.0000, 4.0000, 5.0000, 6.0000, 7.0000, 8.0000, 9.0000, 10.000, 11.000, 12.000, 13.000, 14.000, 15.000,
     &      16.000, 17.000, 18.000, 19.000, 20.000, 21.000, 22.000, 23.000, 24.000, 25.000, 26.000, 27.000, 28.000, 29.000, 30.000,
     &      31.000, 32.000, 33.000, 34.000, 35.000, 36.000, 37.000, 38.000, 39.000, 40.000, 41.000, 42.000, 43.000, 44.000, 45.000,
     &      46.000, 47.000, 48.000, 49.000, 50.000, 51.000, 52.000, 53.000, 54.000, 55.000, 56.000, 57.000, 58.000, 59.000, 60.000,
     &      61.000, 62.000, 63.000, 64.000, 65.000, 66.000, 67.000, 68.000, 69.000, 70.000, 71.000, 72.000, 73.000, 74.000, 75.000,
     &      76.000, 77.000, 78.000, 79.000, 80.000, 81.000, 82.000, 83.000, 84.000, 85.000, 86.000, 87.000, 88.000, 89.000, 90.000,
     &      91.000, 92.000, 93.000, 94.000, 95.000, 96.000, 97.000, 98.000, 99.000, 100.00, 101.00, 102.00, 103.00, 104.00, 105.00,
     &      106.00, 107.00, 108.00, 109.00, 110.00, 111.00, 112.00, 113.00, 114.00, 115.00, 116.00, 117.00, 118.00, 119.00, 120.00,
     &      121.00, 122.00, 123.00, 124.00, 125.00, 126.00, 127.00, 128.00, 129.00, 130.00, 131.00, 132.00, 133.00, 134.00, 135.00,
     &      136.00, 137.00, 138.00, 139.00, 140.00, 141.00, 142.00, 143.00, 144.00, 145.00, 146.00, 147.00, 148.00, 149.00, 150.00,
     &      151.00, 152.00, 153.00, 154.00, 155.00, 156.00, 157.00, 158.00, 159.00, 160.00, 161.00, 162.00, 163.00, 164.00, 165.00,
     &      166.00, 167.00, 168.00, 169.00, 170.00, 171.00, 172.00, 173.00, 174.00, 175.00, 176.00, 177.00, 178.00, 179.00, 180.00,
     &      181.00, 182.00, 183.00, 184.00, 185.00, 186.00, 187.00, 188.00, 189.00, 190.00, 191.00, 192.00, 193.00, 194.00, 195.00,
     &      196.00, 197.00, 198.00, 199.00, 200.00, 201.00, 202.00, 203.00, 204.00, 205.00, 206.00, 207.00, 208.00, 209.00, 210.00,
     &      211.00, 212.00, 213.00, 214.00, 215.00, 216.00, 217.00, 218.00, 219.00, 220.00, 221.00, 222.00, 223.00, 224.00, 225.00,
     &      226.00, 227.00, 228.00, 229.00, 230.00, 231.00, 232.00, 233.00, 234.00, 235.00, 236.00, 237.00, 238.00, 239.00, 240.00,
     &      241.00, 242.00, 243.00, 244.00, 245.00, 246.00, 247.00, 248.00, 249.00, 250.00, 251.00, 252.00, 253.00, 254.00, 255.00,
     &      256.00, 257.00, 258.00, 259.00, 260.00, 261.00, 262.00, 263.00, 264.00, 265.00, 266.00, 267.00, 268.00, 269.00, 270.00,
     &      271.00, 272.00, 273.00, 274.00, 275.00, 276.00, 277.00, 278.00, 279.00, 280.00, 281.00, 282.00, 283.00, 284.00, 285.00,
     &      286.00, 287.00, 288.00, 289.00, 290.00, 291.00, 292.00, 293.00, 294.00, 295.00, 296.00, 297.00, 298.00, 299.00, 300.00,
     &      301.00, 302.00, 303.00, 304.00, 305.00, 306.00, 307.00, 308.00, 309.00, 310.00, 311.00, 312.00, 313.00, 314.00, 315.00,
     &      316.00, 317.00, 318.00, 319.00, 320.00, 321.00, 322.00, 323.00, 324.00, 325.00, 326.00, 327.00, 328.00, 329.00, 330.00,
     &      331.00, 332.00, 333.00, 334.00, 335.00, 336.00, 337.00, 338.00, 339.00, 340.00, 341.00, 342.00, 343.00, 344.00, 345.00,
     &      346.00, 347.00, 348.00, 349.00, 350.00, 351.00, 352.00, 353.00, 354.00, 355.00, 356.00, 357.00, 358.00, 359.00, 360.00,
     &      361.00, 362.00, 363.00, 364.00, 365.00, 366.00, 367.00, 368.00, 369.00, 370.00, 371.00, 372.00, 373.00, 374.00, 375.00,
     &      376.00, 377.00, 378.00, 379.00, 380.00, 381.00, 382.00, 383.00, 384.00, 385.00, 386.00, 387.00, 388.00, 389.00, 390.00,
     &      391.00, 392.00, 393.00, 394.00, 395.00, 396.00, 397.00, 398.00, 399.00, 400.00, 401.00, 402.00, 403.00, 404.00, 405.00,
     &      406.00, 407.00, 408.00, 409.00, 410.00, 411.00, 412.00, 413.00, 414.00, 415.00, 416.00, 417.00, 418.00, 419.00, 420.00,
     &      421.00, 422.00, 423.00, 424.00, 425.00, 426.00, 427.00, 428.00, 429.00, 430.00, 431.00, 432.00, 433.00, 434.00, 435.00,
     &      436.00, 437.00, 438.00, 439.00, 440.00, 441.00, 442.00, 443.00, 444.00, 445.00, 446.00, 447.00, 448.00, 449.00, 450.00,
     &      451.00, 452.00, 453.00, 454.00, 455.00, 456.00, 457.00, 458.00, 459.00, 460.00, 461.00, 462.00, 463.00, 464.00, 465.00,
     &      466.00, 467.00, 468.00, 469.00, 470.00, 471.00, 472.00, 473.00, 474.00, 475.00, 476.00, 477.00, 478.00, 479.00, 480.00,
     &      481.00, 482.00, 483.00, 484.00, 485.00, 486.00, 487.00, 488.00, 489.00, 490.00, 491.00, 492.00, 493.00, 494.00, 495.00,
     &      496.00, 497.00, 498.00, 499.00, 500.00, 501.00, 502.00, 503.00, 504.00, 505.00, 506.00, 507.00, 508.00, 509.00, 510.00,
     &      511.00, 512.00, 513.00, 514.00, 515.00, 516.00, 517.00, 518.00, 519.00, 520.00, 521.00, 522.00, 523.00, 524.00, 525.00,
     &      526.00, 527.00, 528.00, 529.00, 530.00, 531.00, 532.00, 533.00, 534.00, 535.00, 536.00, 537.00, 538.00, 539.00, 540.00,
     &      541.00, 542.00, 543.00, 544.00, 545.00, 546.00, 547.00, 548.00, 549.00, 550.00, 551.00, 552.00, 553.00, 554.00, 555.00,
     &      556.00, 557.00, 558.00, 559.00, 560.00, 561.00, 562.00, 563.00, 564.00, 565.00, 566.00, 567.00, 568.00, 569.00, 570.00,
     &      571.00, 572.00, 573.00, 574.00, 575.00, 576.00, 577.00, 578.00, 579.00, 580.00, 581.00, 582.00, 583.00, 584.00, 585.00,
     &      586.00, 587.00, 588.00, 589.00, 590.00, 591.00, 592.00, 593.00, 594.00, 595.00, 596.00, 597.00, 598.00, 599.00, 600.00,
     &      601.00, 602.00, 603.00, 604.00, 605.00, 606.00, 607.00, 608.00, 609.00, 610.00, 611.00, 612.00, 613.00, 614.00, 615.00,
     &      616.00, 617.00, 618.00, 619.00, 620.00, 621.00, 622.00, 623.00, 624.00, 625.00, 626.00, 627.00, 628.00, 629.00, 630.00,
     &      631.00, 632.00, 633.00, 634.00, 635.00, 636.00, 637.00, 638.00, 639.00, 640.00, 641.00, 642.00, 643.00, 644.00, 645.00,
     &      646.00, 647.00, 648.00, 649.00, 650.00, 651.00, 652.00, 653.00, 654.00, 655.00, 656.00, 657.00, 658.00, 659.00, 660.00,
     &      661.00, 662.00, 663.00, 664.00, 665.00, 666.00, 667.00, 668.00, 669.00, 670.00, 671.00, 672.00, 673.00, 674.00, 675.00,
     &      676.00, 677.00, 678.00, 679.00, 680.00, 681.00, 682.00, 683.00, 684.00, 685.00, 686.00, 687.00, 688.00, 689.00, 690.00,
     &      691.00, 692.00, 693.00, 694.00, 695.00, 696.00, 697.00, 698.00, 699.00, 700.00 /
       data (af350(i),i=1,na350)
     &    / 0.0115, 0.0292, 0.0538, 0.0862, 0.1238, 0.1641, 0.2145, 0.2634, 0.3139, 0.3636, 0.4168, 0.4697, 0.5168, 0.5621, 0.6050,
     &      0.6443, 0.6784, 0.7096, 0.7364, 0.7586, 0.7771, 0.7922, 0.8043, 0.8143, 0.8216, 0.8274, 0.8318, 0.8355, 0.8387, 0.8416,
     &      0.8447, 0.8479, 0.8516, 0.8554, 0.8598, 0.8649, 0.8700, 0.8756, 0.8810, 0.8868, 0.8926, 0.8982, 0.9036, 0.9086, 0.9134,
     &      0.9177, 0.9216, 0.9253, 0.9284, 0.9312, 0.9336, 0.9357, 0.9375, 0.9390, 0.9404, 0.9414, 0.9424, 0.9433, 0.9440, 0.9447,
     &      0.9453, 0.9459, 0.9464, 0.9470, 0.9476, 0.9481, 0.9488, 0.9494, 0.9501, 0.9509, 0.9516, 0.9525, 0.9534, 0.9543, 0.9553,
     &      0.9563, 0.9574, 0.9585, 0.9596, 0.9608, 0.9620, 0.9631, 0.9643, 0.9654, 0.9665, 0.9677, 0.9687, 0.9698, 0.9707, 0.9717,
     &      0.9726, 0.9734, 0.9742, 0.9750, 0.9756, 0.9763, 0.9769, 0.9774, 0.9780, 0.9784, 0.9789, 0.9793, 0.9797, 0.9801, 0.9804,
     &      0.9807, 0.9810, 0.9813, 0.9816, 0.9819, 0.9822, 0.9824, 0.9827, 0.9830, 0.9832, 0.9835, 0.9837, 0.9840, 0.9842, 0.9844,
     &      0.9847, 0.9849, 0.9851, 0.9854, 0.9856, 0.9858, 0.9860, 0.9862, 0.9864, 0.9866, 0.9868, 0.9870, 0.9872, 0.9874, 0.9876,
     &      0.9878, 0.9879, 0.9881, 0.9883, 0.9885, 0.9886, 0.9888, 0.9890, 0.9891, 0.9893, 0.9894, 0.9896, 0.9897, 0.9899, 0.9900,
     &      0.9902, 0.9903, 0.9905, 0.9906, 0.9907, 0.9908, 0.9910, 0.9911, 0.9912, 0.9913, 0.9915, 0.9916, 0.9917, 0.9918, 0.9919,
     &      0.9921, 0.9922, 0.9923, 0.9924, 0.9925, 0.9926, 0.9927, 0.9929, 0.9930, 0.9931, 0.9932, 0.9933, 0.9934, 0.9935, 0.9936,
     &      0.9937, 0.9938, 0.9939, 0.9940, 0.9941, 0.9942, 0.9944, 0.9945, 0.9946, 0.9947, 0.9948, 0.9949, 0.9950, 0.9951, 0.9952,
     &      0.9953, 0.9954, 0.9955, 0.9956, 0.9957, 0.9958, 0.9959, 0.9960, 0.9961, 0.9963, 0.9964, 0.9965, 0.9966, 0.9967, 0.9968,
     &      0.9969, 0.9970, 0.9971, 0.9972, 0.9973, 0.9974, 0.9975, 0.9976, 0.9977, 0.9977, 0.9978, 0.9979, 0.9979, 0.9980, 0.9980,
     &      0.9981, 0.9981, 0.9981, 0.9982, 0.9982, 0.9982, 0.9983, 0.9983, 0.9983, 0.9983, 0.9983, 0.9983, 0.9983, 0.9984, 0.9984,
     &      0.9984, 0.9984, 0.9984, 0.9984, 0.9984, 0.9985, 0.9985, 0.9985, 0.9985, 0.9985, 0.9985, 0.9985, 0.9985, 0.9985, 0.9986,
     &      0.9986, 0.9986, 0.9986, 0.9986, 0.9986, 0.9985, 0.9985, 0.9985, 0.9985, 0.9985, 0.9984, 0.9984, 0.9984, 0.9983, 0.9983,
     &      0.9983, 0.9982, 0.9982, 0.9981, 0.9981, 0.9980, 0.9980, 0.9980, 0.9979, 0.9979, 0.9978, 0.9978, 0.9977, 0.9977, 0.9976,
     &      0.9976, 0.9976, 0.9975, 0.9975, 0.9974, 0.9974, 0.9974, 0.9973, 0.9973, 0.9973, 0.9972, 0.9972, 0.9972, 0.9972, 0.9971,
     &      0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970,
     &      0.9970, 0.9970, 0.9970, 0.9970, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971,
     &      0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972,
     &      0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9972, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971, 0.9971,
     &      0.9971, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970, 0.9970,
     &      0.9970, 0.9971, 0.9971, 0.9971, 0.9971, 0.9972, 0.9972, 0.9972, 0.9973, 0.9973, 0.9974, 0.9974, 0.9975, 0.9975, 0.9976,
     &      0.9977, 0.9977, 0.9978, 0.9979, 0.9980, 0.9981, 0.9981, 0.9982, 0.9983, 0.9984, 0.9985, 0.9986, 0.9987, 0.9988, 0.9989,
     &      0.9990, 0.9990, 0.9991, 0.9992, 0.9993, 0.9994, 0.9994, 0.9995, 0.9995, 0.9996, 0.9997, 0.9997, 0.9998, 0.9998, 0.9999,
     &      0.9999, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000 /
       data (ar500(i),i=1,na500)
     &    / 1.0000, 2.0000, 3.0000, 4.0000, 5.0000, 6.0000, 7.0000, 8.0000, 9.0000, 10.000, 11.000, 12.000, 13.000, 14.000, 15.000,
     &      16.000, 17.000, 18.000, 19.000, 20.000, 21.000, 22.000, 23.000, 24.000, 25.000, 26.000, 27.000, 28.000, 29.000, 30.000,
     &      31.000, 32.000, 33.000, 34.000, 35.000, 36.000, 37.000, 38.000, 39.000, 40.000, 41.000, 42.000, 43.000, 44.000, 45.000,
     &      46.000, 47.000, 48.000, 49.000, 50.000, 51.000, 52.000, 53.000, 54.000, 55.000, 56.000, 57.000, 58.000, 59.000, 60.000,
     &      61.000, 62.000, 63.000, 64.000, 65.000, 66.000, 67.000, 68.000, 69.000, 70.000, 71.000, 72.000, 73.000, 74.000, 75.000,
     &      76.000, 77.000, 78.000, 79.000, 80.000, 81.000, 82.000, 83.000, 84.000, 85.000, 86.000, 87.000, 88.000, 89.000, 90.000,
     &      91.000, 92.000, 93.000, 94.000, 95.000, 96.000, 97.000, 98.000, 99.000, 100.00, 101.00, 102.00, 103.00, 104.00, 105.00,
     &      106.00, 107.00, 108.00, 109.00, 110.00, 111.00, 112.00, 113.00, 114.00, 115.00, 116.00, 117.00, 118.00, 119.00, 120.00,
     &      121.00, 122.00, 123.00, 124.00, 125.00, 126.00, 127.00, 128.00, 129.00, 130.00, 131.00, 132.00, 133.00, 134.00, 135.00,
     &      136.00, 137.00, 138.00, 139.00, 140.00, 141.00, 142.00, 143.00, 144.00, 145.00, 146.00, 147.00, 148.00, 149.00, 150.00,
     &      151.00, 152.00, 153.00, 154.00, 155.00, 156.00, 157.00, 158.00, 159.00, 160.00, 161.00, 162.00, 163.00, 164.00, 165.00,
     &      166.00, 167.00, 168.00, 169.00, 170.00, 171.00, 172.00, 173.00, 174.00, 175.00, 176.00, 177.00, 178.00, 179.00, 180.00,
     &      181.00, 182.00, 183.00, 184.00, 185.00, 186.00, 187.00, 188.00, 189.00, 190.00, 191.00, 192.00, 193.00, 194.00, 195.00,
     &      196.00, 197.00, 198.00, 199.00, 200.00, 201.00, 202.00, 203.00, 204.00, 205.00, 206.00, 207.00, 208.00, 209.00, 210.00,
     &      211.00, 212.00, 213.00, 214.00, 215.00, 216.00, 217.00, 218.00, 219.00, 220.00, 221.00, 222.00, 223.00, 224.00, 225.00,
     &      226.00, 227.00, 228.00, 229.00, 230.00, 231.00, 232.00, 233.00, 234.00, 235.00, 236.00, 237.00, 238.00, 239.00, 240.00,
     &      241.00, 242.00, 243.00, 244.00, 245.00, 246.00, 247.00, 248.00, 249.00, 250.00, 251.00, 252.00, 253.00, 254.00, 255.00,
     &      256.00, 257.00, 258.00, 259.00, 260.00, 261.00, 262.00, 263.00, 264.00, 265.00, 266.00, 267.00, 268.00, 269.00, 270.00,
     &      271.00, 272.00, 273.00, 274.00, 275.00, 276.00, 277.00, 278.00, 279.00, 280.00, 281.00, 282.00, 283.00, 284.00, 285.00,
     &      286.00, 287.00, 288.00, 289.00, 290.00, 291.00, 292.00, 293.00, 294.00, 295.00, 296.00, 297.00, 298.00, 299.00, 300.00,
     &      301.00, 302.00, 303.00, 304.00, 305.00, 306.00, 307.00, 308.00, 309.00, 310.00, 311.00, 312.00, 313.00, 314.00, 315.00,
     &      316.00, 317.00, 318.00, 319.00, 320.00, 321.00, 322.00, 323.00, 324.00, 325.00, 326.00, 327.00, 328.00, 329.00, 330.00,
     &      331.00, 332.00, 333.00, 334.00, 335.00, 336.00, 337.00, 338.00, 339.00, 340.00, 341.00, 342.00, 343.00, 344.00, 345.00,
     &      346.00, 347.00, 348.00, 349.00, 350.00, 351.00, 352.00, 353.00, 354.00, 355.00, 356.00, 357.00, 358.00, 359.00, 360.00,
     &      361.00, 362.00, 363.00, 364.00, 365.00, 366.00, 367.00, 368.00, 369.00, 370.00, 371.00, 372.00, 373.00, 374.00, 375.00,
     &      376.00, 377.00, 378.00, 379.00, 380.00, 381.00, 382.00, 383.00, 384.00, 385.00, 386.00, 387.00, 388.00, 389.00, 390.00,
     &      391.00, 392.00, 393.00, 394.00, 395.00, 396.00, 397.00, 398.00, 399.00, 400.00, 401.00, 402.00, 403.00, 404.00, 405.00,
     &      406.00, 407.00, 408.00, 409.00, 410.00, 411.00, 412.00, 413.00, 414.00, 415.00, 416.00, 417.00, 418.00, 419.00, 420.00,
     &      421.00, 422.00, 423.00, 424.00, 425.00, 426.00, 427.00, 428.00, 429.00, 430.00, 431.00, 432.00, 433.00, 434.00, 435.00,
     &      436.00, 437.00, 438.00, 439.00, 440.00, 441.00, 442.00, 443.00, 444.00, 445.00, 446.00, 447.00, 448.00, 449.00, 450.00,
     &      451.00, 452.00, 453.00, 454.00, 455.00, 456.00, 457.00, 458.00, 459.00, 460.00, 461.00, 462.00, 463.00, 464.00, 465.00,
     &      466.00, 467.00, 468.00, 469.00, 470.00, 471.00, 472.00, 473.00, 474.00, 475.00, 476.00, 477.00, 478.00, 479.00, 480.00,
     &      481.00, 482.00, 483.00, 484.00, 485.00, 486.00, 487.00, 488.00, 489.00, 490.00, 491.00, 492.00, 493.00, 494.00, 495.00,
     &      496.00, 497.00, 498.00, 499.00, 500.00, 501.00, 502.00, 503.00, 504.00, 505.00, 506.00, 507.00, 508.00, 509.00, 510.00,
     &      511.00, 512.00, 513.00, 514.00, 515.00, 516.00, 517.00, 518.00, 519.00, 520.00, 521.00, 522.00, 523.00, 524.00, 525.00,
     &      526.00, 527.00, 528.00, 529.00, 530.00, 531.00, 532.00, 533.00, 534.00, 535.00, 536.00, 537.00, 538.00, 539.00, 540.00,
     &      541.00, 542.00, 543.00, 544.00, 545.00, 546.00, 547.00, 548.00, 549.00, 550.00, 551.00, 552.00, 553.00, 554.00, 555.00,
     &      556.00, 557.00, 558.00, 559.00, 560.00, 561.00, 562.00, 563.00, 564.00, 565.00, 566.00, 567.00, 568.00, 569.00, 570.00,
     &      571.00, 572.00, 573.00, 574.00, 575.00, 576.00, 577.00, 578.00, 579.00, 580.00, 581.00, 582.00, 583.00, 584.00, 585.00,
     &      586.00, 587.00, 588.00, 589.00, 590.00, 591.00, 592.00, 593.00, 594.00, 595.00, 596.00, 597.00, 598.00, 599.00, 600.00,
     &      601.00, 602.00, 603.00, 604.00, 605.00, 606.00, 607.00, 608.00, 609.00, 610.00, 611.00, 612.00, 613.00, 614.00, 615.00,
     &      616.00, 617.00, 618.00, 619.00, 620.00, 621.00, 622.00, 623.00, 624.00, 625.00, 626.00, 627.00, 628.00, 629.00, 630.00,
     &      631.00, 632.00, 633.00, 634.00, 635.00, 636.00, 637.00, 638.00, 639.00, 640.00, 641.00, 642.00, 643.00, 644.00, 645.00,
     &      646.00, 647.00, 648.00, 649.00, 650.00, 651.00, 652.00, 653.00, 654.00, 655.00, 656.00, 657.00, 658.00, 659.00, 660.00,
     &      661.00, 662.00, 663.00, 664.00, 665.00, 666.00, 667.00, 668.00, 669.00, 670.00, 671.00, 672.00, 673.00, 674.00, 675.00,
     &      676.00, 677.00, 678.00, 679.00, 680.00, 681.00, 682.00, 683.00, 684.00, 685.00, 686.00, 687.00, 688.00, 689.00, 690.00,
     &      691.00, 692.00, 693.00, 694.00, 695.00, 696.00, 697.00, 698.00, 699.00, 700.00 /
       data (af500(i),i=1,na500)
     &    / 0.0054, 0.0151, 0.0258, 0.0417, 0.0603, 0.0822, 0.1085, 0.1347, 0.1645, 0.1947, 0.2282, 0.2643, 0.2980, 0.3345, 0.3697,
     &      0.4050, 0.4412, 0.4761, 0.5109, 0.5426, 0.5732, 0.6013, 0.6287, 0.6555, 0.6791, 0.7007, 0.7207, 0.7395, 0.7559, 0.7703,
     &      0.7832, 0.7944, 0.8042, 0.8125, 0.8197, 0.8260, 0.8312, 0.8357, 0.8395, 0.8429, 0.8460, 0.8486, 0.8512, 0.8535, 0.8559,
     &      0.8583, 0.8607, 0.8634, 0.8661, 0.8690, 0.8719, 0.8751, 0.8784, 0.8818, 0.8853, 0.8888, 0.8925, 0.8962, 0.8998, 0.9034,
     &      0.9069, 0.9104, 0.9138, 0.9170, 0.9201, 0.9231, 0.9259, 0.9286, 0.9310, 0.9334, 0.9355, 0.9375, 0.9393, 0.9410, 0.9425,
     &      0.9439, 0.9452, 0.9463, 0.9474, 0.9483, 0.9492, 0.9500, 0.9507, 0.9514, 0.9521, 0.9527, 0.9532, 0.9538, 0.9543, 0.9548,
     &      0.9553, 0.9558, 0.9563, 0.9568, 0.9573, 0.9578, 0.9583, 0.9589, 0.9594, 0.9600, 0.9606, 0.9612, 0.9618, 0.9624, 0.9630,
     &      0.9637, 0.9643, 0.9650, 0.9657, 0.9664, 0.9671, 0.9678, 0.9685, 0.9692, 0.9699, 0.9706, 0.9713, 0.9720, 0.9727, 0.9734,
     &      0.9741, 0.9747, 0.9754, 0.9760, 0.9766, 0.9772, 0.9778, 0.9784, 0.9789, 0.9794, 0.9800, 0.9805, 0.9809, 0.9814, 0.9819,
     &      0.9823, 0.9827, 0.9831, 0.9835, 0.9838, 0.9842, 0.9845, 0.9849, 0.9852, 0.9855, 0.9857, 0.9860, 0.9862, 0.9865, 0.9867, 
     &      0.9869, 0.9871, 0.9873, 0.9875, 0.9877, 0.9879, 0.9880, 0.9882, 0.9884, 0.9885, 0.9886, 0.9888, 0.9889, 0.9890, 0.9892,
     &      0.9893, 0.9894, 0.9895, 0.9897, 0.9898, 0.9899, 0.9900, 0.9901, 0.9902, 0.9903, 0.9904, 0.9905, 0.9906, 0.9907, 0.9908,
     &      0.9909, 0.9910, 0.9911, 0.9912, 0.9913, 0.9914, 0.9915, 0.9916, 0.9917, 0.9917, 0.9918, 0.9919, 0.9920, 0.9921, 0.9922,
     &      0.9923, 0.9924, 0.9924, 0.9925, 0.9926, 0.9927, 0.9928, 0.9929, 0.9930, 0.9930, 0.9931, 0.9932, 0.9933, 0.9934, 0.9934,
     &      0.9935, 0.9936, 0.9937, 0.9937, 0.9938, 0.9939, 0.9939, 0.9940, 0.9940, 0.9941, 0.9941, 0.9942, 0.9942, 0.9943, 0.9943,
     &      0.9943, 0.9944, 0.9944, 0.9945, 0.9945, 0.9945, 0.9945, 0.9946, 0.9946, 0.9946, 0.9946, 0.9947, 0.9947, 0.9947, 0.9947,
     &      0.9947, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9950, 0.9950,
     &      0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950,
     &      0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9948, 0.9948,
     &      0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9947, 0.9948, 0.9948, 0.9947, 0.9947,
     &      0.9948, 0.9948, 0.9947, 0.9947, 0.9947, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948,
     &      0.9948, 0.9948, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9950, 0.9950, 0.9950, 0.9950,
     &      0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950, 0.9950,
     &      0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9949, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948, 0.9948,
     &      0.9948, 0.9948, 0.9948, 0.9948, 0.9947, 0.9947, 0.9947, 0.9947, 0.9947, 0.9947, 0.9947, 0.9947, 0.9948, 0.9948, 0.9948,
     &      0.9948, 0.9948, 0.9948, 0.9949, 0.9949, 0.9949, 0.9949, 0.9950, 0.9950, 0.9950, 0.9951, 0.9951, 0.9952, 0.9952, 0.9953,
     &      0.9953, 0.9954, 0.9955, 0.9955, 0.9956, 0.9957, 0.9957, 0.9958, 0.9959, 0.9959, 0.9960, 0.9961, 0.9962, 0.9962, 0.9963,
     &      0.9964, 0.9965, 0.9965, 0.9966, 0.9967, 0.9967, 0.9968, 0.9969, 0.9970, 0.9970, 0.9971, 0.9971, 0.9972, 0.9973, 0.9973,
     &      0.9974, 0.9975, 0.9975, 0.9976, 0.9976, 0.9977, 0.9978, 0.9978, 0.9979, 0.9979, 0.9980, 0.9980, 0.9981, 0.9982, 0.9982,
     &      0.9983, 0.9983, 0.9984, 0.9984, 0.9985, 0.9986, 0.9986, 0.9987, 0.9987, 0.9988, 0.9988, 0.9989, 0.9989, 0.9990, 0.9990,
     &      0.9990, 0.9991, 0.9991, 0.9992, 0.9992, 0.9992, 0.9993, 0.9993, 0.9993, 0.9994, 0.9994, 0.9994, 0.9995, 0.9995, 0.9995,
     &      0.9995, 0.9996, 0.9996, 0.9996, 0.9996, 0.9997, 0.9997, 0.9997, 0.9997, 0.9997, 0.9997, 0.9997, 0.9997, 0.9998, 0.9998,
     &      0.9998, 0.9998, 0.9998, 0.9998, 0.9998, 0.9998, 0.9999, 0.9999, 0.9999, 0.9999, 0.9999, 0.9999, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000,
     &      1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000, 1.0000 /

       external      firstb, lastc, lasts, rfits, when, getnumpix, timer
!__________________________________________________________________________________________________________________________________
!                                     
       sqreightlogtwo = sqrt ( 8.0d0 * log ( 2.0d0 ) )
       
! Determine operating system

       call osystem ( lunix )

! Get the current date and time.

       call when ( lunix, ctime, cdate, ndate, 4 )

       call ftvers ( fitsvers )

       lb = 1
       write (cfitsversion,'(f6.3)') fitsvers
       if (cfitsversion .eq. ' 5.030') then
         lb = 2
       endif
       clibname = 'CFITSIO'
       cfpptime = __TIME__
       compda = __DATE__//' '//cfpptime

! Get command line parameters (file names).

       call getarg (  1, arg1 )
       call getarg (  2, arg2 )
       call getarg (  3, arg3 )
       call getarg (  4, arg4 )
       call getarg (  5, arg5 )
       call getarg (  6, arg6 )
       call getarg (  7, arg7 )
       call getarg (  8, arg8 )
       call getarg (  9, arg9 )
       call getarg ( 10, argA )
       call getarg ( 11, argB )
       call getarg ( 12, argC )
       call getarg ( 13, argD )
       call getarg ( 14, argE )
       call getarg ( 15, argF )
       call getarg ( 16, argG )

       ia1 = lastc ( arg1 )
       ia2 = lastc ( arg2 )
       ia3 = lastc ( arg3 )
       ia4 = lastc ( arg4 )
       ia5 = lastc ( arg5 )
       ia6 = lastc ( arg6 )
       ia7 = lastc ( arg7 )
       ia8 = lastc ( arg8 )
       ia9 = lastc ( arg9 )
       iaA = lastc ( argA )
       iaB = lastc ( argB )
       iaC = lastc ( argC )
       iaD = lastc ( argD )
       iaE = lastc ( argE )
       iaF = lastc ( argF )
       iaG = lastc ( argG )

       lverbose = '-verb2'
       if (iaG .gt. 0 .and. argG(1:iaG-1) .eq. '-verb') lverbose = argG(1:iaG)
       if (iaF .gt. 0 .and. argF(1:iaF-1) .eq. '-verb') lverbose = argF(1:iaF)
       if (iaE .gt. 0 .and. argE(1:iaE-1) .eq. '-verb') lverbose = argE(1:iaE)
       if (iaD .gt. 0 .and. argD(1:iaD-1) .eq. '-verb') lverbose = argD(1:iaD)

       if (lverbose .eq. '-verb2') write (iotty,'(/a$)') ' SMEASURE = Measure & Catalog Sources = '//compda
       if (arg1(1:ia1) .eq. ':') stop
       if (lverbose .eq. '-verb2') write (iotty,'()')
       if (lverbose .eq. '-verb2') write (iotty,'( a)') ' Alexander Men`shchikov, SAp IRFU CEA Saclay, France.'
       if (lverbose .eq. '-verb2') write (iotty,'( a)') ' Using '//clibname(lb:7)//' library version'//cfitsversion
     &                                                //' by William D Pence.'
       if (ia9 .eq. 0) then
         write (iotty,'(/a)') ' USAGE: smeasure <pixel> <owave> <beam> <apcorr> <aperture> <snt> <snr> <nwdetect> <factortotal>'
     &                      //' <originpath> <dirmono> <obsbsfsname> <icatname> [-o <ocatname>] [-verb{0|1|2}]'
         stop 11
       endif

       icp  = ia1
       icw  = ia2
       icb  = ia3
       ica  = ia4
       icar = ia5
       isnt = ia6
       isnr = ia7
       inwd = ia8
       ifto = ia9
       iopa = iaA
       cpixel  = arg1(1:icp)
       cowave  = arg2(1:icw)
       cbeam   = arg3(1:icb)
       capcorr = arg4(1:ica)
       caprad  = arg5(1:icar)
       csnt    = arg6(1:isnt)
       csnr    = arg7(1:isnr)
       cnwd    = arg8(1:inwd)
       cfto    = arg9(1:ifto)
       originpath = argA(1:iopa)

       read (cpixel(1:icp) ,*,end=11,err=11) pixel      !<-- pixel size (arcsec)
       read (cowave(1:icw) ,*,end=12,err=12) owave      !<-- wavelength (microns)
       read (cbeam(1:icb)  ,*,end=13,err=13) beam       !<-- beam size (arcsec)
       read (caprad(1:icar),*,end=14,err=14) aperture   !<-- aperture radius (arcsec)
       read (csnt(1:isnt)  ,*,end=4 ,err=4 ) stentative
       read (csnr(1:isnr)  ,*,end=5 ,err=5 ) sreliable
       read (cnwd(1:inwd)  ,*,end=6 ,err=6 ) nwavesdetect
       read (cfto(1:ifto)  ,*,end=63,err=63) factortotal

       lonlypositives = .false.
       if (cowave(1:1) .eq. '+') then
         lonlypositives = .true.
         cowave = cowave(2:icw)
         icw = lastc ( cowave )
       endif

       liter_phase1 = .false.
       if (csnt(1:1) .eq. '+') then
         liter_phase1 = .true.
       endif
       liter_phase2 = .false.
       if (csnr(1:1) .eq. '+') then
         liter_phase2 = .true.
       endif
       liter_phase3 = .false.
       if (cnwd(1:1) .eq. '+' .or. cnwd(1:1) .eq. '-') then
         liter_phase3 = .true.
       endif
       lfinishing_mode = .false.
       if (cnwd(1:1) .eq. '-') then
         lfinishing_mode = .true.
       endif
       ldevelopment = .false.
       if (lfinishing_mode .and. csnr(1:1) .eq. '+') then
         ldevelopment = .true.
       endif

       if (csnt(1:1) .eq. '+') then
         csnt = csnt(2:isnt)
       endif
       if (csnt(1:1) .eq. '-') then
         stentative = abs ( stentative )
         csnt = csnt(2:isnt)
       endif
       if (csnr(1:1) .eq. '+') then
         csnr = csnr(2:isnr)
       endif
       if (csnr(1:1) .eq. '-') then
         sreliable = abs ( sreliable )
         csnr = csnr(2:isnr)
       endif
       if (cnwd(1:1) .eq. '+') then
         cnwd = cnwd(2:inwd)
       endif
       if (cnwd(1:1) .eq. '-') then
         nwavesdetect = abs ( nwavesdetect )
         cnwd = cnwd(2:inwd)
       endif

       isnt = lastc ( csnt )
       isnr = lastc ( csnr )
       inwd = lastc ( cnwd )

       dirmono = argB(1:iaB)
       obsbsfsname = argC(1:iaC)
       icatname = argD(1:iaD)
       idmon = lastc ( dirmono )
       iobsbsfs = lastc ( obsbsfsname )
       iicat = lastc ( icatname  )

       isw = index ( icatname(1:iicat), '.det.cat' )
       lfirstcall = .false.
       if (isw .gt. 0) lfirstcall = .true.

       if (ltiming) then
         inquire ( file='+timing.smeasure', exist=ltime )
         open ( 60, file='+timing.smeasure', status='unknown' )
         if (ltime) then
           do 
             read (60,'()',end=61)
           enddo
  61       backspace ( 60 )
         endif
         if (lfirstcall) then
           write (60,'(/a)') ' SMEASURE started: '//cdate//' '//ctime//' Image: '//obsbsfsname(1:iobsbsfs)//' <~ 1ST ITERATION'
         else
           write (60,'(/a)') ' SMEASURE started: '//cdate//' '//ctime//' Image: '//obsbsfsname(1:iobsbsfs)
         endif
         
         cput_readimages    = 0.0d0
         walt_readimages    = 0.0d0
         cput_iteratepeaks  = 0.0d0
         walt_iteratepeaks  = 0.0d0
         cput_secondmoments = 0.0d0
         walt_secondmoments = 0.0d0
         cput_totalfluxes   = 0.0d0
         walt_totalfluxes   = 0.0d0
         cput_fittedfluxes  = 0.0d0
         walt_fittedfluxes  = 0.0d0
         cput_createannuli  = 0.0d0
         walt_createannuli  = 0.0d0
         cput_fluctuations1 = 0.0d0
         cput_fluctuations2 = 0.0d0
         cput_fluctuations3 = 0.0d0
         cput_fluctuations4 = 0.0d0
         cput_fluctuations5 = 0.0d0
         cput_fluctuations  = 0.0d0
         walt_fluctuations1 = 0.0d0
         walt_fluctuations2 = 0.0d0
         walt_fluctuations3 = 0.0d0
         walt_fluctuations4 = 0.0d0
         walt_fluctuations5 = 0.0d0
         walt_fluctuations  = 0.0d0
         cput_significances = 0.0d0
         walt_significances = 0.0d0
         cpu_sum = 0.0d0
         wal_sum = 0.0d0
       endif

       goto 15
  4    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading stentative: '//csnt(1:isnt)
       stop 51
  5    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading sreliable: '//csnr(1:isnr)
       stop 52 
  6    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading nwavesdetect: '//cnwd(1:inwd)
       stop 53
 63    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading factortotal: '//cfto(1:ifto)
       stop 54
 11    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading pixel size: '//cpixel(1:icp)
       stop 55
 12    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading obs wave: '//cowave(1:icw)
       stop 56
 13    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading beam size: '//cbeam(1:icb)
       stop 57
 14    write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading aperture: '//caprad(1:icar)
       stop 58
 15    continue
       if (capcorr(1:ica) .ne. 'y' .and. capcorr(1:ica) .ne. 'n') then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Invalid aperture correction parameter: '//capcorr(1:ica)
         stop 59
       endif
 
       sqpixel = pixel**2
       sq_arcsecs_per_beam_area = pi * (beam / 2.0)**2 / log ( 2.0d0 )

       sterad_per_beam_area = sq_arcsecs_per_beam_area / sq_arcsecs_per_sterad
   
       convftot1 = 1.0e6 * sqpixel / sq_arcsecs_per_sterad  !<-- intensity in MJy/sr to flux in Jy
       
       idot = index ( icatname(1:iicat), '.' )
       idot2 = index ( icatname(idot+1:iicat), '.' )  + idot
       wcsfile = icatname(1:idot2-1)//'.sw.det.wcs'
       iwcs = lastc ( wcsfile )

! Check if the observed background-subtracted image exists.

       inquire ( file=obsbsfsname(1:iobsbsfs), exist=lfnam1 )
       if (.not.lfnam1) then
         obsbsfsname = obsbsfsname(1:iobsbsfs)//'.fits'
         iobsbsfs = lastc ( obsbsfsname )
         inquire ( file=obsbsfsname(1:iobsbsfs), exist=lfnam1 )
       endif

! Determine name for full observed image.

       ibs = index ( obsbsfsname, '.bs.' )
       if (ibs .eq. 0) then
         obsname = obsbsfsname(1:iobsbsfs)
       else
         obsname = obsbsfsname(1:ibs-1)//'.fits'
       endif
       iobsn = lastc ( obsname )

       inquire ( file=obsname(1:iobsn), exist=lfnam6 )

       cbfsname = obsname(1:iobsn-5)//'.cb.fs.fits'
       icbfs = lastc ( cbfsname )

       inquire ( file=cbfsname(1:icbfs), exist=lfnam8 )

! Define name for the derived background image.

       bgname = 'sm.'//obsname(1:iobsn-5)//'.backg.fits'
       ibg = lastc ( bgname )

! Determine name for single wave-combined detection image.

       idot = index ( obsbsfsname, '.' )
       iobs = index ( obsbsfsname, '.obs.' )

! Determine name for the observational mask image.

       maskname = obsbsfsname(1:iobs-1)//'.bs.omask.fits'
       imsk = lastc ( maskname )

       inquire ( file=maskname(1:imsk), exist=lfnam9 )

! Define name for the observed background image.

       idot2 = index ( obsbsfsname(idot+1:iobsbsfs), '.' )  + idot
       idot3 = index ( obsbsfsname(idot2+1:iobsbsfs), '.' ) + idot2
       idot4 = index ( obsbsfsname(idot3+1:iobsbsfs), '.' ) + idot3
                    
! This is the name of a true background+noise image (no sources) from simulated skies.

       truebgnoname = 'background+noise.'//cowave(1:icw)//'.true.fits'
       itruebg = lastc ( truebgnoname )
       inquire ( file=truebgnoname(1:itruebg), exist=ltruebacknoise )

! This is the name of a true rms image from simulated skies.

       obsfsname = obsbsfsname(1:iobs-1)//'.backrms.fits'
       iobscb = lastc ( obsfsname )
       inquire ( file=obsfsname(1:iobscb), exist=lfnam5 )

! If the true rms image does not exist, define the name of a clean background (filament-subtracted).
       
       if (.not.lfnam5) then
         obsfsname = obsbsfsname(1:ibs-1)//'.fs.fits'
         iobscb = lastc ( obsfsname )
         inquire ( file=obsfsname(1:iobscb), exist=lfnam5 )
       endif

! Define name of a file listing all file names.

       filewithnames = dirmono(1:idmon)//'/'//obsbsfsname(1:iobs-1)//'.det.cleaning'
       ifdn = lastc ( filewithnames )

       inquire ( file=filewithnames(1:ifdn), exist=lfnam7 )

       inquire ( file=icatname(1:iicat), exist=lfnam3 )

       ocatname = icatname(1:iicat)
       if (argE(1:2) .eq. '-o') ocatname = argF
       iocat = lastc ( ocatname )

       lmysimsky = index ( obsname(1:iobsn), 'sky5' ) .gt. 0 .or. index ( obsname(1:iobsn), 'sky6' ) .gt. 0

       if (lverbose .eq. '-verb1') write (iotty,'(/a)') ' SMEASURE: '//cpixel(1:icp)//' '//cbeam(1:icb)//' '//icatname(1:iicat)
     &                                                          //' '//ocatname(1:iocat)

       if (.not.lfnam1) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: File '''//obsbsfsname(1:iobsbsfs-5)//''' not found.'
         stop 31
       endif
       if (.not.lfnam3) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: File '''//icatname(1:iicat)//''' not found.'
         stop 32
       endif
       if (.not.lfnam5) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: File '''//obsfsname(1:iobscb)//''' not found.'
       endif
       if (.not.lfnam6) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: File '''//obsname(1:iobsn)//''' not found.'
         stop 33
       endif
       if (.not.lfnam7) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: File '''//filewithnames(1:ifdn)//''' not found.'
         stop 34
       endif
       if (.not.lfnam8) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: File '''//cbfsname(1:icbfs)//''' not found.'
         stop 35
       endif
       if (.not.lfnam9) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: File '''//maskname(1:imsk)//''' not found.'
         stop 36
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(/a)') '   Reading input catalog '''//icatname(1:iicat)//'''...'
       
       open ( 15, file=icatname(1:iicat), status='old' )

! Compute final fluxes for each detected source.
       
       call skipcomm     ( 15, icatname(1:iicat), nhead )
       call linescolumns ( 15, icatname(1:iicat), nhead, nextr, ncolumns )

       rewind ( 15 )

! Determine numbers of pixels in the FITS image.

       call getnumpix ( obsbsfsname(1:iobsbsfs), nx, ny )

       allocate ( momxco(nextr), momyco(nextr), momxx(nextr), momyy(nextr), momxy(nextr), int0(nextr), afwhm(nextr), bfwhm(nextr)
     &          , atheta(nextr), fluxtotfit(nextr), fluxpeakbest(nextr), fluxtotbest(nextr), equivrad(nextr), sigmono(nextr)
     &          , sigglob(nextr), scalensx(nextr), lconverged(nextr), numpix(nextr), catline(nextr), fluxpko(nextr), flag(nextr)
     &          , badsource(nextr), backrms(nextr), fluxperror(nextr), apcorrect(nextr), fluxterror(nextr), lfootexpandable(nextr)
     &          , dxcon2(nextr,nx), dycon2(nextr,ny), fluxpkss(nextr), foomajor(nextr), foominor(nextr), foothepa(nextr), aa(nextr)
     &          , bb(nextr), cc(nextr), flg(nextr), flm(nextr), lfootprint(nextr), wcsxco(nextr), wcsyco(nextr), convdelta(nextr,99)
     &          , slope(nextr), ratiomax(nextr), good(nextr), footfact(nextr), fluxpksso(nextr), ssimagemax(nextr), foamajor(nextr)
     &          , foaminor(nextr), foathepa(nextr), pedestal(nextr), numpixbg(nextr), backav1(nextr), backav2(nextr), backav3(nextr)
     &          , backavf(nextr), backrmsf(nextr), backrms1(nextr), backrms2(nextr), backrms3(nextr), surround(nextr), cflm(nextr)
     &          , nkovlap(nextr), nxco(nextr), nyco(nextr), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble allocating memory (71).'
         stop 71
       endif

       nsigglo = 0
       nfluxes = 0
       nxcopix = 0
       npeakfx = 0
       do i=1,nhead
         read (15,'(a)') headline(i)
         ncolumn = index ( headline(i), '  SIG_GLOB  ' )
         if (ncolumn .gt. 0) nsigglo = ncolumn
         ncolumn = index ( headline(i), '  FXP_BEST   ' )
         if (ncolumn .gt. 0) nfluxes = ncolumn
         ncolumn = index ( headline(i), '  XCO_PIXEL  ' )
         if (ncolumn .gt. 0) nxcopix = ncolumn
         ncolumn = index ( headline(i), '  PEAKFLUX   ' )
         if (ncolumn .gt. 0) npeakfx = ncolumn
       enddo
       if (nsigglo .eq. 0) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Column SIG_GLOB not found.'
         stop 12
       endif
       if (nfluxes .eq. 0) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Column FXP_BEST not found.'
         stop 13
       endif
       if (nxcopix .eq. 0) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Column XCO_PIXEL not found.'
         stop 14
       endif
       if (npeakfx .eq. 0) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Column PEAKFLUX not found.'
         stop 15
       endif
       write (cskipsigglo,'(i3)') nsigglo - 1
       write (cskipfluxes,'(i3)') nfluxes - 1
       write (cskipcoords,'(i3)') nxcopix - 1
       
! Loop over all extracted sources.

       do n=1,nextr
         read (15,'(a)') catline(n)
         read (catline(n),'(12x,i3,2x,a1)') nsx, flag(n)
         if (nsx .eq. 0 .and. flag(n) .eq. ' ') then
           write (iotty,'(/a)') '   SMEASURE: ERROR: Some sources have not been footprinted.'
           stop 91
         endif
         read (catline(n),'(a1)') badsource(n)
         read (catline(n),'('//cskipcoords//'x,4(f11.4))') momxco(n), momyco(n), wcsxco(n), wcsyco(n)
         read (catline(n),'('//cskipsigglo//'x,1pe11.3,i3,0pf6.2,1pe11.3,i5)') sigglob(n), flg(n), good(n), sigmono(n), flm(n)
         read (catline(n),'('//cskipfluxes//'x,15(1pe11.3))') fluxpeakbest(n), fluxperror(n), fluxtotbest(n), fluxterror(n)
     &                   , fluxtotfit(n), scalensx(n), afwhm(n), bfwhm(n), atheta(n), equivrad(n), footfact(n), foomajor(n)
     &                   , foominor(n), foothepa(n)
         
         if (lfirstcall) then
           fluxpeakbest(n) = 0.0d0
           fluxtotbest(n) = 0.0d0
           fluxperror(n) = 0.0d0
           fluxterror(n) = 0.0d0
           fluxtotfit(n) = 0.0d0
           sigmono(n) = 0.0d0
           foomajor(n) = max ( foomajor(n), factortotal * beam, 2.0d0 * aperture )
           foominor(n) = max ( foominor(n), factortotal * beam, 2.0d0 * aperture )
           lfootprint(n) = .true.
         else

! Check if there is a signal from FINALCAT that the source is not good in some way and it should not be considered.

           if (foomajor(n) .gt. almostzero .and. foominor(n) .gt. almostzero) then
             lfootprint(n) = .true.
           else
             lfootprint(n) = .false.
             foomajor(n) = abs ( foomajor(n) )
             foominor(n) = abs ( foominor(n) )
             foothepa(n) = abs ( foothepa(n) )
           endif
         endif
         
! Measurements of sizes and fluxes will be done within fixed circular apertures, if requested.

         if (aperture .gt. almostzero) then
           foamajor(n) = 2.0d0 * aperture
           foaminor(n) = 2.0d0 * aperture
           foathepa(n) = 0.0d0
         else
           foamajor(n) = foomajor(n)
           foaminor(n) = foominor(n)
           foathepa(n) = foothepa(n)
         endif
         if (capcorr(1:ica) .eq. 'y') then
           apcorrect(n) = 1.0d0
         else
           apcorrect(n) = 0.0d0
         endif
         lconverged(n) = .false.

         nxco(n) = nint ( momxco(n) )
         nyco(n) = nint ( momyco(n) )
       enddo

       close ( 15 )

! Allocate the image arrays.
       
       if (ltruebacknoise) then
         allocate ( obsbsfsimage(nx,ny), obsfsimage(nx,ny), maskimage(nx,ny), bigfoot(nx,ny), smafoot(nx,ny)
     &            , worker(nx,ny), workerf(nx,ny), n1x(ny), n2x(ny), annulus(nx,ny), truebacknoise(nx,ny), stat=irc )
       else
         allocate ( obsbsfsimage(nx,ny), obsfsimage(nx,ny), maskimage(nx,ny), bigfoot(nx,ny), smafoot(nx,ny)
     &            , worker(nx,ny), workerf(nx,ny), n1x(ny), n2x(ny), annulus(nx,ny), stat=irc )
       endif

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble allocating memory (72).'
         stop 72
       endif

       do m=1,ny
         do l=1,nx
           obsfsimage(l,m) = 0.0d0     
         enddo
       enddo

!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_readimages = timer ( 'cpu', 0.0d0 )
         wal_readimages = timer ( 'wal', 0.0d0 )
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading background-subtracted image '''//obsbsfsname(1:iobsbsfs)//'''...'
       
       call rfits ( nx, ny, intensunits, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsbsfsimage, dx, dy, object, ra, dec
     &            , obsbsfsname(1:iobsbsfs), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11
     &            , cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )

       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
              
       obsbsfsmin = funmin
       obsbsfsmax = funmax
       dxdeg = dx / 3600.0d0
       dydeg = dy / 3600.0d0
       iu = lastc ( intensunits )

       if (intensunits(1:iu) .ne. 'MJy/sr' .and. intensunits(1:iu) .ne. 'no-units') then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Unknown intensity units in the image.'
         write (iotty,'(a )') '   BUNIT must be ''MJy/sr'' or ''no-units''.'
         stop 92
       endif                  
       
       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading observational mask image '''//maskname(1:imsk)//'''...'
       
       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, maskimage, dx, dy, object, ra, dec
     &            , maskname(1:imsk), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11, cd12
     &            , cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )

       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       
       if (lfnam5) then
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading filament-subtracted image '''//obsfsname(1:iobscb)//'''...'
       
         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, obsfsimage, dx, dy, object, ra, dec
     &              , obsfsname(1:iobscb), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11
     &              , cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )

         if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       endif
       
       if (ltruebacknoise) then
         if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading true backg+noise image '''//truebgnoname(1:itruebg)//'''...'
       
         call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, truebacknoise, dx, dy, object, ra, dec
     &              , truebgnoname(1:itruebg), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2
     &              , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )

         if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       endif
       
       if (ltiming) then
         cput_readimages = cput_readimages + timer ( 'cpu', cpu_readimages )
         walt_readimages = walt_readimages + timer ( 'wal', wal_readimages )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       lnotwarned = .true.

       do n=1,nextr
         if (flag(n) .ne. 'n') then
           fluxpko(n) = obsbsfsimage(nxco(n),nyco(n))
         endif
         if (lfirstcall) then
           sigmaa2 = (scalensx(n) / 2.0d0)**2 * correct
           sigmab2 = sigmaa2
           angle = 0.0d0
         else
           sigmaa2 = (afwhm(n) / 2.0d0)**2 * correct
           sigmab2 = (bfwhm(n) / 2.0d0)**2 * correct
           angle = (90.0d0 - atheta(n)) * convtoradians
         endif
         if (flag(n) .ne. 'n') then
           cosa2 = cos ( angle )**2
           sina2 = sin ( angle )**2
           sin2a = sin ( 2.0d0 * angle )
           aa(n) =  cosa2 / (sigmaa2 + almostzero) + sina2 / (sigmab2 + almostzero)
           bb(n) = -sin2a / (sigmaa2 + almostzero) + sin2a / (sigmab2 + almostzero)
           cc(n) =  sina2 / (sigmaa2 + almostzero) + cosa2 / (sigmab2 + almostzero)
         else
           aa(n) = 0.0d0
           bb(n) = 0.0d0
           cc(n) = 0.0d0
         endif
         do l=1,nx
           dbll = dble ( l )
           dxcon2(n,l) = (dbll - momxco(n))**2 * sqpixel
         enddo
         do m=1,ny
           dblm = dble ( m )
           dycon2(n,m) = (dblm - momyco(n))**2 * sqpixel
         enddo
       enddo
       
!-----------------------------------------------------------------------------------------------------------------------------------

! Deblend sources and iterate peak fluxes.
       
       if (ltiming) then
         cpu_iteratepeaks = timer ( 'cpu', 0.0d0 )
         wal_iteratepeaks = timer ( 'wal', 0.0d0 )
       endif

       iter = 0
  111  continue
       iter = iter + 1

       do n=1,nextr

         if (.not.lconverged(n) .and. flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. lfootprint(n)) then
           
           nkovl = 0
           do k=1,nextr
             if (k .ne. n .and. flag(k) .ne. 'n' .and. badsource(k) .ne. '!' .and. lfootprint(k)) then
               dist2 = (momxco(n) - momxco(k))**2 + (momyco(n) - momyco(k))**2
               if (dist2 .lt. (foamajor(k) / dx / 2.0d0)**2 .and. fluxpko(k) .gt. almostzero) then
                 nkovl = nkovl + 1
                 nkovlap(nkovl) = k
               endif
             endif
           enddo

           fluxpeakbest(n) = 0.0d0
           funn = fluxpko(n)
           funsum = abs ( funn )
           
           do j=1,nkovl
             k = nkovlap(j)
             if (inellipse ( momxco(n), momyco(n), dx, dy, momxco(k), momyco(k), foamajor(k), foaminor(k), foathepa(k) )) then
               amoffat = aa(k) * dxcon2(k,nxco(n)) + bb(k) * sqrt ( dxcon2(k,nxco(n)) * dycon2(k,nyco(n)) ) 
     &                 + cc(k) * dycon2(k,nyco(n))
               funk = fluxpko(k) / (1.0d0 + amoffat)**beta
               funsum = funsum + abs ( funk )
             endif
           enddo
           
           if (maskimage(nxco(n),nyco(n)) .gt. 0.9d0) then
             if (fluxpko(n) .gt. almostzero) then
               fluxpeakbest(n) = (funn / (funsum + almostzero)) * obsbsfsimage(nxco(n),nyco(n))
             elseif (fluxpko(n) .lt. -almostzero) then
               fluxpeakbest(n) = obsbsfsimage(nxco(n),nyco(n))
             endif
           endif
         endif
       enddo
       
       lallsmall = .true.
       changemax = 0.3d0
       do n=1,nextr
         convdelta(n,iter) = 0.0d0
         if (.not.lconverged(n)) then
           lconverged(n) = .true.
           if (flag(n) .ne. 'n'  .and. badsource(n) .ne. '!' .and. lfootprint(n)) then
             if (maskimage(nxco(n),nyco(n)) .gt. 0.9d0) then

! Bound possible drastic changes in the quantities to reasonable limits.

               if (abs ( fluxpeakbest(n) - fluxpko(n) ) .gt. changemax * abs ( fluxpko(n) )) then
                 qsign = sign ( 1.0d0, fluxpeakbest(n) - fluxpko(n) )
                 convdelta(n,iter) = qsign * changemax
                 fluxpko(n) = (1.0d0 + qsign * changemax) * fluxpko(n)
               else
                 convdelta(n,iter) = (fluxpeakbest(n) - fluxpko(n)) / (fluxpko(n) + almostzero)
                 fluxpko(n) = fluxpeakbest(n)
               endif
               if (abs ( convdelta(n,iter) ) .gt. 1.0d-3) then
                 lconverged(n) = .false.
                 lallsmall = .false.
               endif
             endif
           endif
         endif
       enddo

       if (.not.lallsmall .and. iter .lt. 99) goto 111

! Monochromatic flag of a source will become negative, if the above deblending iterations have not converged in 99 iterations.

       do n=1,nextr
         if (.not.lconverged(n)) then
           if (abs ( flm(n) ) .ge. 1) then
             write (cflm(n),'(i5)') -abs ( flm(n) )
           else
             cflm(n) = '   -0'
           endif
         else
           write (cflm(n),'(i5)') abs ( flm(n) )
         endif
       enddo
       
       nbad = 0
       do n=1,nextr
         if (badsource(n) .eq. '!') nbad = nbad + 1
         if (flag(n) .ne. 'n'  .and. badsource(n) .ne. '!') then
           if (maskimage(nxco(n),nyco(n)) .lt. 0.9d0) then
             fluxpeakbest(n) = 0.0d0
           endif
         endif
       enddo

       if (ltiming) then
         cput_iteratepeaks = cput_iteratepeaks + timer ( 'cpu', cpu_iteratepeaks )
         walt_iteratepeaks = walt_iteratepeaks + timer ( 'wal', wal_iteratepeaks )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       open ( 17, file='sm'//obsbsfsname(idot:idot2)//'deblending.fpbest.dat', status='unknown' )
       write (cniter,'(i2)') iter
       write (17,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by SMEASURE compiled on '//compda
       write (17,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
       write (17,'(a)') '# Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                //'(william.d.pence@nasa.gov)'
       write (17,'(a)') '#'
       write (17,'(a)') '#  N  (RELATIVEDELTA(I),I=1,NITER), NITER='//cniter
       write (17,'(a,'//cniter//'i10)') '#  0     1',(i,i=2,iter)
       write (17,'(a)') '#'
       
       do n=1,nextr
         if (flag(n) .ne. 'n'  .and. badsource(n) .ne. '!' .and. lfootprint(n)) then
           if (maskimage(nxco(n),nyco(n)) .gt. 0.9d0) then
             write (17,'(i4,'//cniter//'(1pg10.2))') n, (convdelta(n,i),i=1,iter)
           endif
         endif
       enddo
       
       close ( 17 )
       
       ibad = 1
       igood = 1
       write (cnextrbad,'(i5)') nbad
       if (cnextrbad(1:1) .eq. ' '   ) ibad = 2
       if (cnextrbad(1:2) .eq. '  '  ) ibad = 3
       if (cnextrbad(1:3) .eq. '   ' ) ibad = 4
       if (cnextrbad(1:4) .eq. '    ') ibad = 5
       write (cnextrgood,'(i5)') nextr - nbad
       if (cnextrgood(1:1) .eq. ' '   ) igood = 2
       if (cnextrgood(1:2) .eq. '  '  ) igood = 3
       if (cnextrgood(1:3) .eq. '   ' ) igood = 4
       if (cnextrgood(1:4) .eq. '    ') igood = 5
      
!-----------------------------------------------------------------------------------------------------------------------------------

! Compute intensity moments.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Computing intensity moments for each source...'

       if (ltiming) then
         cpu_secondmoments = timer ( 'cpu', 0.0d0 )
         wal_secondmoments = timer ( 'wal', 0.0d0 )
       endif

       do n=1,nextr
         
         intx = 0.0d0
         inty = 0.0d0
         intxx = 0.0d0
         intyy = 0.0d0
         intxy = 0.0d0           
         int0(n) = 0.0d0
         numpix(n) = 0
         
         if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. lfootprint(n)) then
           semimajor = foamajor(n) / 2.0d0
           nr = nint ( semimajor / dx )

           nkovl = 0
           do k=1,nextr
             if (k .ne. n .and. flag(k) .ne. 'n' .and. badsource(k) .ne. '!' .and. lfootprint(k)) then
               dist2 = (momxco(n) - momxco(k))**2 + (momyco(n) - momyco(k))**2
               if (dist2 .lt. (foamajor(n) / dx / 2.0d0 + foamajor(k) / dx / 2.0d0)**2 .and. fluxpko(k) .gt. almostzero) then
                 nkovl = nkovl + 1
                 nkovlap(nkovl) = k
               endif
             endif
           enddo

           l1 = max ( nxco(n) - nr , 1 )
           l2 = min ( nxco(n) + nr , nx )
           m1 = max ( nyco(n) - nr , 1 )
           m2 = min ( nyco(n) + nr , ny )
           
           do m=m1,m2
             dblm = dble ( m )
             
             do l=l1,l2
               dbll = dble ( l )
               
               if (inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), foamajor(n), foaminor(n), foathepa(n) )) then
                 amoffat = aa(n) * dxcon2(n,l) + bb(n) * sqrt ( dxcon2(n,l) * dycon2(n,m) ) + cc(n) * dycon2(n,m)
                 funn = fluxpko(n) / (1.0d0 + amoffat)**beta
                 funn = abs ( funn )
                 funsum = funn
                 
                 do j=1,nkovl
                   k = nkovlap(j)
                   if (inellipse ( dbll, dblm, dx, dy, momxco(k), momyco(k), foamajor(k), foaminor(k), foathepa(k) )) then
                     amoffat = aa(k) * dxcon2(k,l) + bb(k) * sqrt ( dxcon2(k,l) * dycon2(k,m) ) + cc(k) * dycon2(k,m)
                     funk = fluxpko(k) / (1.0d0 + amoffat)**beta
                     funsum = funsum + abs ( funk )
                   endif
                 enddo

                 deblend = 0.0d0
                 if (fluxpeakbest(n) .gt. almostzero) then
                   deblend = (funn / (funsum + almostzero)) * max ( obsbsfsimage(l,m), 0.0d0 )
                 elseif (fluxpeakbest(n) .lt. -almostzero) then
                   deblend = max ( -obsbsfsimage(l,m), 0.0d0 )
                 endif

! Next condition selects only pixels around half-maximum inensity. In this case, the sizes from intensity moments will always be
! consistent with FWHM sizes, independently of the intensity distribution of a source (Gaussian or shallower power-law).

                 if (deblend .ge. 0.4d0 * abs ( fluxpeakbest(n) ) .and. deblend .le. 0.7d0 * abs ( fluxpeakbest(n) )) then
                   intd  = deblend * sqpixel
                   xcorc = dbll - momxco(n)
                   ycorc = dblm - momyco(n)
                   intxx = intxx + xcorc * xcorc * intd
                   intyy = intyy + ycorc * ycorc * intd
                   intxy = intxy + xcorc * ycorc * intd
                   int0(n) = int0(n) + intd
                 endif
                 numpix(n) = numpix(n) + 1
               endif
             enddo
           enddo
         endif
         int0m = int0(n) + almostzero
         momxx(n) = intxx / int0m
         momyy(n) = intyy / int0m
         momxy(n) = intxy / int0m
       enddo

       if (ltiming) then
         cput_secondmoments = cput_secondmoments + timer ( 'cpu', cpu_secondmoments )
         walt_secondmoments = walt_secondmoments + timer ( 'wal', wal_secondmoments )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

! Compute FWHM sizes using the intensity moments.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Computing FWHM sizes of sources using intensity moments...'
       
       call sourcesizes ( nextr, pixel, sqpixel, beam, badsource, lfootprint, flag, numpix, momxx, momyy, momxy, afwhm, bfwhm
     &                  , atheta, equivrad, foamajor, foaminor, sqreightlogtwo, convtodegrees, pi )

       do n=1,nextr
         if (equivrad(n) .lt. almostzero) then
           write (iotty,'(/a,i6,a)') '   SMEASURE: ERROR: Source ', n, ' has zero equivalent radius at '//cowave(1:icw)//' um'
         endif
       enddo

!-----------------------------------------------------------------------------------------------------------------------------------

! Compute total fluxes assuming the intensity distribution of an elliptical source with known peak flux and size.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Computing total fluxes of fitted elliptical sources...'

       if (ltiming) then
         cpu_fittedfluxes = timer ( 'cpu', 0.0d0 )
         wal_fittedfluxes = timer ( 'wal', 0.0d0 )
       endif

       call fitsourcesflux ( nextr, badsource, lfootprint, flag, nx, ny, dx, dy, momxco, momyco, nxco, nyco, afwhm, bfwhm, atheta
     &                     , foamajor, foaminor, foathepa, fluxpeakbest, fluxtotfit, beta, correct, convtoradians )

       if (ltiming) then
         cput_fittedfluxes = cput_fittedfluxes + timer ( 'cpu', cpu_fittedfluxes )
         walt_fittedfluxes = walt_fittedfluxes + timer ( 'wal', wal_fittedfluxes )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

! Compute total fluxes.
       
       if (ltiming) then
         cpu_totalfluxes = timer ( 'cpu', 0.0d0 )
         wal_totalfluxes = timer ( 'wal', 0.0d0 )
       endif

       allocate ( cbfsimage(nx,ny), stat=irc )

       if (irc .ne. 0) then
         write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble allocating memory (93).'
         stop 93
       endif

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Reading clean-background image '''//cbfsname(1:icbfs)//'''...'
       
       call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, cbfsimage, dx, dy, object, ra, dec
     &            , cbfsname(1:icbfs), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2, cd11
     &            , cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
       
       if (lverbose .eq. '-verb2') write (iotty,'(a,1x,2(1pe14.7))') '   Minmax values in the image:', funmin, funmax
       
       do n=1,nextr
         
         pedestal(n) = 0.0d0
         numpixbg(n) = 0
         lfootexpandable(n) = .true.
         
         if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. lfootprint(n)) then
           
           fluxtotbest(n) = 0.0d0

           nkovl = 0
           do k=1,nextr
             if (k .ne. n .and. flag(k) .ne. 'n' .and. badsource(k) .ne. '!' .and. lfootprint(k)) then
               if (maskimage(nxco(k),nyco(k)) .gt. 0.9d0 .and. fluxpko(k) .gt. almostzero) then
                 dist2 = (momxco(n) - momxco(k))**2 + (momyco(n) - momyco(k))**2
                 if (dist2 .lt. (foamajor(n) / dx / 2.0d0 + foamajor(k) / dx / 2.0d0)**2) then
                   nkovl = nkovl + 1
                   nkovlap(nkovl) = k
                 endif
               endif
             endif
           enddo

           semimajor = foamajor(n) / 2.0d0
           nr = nint ( semimajor / dx )
           l1 = max ( nxco(n) - nr , 1 )
           l2 = min ( nxco(n) + nr , nx )
           m1 = max ( nyco(n) - nr , 1 )
           m2 = min ( nyco(n) + nr , ny )
           
           do m=m1,m2
             dblm = dble ( m )
             
             do l=l1,l2
               dbll = dble ( l )
               
               if (maskimage(l,m) .gt. 0.9d0) then
                 
                 if (inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), foamajor(n), foaminor(n), foathepa(n) )) then
                   amoffat = aa(n) * dxcon2(n,l) + bb(n) * sqrt ( dxcon2(n,l) * dycon2(n,m) ) + cc(n) * dycon2(n,m)
                   funn = fluxpko(n) / (1.0d0 + amoffat)**beta
                   funn = abs ( funn )
                   funsum = funn
                   
                   do j=1,nkovl
                     k = nkovlap(j)
                     if (inellipse ( dbll, dblm, dx, dy, momxco(k), momyco(k), foamajor(k), foaminor(k), foathepa(k) )) then
                       amoffat = aa(k) * dxcon2(k,l) + bb(k) * sqrt ( dxcon2(k,l) * dycon2(k,m) ) + cc(k) * dycon2(k,m)
                       funk = fluxpko(k) / (1.0d0 + amoffat)**beta
                       funsum = funsum + abs ( funk )
                     endif
                   enddo

                   deblended = 0.0d0
                   if (fluxpeakbest(n) .gt. almostzero) then
                     deblended = (funn / (funsum + almostzero)) * obsbsfsimage(l,m)
                   elseif (fluxpeakbest(n) .lt. -almostzero) then
                     deblended = obsbsfsimage(l,m)
                   endif
                   fluxtotbest(n) = fluxtotbest(n) + deblended
                   pedestal(n) = pedestal(n) + cbfsimage(l,m)
                   numpixbg(n) = numpixbg(n) + 1
                 endif
               else
                 lfootexpandable(n) = .false.                 
               endif
             enddo
           enddo
           
           if (numpixbg(n) .gt. 1) pedestal(n) = pedestal(n) / dble ( numpixbg(n) )

! Aperture corrections for Herschel wavelengths.
           
           if (capcorr(1:ica) .eq. 'y' .and.
     &         (cowave(1:icw) .eq. '070' .or. cowave(1:icw) .eq. '0070' .or. cowave(1:icw) .eq. '70' .or. 
     &          cowave(1:icw) .eq. '100' .or. cowave(1:icw) .eq. '0100' .or. 
     &          cowave(1:icw) .eq. '160' .or. cowave(1:icw) .eq. '0160' .or. 
     &          cowave(1:icw) .eq. '250' .or. cowave(1:icw) .eq. '0250' .or. 
     &          cowave(1:icw) .eq. '350' .or. cowave(1:icw) .eq. '0350' .or. 
     &          cowave(1:icw) .eq. '500' .or. cowave(1:icw) .eq. '0500')) then

             frac = 1.0d0

             if (cowave(1:icw) .eq. '070' .or. cowave(1:icw) .eq. '0070' .or. cowave(1:icw) .eq. '70') then
               if (equivrad(n) .ge. ar070(1) .and. equivrad(n) .le. ar070(na070)) then
                 call interpolation ( iotty, equivrad(n), na070, ar070, af070, frac )
               endif
             endif
             if (cowave(1:icw) .eq. '100' .or. cowave(1:icw) .eq. '0100') then
               if (equivrad(n) .ge. ar100(1) .and. equivrad(n) .le. ar100(na100)) then
                 call interpolation ( iotty, equivrad(n), na100, ar100, af100, frac )
               endif
             endif
             if (cowave(1:icw) .eq. '160' .or. cowave(1:icw) .eq. '0160') then
               if (equivrad(n) .ge. ar160(1) .and. equivrad(n) .le. ar160(na160)) then
                 call interpolation ( iotty, equivrad(n), na160, ar160, af160, frac )
               endif
             endif
             if (cowave(1:icw) .eq. '250' .or. cowave(1:icw) .eq. '0250') then
               if (equivrad(n) .ge. ar250(1) .and. equivrad(n) .le. ar250(na250)) then
                 call interpolation ( iotty, equivrad(n), na250, ar250, af250, frac )
               endif
             endif
             if (cowave(1:icw) .eq. '350' .or. cowave(1:icw) .eq. '0350') then
               if (equivrad(n) .ge. ar350(1) .and. equivrad(n) .le. ar350(na350)) then
                 call interpolation ( iotty, equivrad(n), na350, ar350, af350, frac )
               endif
             endif
             if (cowave(1:icw) .eq. '500' .or. cowave(1:icw) .eq. '0500') then
               if (equivrad(n) .ge. ar500(1) .and. equivrad(n) .le. ar500(na500)) then
                 call interpolation ( iotty, equivrad(n), na500, ar500, af500, frac )
               endif
             endif
             
             apcorrect(n) = 1.0d0 / frac

             fluxpeakbest(n) = fluxpeakbest(n) * apcorrect(n)
             fluxtotbest(n) = fluxtotbest(n) * apcorrect(n)
             fluxtotfit(n) = fluxtotfit(n) * apcorrect(n)
           endif
                 
           if (maskimage(nxco(n),nyco(n)) .lt. 0.9d0) then
             fluxtotbest(n) = 0.0d0
             fluxtotfit(n) = 0.0d0
           endif

! Convert flux units for extracted sources.

           if (intensunits(1:iu) .eq. 'MJy/sr') then
             fluxtotbest(n) = fluxtotbest(n) * convftot1     !<-- convert into Jy
             fluxtotfit(n) = fluxtotfit(n) * convftot1     !<-- convert into Jy
           endif
         endif
       enddo

       if (ltiming) then
         cput_totalfluxes = cput_totalfluxes + timer ( 'cpu', cpu_totalfluxes )
         walt_totalfluxes = walt_totalfluxes + timer ( 'wal', wal_totalfluxes )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

! Compute the rms of intensity fluctuations around sources.

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Computing local rms values and significances for all sources...'
       
       if (ltruebacknoise) then
         open ( 18, file=truebgnoname(1:itruebg)//'.dat', status='unknown' )
       
         write (18,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by SMEASURE compiled on '//compda
         write (18,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (18,'(a)') '# Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'
         write (18,'(a)') '#'
         write (18,'(a)') '#  N  XCO_PIXEL  YCO_PIXEL  SN_RATIO   ANNSIGMA1  ANNSIGMA2  ANNSIGMA3  ANNSIGMAN  TRUESIGMA'
         write (18,'(a)') '#'
       endif
       if (ldevelopment) then
         open ( 17, file='sm'//obsbsfsname(idot:idot2)//'snratios.annuli.apcorrs.dat', status='unknown' )
       
         write (17,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by SMEASURE compiled on '//compda
         write (17,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (17,'(a)') '# Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'
         write (17,'(a)') '#'
         write (17,'(a)') '#  N  XCO_PIXEL  YCO_PIXEL  FP/SIGMA  ANNULPIX ANNULPIX1 ANNULPIX2  MAJORPIX  MINORPIX  THICKPIX'
     &                  //'  APCORRECT'
         write (17,'(a)') '#'
       endif

       if (ltiming) then
         cpu_createannuli = timer ( 'cpu', 0.0d0 )
         wal_createannuli = timer ( 'wal', 0.0d0 )
       endif

! Prepare the limiting boxes to accelerate.

       n1xmin = nx
       n2xmax = 1
       do m=1,ny
         n1x(m) = 0
         do l=1,nx
           if (maskimage(l,m) .gt. 0.9d0) then
             n1x(m) = max ( l - 2, 1 )
             if (n1x(m) .lt. n1xmin) n1xmin = n1x(m)
             exit
           endif
         enddo
         n2x(m) = 0
         do l=nx,1,-1
           if (maskimage(l,m) .gt. 0.9d0) then
             n2x(m) = min ( l + 2, nx )
             if (n2x(m) .gt. n2xmax) n2xmax = n2x(m)
             exit
           endif
         enddo
       enddo
       n1ymin = ny
       n2ymax = 1
       do l=1,nx
         do m=1,ny
           if (maskimage(l,m) .gt. 0.9d0) then
             n1y = max ( m - 2, 1 )
             if (n1y .lt. n1ymin) n1ymin = n1y
             exit
           endif
         enddo
         do m=ny,1,-1
           if (maskimage(l,m) .gt. 0.9d0) then
             n2y = min ( m + 2, ny )
             if (n2y .gt. n2ymax) n2ymax = n2y
             exit
           endif
         enddo
       enddo
       if (n1ymin .eq. ny) n1ymin = 1
       if (n2ymax .eq. 1 ) n2ymax = 1
       do m=1,ny
         if (n1x(m) .eq. 0) n1x(m) = 1
         if (n2x(m) .eq. 0) n2x(m) = 1
       enddo
       
       do m=1,ny
         do l=1,nx
           smafoot(l,m) = 0.0d0
           bigfoot(l,m) = 0.0d0
         enddo
       enddo

       aaa = 1.0d0
       newpixval = 1.0d0
       annulusarea = 20.0d0 * max ( sq_arcsecs_per_beam_area, pi * sqpixel / log ( 2.0d0 ) )
       ntry = 20

! Prepare the accumulated footprints image for the inner sides of the annuli.

       do n=1,nextr
         if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. 
     &       (lfootprint(n) .or. (maskimage(nxco(n),nyco(n)) .gt. 0.9d0 .and. fluxperror(n) .lt. 1.0d-50))) then
           major1 = factoff * foomajor(n)
           minor1 = factoff * foominor(n)
           semimajor1 = major1 / 2.0d0
           semiminor1 = minor1 / 2.0d0

! Limit the area to accelerate.
           
           nr = nint ( semimajor1 / dx ) + 1
           l1 = max ( nxco(n) - nr , 1 )
           l2 = min ( nxco(n) + nr , nx )
           m1 = max ( nyco(n) - nr , 1 )
           m2 = min ( nyco(n) + nr , ny )
           do m=m1,m2
             dblm = dble ( m )
             do l=l1,l2
               if (maskimage(l,m) .gt. 0.9d0) then
                 dbll = dble ( l )
                 if (inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), major1, minor1, foothepa(n) )) then
                   smafoot(l,m) = 0.1d0
                 endif
               endif
             enddo
           enddo
         endif
       enddo
       
! Prepare the accumulated footprints image for the annuli.

       do n=1,nextr
         if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. 
     &       (lfootprint(n) .or. (maskimage(nxco(n),nyco(n)) .gt. 0.9d0 .and. fluxperror(n) .lt. 1.0d-50))) then
           major1 = factoff * foomajor(n)
           minor1 = factoff * foominor(n)
           semimajor1 = major1 / 2.0d0
           semiminor1 = minor1 / 2.0d0
           bbb = semimajor1 - semiminor1
           ccc = -annulusarea / pi - semiminor1 * semimajor1
           semiminor2 = (-bbb + sqrt ( bbb**2 - 4.0d0 * aaa * ccc )) / (2.0d0 * aaa)
           semimajor2 = semimajor1 + semiminor2 - semiminor1
           major2 = semimajor2 * 2.0d0
           minor2 = semiminor2 * 2.0d0

! Limit the area to accelerate.
           
           nr = nint ( semimajor2 / dx ) + 1
           l1 = max ( nxco(n) - nr , 1 )
           l2 = min ( nxco(n) + nr , nx )
           m1 = max ( nyco(n) - nr , 1 )
           m2 = min ( nyco(n) + nr , ny )
           do m=m1,m2
             dblm = dble ( m )
             do l=l1,l2
               if (maskimage(l,m) .gt. 0.9d0) then
                 dbll = dble ( l )
                 if (inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), major2, minor2, foothepa(n) )) then
                   bigfoot(l,m) = max ( 0.1d0 - smafoot(l,m), 0.0d0 )
                 endif
               endif
             enddo
           enddo
         endif
       enddo
       
       if (ltiming) then
         cput_createannuli = cput_createannuli + timer ( 'cpu', cpu_createannuli )
         walt_createannuli = walt_createannuli + timer ( 'wal', wal_createannuli )
       endif

       call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, bigfoot, dx, dy, object, crval1
     &            , crval2, 'bigfoot.'//cowave(1:icw)//'.fits', header, footer, cdate, ctime, creator, beam, blank, crota1, crota2
     &            , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history )
                    
!-----------------------------------------------------------------------------------------------------------------------------------

       if (liter_phase2 .or. liter_phase3) then

         if (ltiming) then
           cpu_fluctuations = timer ( 'cpu', 0.0d0 )
           wal_fluctuations = timer ( 'wal', 0.0d0 )
         endif

         do n=1,nextr
           
           if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. 
     &         (lfootprint(n) .or. (maskimage(nxco(n),nyco(n)) .gt. 0.9d0 .and. fluxperror(n) .lt. 1.0d-50))) then
             
             czno = catline(n)(1:6)
             if (czno(2:2) .eq. ' ') czno(2:2) = '0'
             if (czno(3:3) .eq. ' ') czno(3:3) = '0'
             if (czno(4:4) .eq. ' ') czno(4:4) = '0'
             if (czno(5:5) .eq. ' ') czno(5:5) = '0'

             if (ltiming) then
               cpu_fluctuations1 = timer ( 'cpu', 0.0d0 )
               wal_fluctuations1 = timer ( 'wal', 0.0d0 )
             endif

! Make a special work image for footprint expansion.

             do m=n1ymin,n2ymax
               do l=n1x(m),n2x(m)
                 workerf(l,m) = 0.0d0
               enddo
             enddo
             
             nkovl = 0
             do k=1,nextr
               if (k .ne. n .and. flag(k) .ne. 'n' .and. badsource(k) .ne. '!' .and. 
     &             (lfootprint(k) .or. (maskimage(nxco(k),nyco(k)) .gt. 0.9d0 .and. fluxperror(k) .lt. 1.0d-50))) then
                 nkovl = nkovl + 1
                 nkovlap(nkovl) = k
               endif
             enddo

             do j=1,nkovl
               k = nkovlap(j)
               major1 = factoff * foomajor(k)
               minor1 = factoff * foominor(k)
               semimajor1 = major1 / 2.0d0
               semiminor1 = minor1 / 2.0d0
               nr = nint ( semimajor1 / dx ) + 1
               l1 = max ( nxco(k) - nr , 1 )
               l2 = min ( nxco(k) + nr , nx )
               m1 = max ( nyco(k) - nr , 1 )
               m2 = min ( nyco(k) + nr , ny )
               
               do m=m1,m2
                 dblm = dble ( m )
                 do l=l1,l2
                   dbll = dble ( l )
                   
                   if (maskimage(l,m) .gt. 0.9d0) then
                     if (inellipse ( dbll, dblm, dx, dy, momxco(k), momyco(k), major1, minor1, foothepa(k) )) then
                       workerf(l,m) = 0.1d0
                     endif
                   endif
                 enddo
               enddo
             enddo
             
             rad2max = -1.0d30
             do m=n1ymin,n2ymax
               do l=n1x(m),n2x(m)
                 if (bigfoot(l,m) .gt. almostzero) then
                   rad2max = max ( rad2max, dxcon2(n,l) + dycon2(n,m) )
                 endif
                 annulus(l,m) = bigfoot(l,m)
               enddo
             enddo
             radmax = sqrt ( rad2max )
             if (ltiming) then
               cput_fluctuations1 = cput_fluctuations1 + timer ( 'cpu', cpu_fluctuations1 )
               walt_fluctuations1 = walt_fluctuations1 + timer ( 'wal', wal_fluctuations1 )
             endif

             if (ltiming) then
               cpu_fluctuations2 = timer ( 'cpu', 0.0d0 )
               wal_fluctuations2 = timer ( 'wal', 0.0d0 )
             endif
             nr = nint ( radmax / dx ) + 1
             l1x = max ( nxco(n) - nr , 1 )
             l2x = min ( nxco(n) + nr , nx )
             m1x = max ( nyco(n) - nr , 1 )
             m2x = min ( nyco(n) + nr , ny )
             rad2min = 1.0d30
             do m=m1x,m2x
               do l=l1x,l2x
                 if (annulus(l,m) .gt. almostzero) then
                   rad2min = min ( rad2min, dxcon2(n,l) + dycon2(n,m) )
                 endif
               enddo
             enddo
             radmin = sqrt ( rad2min )
             if (ltiming) then
               cput_fluctuations2 = cput_fluctuations2 + timer ( 'cpu', cpu_fluctuations2 )
               walt_fluctuations2 = walt_fluctuations2 + timer ( 'wal', wal_fluctuations2 )
             endif

             if (ltiming) then
               cpu_fluctuations3 = timer ( 'cpu', 0.0d0 )
               wal_fluctuations3 = timer ( 'wal', 0.0d0 )
             endif
             deficit = 0.0d0
             annulusareait = annulusarea
             absobsfsatpos = abs ( obsfsimage(nxco(n),nyco(n)) )
             do ir=1,ntry
               rad2x = rad2min + annulusareait / pi
               nr = nint ( sqrt ( rad2x ) / dx ) + 1
               l1 = max ( nxco(n) - nr , 1 )
               l2 = min ( nxco(n) + nr , nx )
               m1 = max ( nyco(n) - nr , 1 )
               m2 = min ( nyco(n) + nr , ny )
               iann = 0
               do m=m1,m2
                 do l=l1,l2
                   if (smafoot(l,m) .lt. almostzero) then
                     rad2 = dxcon2(n,l) + dycon2(n,m)
                     if (rad2 .le. rad2x .and. abs ( obsfsimage(l,m) ) .lt. absobsfsatpos) then
                       iann = iann + 1
                     endif
                   endif
                 enddo
               enddo
               deficit = annulusarea - iann * sqpixel
               if (deficit .ge. almostzero) then
                 annulusareait = 1.2d0 * annulusareait
               else
                 exit
               endif
             enddo
             
             if (deficit / annulusarea .lt. 0.333d0) then
               lann3usable = .true.
             else
               lann3usable = .false.
             endif
             
             if (ltiming) then
               cput_fluctuations3 = cput_fluctuations3 + timer ( 'cpu', cpu_fluctuations3 )
               walt_fluctuations3 = walt_fluctuations3 + timer ( 'wal', wal_fluctuations3 )
             endif

             if (ltiming) then
               cpu_fluctuations4 = timer ( 'cpu', 0.0d0 )
               wal_fluctuations4 = timer ( 'wal', 0.0d0 )
             endif
             do m=m1,m2
               do l=l1,l2
                 if (smafoot(l,m) .lt. almostzero) then
                   rad2 = dxcon2(n,l) + dycon2(n,m)
                   if (rad2 .le. rad2x) annulus(l,m) = newpixval
                 endif
               enddo
             enddo
             if (ltiming) then
               cput_fluctuations4 = cput_fluctuations4 + timer ( 'cpu', cpu_fluctuations4 )
               walt_fluctuations4 = walt_fluctuations4 + timer ( 'wal', wal_fluctuations4 )
             endif
             
! If 'obsfsimage' is the filament-subtracted image '*.fs.fits', then use it to compute some rms values.

             if (ltiming) then
               cpu_fluctuations5 = timer ( 'cpu', 0.0d0 )
               wal_fluctuations5 = timer ( 'wal', 0.0d0 )
             endif

             if (index ( obsfsname(1:iobscb), '.fs.fits' ) .gt. 0) then

! The nearest elliptical annulus around the source.

               do m=n1ymin,n2ymax
                 do l=n1x(m),n2x(m)
                   worker(l,m) = bigfoot(l,m)
                 enddo
               enddo
               annulusareait = annulusarea

               do ir=1,ntry
                 major1 = factoff * foomajor(n)
                 minor1 = factoff * foominor(n)
                 semimajor1 = major1 / 2.0d0
                 semiminor1 = minor1 / 2.0d0
                 bbb = semimajor1 - semiminor1
                 ccc = -annulusareait / pi - semiminor1 * semimajor1
                 semiminor2 = (-bbb + sqrt ( bbb**2 - 4.0d0 * aaa * ccc )) / (2.0d0 * aaa)
                 semimajor2 = semimajor1 + semiminor2 - semiminor1
                 major2 = semimajor2 * 2.0d0
                 minor2 = semiminor2 * 2.0d0

! Compute standard deviation over an annulus around the source; other nearby sources may contaminate the annulus pixels.
          
                 if (ltruebacknoise) then
                   ibav0 = 0
                   backav0 = 0.0d0
                 endif
                 ibav1 = 0
                 ibavf = 0
                 backav1(n) = 0.0d0
                 backavf(n) = 0.0d0
              
                 nrz = nint ( semimajor2 / dx ) + 1
                 l1z = max ( nxco(n) - nrz , 1 )
                 l2z = min ( nxco(n) + nrz , nx )
                 m1z = max ( nyco(n) - nrz , 1 )
                 m2z = min ( nyco(n) + nrz , ny )
                 
                 do m=m1z,m2z
                   dblm = dble ( m )
                   
                   do l=l1z,l2z
                     
                     if (maskimage(l,m) .gt. 0.9d0) then
                       dbll = dble ( l )
                       
                       if (inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), major2, minor2, foothepa(n) ) .and.
     &                     .not.inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), major1, minor1, foothepa(n) )) then
                         
                         if (abs ( obsfsimage(l,m) ) .lt. absobsfsatpos) then
                           if (ltruebacknoise) then
                             backav0 = backav0 + truebacknoise(l,m)
                             ibav0 = ibav0 + 1
                           endif
                           backav1(n) = backav1(n) + obsfsimage(l,m)
                           ibav1 = ibav1 + 1
                           worker(l,m) = newpixval
                         else
                           worker(l,m) = 0.7d0
                         endif
                       endif

! Estimate quantities for footprint expansion in only those pixels of the nearest annulus 
! that are free from contamination by footprints of surrounding sources.

                       if (inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), major2, minor2, foothepa(n) ) .and.
     &                     .not.inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), foomajor(n), foominor(n), foothepa(n) )) then
                         
                         if (workerf(l,m) .lt. almostzero) then
                           backavf(n) = backavf(n) + cbfsimage(l,m)
                           ibavf = ibavf + 1
                           workerf(l,m) = newpixval
                         endif
                       endif
                     endif
                   enddo
                 enddo
                 deficit = annulusarea - ibav1 * sqpixel
                 if (deficit .ge. almostzero) then
                   annulusareait = 1.2d0 * annulusareait
                 else
                   exit
                 endif
               enddo

               if (deficit / annulusarea .lt. 0.333d0) then
                 lann1usable = .true.
               else
                 lann1usable = .false.
               endif

               if (ltruebacknoise) then
                 if (ibav0 .gt. 0) backav0 = backav0 / dble ( ibav0 )
               endif
               if (ibav1 .gt. 0) backav1(n) = backav1(n) / dble ( ibav1 )
               if (ibavf .gt. 0) backavf(n) = backavf(n) / dble ( ibavf )

               ibrms0 = 0
               ibrms1 = 0
               ibrmsf = 0
               backrms0 = 0.0d0
               backrms1(n) = 0.0d0
               backrmsf(n) = 0.0d0

               do m=m1z,m2z
                 do l=l1z,l2z
                   if (maskimage(l,m) .gt. 0.9d0) then
                     if (worker(l,m) .gt. 0.9d0) then
                       if (ltruebacknoise) then
                         backrms0 = backrms0 + (truebacknoise(l,m) - backav0)**2
                         ibrms0 = ibrms0 + 1
                       endif
                       backrms1(n) = backrms1(n) + (obsfsimage(l,m) - backav1(n))**2
                       ibrms1 = ibrms1 + 1
                     endif
                     if (workerf(l,m) .gt. 0.9d0) then
                       backrmsf(n) = backrmsf(n) + (cbfsimage(l,m) - backavf(n))**2
                       ibrmsf = ibrmsf + 1
                     endif
                   endif
                 enddo
               enddo
          
               if (ltruebacknoise) then
                 if (ibrms0 .gt. 1) backrms0 = sqrt ( backrms0 / dble ( ibrms0 - 1 ) )
               endif
               if (ibrms1 .gt. 1) backrms1(n) = sqrt ( backrms1(n) / dble ( ibrms1 - 1 ) )
               if (ibrmsf .gt. 1) backrmsf(n) = sqrt ( backrmsf(n) / dble ( ibrmsf - 1 ) )
               if (.not.lann1usable .or. backrms0 .lt. almostzero) backrms0 = 9.999e+29
               if (.not.lann1usable .or. backrms1(n) .lt. almostzero) backrms1(n) = 9.999e+29
               if (.not.lann1usable .or. backrmsf(n) .lt. almostzero) backrmsf(n) = 9.999e+29

! Make sure that the area used for footprint expansion has enough pixels to give meaningful values.

               if (ibrmsf .lt. 0.1d0 * annulusarea) then
                 backrmsf(n) = 9.999e+29
               endif

! Additional, twice more distant elliptical annulus around the source.

               do m=n1ymin,n2ymax
                 do l=n1x(m),n2x(m)
                   worker(l,m) = bigfoot(l,m)
                 enddo
               enddo
               annulusareait = annulusarea

               do ir=1,ntry
                 major1a = (2.0d0 * factoff) * foomajor(n)
                 minor1a = (2.0d0 * factoff) * foominor(n)
                 semimajor1a = major1a / 2.0d0
                 semiminor1a = minor1a / 2.0d0
                 bbb = semimajor1a - semiminor1a
                 ccc = -annulusareait / pi - semiminor1a * semimajor1a
                 semiminor2a = (-bbb + sqrt ( bbb**2 - 4.0d0 * aaa * ccc )) / (2.0d0 * aaa)
                 semimajor2a = semimajor1a + semiminor2a - semiminor1a
                 major2a = semimajor2a * 2.0d0
                 minor2a = semiminor2a * 2.0d0

! Compute standard deviation over an annulus around the source; other nearby sources may contaminate the annulus pixels.
          
                 ibav2 = 0
                 backav2(n) = 0.0d0
              
                 nrz = nint ( semimajor2a / dx ) + 1
                 l1z = max ( nxco(n) - nrz , 1 )
                 l2z = min ( nxco(n) + nrz , nx )
                 m1z = max ( nyco(n) - nrz , 1 )
                 m2z = min ( nyco(n) + nrz , ny )
                 
                 do m=m1z,m2z
                   dblm = dble ( m )
                   
                   do l=l1z,l2z
                     
                     if (maskimage(l,m) .gt. 0.9d0) then
                       dbll = dble ( l )
                       
                       if (inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), major2a, minor2a, foothepa(n) ) .and.
     &                     .not.inellipse ( dbll, dblm, dx, dy, momxco(n), momyco(n), major1a, minor1a, foothepa(n) )) then
                         
                         if (abs ( obsfsimage(l,m) ) .lt. absobsfsatpos) then
                           backav2(n) = backav2(n) + obsfsimage(l,m)
                           ibav2 = ibav2 + 1
                           worker(l,m) = newpixval
                         else
                           worker(l,m) = 0.7d0
                         endif
                       endif
                     endif
                   enddo
                 enddo
                 deficit = annulusarea - ibav2 * sqpixel
                 if (deficit .ge. almostzero) then
                   annulusareait = 1.2d0 * annulusareait
                 else
                   exit
                 endif
               enddo

               if (deficit / annulusarea .lt. 0.333d0) then
                 lann2usable = .true.
               else
                 lann2usable = .false.
               endif

               if (ibav2 .gt. 0) backav2(n) = backav2(n) / dble ( ibav2 )
                    
               ibrms2 = 0
               backrms2(n) = 0.0d0

               do m=m1z,m2z
                 do l=l1z,l2z
                   if (maskimage(l,m) .gt. 0.9d0) then
                     if (worker(l,m) .gt. 0.9d0) then
                       backrms2(n) = backrms2(n) + (obsfsimage(l,m) - backav2(n))**2
                       ibrms2 = ibrms2 + 1
                     endif
                   endif
                 enddo
               enddo
          
               if (ibrms2 .gt. 1) backrms2(n) = sqrt ( backrms2(n) / dble ( ibrms2 - 1 ) )
               if (.not.lann2usable .or. backrms2(n) .lt. almostzero) backrms2(n) = 9.999e+29

! Compute standard deviation over a (possibly larger) environment of the source, extending the annulus to avoid other sources.
          
               ibav3 = 0
               ibrms3 = 0
               backav3(n) = 0.0d0
               backrms3(n) = 0.0d0

               do m=m1,m2
                 do l=l1,l2
                   if (maskimage(l,m) .gt. 0.9d0) then
                     if (annulus(l,m) .gt. 0.9d0) then
                       if (abs ( obsfsimage(l,m) ) .lt. absobsfsatpos) then
                         backav3(n) = backav3(n) + obsfsimage(l,m)
                         ibav3 = ibav3 + 1
                       else
                         annulus(l,m) = 0.3d0
                       endif
                     endif
                   endif
                 enddo
               enddo
            
               if (ibav3 .gt. 0) backav3(n) = backav3(n) / dble ( ibav3 )
                    
               do m=m1,m2
                 do l=l1,l2
                   if (maskimage(l,m) .gt. 0.9d0) then
                     if (annulus(l,m) .gt. 0.9d0) then
                       backrms3(n) = backrms3(n) + (obsfsimage(l,m) - backav3(n))**2
                       ibrms3 = ibrms3 + 1
                     endif
                   endif
                 enddo
               enddo
          
               if (ibrms3 .gt. 1) backrms3(n) = sqrt ( backrms3(n) / dble ( ibrms3 - 1 ) )
               if (.not.lann3usable .or. backrms3(n) .lt. almostzero) backrms3(n) = 9.999e+29

! The final standard deviation is a minimum of the three estimates; this must be more accurate than either one.

               backrms(n) = min ( backrms1(n), backrms2(n), backrms3(n) )
          
               if (backrms(n) .gt. almostzero .and. backrms(n) .lt. 9.0e+29) then
                 sigmarms = backrms(n)
               else
                 sigmarms = 1.111d-31
               endif

               factrms = 2.0d0
               surround(n) = 9.999e+29
               if (lann1usable .and. backrmsf(n) .lt. 9.0e+29 .and. backrms1(n) .lt. 9.0e+29) then
                 surround(n) = min ( backavf(n) + factrms * backrmsf(n), backav1(n) + factrms * backrms1(n) )
               endif

               if (ldevelopment) then
                 if (ibrms2 .lt. 80 .and. lverbose .eq. '-verb2') then
                   icon = 1
                   write (con,'(i5)') n
                   if (con(1:1) .eq. ' '   ) icon = 2
                   if (con(1:2) .eq. '  '  ) icon = 3
                   if (con(1:3) .eq. '   ' ) icon = 4
                   if (con(1:4) .eq. '    ') icon = 5
                   areapix1 = pi * semimajor1 * semiminor1 / sqpixel
                   areapix2 = pi * semimajor2 * semiminor2 / sqpixel
                   thickpix = (semiminor2 - semiminor1) / dx
                   write (iotty,'(a)') '   SMEASURE: WARNING: Computing rms with too few pixels for source # '//con(icon:5)//'...'
                   write (iotty,*) nxco(n), nyco, areapix2 - areapix1, ibrms2 
                 endif
          
                 write (17,'(i4,10(1pe10.2))') n, momxco(n), momyco(n), fluxpeakbest(n) / max ( backrms(n), almostzero)
     &                                       , areapix2 - areapix1, dble ( ibrms1 ), dble ( ibrms2 ), major2 / dx, minor2 / dx
     &                                       , thickpix, apcorrect(n)

                 annulusname = originpath(1:iopa)//'/+iterations/+annuli/'//'sm.annulus.'//cowave(1:icw)//'.no'//czno(2:6)//'.fits'
                 ian = lastc ( annulusname )
              
                 if (backrms1(n) .lt. backrms3(n) .or. backrms2(n) .lt. backrms3(n)) then
                   call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, worker, dx, dy
     &                        , object, crval1, crval2, annulusname(1:ian), header, footer, cdate, ctime, creator, beam, blank
     &                        , crota1, crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax
     &                        , history )
                 else
                   call wfits ( cfitsversion, nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, annulus, dx, dy
     &                        , object, crval1, crval2, annulusname(1:ian), header, footer, cdate, ctime, creator, beam, blank
     &                        , crota1, crota2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax
     &                        , history )
                 endif
               endif
             endif
         
! If 'obsfsimage' is the true simulated rms image, then take the rms values from it.
! Allow for inaccuracy of 1 pixel in the derived coordinates.

             if (index ( obsfsname(1:iobscb), '.backrms.fits' ) .gt. 0) then
         
               if (obsfsimage(nxco(n),nyco(n)) .gt. 1.0d-10 .or. 
     &             obsfsimage(max(nxco(n)-1,1),nyco(n)) .gt. 1.0d-10 .or. 
     &             obsfsimage(min(nxco(n)+1,nx),nyco(n)) .gt. 1.0d-10 .or. 
     &             obsfsimage(max(nxco(n)-1,1),min(nyco(n)+1,ny)) .gt. 1.0d-10 .or. 
     &             obsfsimage(min(nxco(n)+1,nx),min(nyco(n)+1,ny)) .gt. 1.0d-10 .or. 
     &             obsfsimage(max(nxco(n)-1,1),max(nyco(n)-1,1 )) .gt. 1.0d-10 .or. 
     &             obsfsimage(min(nxco(n)+1,nx),max(nyco(n)-1,1 )) .gt. 1.0d-10 .or. 
     &             obsfsimage(nxco(n),max(nyco(n)-1,1)) .gt. 1.0d-10 .or. 
     &             obsfsimage(nxco(n),min(nyco(n)+1,ny)) .gt. 1.0d-10) then
                 rmsav = 0.0d0
                 ibav = 0
                 if (obsfsimage(nxco(n),nyco(n)) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(nxco(n),nyco(n))
                 endif
                 if (obsfsimage(max(nxco(n)-1,1),nyco(n)) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(max(nxco(n)-1,1),nyco(n))
                 endif
                 if (obsfsimage(min(nxco(n)+1,nx),nyco(n)) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(min(nxco(n)+1,nx),nyco(n))
                 endif
                 if (obsfsimage(max(nxco(n)-1,1),min(nyco(n)+1,ny)) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(max(nxco(n)-1,1),min(nyco(n)+1,ny))
                 endif
                 if (obsfsimage(min(nxco(n)+1,nx),min(nyco(n)+1,ny)) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(min(nxco(n)+1,nx),min(nyco(n)+1,ny))
                 endif       
                 if (obsfsimage(max(nxco(n)-1,1),max(nyco(n)-1,1 )) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(max(nxco(n)-1,1),max(nyco(n)-1,1 ))
                 endif       
                 if (obsfsimage(min(nxco(n)+1,nx),max(nyco(n)-1,1 )) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(min(nxco(n)+1,nx),max(nyco(n)-1,1 ))
                 endif       
                 if (obsfsimage(nxco(n),max(nyco(n)-1,1)) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(nxco(n),max(nyco(n)-1,1))
                 endif       
                 if (obsfsimage(nxco(n),min(nyco(n)+1,ny)) .gt. 1.0d-10) then
                   ibav = ibav + 1
                   rmsav = rmsav + obsfsimage(nxco(n),min(nyco(n)+1,ny))
                 endif       
                 sigmarms = rmsav / dble ( ibav )
               endif
             endif

! If the footprint area contains N times the beam area, then the rms error of the sum of intensities over the footprint area 
! will be the square root of the quadratic sum of the individual rms errors, since the N beam measurements are statistically 
! independent. If the individual rms errors are assumed identical and equal to errFpeak, then errFtot = errFpeak * sqrt ( N ). 
! Since N = footprint area / beam area, sqrt ( N ) = sqrt ( footprint area / beam area ).
       
             fluxperror(n) = sigmarms
             fluxterror(n) = fluxperror(n) * sqrt ( foomajor(n) * foominor(n) ) / (factortotal * beam)
           
! Convert flux error units from MJy/sr into Jy before cataloging them.

             if (intensunits(1:iu) .eq. 'MJy/sr') then
               fluxterror(n) = fluxterror(n) * 1.0d6 * sterad_per_beam_area
             endif
        
             if (ltruebacknoise) then
               if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!') then
                 write (18,'(i4,12(1pe11.3))') n, momxco(n), momyco(n), abs ( fluxpeakbest(n) ) / fluxperror(n), backrms1(n)
     &                                       , backrms2(n), backrms3(n), backrms(n), backrms0
               endif
             endif

             if (ltiming) then
               cput_fluctuations5 = cput_fluctuations5 + timer ( 'cpu', cpu_fluctuations5 )
               walt_fluctuations5 = walt_fluctuations5 + timer ( 'wal', wal_fluctuations5 )
             endif
           endif

! For sources in absorption, there is no way of computing accurate single-scale monochromatic significances.
! One has to replace the significance with a signal-to-noise ratio.

           if (fluxpeakbest(n) .lt. -almostzero) then
             if (fluxperror(n) .gt. almostzero) then
               if (lonlypositives) then
                 sigmono(n) = fluxpeakbest(n) / fluxperror(n)
               else
                 sigmono(n) = abs ( fluxpeakbest(n) ) / fluxperror(n)
               endif
             else
               sigmono(n) = 6.666d-31
             endif
           endif
         enddo
       
         if (ltiming) then
           cput_fluctuations = cput_fluctuations + timer ( 'cpu', cpu_fluctuations )
           walt_fluctuations = walt_fluctuations + timer ( 'wal', wal_fluctuations )
         endif
       endif

       deallocate ( cbfsimage )

       if (ltruebacknoise) then
         close ( 18 )
       endif
       if (ldevelopment) then
         close ( 17 )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

! Now compute wavelength-dependent significances.

       if (.not.lfinishing_mode) then
        
         if (ltiming) then
           cpu_significances = timer ( 'cpu', 0.0d0 )
           wal_significances = timer ( 'wal', 0.0d0 )
         endif

         allocate ( ssimage(nx,ny), stat=irc )
  
         if (irc .ne. 0) then
           write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble allocating memory (94).'
           stop 94
         endif

         if (lverbose .eq. '-verb2') then
           iss = lasts ( filewithnames(1:ifdn) ) + 1
           write (iotty,'(a)') '   Reading names of images from '''//filewithnames(iss:ifdn)//'''...'
         endif
         
         open ( 25, file=filewithnames(1:ifdn), status='old' )
       
         call skipcomm     ( 25, filewithnames(1:ifdn), nheadf )
         call linescolumns ( 25, filewithnames(1:ifdn), nheadf, nfiles, ncolumns )
       
         rewind ( 25 )
         do k=1,nheadf
           read (25,'(a)')
         enddo

         cutoffmax = 0.0d0
         sigmamax = 0.0d0
                    
         do kk=1,nfiles
           read (25,*) sswavename(kk), sigma(kk), sigmas(kk), cutoff(kk)
           iss = lastc ( sswavename(kk) )
           isca = index ( sswavename(kk)(1:iss), '.c' )
           read (sswavename(kk)(isca+2:isca+7),*) sscale(kk)
           isca = index ( sswavename(kk)(1:iss), '.an.' )
           sswavename(kk)(isca:isca+3) = '.fs.'
           inquire ( file=sswavename(kk)(1:iss), exist=lfnam1 )
           if (.not.lfnam1) then
             sswavename(kk)(isca:isca+3) = '.an.'
           endif
           if (cutoff(kk) .gt. cutoffmax .and. cutoff(kk) .lt. 1.0d9 .and. sscale(kk) .gt. beam / 1.5d0) then
             cutoffmax = cutoff(kk)
             sigmamax = cutoffmax / sigmas(kk)
           endif
         enddo
         sfactor = sscale(2) / sscale(1)

         nfiles1 = 0
         nfiles2 = nfiles
       
         do kk=1,nfiles
           iss = lastc ( sswavename(kk) )
           inquire ( file=sswavename(kk)(1:iss), exist=lfnam1 )
           if (nfiles1 .eq. 0 .and. lfnam1 .and. cutoff(kk) .lt. 1.0d9) then
             nfiles1 = kk + 1
           endif
           if (nfiles1 .gt. 0 .and. .not.lfnam1) then
             nfiles2 = kk - 1
             exit
           endif
         enddo 
         
         close ( 25 )
       
         if (nfiles1 .eq. 0 .or. nfiles2 .eq. 0) then
           write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble finding files from '//filewithnames(1:ifdn)
           stop 37
         endif
       
         do kk=1,nfiles
           if (kk .gt. nfiles2) then
             sscale(kk) = sscale(kk-1) * sfactor
             sigma (kk) = sigma (kk-1)
             sigmas(kk) = sigmas(kk-1)
             cutoff(kk) = cutoff(kk-1)
           endif
         enddo

         do n=1,nextr
           ratiomax(n) = 0.0d0
           ssimagemax(n) = 0.0d0
         enddo

! Compute single-scale significances.
 
         do kk=nfiles1,nfiles2
           
           call rfits ( nx, ny, bunit, ctype1, ctype2, crpix1, crpix2, crval1, crval2, ssimage, dx, dy, object, ra, dec
     &                , sswavename(kk)(1:iss), header, footer, iotty, 0, creator, beamd, funmin, funmax, blank, crota1, crota2
     &                , cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale, wave, datamin, datamax, history, lverbose )
       
           do n=1,nextr
             read (catline(n)(2:18),'(i5,3i3)') no, ns1, ns2, nsx
       
             if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!') then
               fluxpkss(n) = ssimage(nxco(n),nyco(n))

! The condition below includes 2.0d0 * sscale(nsx), because otherwise sources that happened to lie on top of large clumps
! tend to expand their footprints to the size of the whole clump.

               if (kk .ge. ns1 .and. sscale(kk) .le. min ( 1.5d0 * max ( scalensx(n), sscale(nfiles1), beam ), sscale(ns2) )) then
                 if (ssimage(nxco(n),nyco(n)) .gt. almostzero) then
                   ssimagemax(n) = ssimage(nxco(n),nyco(n))
                   if (fluxpeakbest(n) .gt. almostzero) then

! Compute monochromatic significance of each source from the monochromatic single-scale images.

                     ratio1 = fluxpkss(n) / sigma(nfiles1)
                  
                     if (ratio1 .gt. ratiomax(n)) then
                       ratiomax(n) = ratio1
                       if (maskimage(nxco(n),nyco(n)) .gt. 0.9d0) then
                         sigmono(n) = fluxpkss(n) / sigma(kk)
                       else
                         sigmono(n) = 0.0d0
                       endif
! 121109 A.M.: This was a mistake to re-compute the characteristic scale for each wavelength
! because the scale is fundamentally a wave-independent detection quantity. When re-computed,
! the scale was determined by the longest wavelength (poorest resolution), which is not good.
!!!!                       scalensx(n) = sscale(kk)
                     endif
                   endif
                 endif
               endif
             endif
           enddo
         enddo

         deallocate ( ssimage )
       
         do n=1,nextr
           if (flag(n) .ne. 'n'  .and. badsource(n) .ne. '!') then
             if (maskimage(nxco(n),nyco(n)) .gt. 0.9d0) then
               if (abs ( fluxpeakbest(n) ) .lt. almostzero) then
                 sigmono(n) = 7.777d-31
               else
                 if (ratiomax(n) .lt. almostzero) then
                   if (ssimagemax(n) .lt. almostzero) then
                     sigmono(n) = 9.999d-31
                   else
                     sigmono(n) = 8.888d-31
                   endif
                 endif

! For sources in absorption, this is a temporary value to allow normal further processing. 
! In the last measurement iteration, it will be replaced by the signal-to-noise value.

                 if (fluxpeakbest(n) .lt. -almostzero .and. .not.lfinishing_mode) then
                   if (liter_phase2 .or. liter_phase3) then
                     if (lonlypositives) then
                       sigmono(n) = -100.0d0
                     else
                       sigmono(n) = 100.0d0
                     endif
                   else
                     sigmono(n) = 100.0d0
                   endif
                 endif
               endif
             else
               sigmono(n) = 0.0d0
             endif
           endif
         enddo

         if (ltiming) then
           cput_significances = cput_significances + timer ( 'cpu', cpu_significances )
           walt_significances = walt_significances + timer ( 'wal', wal_significances )
         endif
       endif

       if (liter_phase1) then
         do n=1,nextr
           footfact(n) = factortotal
         enddo
       endif

       if ((liter_phase2 .or. liter_phase3) .and. .not.lfinishing_mode) then
         do n=1,nextr
           if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. lfootexpandable(n)) then
             if (fluxpeakbest(n) .gt. almostzero .and. fluxperror(n) .gt. almostzero) then
               if (surround(n) .lt. 9.0e+29 .and. pedestal(n) .ge. surround(n) .and. afwhm(n) / bfwhm(n) .lt. 1.5d0 .and.
     &             min ( sigmono(n), sigglob(n) ) .gt. 10.0d0 .and. fluxpeakbest(n) / fluxperror(n) .gt. 3.0d0) then
                 upperlimit = 0.9d0 * min ( nx * dx, ny * dy ) / max ( scalensx(n), beam )
                 footfact(n) = min ( 1.15d0 * footfact(n), upperlimit )
               endif
             endif
           endif
         enddo
       endif

       if (.not.liter_phase1) then
         open ( 17, file='sm'//obsbsfsname(idot:idot2)//'snrs.fofa.dat', status='unknown' )
                                                           
         write (17,'(a)') '# Date: '//cdate//' Time: '//ctime//'  Created by SMEASURE compiled on '//compda
         write (17,'(a)') '# Alexander Men''shchikov, SAp IRFU CEA Saclay, France (alexander.menshchikov@cea.fr)'
         write (17,'(a)') '# Used '//clibname(lb:7)//' library version '//cfitsversion//' by William D Pence '
     &                  //'(william.d.pence@nasa.gov)'     
         write (17,'(a)') '#'                              
         write (17,'(a)') '#  N  SIG_GLOB  SIG_MONO  FP/ERROR  FT/ERROR  FPRAT1    FTRAT1    FPRAT2    FTRAT2    SCALENSX   BACKAV1'
     &                  //'   BACKAV2   BACKAV3  BACKRMS1  BACKRMS2  BACKRMS3   BACKAVF  BACKRMSF  SURROUND  PEDESTAL   FOOFA'
         write (17,'(a)') '#'                              
                                                           
         do n=1,nextr                                      
           if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!') then
             fp2error = 0.0d0
             if (fluxperror(n) .gt. almostzero) fp2error = fluxpeakbest(n) / fluxperror(n)
             ft2error = 0.0d0
             if (fluxterror(n) .gt. almostzero) ft2error = fluxtotbest(n) / fluxterror(n)
             fprat1 = 0.0d0
             if (fluxperror(n) .gt. almostzero .and. sigglob(n) .gt. almostzero) fprat1 = fp2error / sigglob(n)
             ftrat1 = 0.0d0
             if (fluxterror(n) .gt. almostzero .and. sigglob(n) .gt. almostzero) ftrat1 = ft2error / sigglob(n)
             fprat2 = 0.0d0
             if (fluxperror(n) .gt. almostzero .and. sigmono(n) .gt. almostzero) fprat2 = fp2error / sigmono(n)
             ftrat2 = 0.0d0
             if (fluxterror(n) .gt. almostzero .and. sigmono(n) .gt. almostzero) ftrat2 = ft2error / sigmono(n)
             
             write (17,'(i4,19(1pe10.2),1(0pf8.3))') n, sigglob(n), sigmono(n), fp2error, ft2error, fprat1, ftrat1, fprat2, ftrat2
     &                                             , scalensx(n), backav1(n), backav2(n), backav3(n), backrms1(n), backrms2(n)
     &                                             , backrms3(n), backavf(n), backrmsf(n), surround(n), pedestal(n), footfact(n)
           endif
         enddo

         close ( 17 )
       endif
       
       deallocate ( obsbsfsimage, obsfsimage, maskimage, bigfoot, smafoot, worker, workerf, n1x, n2x, annulus )

       if(ltruebacknoise) deallocate ( truebacknoise )

!-----------------------------------------------------------------------------------------------------------------------------------

       if (ltiming) then
         cpu_sum = cpu_sum + cput_readimages + cput_iteratepeaks + cput_secondmoments + cput_totalfluxes + cput_fittedfluxes
     &                     + cput_createannuli + cput_fluctuations + cput_significances
         wal_sum = wal_sum + walt_readimages + walt_iteratepeaks + walt_secondmoments + walt_totalfluxes + walt_fittedfluxes
     &                     + walt_createannuli + walt_fluctuations + walt_significances

! Total cpu usage, expressed in hours, minutes, and seconds.

         cputot = cpu_sum
         cpuhours = int ( cputot / 3600.0d0 )
         cpumins  = int ( cputot / 60.0d0 ) -  60 * cpuhours
         cpusecs  = int ( cputot + 0.5d0 ) - 3600 * cpuhours - 60 * cpumins

! Final wall clock time, expressed in hours, minutes, and seconds.

         wctot  = wal_sum
         wchours  = int ( wctot / 3600.0d0 )
         wcmins   = int ( wctot / 60.0d0 ) -  60 * wchours
         wcsecs   = int ( wctot + 0.5d0 ) - 3600 * wchours - 60 * wcmins

         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' Total ''READING IMAGES''  CPU',cput_readimages   ,' REAL',walt_readimages   ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''ITERATE PEAKS''   CPU',cput_iteratepeaks ,' REAL',walt_iteratepeaks ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''SECOND MOMENTS''  CPU',cput_secondmoments,' REAL',walt_secondmoments,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''TOTAL FLUXES''    CPU',cput_totalfluxes  ,' REAL',walt_totalfluxes  ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FITTED FLUXES''   CPU',cput_fittedfluxes ,' REAL',walt_fittedfluxes ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''CREATE ANNULI''   CPU',cput_createannuli ,' REAL',walt_createannuli ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLUCTUATIONS1''   CPU',cput_fluctuations1,' REAL',walt_fluctuations1,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLUCTUATIONS2''   CPU',cput_fluctuations2,' REAL',walt_fluctuations2,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLUCTUATIONS3''   CPU',cput_fluctuations3,' REAL',walt_fluctuations3,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLUCTUATIONS4''   CPU',cput_fluctuations4,' REAL',walt_fluctuations4,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLUCTUATIONS5''   CPU',cput_fluctuations5,' REAL',walt_fluctuations5,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''FLUCTUATIONS''    CPU',cput_fluctuations ,' REAL',walt_fluctuations ,' sec'
         write (60,'(a,2(1pe9.2,a))') ' Total ''SIGNIFICANCES''   CPU',cput_significances,' REAL',walt_significances,' sec'
         write (60,'(a            )') ' ------------------------------------------------------'
         write (60,'(a,2(1pe9.2,a))') ' ACCUMULATED CPU & REAL TIME' ,cpu_sum             ,' sec ',wal_sum            ,' sec'
         write (60,'(a,i3.2,a,i2.2,a,i2.2,a,i3.2,a,i2.2,a,i2.2,a,f7.2,a)')
     &             ' ---------------------------',cpuhours,':',cpumins,':',cpusecs,' ----',wchours,':',wcmins,':',wcsecs,' ---'
  
         call when ( lunix, ctime, cdate, ndate, 4 )
  
         write (60,'(a)') ' SMEASURE finished: '//cdate//' '//ctime
         close ( 60 )
       endif

!-----------------------------------------------------------------------------------------------------------------------------------

       if (lverbose .eq. '-verb2') write (iotty,'(a)') '   Writing output catalog '''//ocatname(1:iocat)//'''...'
                                     
       fmtwcs='2(0pf11.5)'

       inquire ( file=wcsfile(1:iwcs), exist=lfnwcs )
       if (lfnwcs) then
         open ( 88, file=wcsfile(1:iwcs), status='old' )
         do n=1,nextr
           read (88,*,err=199) wcsxco(n), wcsyco(n), coosystem
         enddo
         close ( 88 )
         goto 200
  199    continue
           write (iotty,'(/a)') '   SMEASURE: ERROR: Trouble reading WCS coordinates from '''//wcsfile(1:iwcs)//'''...'
           stop 60
  200    continue
       endif
       
       open ( 15, file=ocatname(1:iocat), status='unknown' )

! Copy the original catalog header lines.

       ncolumn1 = 0
       do i=1,nhead
         ic = lastc ( headline(i) )
         ncolumn = index ( headline(i)(1:ic), '# Tabulated quantities' )
         if (ncolumn .eq. 0) then
           ncolumn = index ( headline(i)(1:ic), '# TABULATED QUANTITIES' )
         endif
         if (ncolumn .gt. 0) then
           headline(i) = headline(i)(1:ic-1)//' ('//cnextrgood(igood:5)//' good + '//cnextrbad(ibad:5)//' bad):'
           ic = lastc ( headline(i) )
         endif
         ncolumn  = index ( headline(i)(1:ic), '#         measurement image ' )
         if (ncolumn1 .gt. 0 .and. ncolumn .eq. 0) then
           write (15,'(a)') '#         measurement image '''//obsbsfsname(1:iobsbsfs)//''''
         endif
         ncolumn1 = index ( headline(i)(1:ic), '# DETECTION TABLE for image ' )
         if (lfnwcs) then
           ncolumn = index ( headline(i)(1:ic), '#   XCO_PIXRO .....' )
           if (ncolumn .gt. 0) then
             headline(i) = '#   WCS_ACOOR ..... WCS ('//coosystem
     &                   //') alpha-coordinate of current source ........... (degrees)'
           endif
           ncolumn = index ( headline(i)(1:ic), '#   YCO_PIXRO .....' )
           if (ncolumn .gt. 0) then
             headline(i) = '#   WCS_DCOOR ..... WCS ('//coosystem
     &                   //') delta-coordinate of current source ........... (degrees)'
           endif
           ncolumn = index ( headline(i)(1:ic), 'XCO_PIXRO  YCO_PIXRO  ' )
           if (ncolumn .gt. 0) then
             headline(i)(ncolumn:ncolumn+21) = 'WCS_ACOOR  WCS_DCOOR  '
           endif
         endif
         write (15,'(a)') headline(i)(1:ic)
       enddo                                     

       do n=1,nextr
         ic = lastc ( catline(n) )
         write (15,'(a1,a,2(f11.4),'//fmtwcs//',1pe11.3,i3,0pf6.2,1pe11.3,a5,14(1pe11.3),a)')
     &         badsource(n), catline(n)(2:18), momxco(n), momyco(n), wcsxco(n), wcsyco(n), sigglob(n), flg(n), good(n), sigmono(n)
     &       , cflm(n), fluxpeakbest(n), fluxperror(n), fluxtotbest(n), fluxterror(n), fluxtotfit(n), scalensx(n), afwhm(n)
     &       , bfwhm(n), atheta(n), equivrad(n), footfact(n), foomajor(n), foominor(n), foothepa(n), catline(n)(npeakfx:ic)
       enddo

       close ( 15 )

       deallocate ( momxco, momyco, momxx, momyy, momxy, int0, afwhm, bfwhm, atheta, fluxtotfit, fluxpeakbest, fluxtotbest, equivrad
     &            , sigmono, sigglob, scalensx, lconverged, numpix, catline, fluxpko, flag, badsource, backrms, fluxperror, cflm
     &            , apcorrect, fluxterror, dxcon2, dycon2, fluxpkss, foomajor, foominor, foothepa, aa, bb, cc, flg, flm, lfootprint
     &            , wcsxco, wcsyco, convdelta, slope, ratiomax, ssimagemax, good, footfact, foamajor, foaminor, foathepa, pedestal
     &            , numpixbg, backav1, backav2, backav3, backavf, backrmsf, backrms1, backrms2, backrms3, surround
     &            , lfootexpandable, nkovlap, nxco, nyco )
       
       if (lverbose .eq. '-verb2') write (iotty,'(/a)') ' Done.'

       stop
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine interpolation

     &            ( iotty, x, n, arg, fun, y )
!__________________________________________________________________________________________________________________________________
!
! Interpolation in table fun(arg) for a given argument x. arg(i), i=1,2,...,n  should be monotonically increasing.
!
!   Input parameters:
!      x   - argument value for interpolation
!      n   - dimension of argument and function vectors
!      arg - vector of argument values of a table
!      fun - vector of function values of a table
!
!   Output parameter:
!      y   - value of function y(x)
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       integer       i, j, k, n, iotty
       real*8        x, y, dx, arg(n), fun(n)
!__________________________________________________________________________________________________________________________________
!
       if ((x .lt. arg(1) .and. abs ( (x - arg(1)) / (arg(1) + 1.0d-30) ) .gt. 1.0d-13) .or. 
     &     (x .gt. arg(n) .and. abs ( (x - arg(n)) / (arg(n) + 1.0d-30) ) .gt. 1.0d-13)) then
         write (iotty,'(/'' ERROR: Invalid argument x='',1pd10.3)') x
         write (iotty,'(/'' Here are the input data (x,n,j,argj,funj):''/)')
         write (iotty,*) x,n
         do j=1,n
            write (iotty,*) j, arg(j), fun(j)
         enddo
         stop 99
       endif

       i = 1
       j = n + 1
 10    continue
         k = (i + j) / 2

         if (x .le. arg(k)) then
           j = k
         else
           i = k
         endif

       if (j .gt. i + 1) then
         goto 10
       endif

      if (i .eq. n) i = i - 1

      dx = (x - arg(i)) / (arg(i+1) - arg(i) + 1.0d-30)

      y = fun(i) * (1.0d0 - dx) + fun(i+1) * dx

      return
      end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine sourcesizes
       
     &            ( nextr, pixel, sqpixel, beam, badsource, lfootprint, flag, numpix, momxx, momyy, momxy, afwhm, bfwhm, atheta
     &            , equivrad, foomajor, foominor, sqreightlogtwo, convtodegrees, pi )
!__________________________________________________________________________________________________________________________________
!
! Compute FWHM sizes from intensity moments.
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       lfootprint(*)
       character*(*) flag(*), badsource(*)
       integer       n, nextr
       real*8        pixel, sqpixel, sqreightlogtwo, momp2, momm2, sqrmo, asig, bsig, convtodegrees, sourcearea, pi, beam

       integer       numpix(*)
       real*8        afwhm(*), bfwhm(*), atheta(*), momxx(*), momyy(*), momxy(*), equivrad(*), foomajor(*), foominor(*)
!__________________________________________________________________________________________________________________________________
!
! Loop over all extracted sources.       
       
       do n=1,nextr

         if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. lfootprint(n)) then
           momp2 = (momxx(n) + momyy(n)) / 2.0d0
           momm2 = (momxx(n) - momyy(n)) / 2.0d0

           if (abs ( momxy(n) ) .lt. 1.0d-20) then
             if (momxx(n) .gt. momyy(n)) then
               momp2 = momxx(n)
               momm2 = momyy(n)
               atheta(n) = 90.0d0
             else
               momp2 = momyy(n)
               momm2 = momxx(n)
               atheta(n) = 0.0d0
             endif
             sqrmo = sqrt ( momm2**2 + momxy(n)**2 )
             asig  = sqrt ( momp2 + sqrmo ) * pixel
             if (momp2 .gt. sqrmo) then 
               bsig = sqrt ( momp2 - sqrmo ) * pixel
             else
               asig = 0.0d0
               bsig = 0.0d0
             endif
           else       
             sqrmo = sqrt ( momm2**2 + momxy(n)**2 )
             if (momp2 + sqrmo .ge. 0.0d0) then 
               asig  = sqrt ( momp2 + sqrmo ) * pixel
             endif
             if (momp2 - sqrmo .ge. 0.0d0) then 
               bsig  = sqrt ( momp2 - sqrmo ) * pixel
             endif
             if (momp2 + sqrmo .lt. 0.0d0 .or. momp2 - sqrmo .lt. 0.0d0) then 
               asig = 0.0d0
               bsig = 0.0d0
             endif
             atheta(n) = 180.0d0 - atan2 ( sqrmo + momm2, momxy(n) ) * convtodegrees
           endif                                        
           
           afwhm(n) = min ( max ( sqreightlogtwo * asig, beam ), foomajor(n) )
           bfwhm(n) = min ( max ( sqreightlogtwo * bsig, beam ), foominor(n) )

           sourcearea = dble ( numpix(n) ) * sqpixel
           equivrad(n) = sqrt ( sourcearea / pi )
         endif
       enddo
       
       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine fitsourcesflux
       
     &            ( nextr, badsource, lfootprint, flag, nx, ny, dx, dy, mxco, myco, nxco, nyco, afwhm, bfwhm, atheta, foomajor
     &            , foominor, foothepa, fluxpeakbest, fluxtotfit, beta, correct, convtoradians )
!__________________________________________________________________________________________________________________________________
!
! Compute total fluxes assuming an intensity distribution of an elliptical sources with known peak flux and size.
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       inellipse, lfootprint(*)
       character*(*) flag(*), badsource(*)
       integer       n, nextr, nx, ny, l, m, beta, nr, nxco(nextr), nyco(nextr), l1, l2, m1, m2
       real*8        dbll, dblm, angle, dxcon, dycon, aa, bb, cc, dx, dy, amoffat, moffatfun
     &             , correct, convtoradians, sigmaa2, sigmab2, cosa2, sina2, sin2a, dxcon2, dycon2, semimajor

       real*8        fluxpeakbest(*), fluxtotfit(*), afwhm(*), bfwhm(*), atheta(*), mxco(*), myco(*)
     &             , foomajor(*), foominor(*), foothepa(*)
!__________________________________________________________________________________________________________________________________
!                  
       do n=1,nextr
         if (flag(n) .ne. 'n' .and. badsource(n) .ne. '!' .and. lfootprint(n)) then
           if (afwhm(n) .gt. 0.0d0 .and. bfwhm(n) .gt. 0.0d0) then
             fluxtotfit(n) = 0.0d0
             sigmaa2 = (afwhm(n) / 2.0d0)**2 * correct
             sigmab2 = (bfwhm(n) / 2.0d0)**2 * correct
             angle = (90.0d0 - atheta(n)) * convtoradians
             cosa2 = cos ( angle )**2       
             sina2 = sin ( angle )**2       
             sin2a = sin ( 2.0d0 * angle )  
             aa =  cosa2 / sigmaa2 + sina2 / sigmab2
             bb = -sin2a / sigmaa2 + sin2a / sigmab2
             cc =  sina2 / sigmaa2 + cosa2 / sigmab2
             semimajor = foomajor(n) / 2.0d0
             nr = nint ( semimajor / dx )   
             l1 = max ( nxco(n) - nr , 1 )     
             l2 = min ( nxco(n) + nr , nx )    
             m1 = max ( nyco(n) - nr , 1 )     
             m2 = min ( nyco(n) + nr , ny )    
             do m=m1,m2                     
               dblm = dble ( m )            
               dycon = (dblm - myco(n)) * dy
               dycon2 = dycon**2            
               do l=l1,l2                   
                 dbll = dble ( l )          
                 dxcon = (dbll - mxco(n)) * dx
                 dxcon2 = dxcon**2          
                 if (inellipse ( dbll, dblm, dx, dy, mxco(n), myco(n), foomajor(n), foominor(n), foothepa(n) )) then
                   amoffat = aa * dxcon2 + bb * dxcon * dycon + cc * dycon2
                   moffatfun = fluxpeakbest(n) / (1.0d0 + amoffat)**beta
                   fluxtotfit(n) = fluxtotfit(n) + moffatfun
                 endif
               enddo
             enddo
           endif
         endif
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine rfits 
       
     &            ( nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header, footer, iotty
     &            , iolog, creator, beam, funmin, funmax, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history, lverbose )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend, anynull, myfile
       character*(*) ctype1, ctype2, creator, fname, header, footer(2), bunit, object, history, lverbose
       character*25  cdatetime
       character*80  footer1, footer2, comment
       integer       i, j, nx, ny, stat, blksize, group, naxis, pcount, gcount, bitpix, unit, lastc, iotty, iolog, maxdim
     &             , ilc1, ilc2, rw, nfound, blank, stat01, stat02, stat03, stat04, stat05, stat06, stat07, stat08, stat09
     &             , stat10, stat11, stat12, stat13, stat14, stat15, stat16, stat17, stat18, stat19, stat20, stat21, stat22
     &             , stat23, stat24, stat25, stat26, stat27, stat28, stat29, stat30, stat31, stat32, stat0, nan
       parameter   ( maxdim = 2 )
       integer       naxes(maxdim)
       real*8        dx, dy, ra, dec, beam, funmin, funmax, xr, yr, rp1, rp2, rot1, rot2, epoch, equinox, bzero, bscale, wave
     &             , dxdeg, dydeg, cd11, cd12, cd21, cd22
       real*8        fun(nx,ny)
       real*8        as2deg, datamx, datamn
       parameter   ( as2deg = 1.0d0 / 3600.0d0 )
       external      lastc, ftopen, ftgkne, ftghpr, ftgkys, ftgkyd, ftgkye, ftg2de, ftclos, printerr
!__________________________________________________________________________________________________________________________________
!
! Initialize variables.

       stat = 0
       unit   = 20
       group  = 1
       rw     = 0
       stat01 = 0
       stat02 = 0
       stat03 = 0
       stat04 = 0
       stat05 = 0
       stat06 = 0
       stat07 = 0
       stat08 = 0
       stat09 = 0
       stat10 = 0
       stat11 = 0
       stat12 = 0
       stat13 = 0
       stat14 = 0
       stat15 = 0
       stat16 = 0
       stat17 = 0
       stat18 = 0
       stat19 = 0
       stat20 = 0
       stat21 = 0
       stat22 = 0
       stat23 = 0
       stat24 = 0
       stat25 = 0
       stat26 = 0
       stat27 = 0
       stat28 = 0
       stat29 = 0
       stat30 = 0
       stat31 = 0
       stat32 = 0

! Open the FITS file.

       call ftopen ( unit, fname, rw, blksize, stat )

       if (stat .ne. 0) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Trouble opening FITS file '''//fname//'''.'
         stop 99
       endif

! Determine the size of the image.

       call ftgkne ( unit, 'NAXIS', 1, 2, naxes, nfound, stat )

! Check that it found both NAXIS1 and NAXIS2 keywords.

       if (nfound .ne. 2) then
         if (iotty .gt. 0) write (iotty,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         if (iolog .gt. 0) write (iolog,'(/a)') ' RFITS: ERROR: Failed to read the NAXISn keywords.'
         stop 99
       endif

! Get the main primary header keywords which define the array structure.

       call ftghpr ( unit, maxdim, simple, bitpix, naxis, naxes, pcount, gcount, extend, stat )

! Read all parameters.

       call ftgkys ( unit, 'CREATOR', creator, comment, stat )
       
       if (stat .eq. 0 .and. (comment(1:22) .eq. 'Alexander Men`shchikov' .or. comment(1:22) .eq. 'Alexander Men''shchikov')) then
         myfile = .true.
       else
         myfile = .false.
         stat = 0
         creator = 'SMEASURE'
       endif

       header = 'FITS Plot Header'

       if (myfile) then
         call ftgkys ( unit, 'HEADER' , header , comment, stat01 )
         call ftgkys ( unit, 'FOOTER1', footer1, comment, stat02 )
         call ftgkys ( unit, 'FOOTER2', footer2, comment, stat03 )
         ilc1 = lastc ( footer1 )
         ilc2 = lastc ( footer2 )
         if (ilc1 .ne. 0 .and. ilc2 .ne. 0) then
           footer(1) = footer1(1:ilc1)//footer2(1:ilc2)
         else
           footer(1) = 'Footer'
         endif
       else
         call ftgkys ( unit, 'OBJECT' , header, comment, stat04 )
         if (stat04 .ne. 0 .or. header(1:10) .eq. '          ') header = fname
         footer(1) = header
       endif

! I don't understant why blank is assigned to my array values (if blank is not zero) - I have no undefined values in arrays. Maybe
! there is a bug in the version of FITSIO I use. For now I will ignore the blank value when reading FITS files.

       blank = 0

       datamx = 0.0d0
       datamn = 0.0d0
       bunit = ' '
       ctype1 = ' '
       ctype2 = ' '
       rp1 = 0.0d0
       rp2 = 0.0d0
       rot1 = 0.0d0
       rot2 = 0.0d0
       cd11 = 0.0d0
       cd12 = 0.0d0
       cd21 = 0.0d0
       cd22 = 0.0d0
       xr = 0.0d0
       yr = 0.0d0
       dx = 0.0d0
       dy = 0.0d0
       object = ' '
       ra = 0.0d0
       dec = 0.0d0
       epoch = 0.0d0
       equinox = 0.0d0
       beam = 0.0d0
       bzero = 0.0d0
       bscale = 1.0d0
       wave = 1.0d2
       history = ' '

       call ftgkys ( unit, 'DATE', cdatetime , comment, stat05 )
       call ftgkyd ( unit, 'DATAMAX', datamx , comment, stat06 )
       call ftgkyd ( unit, 'DATAMIN', datamn , comment, stat07 )
       call ftgkyj ( unit, 'BLANK'  , blank  , comment, stat08 )
       call ftgkys ( unit, 'BUNIT'  , bunit  , comment, stat09 )
       call ftgkyd ( unit, 'BZERO'  , bzero  , comment, stat10 )
       call ftgkyd ( unit, 'BSCALE' , bscale , comment, stat11 )
       call ftgkys ( unit, 'CTYPE1' , ctype1 , comment, stat12 )
       call ftgkys ( unit, 'CTYPE2' , ctype2 , comment, stat13 )
       call ftgkyd ( unit, 'CRPIX1' , rp1    , comment, stat14 )
       call ftgkyd ( unit, 'CRPIX2' , rp2    , comment, stat15 )
       call ftgkyd ( unit, 'CROTA1' , rot1   , comment, stat16 )
       call ftgkyd ( unit, 'CROTA2' , rot2   , comment, stat17 )
       call ftgkyd ( unit, 'CD1_1'  , cd11   , comment, stat18 )
       call ftgkyd ( unit, 'CD1_2'  , cd12   , comment, stat19 )
       call ftgkyd ( unit, 'CD2_1'  , cd21   , comment, stat20 )
       call ftgkyd ( unit, 'CD2_2'  , cd22   , comment, stat21 )
       call ftgkyd ( unit, 'CRVAL1' , xr     , comment, stat22 )
       call ftgkyd ( unit, 'CRVAL2' , yr     , comment, stat23 )
       call ftgkyd ( unit, 'CDELT1' , dxdeg  , comment, stat24 )
       call ftgkyd ( unit, 'CDELT2' , dydeg  , comment, stat25 )
       call ftgkys ( unit, 'OBJECT' , object , comment, stat26 )
       call ftgkyd ( unit, 'RA'     , ra     , comment, stat27 )
       call ftgkyd ( unit, 'DEC'    , dec    , comment, stat28 )
       call ftgkyd ( unit, 'EPOCH'  , epoch  , comment, stat29 )
       call ftgkyd ( unit, 'EQUINOX', equinox, comment, stat30 )
       call ftgkyd ( unit, 'WAVE'   , wave   , comment, stat31 )
       call ftgkyd ( unit, 'BEAM'   , beam   , comment, stat )
       call ftgkys ( unit, 'HISTORY', history, history, stat32 )

       if (stat .ne. 0) then
         beam = 0.0d0
         stat = 0
       endif

       stat08 = 0
       stat0 = stat01 + stat02 + stat03 + stat05 + stat06 + stat07 + stat09 + stat10 + stat11 + stat12 + stat13 + stat14 + stat15
     &       + stat16 + stat17 + stat18 + stat19 + stat20 + stat21 + stat22 + stat23 + stat24 + stat25 + stat26 + stat27 + stat28
     &       + stat29 + stat30 + stat31

       if (lverbose .ne. '-verb0') then
         if (stat0  .gt. 0) write (iotty,'()')
         if (stat01 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword HEADER absent or error'
         if (stat02 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER1 absent or error'
         if (stat03 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword FOOTER2 absent or error'
         if (stat05 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATE absent or error'
         if (stat06 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMAX absent or error'
         if (stat07 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DATAMIN absent or error'
         if (stat09 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BUNIT absent or error'
         if (stat10 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BZERO absent or error'
         if (stat11 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword BSCALE absent or error'
         if (stat12 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE1 absent or error'
         if (stat13 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CTYPE2 absent or error'
         if (stat14 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX1 absent or error'
         if (stat15 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRPIX2 absent or error'
         if (stat16 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA1 absent or error'
         if (stat17 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CROTA2 absent or error'
         if (stat18 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_1 absent or error'
         if (stat19 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD1_2 absent or error'
         if (stat20 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_1 absent or error'
         if (stat21 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CD2_2 absent or error'
         if (stat22 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL1 absent or error'
         if (stat23 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CRVAL2 absent or error'
         if (stat24 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT1 absent or error'
         if (stat25 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword CDELT2 absent or error'
         if (stat26 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword OBJECT absent or error'
         if (stat27 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword RA absent or error'
         if (stat28 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword DEC absent or error'
         if (stat29 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EPOCH absent or error'
         if (stat30 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword EQUINOX absent or error'
         if (stat31 .ne. 0) write (iotty,'(a)') '   RFITS: WARNING: Keyword WAVE absent or error'
       endif
       if (stat26 .ne. 0 .or. object(1:10) .eq. '          ') object = 'No object specified'

! Read the FITS file into the 2D array.

       call ftg2dd ( unit, group, dble ( blank ), naxes(1), naxes(1), naxes(2), fun, anynull, stat )

       if (stat .ne. 0) write (iotty,'(a)') ' Error reading FITS file'

! Close the file and free the unit number.

       call ftclos ( unit, stat )

! Check for any error, and if so print out error messages.

       if (stat .gt. 0) call printerr ( stat )

       dx = abs ( dxdeg ) / as2deg
       dy = abs ( dydeg ) / as2deg

! Print out the min and max values.

       nx = naxes(1)
       ny = naxes(2)
       funmin = 1.0d30
       funmax =-1.0d30
       nan = 0
       do j=1,ny
         do i=1,nx
           if (isnan ( fun(i,j) )) then  
             nan = nan + 1
             if (lverbose .ne. '-verb0') then
               if (nan .lt. 100) then
                 write (iotty,'(a,i4,a,i4,a)') '   RFITS: Element (', i,',', j, ') contains not a number (NaN)...'
               elseif (nan .eq. 100) then
                 write (iotty,'(a)') '   RFITS: Many NaNs, no more info on the elements.'
               endif
             endif
           else
             funmin = min ( funmin, fun(i,j) )
             funmax = max ( funmax, fun(i,j) )
           endif  
         enddo
       enddo

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

       subroutine wfits 
       
     &            ( cfitsversion, nx, ny, bunit, ctype1, ctype2, rp1, rp2, xr, yr, fun, dx, dy, object, ra, dec, fname, header
     &            , footer, cdate, ctime, creator, beam, blank, rot1, rot2, cd11, cd12, cd21, cd22, epoch, equinox, bzero, bscale
     &            , wave, datamn, datamx, history )
!__________________________________________________________________________________________________________________________________
!
! GETSOURCES = Multi-Scale Multi-Wavelength Source Extraction = Alexander Men'shchikov, SAp IRFU CEA Saclay      
!__________________________________________________________________________________________________________________________________
!
       implicit      none
       logical       simple, extend
       character*(*) fname, ctype1, ctype2, object, creator, header, footer(2), ctime, cdate, bunit, cfitsversion, history
       character*19  cdatetime
       integer       i, j, nx, ny, status, blocksze, group, naxis, pcount, gcount, bitpix, unit, naxes(2), iat, iflen, lastc, blank
       real*8        xr, yr, dx, dy, rp1, rp2, ra, dec, beam, bzero, bscale, as2deg, dfun, rot1, rot2, epoch, equinox, datamn
     &             , cosrota, sinrota, rotangle, datamx, dxdeg, dydeg, wave, cd11, cd12, cd21, cd22, almostzero, pi
       real*8        fun(nx,ny)
       parameter   ( pi = 3.14159265358979d0, as2deg = 1.0d0 / 3600.0d0, almostzero = 1.0d-30 )
       external      lastc
!__________________________________________________________________________________________________________________________________
!
! Create a FITS primary array containing a 2-D image. Initialize parameters about the FITS image.

       status   = 0
       blocksze = 1
       simple   = .true.
       extend   = .false.
       group    = 1
       naxis    = 2
       pcount   = 0
       gcount   = 1
       naxes(1) = nx
       naxes(2) = ny

! Compute offset and scaling factor so as to represent real numbers most efficiently and accurately with given 'bitpix'.

       datamn = 1.0d30
       datamx =-1.0d30
       do j=1,ny
         do i=1,nx
           dfun = fun(i,j)
           if (dfun .lt. datamn ) datamn = dfun
           if (dfun .gt. datamx ) datamx = dfun
         enddo
       enddo

       bitpix = -32     !<-- single precision floating-point values

       cdatetime = cdate(7:10)//'-'//cdate(4:5)//'-'//cdate(1:2)//'T'//ctime

! Delete the file if it already exists.

       if (cfitsversion .eq. '5.030') then
         call fdelete ( fname, status )
       endif

! Get an unused Logical Unit Number to use to open the FITS file.

       call ftgiou ( unit, status )

! Create the new empty FITS file.

       if (cfitsversion .eq. '5.030') then
         call ftinit ( unit, fname, blocksze, status )
       else
         call ftinit ( unit, '!'//fname, blocksze, status )
       endif

! Write the required header keywords.

       call ftphpr ( unit, simple, bitpix, naxis, naxes, pcount, gcount, extend, status )

! Write an optional comment.

       call ftpkys ( unit, 'CREATOR', creator,'Alexander Men`shchikov, SAp IRFU CEA Saclay', status )
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'HEADER' , header, 'title', status )

       iat = 0
       iat = index ( footer(1), ' |F' )
       if (iat .eq. 0) iat = index ( footer(1), ' mm ' )
       iflen = lastc ( footer(1) )

       if (iat .gt. 0) then
         call ftpkys ( unit, 'FOOTER1', footer(1)(1:iat-1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', footer(1)(iat:iflen), 'part 2', status )
       else
         call ftpkys ( unit, 'FOOTER1', footer(1), 'part 1', status )
         call ftpkys ( unit, 'FOOTER2', ' ', 'part 2', status )
       endif
       call ftpcom ( unit,' ',status)
       call ftpkys ( unit, 'DATE'  , cdatetime, 'creation date and time', status )

! Write all parameters.

       dxdeg = dx * as2deg
       dydeg = dy * as2deg

! Correct if the input images had cd11 or cd22 set to zero.

       if (abs ( cd11 ) .lt. almostzero .or. abs ( cd11 ) .gt. dxdeg) then
         cd11 = -dxdeg
         cd12 = 0.0d0
       endif
       if (abs ( cd22 ) .lt. almostzero .or. abs ( cd22 ) .gt. dxdeg) then
         cd21 = 0.0d0
         cd22 = dydeg
       endif

       cosrota = - cd11 / dxdeg
       sinrota = - cd12 / dxdeg
       rotangle = acos ( cosrota ) * 180.0d0 / pi
       
       if (cosrota .ge. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .ge. 0.0d0) then
         rot1 = 180.0d0 - rotangle
       elseif (cosrota .lt. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = 180.0d0 + rotangle
       elseif (cosrota .ge. 0.0d0 .and. sinrota .lt. 0.0d0) then
         rot1 = - rotangle
       endif
       rot2 = rot1

       call ftpkyd ( unit, 'BZERO'  , bzero , 13 , 'zero point in scaling equation', status )
       call ftpkyd ( unit, 'BSCALE' , bscale, 13 , 'linear factor in scaling equation' , status )
       call ftpkyd ( unit, 'DATAMAX', datamx, 13 , 'maximum data value', status )
       call ftpkyd ( unit, 'DATAMIN', datamn, 13 , 'minimum data value', status )
       if  (blank .gt. 0)
     & call ftpkyj ( unit, 'BLANK'  , blank      , 'value used for undefined array elements', status )
       call ftpkys ( unit, 'BUNIT'  , bunit      , 'physical units of the array values', status )
       call ftpkys ( unit, 'CTYPE1' , ctype1     , 'name of the coordinate axis', status )
       call ftpkys ( unit, 'CTYPE2' , ctype2     , 'name of the coordinate axis', status )
       call ftpkyd ( unit, 'CRPIX1' , rp1   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CRPIX2' , rp2   , 13 , 'coordinate system reference pixel', status )
       call ftpkyd ( unit, 'CROTA1' , rot1  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CROTA2' , rot2  , 13 , 'coordinate system rotation angle', status )
       call ftpkyd ( unit, 'CD1_1'  , cd11  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD1_2'  , cd12  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_1'  , cd21  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CD2_2'  , cd22  , 13 , 'linear projection matrix', status )
       call ftpkyd ( unit, 'CRVAL1' , xr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CRVAL2' , yr    , 13 , 'coordinate value at reference pixel', status )
       call ftpkyd ( unit, 'CDELT1' , -dxdeg, 13 , 'coordinate increment along axis', status )
       call ftpkyd ( unit, 'CDELT2' , dydeg , 13 , 'coordinate increment along axis', status )
       call ftpkys ( unit, 'OBJECT' , object     , 'object identifier', status )
       call ftpkyd ( unit, 'RA'     , ra     , 13, 'right ascension', status )
       call ftpkyd ( unit, 'DEC'    , dec    , 13, 'declination', status )
       call ftpkyd ( unit, 'WAVE'   , wave   , 13, 'wavelength (microns)', status )
       call ftpkyd ( unit, 'EPOCH'  , epoch  , 13, ' ', status )
       call ftpkyd ( unit, 'EQUINOX', equinox, 13, ' ', status )
       call ftphis ( unit, history, status )

       if (beam .ne. 0.0d0) call ftpkyd ( unit, 'BEAM', beam, 13, 'image was convolved with the beam (arcsec)', status )

! Write the array to the FITS file.

       call ftp2dd ( unit, group, nx, nx, ny, fun, status )

! Close the file.

       call ftclos ( unit, status )

! Free the unit number.

       call ftfiou ( unit, status )

! Check for any error, and if so print out error messages

       if (status .gt. 0) call printerr ( status )

       return
       end

!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
